package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLBindTransformFeedbackTarget implements GLEnum {
	TRANSFORM_FEEDBACK(0x8e22);
	
	private final int glEnum;

	GLBindTransformFeedbackTarget(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLBindTransformFeedbackTarget> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLBindTransformFeedbackTarget fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8e22 -> TRANSFORM_FEEDBACK;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLBindTransformFeedbackTarget");
		};
	}
}