package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLBoolean implements GLEnum {
	FALSE(0x0),
	TRUE(0x1);
	
	private final int glEnum;

	GLBoolean(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLBoolean> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLBoolean fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> FALSE;
			case 0x1 -> TRUE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLBoolean");
		};
	}

	public boolean value() {
		return this == TRUE;
	}

	public static GLBoolean from(boolean value) {
		return value ? TRUE : FALSE;
	}
}