package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLBuffer implements GLEnum {
	COLOR(0x1800),
	DEPTH(0x1801),
	STENCIL(0x1802);
	
	private final int glEnum;

	GLBuffer(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLBuffer> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLBuffer fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1800 -> COLOR;
			case 0x1801 -> DEPTH;
			case 0x1802 -> STENCIL;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLBuffer");
		};
	}
}