package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLClearBufferMask implements GLEnum {
	DEPTH_BUFFER_BIT(0x100),
	ACCUM_BUFFER_BIT(0x200),
	STENCIL_BUFFER_BIT(0x400),
	COLOR_BUFFER_BIT(0x4000),
	COVERAGE_BUFFER_BIT_NV(0x8000);
	
	private final int glEnum;

	GLClearBufferMask(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLClearBufferMask> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLClearBufferMask fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x100 -> DEPTH_BUFFER_BIT;
			case 0x200 -> ACCUM_BUFFER_BIT;
			case 0x400 -> STENCIL_BUFFER_BIT;
			case 0x4000 -> COLOR_BUFFER_BIT;
			case 0x8000 -> COVERAGE_BUFFER_BIT_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLClearBufferMask");
		};
	}
}