package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLClipPlaneName implements GLEnum {
	CLIP_PLANE0(0x3000),
	CLIP_PLANE1(0x3001),
	CLIP_PLANE2(0x3002),
	CLIP_PLANE3(0x3003),
	CLIP_PLANE4(0x3004),
	CLIP_PLANE5(0x3005),
	CLIP_DISTANCE6(0x3006),
	CLIP_DISTANCE7(0x3007);
	
	private final int glEnum;

	GLClipPlaneName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLClipPlaneName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLClipPlaneName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x3000 -> CLIP_PLANE0;
			case 0x3001 -> CLIP_PLANE1;
			case 0x3002 -> CLIP_PLANE2;
			case 0x3003 -> CLIP_PLANE3;
			case 0x3004 -> CLIP_PLANE4;
			case 0x3005 -> CLIP_PLANE5;
			case 0x3006 -> CLIP_DISTANCE6;
			case 0x3007 -> CLIP_DISTANCE7;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLClipPlaneName");
		};
	}
}