package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLCombinerStageNV implements GLEnum {
	COMBINER0_NV(0x8550),
	COMBINER1_NV(0x8551),
	COMBINER2_NV(0x8552),
	COMBINER3_NV(0x8553),
	COMBINER4_NV(0x8554),
	COMBINER5_NV(0x8555),
	COMBINER6_NV(0x8556),
	COMBINER7_NV(0x8557);
	
	private final int glEnum;

	GLCombinerStageNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLCombinerStageNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLCombinerStageNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8550 -> COMBINER0_NV;
			case 0x8551 -> COMBINER1_NV;
			case 0x8552 -> COMBINER2_NV;
			case 0x8553 -> COMBINER3_NV;
			case 0x8554 -> COMBINER4_NV;
			case 0x8555 -> COMBINER5_NV;
			case 0x8556 -> COMBINER6_NV;
			case 0x8557 -> COMBINER7_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLCombinerStageNV");
		};
	}
}