package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLConditionalRenderMode implements GLEnum {
	QUERY_WAIT(0x8e13),
	QUERY_NO_WAIT(0x8e14),
	QUERY_BY_REGION_WAIT(0x8e15),
	QUERY_BY_REGION_NO_WAIT(0x8e16),
	QUERY_WAIT_INVERTED(0x8e17),
	QUERY_NO_WAIT_INVERTED(0x8e18),
	QUERY_BY_REGION_WAIT_INVERTED(0x8e19),
	QUERY_BY_REGION_NO_WAIT_INVERTED(0x8e1a);
	
	private final int glEnum;

	GLConditionalRenderMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLConditionalRenderMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLConditionalRenderMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8e13 -> QUERY_WAIT;
			case 0x8e14 -> QUERY_NO_WAIT;
			case 0x8e15 -> QUERY_BY_REGION_WAIT;
			case 0x8e16 -> QUERY_BY_REGION_NO_WAIT;
			case 0x8e17 -> QUERY_WAIT_INVERTED;
			case 0x8e18 -> QUERY_NO_WAIT_INVERTED;
			case 0x8e19 -> QUERY_BY_REGION_WAIT_INVERTED;
			case 0x8e1a -> QUERY_BY_REGION_NO_WAIT_INVERTED;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLConditionalRenderMode");
		};
	}
}