package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLConvolutionParameter implements GLEnum {
	CONVOLUTION_BORDER_MODE(0x8013),
	CONVOLUTION_FILTER_SCALE(0x8014),
	CONVOLUTION_FILTER_BIAS(0x8015),
	CONVOLUTION_FORMAT(0x8017),
	CONVOLUTION_WIDTH(0x8018),
	CONVOLUTION_HEIGHT(0x8019),
	MAX_CONVOLUTION_WIDTH(0x801a),
	MAX_CONVOLUTION_HEIGHT(0x801b),
	CONVOLUTION_BORDER_COLOR(0x8154);
	
	private final int glEnum;

	GLConvolutionParameter(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLConvolutionParameter> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLConvolutionParameter fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8013 -> CONVOLUTION_BORDER_MODE;
			case 0x8014 -> CONVOLUTION_FILTER_SCALE;
			case 0x8015 -> CONVOLUTION_FILTER_BIAS;
			case 0x8017 -> CONVOLUTION_FORMAT;
			case 0x8018 -> CONVOLUTION_WIDTH;
			case 0x8019 -> CONVOLUTION_HEIGHT;
			case 0x801a -> MAX_CONVOLUTION_WIDTH;
			case 0x801b -> MAX_CONVOLUTION_HEIGHT;
			case 0x8154 -> CONVOLUTION_BORDER_COLOR;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLConvolutionParameter");
		};
	}
}