package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLDebugSeverity implements GLEnum {
	DONT_CARE(0x1100),
	DEBUG_SEVERITY_NOTIFICATION(0x826b),
	DEBUG_SEVERITY_HIGH(0x9146),
	DEBUG_SEVERITY_MEDIUM(0x9147),
	DEBUG_SEVERITY_LOW(0x9148);
	
	private final int glEnum;

	GLDebugSeverity(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLDebugSeverity> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLDebugSeverity fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1100 -> DONT_CARE;
			case 0x826b -> DEBUG_SEVERITY_NOTIFICATION;
			case 0x9146 -> DEBUG_SEVERITY_HIGH;
			case 0x9147 -> DEBUG_SEVERITY_MEDIUM;
			case 0x9148 -> DEBUG_SEVERITY_LOW;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLDebugSeverity");
		};
	}
}