package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLDepthStencilTextureMode implements GLEnum {
	STENCIL_INDEX(0x1901),
	DEPTH_COMPONENT(0x1902);
	
	private final int glEnum;

	GLDepthStencilTextureMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLDepthStencilTextureMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLDepthStencilTextureMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1901 -> STENCIL_INDEX;
			case 0x1902 -> DEPTH_COMPONENT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLDepthStencilTextureMode");
		};
	}
}