package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLExternalHandleType implements GLEnum {
	HANDLE_TYPE_OPAQUE_FD_EXT(0x9586),
	HANDLE_TYPE_OPAQUE_WIN32_EXT(0x9587),
	HANDLE_TYPE_OPAQUE_WIN32_KMT_EXT(0x9588),
	HANDLE_TYPE_D3D12_TILEPOOL_EXT(0x9589),
	HANDLE_TYPE_D3D12_RESOURCE_EXT(0x958a),
	HANDLE_TYPE_D3D11_IMAGE_EXT(0x958b),
	HANDLE_TYPE_D3D11_IMAGE_KMT_EXT(0x958c),
	HANDLE_TYPE_D3D12_FENCE_EXT(0x9594);
	
	private final int glEnum;

	GLExternalHandleType(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLExternalHandleType> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLExternalHandleType fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x9586 -> HANDLE_TYPE_OPAQUE_FD_EXT;
			case 0x9587 -> HANDLE_TYPE_OPAQUE_WIN32_EXT;
			case 0x9588 -> HANDLE_TYPE_OPAQUE_WIN32_KMT_EXT;
			case 0x9589 -> HANDLE_TYPE_D3D12_TILEPOOL_EXT;
			case 0x958a -> HANDLE_TYPE_D3D12_RESOURCE_EXT;
			case 0x958b -> HANDLE_TYPE_D3D11_IMAGE_EXT;
			case 0x958c -> HANDLE_TYPE_D3D11_IMAGE_KMT_EXT;
			case 0x9594 -> HANDLE_TYPE_D3D12_FENCE_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLExternalHandleType");
		};
	}
}