package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFfdMaskSGIX implements GLEnum {
	TEXTURE_DEFORMATION_BIT_SGIX(0x1),
	GEOMETRY_DEFORMATION_BIT_SGIX(0x2);
	
	private final int glEnum;

	GLFfdMaskSGIX(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFfdMaskSGIX> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFfdMaskSGIX fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1 -> TEXTURE_DEFORMATION_BIT_SGIX;
			case 0x2 -> GEOMETRY_DEFORMATION_BIT_SGIX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFfdMaskSGIX");
		};
	}
}