package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFragmentOp2ATI implements GLEnum {
	ADD_ATI(0x8963),
	MUL_ATI(0x8964),
	SUB_ATI(0x8965),
	DOT3_ATI(0x8966),
	DOT4_ATI(0x8967);
	
	private final int glEnum;

	GLFragmentOp2ATI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFragmentOp2ATI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFragmentOp2ATI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8963 -> ADD_ATI;
			case 0x8964 -> MUL_ATI;
			case 0x8965 -> SUB_ATI;
			case 0x8966 -> DOT3_ATI;
			case 0x8967 -> DOT4_ATI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFragmentOp2ATI");
		};
	}
}