package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFramebufferParameterName implements GLEnum {
	FRAMEBUFFER_DEFAULT_WIDTH(0x9310),
	FRAMEBUFFER_DEFAULT_HEIGHT(0x9311),
	FRAMEBUFFER_DEFAULT_LAYERS(0x9312),
	FRAMEBUFFER_DEFAULT_SAMPLES(0x9313),
	FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS(0x9314);
	
	private final int glEnum;

	GLFramebufferParameterName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFramebufferParameterName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFramebufferParameterName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x9310 -> FRAMEBUFFER_DEFAULT_WIDTH;
			case 0x9311 -> FRAMEBUFFER_DEFAULT_HEIGHT;
			case 0x9312 -> FRAMEBUFFER_DEFAULT_LAYERS;
			case 0x9313 -> FRAMEBUFFER_DEFAULT_SAMPLES;
			case 0x9314 -> FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFramebufferParameterName");
		};
	}
}