package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLGetPName implements GLEnum {
	CURRENT_COLOR(0xb00),
	CURRENT_INDEX(0xb01),
	CURRENT_NORMAL(0xb02),
	CURRENT_TEXTURE_COORDS(0xb03),
	CURRENT_RASTER_COLOR(0xb04),
	CURRENT_RASTER_INDEX(0xb05),
	CURRENT_RASTER_TEXTURE_COORDS(0xb06),
	CURRENT_RASTER_POSITION(0xb07),
	CURRENT_RASTER_POSITION_VALID(0xb08),
	CURRENT_RASTER_DISTANCE(0xb09),
	POINT_SMOOTH(0xb10),
	POINT_SIZE(0xb11),
	POINT_SIZE_RANGE(0xb12),
	POINT_SIZE_GRANULARITY(0xb13),
	LINE_SMOOTH(0xb20),
	LINE_WIDTH(0xb21),
	LINE_WIDTH_RANGE(0xb22),
	LINE_WIDTH_GRANULARITY(0xb23),
	LINE_STIPPLE(0xb24),
	LINE_STIPPLE_PATTERN(0xb25),
	LINE_STIPPLE_REPEAT(0xb26),
	LIST_MODE(0xb30),
	MAX_LIST_NESTING(0xb31),
	LIST_BASE(0xb32),
	LIST_INDEX(0xb33),
	POLYGON_MODE(0xb40),
	POLYGON_SMOOTH(0xb41),
	POLYGON_STIPPLE(0xb42),
	EDGE_FLAG(0xb43),
	CULL_FACE(0xb44),
	CULL_FACE_MODE(0xb45),
	FRONT_FACE(0xb46),
	LIGHTING(0xb50),
	LIGHT_MODEL_LOCAL_VIEWER(0xb51),
	LIGHT_MODEL_TWO_SIDE(0xb52),
	LIGHT_MODEL_AMBIENT(0xb53),
	SHADE_MODEL(0xb54),
	COLOR_MATERIAL_FACE(0xb55),
	COLOR_MATERIAL_PARAMETER(0xb56),
	COLOR_MATERIAL(0xb57),
	FOG(0xb60),
	FOG_INDEX(0xb61),
	FOG_DENSITY(0xb62),
	FOG_START(0xb63),
	FOG_END(0xb64),
	FOG_MODE(0xb65),
	FOG_COLOR(0xb66),
	DEPTH_RANGE(0xb70),
	DEPTH_TEST(0xb71),
	DEPTH_WRITEMASK(0xb72),
	DEPTH_CLEAR_VALUE(0xb73),
	DEPTH_FUNC(0xb74),
	ACCUM_CLEAR_VALUE(0xb80),
	STENCIL_TEST(0xb90),
	STENCIL_CLEAR_VALUE(0xb91),
	STENCIL_FUNC(0xb92),
	STENCIL_VALUE_MASK(0xb93),
	STENCIL_FAIL(0xb94),
	STENCIL_PASS_DEPTH_FAIL(0xb95),
	STENCIL_PASS_DEPTH_PASS(0xb96),
	STENCIL_REF(0xb97),
	STENCIL_WRITEMASK(0xb98),
	MATRIX_MODE(0xba0),
	NORMALIZE(0xba1),
	VIEWPORT(0xba2),
	MODELVIEW_STACK_DEPTH(0xba3),
	PROJECTION_STACK_DEPTH(0xba4),
	TEXTURE_STACK_DEPTH(0xba5),
	MODELVIEW_MATRIX(0xba6),
	PROJECTION_MATRIX(0xba7),
	TEXTURE_MATRIX(0xba8),
	ATTRIB_STACK_DEPTH(0xbb0),
	CLIENT_ATTRIB_STACK_DEPTH(0xbb1),
	ALPHA_TEST(0xbc0),
	ALPHA_TEST_FUNC(0xbc1),
	ALPHA_TEST_REF(0xbc2),
	DITHER(0xbd0),
	BLEND_DST(0xbe0),
	BLEND_SRC(0xbe1),
	BLEND(0xbe2),
	LOGIC_OP_MODE(0xbf0),
	INDEX_LOGIC_OP(0xbf1),
	COLOR_LOGIC_OP(0xbf2),
	AUX_BUFFERS(0xc00),
	DRAW_BUFFER(0xc01),
	READ_BUFFER(0xc02),
	SCISSOR_BOX(0xc10),
	SCISSOR_TEST(0xc11),
	INDEX_CLEAR_VALUE(0xc20),
	INDEX_WRITEMASK(0xc21),
	COLOR_CLEAR_VALUE(0xc22),
	COLOR_WRITEMASK(0xc23),
	INDEX_MODE(0xc30),
	RGBA_MODE(0xc31),
	DOUBLEBUFFER(0xc32),
	STEREO(0xc33),
	RENDER_MODE(0xc40),
	PERSPECTIVE_CORRECTION_HINT(0xc50),
	POINT_SMOOTH_HINT(0xc51),
	LINE_SMOOTH_HINT(0xc52),
	POLYGON_SMOOTH_HINT(0xc53),
	FOG_HINT(0xc54),
	TEXTURE_GEN_S(0xc60),
	TEXTURE_GEN_T(0xc61),
	TEXTURE_GEN_R(0xc62),
	TEXTURE_GEN_Q(0xc63),
	PIXEL_MAP_I_TO_I_SIZE(0xcb0),
	PIXEL_MAP_S_TO_S_SIZE(0xcb1),
	PIXEL_MAP_I_TO_R_SIZE(0xcb2),
	PIXEL_MAP_I_TO_G_SIZE(0xcb3),
	PIXEL_MAP_I_TO_B_SIZE(0xcb4),
	PIXEL_MAP_I_TO_A_SIZE(0xcb5),
	PIXEL_MAP_R_TO_R_SIZE(0xcb6),
	PIXEL_MAP_G_TO_G_SIZE(0xcb7),
	PIXEL_MAP_B_TO_B_SIZE(0xcb8),
	PIXEL_MAP_A_TO_A_SIZE(0xcb9),
	UNPACK_SWAP_BYTES(0xcf0),
	UNPACK_LSB_FIRST(0xcf1),
	UNPACK_ROW_LENGTH(0xcf2),
	UNPACK_SKIP_ROWS(0xcf3),
	UNPACK_SKIP_PIXELS(0xcf4),
	UNPACK_ALIGNMENT(0xcf5),
	PACK_SWAP_BYTES(0xd00),
	PACK_LSB_FIRST(0xd01),
	PACK_ROW_LENGTH(0xd02),
	PACK_SKIP_ROWS(0xd03),
	PACK_SKIP_PIXELS(0xd04),
	PACK_ALIGNMENT(0xd05),
	MAP_COLOR(0xd10),
	MAP_STENCIL(0xd11),
	INDEX_SHIFT(0xd12),
	INDEX_OFFSET(0xd13),
	RED_SCALE(0xd14),
	RED_BIAS(0xd15),
	ZOOM_X(0xd16),
	ZOOM_Y(0xd17),
	GREEN_SCALE(0xd18),
	GREEN_BIAS(0xd19),
	BLUE_SCALE(0xd1a),
	BLUE_BIAS(0xd1b),
	ALPHA_SCALE(0xd1c),
	ALPHA_BIAS(0xd1d),
	DEPTH_SCALE(0xd1e),
	DEPTH_BIAS(0xd1f),
	MAX_EVAL_ORDER(0xd30),
	MAX_LIGHTS(0xd31),
	MAX_CLIP_PLANES(0xd32),
	MAX_TEXTURE_SIZE(0xd33),
	MAX_PIXEL_MAP_TABLE(0xd34),
	MAX_ATTRIB_STACK_DEPTH(0xd35),
	MAX_MODELVIEW_STACK_DEPTH(0xd36),
	MAX_NAME_STACK_DEPTH(0xd37),
	MAX_PROJECTION_STACK_DEPTH(0xd38),
	MAX_TEXTURE_STACK_DEPTH(0xd39),
	MAX_VIEWPORT_DIMS(0xd3a),
	MAX_CLIENT_ATTRIB_STACK_DEPTH(0xd3b),
	SUBPIXEL_BITS(0xd50),
	INDEX_BITS(0xd51),
	RED_BITS(0xd52),
	GREEN_BITS(0xd53),
	BLUE_BITS(0xd54),
	ALPHA_BITS(0xd55),
	DEPTH_BITS(0xd56),
	STENCIL_BITS(0xd57),
	ACCUM_RED_BITS(0xd58),
	ACCUM_GREEN_BITS(0xd59),
	ACCUM_BLUE_BITS(0xd5a),
	ACCUM_ALPHA_BITS(0xd5b),
	NAME_STACK_DEPTH(0xd70),
	AUTO_NORMAL(0xd80),
	MAP1_COLOR_4(0xd90),
	MAP1_INDEX(0xd91),
	MAP1_NORMAL(0xd92),
	MAP1_TEXTURE_COORD_1(0xd93),
	MAP1_TEXTURE_COORD_2(0xd94),
	MAP1_TEXTURE_COORD_3(0xd95),
	MAP1_TEXTURE_COORD_4(0xd96),
	MAP1_VERTEX_3(0xd97),
	MAP1_VERTEX_4(0xd98),
	MAP2_COLOR_4(0xdb0),
	MAP2_INDEX(0xdb1),
	MAP2_NORMAL(0xdb2),
	MAP2_TEXTURE_COORD_1(0xdb3),
	MAP2_TEXTURE_COORD_2(0xdb4),
	MAP2_TEXTURE_COORD_3(0xdb5),
	MAP2_TEXTURE_COORD_4(0xdb6),
	MAP2_VERTEX_3(0xdb7),
	MAP2_VERTEX_4(0xdb8),
	MAP1_GRID_DOMAIN(0xdd0),
	MAP1_GRID_SEGMENTS(0xdd1),
	MAP2_GRID_DOMAIN(0xdd2),
	MAP2_GRID_SEGMENTS(0xdd3),
	TEXTURE_1D(0xde0),
	TEXTURE_2D(0xde1),
	FEEDBACK_BUFFER_SIZE(0xdf1),
	FEEDBACK_BUFFER_TYPE(0xdf2),
	SELECTION_BUFFER_SIZE(0xdf4),
	POLYGON_OFFSET_UNITS(0x2a00),
	POLYGON_OFFSET_POINT(0x2a01),
	POLYGON_OFFSET_LINE(0x2a02),
	CLIP_PLANE0(0x3000),
	CLIP_PLANE1(0x3001),
	CLIP_PLANE2(0x3002),
	CLIP_PLANE3(0x3003),
	CLIP_PLANE4(0x3004),
	CLIP_PLANE5(0x3005),
	LIGHT0(0x4000),
	LIGHT1(0x4001),
	LIGHT2(0x4002),
	LIGHT3(0x4003),
	LIGHT4(0x4004),
	LIGHT5(0x4005),
	LIGHT6(0x4006),
	LIGHT7(0x4007),
	BLEND_COLOR(0x8005),
	BLEND_EQUATION(0x8009),
	PACK_CMYK_HINT_EXT(0x800e),
	UNPACK_CMYK_HINT_EXT(0x800f),
	CONVOLUTION_1D(0x8010),
	CONVOLUTION_2D(0x8011),
	SEPARABLE_2D(0x8012),
	POST_CONVOLUTION_RED_SCALE(0x801c),
	POST_CONVOLUTION_GREEN_SCALE(0x801d),
	POST_CONVOLUTION_BLUE_SCALE(0x801e),
	POST_CONVOLUTION_ALPHA_SCALE(0x801f),
	POST_CONVOLUTION_RED_BIAS(0x8020),
	POST_CONVOLUTION_GREEN_BIAS(0x8021),
	POST_CONVOLUTION_BLUE_BIAS(0x8022),
	POST_CONVOLUTION_ALPHA_BIAS(0x8023),
	HISTOGRAM(0x8024),
	MINMAX(0x802e),
	POLYGON_OFFSET_FILL(0x8037),
	POLYGON_OFFSET_FACTOR(0x8038),
	POLYGON_OFFSET_BIAS_EXT(0x8039),
	RESCALE_NORMAL(0x803a),
	TEXTURE_BINDING_1D(0x8068),
	TEXTURE_BINDING_2D(0x8069),
	TEXTURE_3D_BINDING_EXT(0x806a),
	PACK_SKIP_IMAGES(0x806b),
	PACK_IMAGE_HEIGHT(0x806c),
	UNPACK_SKIP_IMAGES(0x806d),
	UNPACK_IMAGE_HEIGHT(0x806e),
	TEXTURE_3D(0x806f),
	MAX_3D_TEXTURE_SIZE(0x8073),
	VERTEX_ARRAY(0x8074),
	NORMAL_ARRAY(0x8075),
	COLOR_ARRAY(0x8076),
	INDEX_ARRAY(0x8077),
	TEXTURE_COORD_ARRAY(0x8078),
	EDGE_FLAG_ARRAY(0x8079),
	VERTEX_ARRAY_SIZE(0x807a),
	VERTEX_ARRAY_TYPE(0x807b),
	VERTEX_ARRAY_STRIDE(0x807c),
	VERTEX_ARRAY_COUNT_EXT(0x807d),
	NORMAL_ARRAY_TYPE(0x807e),
	NORMAL_ARRAY_STRIDE(0x807f),
	NORMAL_ARRAY_COUNT_EXT(0x8080),
	COLOR_ARRAY_SIZE(0x8081),
	COLOR_ARRAY_TYPE(0x8082),
	COLOR_ARRAY_STRIDE(0x8083),
	COLOR_ARRAY_COUNT_EXT(0x8084),
	INDEX_ARRAY_TYPE(0x8085),
	INDEX_ARRAY_STRIDE(0x8086),
	INDEX_ARRAY_COUNT_EXT(0x8087),
	TEXTURE_COORD_ARRAY_SIZE(0x8088),
	TEXTURE_COORD_ARRAY_TYPE(0x8089),
	TEXTURE_COORD_ARRAY_STRIDE(0x808a),
	TEXTURE_COORD_ARRAY_COUNT_EXT(0x808b),
	EDGE_FLAG_ARRAY_STRIDE(0x808c),
	EDGE_FLAG_ARRAY_COUNT_EXT(0x808d),
	INTERLACE_SGIX(0x8094),
	DETAIL_TEXTURE_2D_BINDING_SGIS(0x8096),
	MULTISAMPLE_SGIS(0x809d),
	SAMPLE_ALPHA_TO_MASK_SGIS(0x809e),
	SAMPLE_ALPHA_TO_ONE_SGIS(0x809f),
	SAMPLE_MASK_SGIS(0x80a0),
	SAMPLE_BUFFERS(0x80a8),
	SAMPLES(0x80a9),
	SAMPLE_COVERAGE_VALUE(0x80aa),
	SAMPLE_COVERAGE_INVERT(0x80ab),
	SAMPLE_PATTERN_SGIS(0x80ac),
	COLOR_MATRIX(0x80b1),
	COLOR_MATRIX_STACK_DEPTH(0x80b2),
	MAX_COLOR_MATRIX_STACK_DEPTH(0x80b3),
	POST_COLOR_MATRIX_RED_SCALE(0x80b4),
	POST_COLOR_MATRIX_GREEN_SCALE(0x80b5),
	POST_COLOR_MATRIX_BLUE_SCALE(0x80b6),
	POST_COLOR_MATRIX_ALPHA_SCALE(0x80b7),
	POST_COLOR_MATRIX_RED_BIAS(0x80b8),
	POST_COLOR_MATRIX_GREEN_BIAS(0x80b9),
	POST_COLOR_MATRIX_BLUE_BIAS(0x80ba),
	POST_COLOR_MATRIX_ALPHA_BIAS(0x80bb),
	TEXTURE_COLOR_TABLE_SGI(0x80bc),
	BLEND_DST_RGB(0x80c8),
	BLEND_SRC_RGB(0x80c9),
	BLEND_DST_ALPHA(0x80ca),
	BLEND_SRC_ALPHA(0x80cb),
	COLOR_TABLE(0x80d0),
	POST_CONVOLUTION_COLOR_TABLE(0x80d1),
	POST_COLOR_MATRIX_COLOR_TABLE(0x80d2),
	MAX_ELEMENTS_VERTICES(0x80e8),
	MAX_ELEMENTS_INDICES(0x80e9),
	PARAMETER_BUFFER_BINDING(0x80ef),
	POINT_SIZE_MIN(0x8126),
	POINT_SIZE_MAX(0x8127),
	POINT_FADE_THRESHOLD_SIZE(0x8128),
	DISTANCE_ATTENUATION_EXT(0x8129),
	FOG_FUNC_POINTS_SGIS(0x812b),
	MAX_FOG_FUNC_POINTS_SGIS(0x812c),
	PACK_SKIP_VOLUMES_SGIS(0x8130),
	PACK_IMAGE_DEPTH_SGIS(0x8131),
	UNPACK_SKIP_VOLUMES_SGIS(0x8132),
	UNPACK_IMAGE_DEPTH_SGIS(0x8133),
	TEXTURE_4D_SGIS(0x8134),
	MAX_4D_TEXTURE_SIZE_SGIS(0x8138),
	PIXEL_TEX_GEN_SGIX(0x8139),
	PIXEL_TILE_BEST_ALIGNMENT_SGIX(0x813e),
	PIXEL_TILE_CACHE_INCREMENT_SGIX(0x813f),
	PIXEL_TILE_WIDTH_SGIX(0x8140),
	PIXEL_TILE_HEIGHT_SGIX(0x8141),
	PIXEL_TILE_GRID_WIDTH_SGIX(0x8142),
	PIXEL_TILE_GRID_HEIGHT_SGIX(0x8143),
	PIXEL_TILE_GRID_DEPTH_SGIX(0x8144),
	PIXEL_TILE_CACHE_SIZE_SGIX(0x8145),
	SPRITE_SGIX(0x8148),
	SPRITE_MODE_SGIX(0x8149),
	SPRITE_AXIS_SGIX(0x814a),
	SPRITE_TRANSLATION_SGIX(0x814b),
	TEXTURE_4D_BINDING_SGIS(0x814f),
	MAX_CLIPMAP_DEPTH_SGIX(0x8177),
	MAX_CLIPMAP_VIRTUAL_DEPTH_SGIX(0x8178),
	POST_TEXTURE_FILTER_BIAS_RANGE_SGIX(0x817b),
	POST_TEXTURE_FILTER_SCALE_RANGE_SGIX(0x817c),
	REFERENCE_PLANE_SGIX(0x817d),
	REFERENCE_PLANE_EQUATION_SGIX(0x817e),
	IR_INSTRUMENT1_SGIX(0x817f),
	INSTRUMENT_MEASUREMENTS_SGIX(0x8181),
	CALLIGRAPHIC_FRAGMENT_SGIX(0x8183),
	FRAMEZOOM_SGIX(0x818b),
	FRAMEZOOM_FACTOR_SGIX(0x818c),
	MAX_FRAMEZOOM_FACTOR_SGIX(0x818d),
	GENERATE_MIPMAP_HINT_SGIS(0x8192),
	DEFORMATIONS_MASK_SGIX(0x8196),
	FOG_OFFSET_SGIX(0x8198),
	FOG_OFFSET_VALUE_SGIX(0x8199),
	LIGHT_MODEL_COLOR_CONTROL(0x81f8),
	SHARED_TEXTURE_PALETTE_EXT(0x81fb),
	MAJOR_VERSION(0x821b),
	MINOR_VERSION(0x821c),
	NUM_EXTENSIONS(0x821d),
	CONTEXT_FLAGS(0x821e),
	PROGRAM_PIPELINE_BINDING(0x825a),
	MAX_VIEWPORTS(0x825b),
	VIEWPORT_SUBPIXEL_BITS(0x825c),
	VIEWPORT_BOUNDS_RANGE(0x825d),
	LAYER_PROVOKING_VERTEX(0x825e),
	VIEWPORT_INDEX_PROVOKING_VERTEX(0x825f),
	MAX_COMPUTE_UNIFORM_COMPONENTS(0x8263),
	MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS(0x8264),
	MAX_COMPUTE_ATOMIC_COUNTERS(0x8265),
	MAX_COMBINED_COMPUTE_UNIFORM_COMPONENTS(0x8266),
	MAX_DEBUG_GROUP_STACK_DEPTH(0x826c),
	DEBUG_GROUP_STACK_DEPTH(0x826d),
	MAX_UNIFORM_LOCATIONS(0x826e),
	VERTEX_BINDING_DIVISOR(0x82d6),
	VERTEX_BINDING_OFFSET(0x82d7),
	VERTEX_BINDING_STRIDE(0x82d8),
	MAX_VERTEX_ATTRIB_RELATIVE_OFFSET(0x82d9),
	MAX_VERTEX_ATTRIB_BINDINGS(0x82da),
	MAX_LABEL_LENGTH(0x82e8),
	CONVOLUTION_HINT_SGIX(0x8316),
	ASYNC_MARKER_SGIX(0x8329),
	PIXEL_TEX_GEN_MODE_SGIX(0x832b),
	ASYNC_HISTOGRAM_SGIX(0x832c),
	MAX_ASYNC_HISTOGRAM_SGIX(0x832d),
	PIXEL_TEXTURE_SGIS(0x8353),
	ASYNC_TEX_IMAGE_SGIX(0x835c),
	ASYNC_DRAW_PIXELS_SGIX(0x835d),
	ASYNC_READ_PIXELS_SGIX(0x835e),
	MAX_ASYNC_TEX_IMAGE_SGIX(0x835f),
	MAX_ASYNC_DRAW_PIXELS_SGIX(0x8360),
	MAX_ASYNC_READ_PIXELS_SGIX(0x8361),
	VERTEX_PRECLIP_SGIX(0x83ee),
	VERTEX_PRECLIP_HINT_SGIX(0x83ef),
	FRAGMENT_LIGHTING_SGIX(0x8400),
	FRAGMENT_COLOR_MATERIAL_SGIX(0x8401),
	FRAGMENT_COLOR_MATERIAL_FACE_SGIX(0x8402),
	FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX(0x8403),
	MAX_FRAGMENT_LIGHTS_SGIX(0x8404),
	MAX_ACTIVE_LIGHTS_SGIX(0x8405),
	LIGHT_ENV_MODE_SGIX(0x8407),
	FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX(0x8408),
	FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX(0x8409),
	FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX(0x840a),
	FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX(0x840b),
	FRAGMENT_LIGHT0_SGIX(0x840c),
	PACK_RESAMPLE_SGIX(0x842e),
	UNPACK_RESAMPLE_SGIX(0x842f),
	ALIASED_POINT_SIZE_RANGE(0x846d),
	ALIASED_LINE_WIDTH_RANGE(0x846e),
	ACTIVE_TEXTURE(0x84e0),
	MAX_RENDERBUFFER_SIZE(0x84e8),
	TEXTURE_COMPRESSION_HINT(0x84ef),
	TEXTURE_BINDING_RECTANGLE(0x84f6),
	MAX_RECTANGLE_TEXTURE_SIZE(0x84f8),
	MAX_TEXTURE_LOD_BIAS(0x84fd),
	TEXTURE_BINDING_CUBE_MAP(0x8514),
	MAX_CUBE_MAP_TEXTURE_SIZE(0x851c),
	FOG_DISTANCE_MODE_NV(0x855a),
	PACK_SUBSAMPLE_RATE_SGIX(0x85a0),
	UNPACK_SUBSAMPLE_RATE_SGIX(0x85a1),
	VERTEX_ARRAY_BINDING(0x85b5),
	PROGRAM_POINT_SIZE(0x8642),
	NUM_COMPRESSED_TEXTURE_FORMATS(0x86a2),
	COMPRESSED_TEXTURE_FORMATS(0x86a3),
	NUM_PROGRAM_BINARY_FORMATS(0x87fe),
	PROGRAM_BINARY_FORMATS(0x87ff),
	STENCIL_BACK_FUNC(0x8800),
	STENCIL_BACK_FAIL(0x8801),
	STENCIL_BACK_PASS_DEPTH_FAIL(0x8802),
	STENCIL_BACK_PASS_DEPTH_PASS(0x8803),
	MAX_DRAW_BUFFERS(0x8824),
	BLEND_EQUATION_ALPHA(0x883d),
	MAX_VERTEX_ATTRIBS(0x8869),
	MAX_TEXTURE_IMAGE_UNITS(0x8872),
	ARRAY_BUFFER_BINDING(0x8894),
	ELEMENT_ARRAY_BUFFER_BINDING(0x8895),
	PIXEL_PACK_BUFFER_BINDING(0x88ed),
	PIXEL_UNPACK_BUFFER_BINDING(0x88ef),
	MAX_DUAL_SOURCE_DRAW_BUFFERS(0x88fc),
	MAX_ARRAY_TEXTURE_LAYERS(0x88ff),
	MIN_PROGRAM_TEXEL_OFFSET(0x8904),
	MAX_PROGRAM_TEXEL_OFFSET(0x8905),
	SAMPLER_BINDING(0x8919),
	FRAGMENT_SHADER_ATI(0x8920),
	UNIFORM_BUFFER_BINDING(0x8a28),
	UNIFORM_BUFFER_START(0x8a29),
	UNIFORM_BUFFER_SIZE(0x8a2a),
	MAX_VERTEX_UNIFORM_BLOCKS(0x8a2b),
	MAX_GEOMETRY_UNIFORM_BLOCKS(0x8a2c),
	MAX_FRAGMENT_UNIFORM_BLOCKS(0x8a2d),
	MAX_COMBINED_UNIFORM_BLOCKS(0x8a2e),
	MAX_UNIFORM_BUFFER_BINDINGS(0x8a2f),
	MAX_UNIFORM_BLOCK_SIZE(0x8a30),
	MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS(0x8a31),
	MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS(0x8a32),
	MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS(0x8a33),
	UNIFORM_BUFFER_OFFSET_ALIGNMENT(0x8a34),
	MAX_FRAGMENT_UNIFORM_COMPONENTS(0x8b49),
	MAX_VERTEX_UNIFORM_COMPONENTS(0x8b4a),
	MAX_VARYING_FLOATS(0x8b4b),
	MAX_VERTEX_TEXTURE_IMAGE_UNITS(0x8b4c),
	MAX_COMBINED_TEXTURE_IMAGE_UNITS(0x8b4d),
	FRAGMENT_SHADER_DERIVATIVE_HINT(0x8b8b),
	CURRENT_PROGRAM(0x8b8d),
	IMPLEMENTATION_COLOR_READ_TYPE(0x8b9a),
	IMPLEMENTATION_COLOR_READ_FORMAT(0x8b9b),
	TEXTURE_BINDING_1D_ARRAY(0x8c1c),
	TEXTURE_BINDING_2D_ARRAY(0x8c1d),
	MAX_GEOMETRY_TEXTURE_IMAGE_UNITS(0x8c29),
	TEXTURE_BUFFER_BINDING(0x8c2a),
	MAX_TEXTURE_BUFFER_SIZE(0x8c2b),
	TEXTURE_BINDING_BUFFER(0x8c2c),
	TRANSFORM_FEEDBACK_BUFFER_START(0x8c84),
	TRANSFORM_FEEDBACK_BUFFER_SIZE(0x8c85),
	TRANSFORM_FEEDBACK_BUFFER_BINDING(0x8c8f),
	MOTION_ESTIMATION_SEARCH_BLOCK_X_QCOM(0x8c90),
	MOTION_ESTIMATION_SEARCH_BLOCK_Y_QCOM(0x8c91),
	STENCIL_BACK_REF(0x8ca3),
	STENCIL_BACK_VALUE_MASK(0x8ca4),
	STENCIL_BACK_WRITEMASK(0x8ca5),
	DRAW_FRAMEBUFFER_BINDING(0x8ca6),
	RENDERBUFFER_BINDING(0x8ca7),
	READ_FRAMEBUFFER_BINDING(0x8caa),
	MAX_COLOR_ATTACHMENTS(0x8cdf),
	TEXTURE_GEN_STR_OES(0x8d60),
	MAX_ELEMENT_INDEX(0x8d6b),
	MAX_GEOMETRY_UNIFORM_COMPONENTS(0x8ddf),
	SHADER_BINARY_FORMATS(0x8df8),
	NUM_SHADER_BINARY_FORMATS(0x8df9),
	SHADER_COMPILER(0x8dfa),
	MAX_VERTEX_UNIFORM_VECTORS(0x8dfb),
	MAX_VARYING_VECTORS(0x8dfc),
	MAX_FRAGMENT_UNIFORM_VECTORS(0x8dfd),
	TIMESTAMP(0x8e28),
	PROVOKING_VERTEX(0x8e4f),
	MAX_SAMPLE_MASK_WORDS(0x8e59),
	MAX_TESS_CONTROL_UNIFORM_BLOCKS(0x8e89),
	MAX_TESS_EVALUATION_UNIFORM_BLOCKS(0x8e8a),
	COPY_READ_BUFFER_BINDING(0x8f36),
	COPY_WRITE_BUFFER_BINDING(0x8f37),
	DRAW_INDIRECT_BUFFER_BINDING(0x8f43),
	FETCH_PER_SAMPLE_ARM(0x8f65),
	FRAGMENT_SHADER_FRAMEBUFFER_FETCH_MRT_ARM(0x8f66),
	FRAGMENT_SHADING_RATE_NON_TRIVIAL_COMBINERS_SUPPORTED_EXT(0x8f6f),
	PRIMITIVE_RESTART_INDEX(0x8f9e),
	MIN_MAP_BUFFER_ALIGNMENT(0x90bc),
	SHADER_STORAGE_BUFFER_BINDING(0x90d3),
	SHADER_STORAGE_BUFFER_START(0x90d4),
	SHADER_STORAGE_BUFFER_SIZE(0x90d5),
	MAX_VERTEX_SHADER_STORAGE_BLOCKS(0x90d6),
	MAX_GEOMETRY_SHADER_STORAGE_BLOCKS(0x90d7),
	MAX_TESS_CONTROL_SHADER_STORAGE_BLOCKS(0x90d8),
	MAX_TESS_EVALUATION_SHADER_STORAGE_BLOCKS(0x90d9),
	MAX_FRAGMENT_SHADER_STORAGE_BLOCKS(0x90da),
	MAX_COMPUTE_SHADER_STORAGE_BLOCKS(0x90db),
	MAX_COMBINED_SHADER_STORAGE_BLOCKS(0x90dc),
	MAX_SHADER_STORAGE_BUFFER_BINDINGS(0x90dd),
	SHADER_STORAGE_BUFFER_OFFSET_ALIGNMENT(0x90df),
	MAX_COMPUTE_WORK_GROUP_INVOCATIONS(0x90eb),
	DISPATCH_INDIRECT_BUFFER_BINDING(0x90ef),
	TEXTURE_BINDING_2D_MULTISAMPLE(0x9104),
	TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY(0x9105),
	MAX_COLOR_TEXTURE_SAMPLES(0x910e),
	MAX_DEPTH_TEXTURE_SAMPLES(0x910f),
	MAX_INTEGER_SAMPLES(0x9110),
	MAX_SERVER_WAIT_TIMEOUT(0x9111),
	MAX_VERTEX_OUTPUT_COMPONENTS(0x9122),
	MAX_GEOMETRY_INPUT_COMPONENTS(0x9123),
	MAX_GEOMETRY_OUTPUT_COMPONENTS(0x9124),
	MAX_FRAGMENT_INPUT_COMPONENTS(0x9125),
	CONTEXT_PROFILE_MASK(0x9126),
	QUERY_BUFFER_BINDING(0x9193),
	TEXTURE_BUFFER_OFFSET_ALIGNMENT(0x919f),
	MAX_COMPUTE_UNIFORM_BLOCKS(0x91bb),
	MAX_COMPUTE_TEXTURE_IMAGE_UNITS(0x91bc),
	MAX_COMPUTE_WORK_GROUP_COUNT(0x91be),
	MAX_COMPUTE_WORK_GROUP_SIZE(0x91bf),
	MAX_VERTEX_ATOMIC_COUNTERS(0x92d2),
	MAX_TESS_CONTROL_ATOMIC_COUNTERS(0x92d3),
	MAX_TESS_EVALUATION_ATOMIC_COUNTERS(0x92d4),
	MAX_GEOMETRY_ATOMIC_COUNTERS(0x92d5),
	MAX_FRAGMENT_ATOMIC_COUNTERS(0x92d6),
	MAX_COMBINED_ATOMIC_COUNTERS(0x92d7),
	MAX_FRAMEBUFFER_WIDTH(0x9315),
	MAX_FRAMEBUFFER_HEIGHT(0x9316),
	MAX_FRAMEBUFFER_LAYERS(0x9317),
	MAX_FRAMEBUFFER_SAMPLES(0x9318),
	NUM_DEVICE_UUIDS_EXT(0x9596),
	DEVICE_UUID_EXT(0x9597),
	DRIVER_UUID_EXT(0x9598),
	DEVICE_LUID_EXT(0x9599),
	DEVICE_NODE_MASK_EXT(0x959a),
	SHADING_RATE_IMAGE_PER_PRIMITIVE_NV(0x95b1),
	SHADING_RATE_IMAGE_PALETTE_COUNT_NV(0x95b2),
	MAX_TIMELINE_SEMAPHORE_VALUE_DIFFERENCE_NV(0x95b6),
	FRAMEBUFFER_FETCH_NONCOHERENT_QCOM(0x96a2),
	SHADING_RATE_QCOM(0x96a4),
	SHADING_RATE_EXT(0x96d0),
	MIN_FRAGMENT_SHADING_RATE_ATTACHMENT_TEXEL_WIDTH_EXT(0x96d7),
	MAX_FRAGMENT_SHADING_RATE_ATTACHMENT_TEXEL_WIDTH_EXT(0x96d8),
	MIN_FRAGMENT_SHADING_RATE_ATTACHMENT_TEXEL_HEIGHT_EXT(0x96d9),
	MAX_FRAGMENT_SHADING_RATE_ATTACHMENT_TEXEL_HEIGHT_EXT(0x96da),
	MAX_FRAGMENT_SHADING_RATE_ATTACHMENT_TEXEL_ASPECT_RATIO_EXT(0x96db),
	MAX_FRAGMENT_SHADING_RATE_ATTACHMENT_LAYERS_EXT(0x96dc),
	FRAGMENT_SHADING_RATE_WITH_SHADER_DEPTH_STENCIL_WRITES_SUPPORTED_EXT(0x96dd),
	FRAGMENT_SHADING_RATE_WITH_SAMPLE_MASK_SUPPORTED_EXT(0x96de),
	FRAGMENT_SHADING_RATE_ATTACHMENT_WITH_DEFAULT_FRAMEBUFFER_SUPPORTED_EXT(0x96df),
	SHADER_CORE_COUNT_ARM(0x96f0),
	SHADER_CORE_ACTIVE_COUNT_ARM(0x96f1),
	SHADER_CORE_PRESENT_MASK_ARM(0x96f2),
	SHADER_CORE_MAX_WARP_COUNT_ARM(0x96f3),
	SHADER_CORE_PIXEL_RATE_ARM(0x96f4),
	SHADER_CORE_TEXEL_RATE_ARM(0x96f5),
	SHADER_CORE_FMA_RATE_ARM(0x96f6);
	
	private final int glEnum;

	GLGetPName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLGetPName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLGetPName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0xb00 -> CURRENT_COLOR;
			case 0xb01 -> CURRENT_INDEX;
			case 0xb02 -> CURRENT_NORMAL;
			case 0xb03 -> CURRENT_TEXTURE_COORDS;
			case 0xb04 -> CURRENT_RASTER_COLOR;
			case 0xb05 -> CURRENT_RASTER_INDEX;
			case 0xb06 -> CURRENT_RASTER_TEXTURE_COORDS;
			case 0xb07 -> CURRENT_RASTER_POSITION;
			case 0xb08 -> CURRENT_RASTER_POSITION_VALID;
			case 0xb09 -> CURRENT_RASTER_DISTANCE;
			case 0xb10 -> POINT_SMOOTH;
			case 0xb11 -> POINT_SIZE;
			case 0xb12 -> POINT_SIZE_RANGE;
			case 0xb13 -> POINT_SIZE_GRANULARITY;
			case 0xb20 -> LINE_SMOOTH;
			case 0xb21 -> LINE_WIDTH;
			case 0xb22 -> LINE_WIDTH_RANGE;
			case 0xb23 -> LINE_WIDTH_GRANULARITY;
			case 0xb24 -> LINE_STIPPLE;
			case 0xb25 -> LINE_STIPPLE_PATTERN;
			case 0xb26 -> LINE_STIPPLE_REPEAT;
			case 0xb30 -> LIST_MODE;
			case 0xb31 -> MAX_LIST_NESTING;
			case 0xb32 -> LIST_BASE;
			case 0xb33 -> LIST_INDEX;
			case 0xb40 -> POLYGON_MODE;
			case 0xb41 -> POLYGON_SMOOTH;
			case 0xb42 -> POLYGON_STIPPLE;
			case 0xb43 -> EDGE_FLAG;
			case 0xb44 -> CULL_FACE;
			case 0xb45 -> CULL_FACE_MODE;
			case 0xb46 -> FRONT_FACE;
			case 0xb50 -> LIGHTING;
			case 0xb51 -> LIGHT_MODEL_LOCAL_VIEWER;
			case 0xb52 -> LIGHT_MODEL_TWO_SIDE;
			case 0xb53 -> LIGHT_MODEL_AMBIENT;
			case 0xb54 -> SHADE_MODEL;
			case 0xb55 -> COLOR_MATERIAL_FACE;
			case 0xb56 -> COLOR_MATERIAL_PARAMETER;
			case 0xb57 -> COLOR_MATERIAL;
			case 0xb60 -> FOG;
			case 0xb61 -> FOG_INDEX;
			case 0xb62 -> FOG_DENSITY;
			case 0xb63 -> FOG_START;
			case 0xb64 -> FOG_END;
			case 0xb65 -> FOG_MODE;
			case 0xb66 -> FOG_COLOR;
			case 0xb70 -> DEPTH_RANGE;
			case 0xb71 -> DEPTH_TEST;
			case 0xb72 -> DEPTH_WRITEMASK;
			case 0xb73 -> DEPTH_CLEAR_VALUE;
			case 0xb74 -> DEPTH_FUNC;
			case 0xb80 -> ACCUM_CLEAR_VALUE;
			case 0xb90 -> STENCIL_TEST;
			case 0xb91 -> STENCIL_CLEAR_VALUE;
			case 0xb92 -> STENCIL_FUNC;
			case 0xb93 -> STENCIL_VALUE_MASK;
			case 0xb94 -> STENCIL_FAIL;
			case 0xb95 -> STENCIL_PASS_DEPTH_FAIL;
			case 0xb96 -> STENCIL_PASS_DEPTH_PASS;
			case 0xb97 -> STENCIL_REF;
			case 0xb98 -> STENCIL_WRITEMASK;
			case 0xba0 -> MATRIX_MODE;
			case 0xba1 -> NORMALIZE;
			case 0xba2 -> VIEWPORT;
			case 0xba3 -> MODELVIEW_STACK_DEPTH;
			case 0xba4 -> PROJECTION_STACK_DEPTH;
			case 0xba5 -> TEXTURE_STACK_DEPTH;
			case 0xba6 -> MODELVIEW_MATRIX;
			case 0xba7 -> PROJECTION_MATRIX;
			case 0xba8 -> TEXTURE_MATRIX;
			case 0xbb0 -> ATTRIB_STACK_DEPTH;
			case 0xbb1 -> CLIENT_ATTRIB_STACK_DEPTH;
			case 0xbc0 -> ALPHA_TEST;
			case 0xbc1 -> ALPHA_TEST_FUNC;
			case 0xbc2 -> ALPHA_TEST_REF;
			case 0xbd0 -> DITHER;
			case 0xbe0 -> BLEND_DST;
			case 0xbe1 -> BLEND_SRC;
			case 0xbe2 -> BLEND;
			case 0xbf0 -> LOGIC_OP_MODE;
			case 0xbf1 -> INDEX_LOGIC_OP;
			case 0xbf2 -> COLOR_LOGIC_OP;
			case 0xc00 -> AUX_BUFFERS;
			case 0xc01 -> DRAW_BUFFER;
			case 0xc02 -> READ_BUFFER;
			case 0xc10 -> SCISSOR_BOX;
			case 0xc11 -> SCISSOR_TEST;
			case 0xc20 -> INDEX_CLEAR_VALUE;
			case 0xc21 -> INDEX_WRITEMASK;
			case 0xc22 -> COLOR_CLEAR_VALUE;
			case 0xc23 -> COLOR_WRITEMASK;
			case 0xc30 -> INDEX_MODE;
			case 0xc31 -> RGBA_MODE;
			case 0xc32 -> DOUBLEBUFFER;
			case 0xc33 -> STEREO;
			case 0xc40 -> RENDER_MODE;
			case 0xc50 -> PERSPECTIVE_CORRECTION_HINT;
			case 0xc51 -> POINT_SMOOTH_HINT;
			case 0xc52 -> LINE_SMOOTH_HINT;
			case 0xc53 -> POLYGON_SMOOTH_HINT;
			case 0xc54 -> FOG_HINT;
			case 0xc60 -> TEXTURE_GEN_S;
			case 0xc61 -> TEXTURE_GEN_T;
			case 0xc62 -> TEXTURE_GEN_R;
			case 0xc63 -> TEXTURE_GEN_Q;
			case 0xcb0 -> PIXEL_MAP_I_TO_I_SIZE;
			case 0xcb1 -> PIXEL_MAP_S_TO_S_SIZE;
			case 0xcb2 -> PIXEL_MAP_I_TO_R_SIZE;
			case 0xcb3 -> PIXEL_MAP_I_TO_G_SIZE;
			case 0xcb4 -> PIXEL_MAP_I_TO_B_SIZE;
			case 0xcb5 -> PIXEL_MAP_I_TO_A_SIZE;
			case 0xcb6 -> PIXEL_MAP_R_TO_R_SIZE;
			case 0xcb7 -> PIXEL_MAP_G_TO_G_SIZE;
			case 0xcb8 -> PIXEL_MAP_B_TO_B_SIZE;
			case 0xcb9 -> PIXEL_MAP_A_TO_A_SIZE;
			case 0xcf0 -> UNPACK_SWAP_BYTES;
			case 0xcf1 -> UNPACK_LSB_FIRST;
			case 0xcf2 -> UNPACK_ROW_LENGTH;
			case 0xcf3 -> UNPACK_SKIP_ROWS;
			case 0xcf4 -> UNPACK_SKIP_PIXELS;
			case 0xcf5 -> UNPACK_ALIGNMENT;
			case 0xd00 -> PACK_SWAP_BYTES;
			case 0xd01 -> PACK_LSB_FIRST;
			case 0xd02 -> PACK_ROW_LENGTH;
			case 0xd03 -> PACK_SKIP_ROWS;
			case 0xd04 -> PACK_SKIP_PIXELS;
			case 0xd05 -> PACK_ALIGNMENT;
			case 0xd10 -> MAP_COLOR;
			case 0xd11 -> MAP_STENCIL;
			case 0xd12 -> INDEX_SHIFT;
			case 0xd13 -> INDEX_OFFSET;
			case 0xd14 -> RED_SCALE;
			case 0xd15 -> RED_BIAS;
			case 0xd16 -> ZOOM_X;
			case 0xd17 -> ZOOM_Y;
			case 0xd18 -> GREEN_SCALE;
			case 0xd19 -> GREEN_BIAS;
			case 0xd1a -> BLUE_SCALE;
			case 0xd1b -> BLUE_BIAS;
			case 0xd1c -> ALPHA_SCALE;
			case 0xd1d -> ALPHA_BIAS;
			case 0xd1e -> DEPTH_SCALE;
			case 0xd1f -> DEPTH_BIAS;
			case 0xd30 -> MAX_EVAL_ORDER;
			case 0xd31 -> MAX_LIGHTS;
			case 0xd32 -> MAX_CLIP_PLANES;
			case 0xd33 -> MAX_TEXTURE_SIZE;
			case 0xd34 -> MAX_PIXEL_MAP_TABLE;
			case 0xd35 -> MAX_ATTRIB_STACK_DEPTH;
			case 0xd36 -> MAX_MODELVIEW_STACK_DEPTH;
			case 0xd37 -> MAX_NAME_STACK_DEPTH;
			case 0xd38 -> MAX_PROJECTION_STACK_DEPTH;
			case 0xd39 -> MAX_TEXTURE_STACK_DEPTH;
			case 0xd3a -> MAX_VIEWPORT_DIMS;
			case 0xd3b -> MAX_CLIENT_ATTRIB_STACK_DEPTH;
			case 0xd50 -> SUBPIXEL_BITS;
			case 0xd51 -> INDEX_BITS;
			case 0xd52 -> RED_BITS;
			case 0xd53 -> GREEN_BITS;
			case 0xd54 -> BLUE_BITS;
			case 0xd55 -> ALPHA_BITS;
			case 0xd56 -> DEPTH_BITS;
			case 0xd57 -> STENCIL_BITS;
			case 0xd58 -> ACCUM_RED_BITS;
			case 0xd59 -> ACCUM_GREEN_BITS;
			case 0xd5a -> ACCUM_BLUE_BITS;
			case 0xd5b -> ACCUM_ALPHA_BITS;
			case 0xd70 -> NAME_STACK_DEPTH;
			case 0xd80 -> AUTO_NORMAL;
			case 0xd90 -> MAP1_COLOR_4;
			case 0xd91 -> MAP1_INDEX;
			case 0xd92 -> MAP1_NORMAL;
			case 0xd93 -> MAP1_TEXTURE_COORD_1;
			case 0xd94 -> MAP1_TEXTURE_COORD_2;
			case 0xd95 -> MAP1_TEXTURE_COORD_3;
			case 0xd96 -> MAP1_TEXTURE_COORD_4;
			case 0xd97 -> MAP1_VERTEX_3;
			case 0xd98 -> MAP1_VERTEX_4;
			case 0xdb0 -> MAP2_COLOR_4;
			case 0xdb1 -> MAP2_INDEX;
			case 0xdb2 -> MAP2_NORMAL;
			case 0xdb3 -> MAP2_TEXTURE_COORD_1;
			case 0xdb4 -> MAP2_TEXTURE_COORD_2;
			case 0xdb5 -> MAP2_TEXTURE_COORD_3;
			case 0xdb6 -> MAP2_TEXTURE_COORD_4;
			case 0xdb7 -> MAP2_VERTEX_3;
			case 0xdb8 -> MAP2_VERTEX_4;
			case 0xdd0 -> MAP1_GRID_DOMAIN;
			case 0xdd1 -> MAP1_GRID_SEGMENTS;
			case 0xdd2 -> MAP2_GRID_DOMAIN;
			case 0xdd3 -> MAP2_GRID_SEGMENTS;
			case 0xde0 -> TEXTURE_1D;
			case 0xde1 -> TEXTURE_2D;
			case 0xdf1 -> FEEDBACK_BUFFER_SIZE;
			case 0xdf2 -> FEEDBACK_BUFFER_TYPE;
			case 0xdf4 -> SELECTION_BUFFER_SIZE;
			case 0x2a00 -> POLYGON_OFFSET_UNITS;
			case 0x2a01 -> POLYGON_OFFSET_POINT;
			case 0x2a02 -> POLYGON_OFFSET_LINE;
			case 0x3000 -> CLIP_PLANE0;
			case 0x3001 -> CLIP_PLANE1;
			case 0x3002 -> CLIP_PLANE2;
			case 0x3003 -> CLIP_PLANE3;
			case 0x3004 -> CLIP_PLANE4;
			case 0x3005 -> CLIP_PLANE5;
			case 0x4000 -> LIGHT0;
			case 0x4001 -> LIGHT1;
			case 0x4002 -> LIGHT2;
			case 0x4003 -> LIGHT3;
			case 0x4004 -> LIGHT4;
			case 0x4005 -> LIGHT5;
			case 0x4006 -> LIGHT6;
			case 0x4007 -> LIGHT7;
			case 0x8005 -> BLEND_COLOR;
			case 0x8009 -> BLEND_EQUATION;
			case 0x800e -> PACK_CMYK_HINT_EXT;
			case 0x800f -> UNPACK_CMYK_HINT_EXT;
			case 0x8010 -> CONVOLUTION_1D;
			case 0x8011 -> CONVOLUTION_2D;
			case 0x8012 -> SEPARABLE_2D;
			case 0x801c -> POST_CONVOLUTION_RED_SCALE;
			case 0x801d -> POST_CONVOLUTION_GREEN_SCALE;
			case 0x801e -> POST_CONVOLUTION_BLUE_SCALE;
			case 0x801f -> POST_CONVOLUTION_ALPHA_SCALE;
			case 0x8020 -> POST_CONVOLUTION_RED_BIAS;
			case 0x8021 -> POST_CONVOLUTION_GREEN_BIAS;
			case 0x8022 -> POST_CONVOLUTION_BLUE_BIAS;
			case 0x8023 -> POST_CONVOLUTION_ALPHA_BIAS;
			case 0x8024 -> HISTOGRAM;
			case 0x802e -> MINMAX;
			case 0x8037 -> POLYGON_OFFSET_FILL;
			case 0x8038 -> POLYGON_OFFSET_FACTOR;
			case 0x8039 -> POLYGON_OFFSET_BIAS_EXT;
			case 0x803a -> RESCALE_NORMAL;
			case 0x8068 -> TEXTURE_BINDING_1D;
			case 0x8069 -> TEXTURE_BINDING_2D;
			case 0x806a -> TEXTURE_3D_BINDING_EXT;
			case 0x806b -> PACK_SKIP_IMAGES;
			case 0x806c -> PACK_IMAGE_HEIGHT;
			case 0x806d -> UNPACK_SKIP_IMAGES;
			case 0x806e -> UNPACK_IMAGE_HEIGHT;
			case 0x806f -> TEXTURE_3D;
			case 0x8073 -> MAX_3D_TEXTURE_SIZE;
			case 0x8074 -> VERTEX_ARRAY;
			case 0x8075 -> NORMAL_ARRAY;
			case 0x8076 -> COLOR_ARRAY;
			case 0x8077 -> INDEX_ARRAY;
			case 0x8078 -> TEXTURE_COORD_ARRAY;
			case 0x8079 -> EDGE_FLAG_ARRAY;
			case 0x807a -> VERTEX_ARRAY_SIZE;
			case 0x807b -> VERTEX_ARRAY_TYPE;
			case 0x807c -> VERTEX_ARRAY_STRIDE;
			case 0x807d -> VERTEX_ARRAY_COUNT_EXT;
			case 0x807e -> NORMAL_ARRAY_TYPE;
			case 0x807f -> NORMAL_ARRAY_STRIDE;
			case 0x8080 -> NORMAL_ARRAY_COUNT_EXT;
			case 0x8081 -> COLOR_ARRAY_SIZE;
			case 0x8082 -> COLOR_ARRAY_TYPE;
			case 0x8083 -> COLOR_ARRAY_STRIDE;
			case 0x8084 -> COLOR_ARRAY_COUNT_EXT;
			case 0x8085 -> INDEX_ARRAY_TYPE;
			case 0x8086 -> INDEX_ARRAY_STRIDE;
			case 0x8087 -> INDEX_ARRAY_COUNT_EXT;
			case 0x8088 -> TEXTURE_COORD_ARRAY_SIZE;
			case 0x8089 -> TEXTURE_COORD_ARRAY_TYPE;
			case 0x808a -> TEXTURE_COORD_ARRAY_STRIDE;
			case 0x808b -> TEXTURE_COORD_ARRAY_COUNT_EXT;
			case 0x808c -> EDGE_FLAG_ARRAY_STRIDE;
			case 0x808d -> EDGE_FLAG_ARRAY_COUNT_EXT;
			case 0x8094 -> INTERLACE_SGIX;
			case 0x8096 -> DETAIL_TEXTURE_2D_BINDING_SGIS;
			case 0x809d -> MULTISAMPLE_SGIS;
			case 0x809e -> SAMPLE_ALPHA_TO_MASK_SGIS;
			case 0x809f -> SAMPLE_ALPHA_TO_ONE_SGIS;
			case 0x80a0 -> SAMPLE_MASK_SGIS;
			case 0x80a8 -> SAMPLE_BUFFERS;
			case 0x80a9 -> SAMPLES;
			case 0x80aa -> SAMPLE_COVERAGE_VALUE;
			case 0x80ab -> SAMPLE_COVERAGE_INVERT;
			case 0x80ac -> SAMPLE_PATTERN_SGIS;
			case 0x80b1 -> COLOR_MATRIX;
			case 0x80b2 -> COLOR_MATRIX_STACK_DEPTH;
			case 0x80b3 -> MAX_COLOR_MATRIX_STACK_DEPTH;
			case 0x80b4 -> POST_COLOR_MATRIX_RED_SCALE;
			case 0x80b5 -> POST_COLOR_MATRIX_GREEN_SCALE;
			case 0x80b6 -> POST_COLOR_MATRIX_BLUE_SCALE;
			case 0x80b7 -> POST_COLOR_MATRIX_ALPHA_SCALE;
			case 0x80b8 -> POST_COLOR_MATRIX_RED_BIAS;
			case 0x80b9 -> POST_COLOR_MATRIX_GREEN_BIAS;
			case 0x80ba -> POST_COLOR_MATRIX_BLUE_BIAS;
			case 0x80bb -> POST_COLOR_MATRIX_ALPHA_BIAS;
			case 0x80bc -> TEXTURE_COLOR_TABLE_SGI;
			case 0x80c8 -> BLEND_DST_RGB;
			case 0x80c9 -> BLEND_SRC_RGB;
			case 0x80ca -> BLEND_DST_ALPHA;
			case 0x80cb -> BLEND_SRC_ALPHA;
			case 0x80d0 -> COLOR_TABLE;
			case 0x80d1 -> POST_CONVOLUTION_COLOR_TABLE;
			case 0x80d2 -> POST_COLOR_MATRIX_COLOR_TABLE;
			case 0x80e8 -> MAX_ELEMENTS_VERTICES;
			case 0x80e9 -> MAX_ELEMENTS_INDICES;
			case 0x80ef -> PARAMETER_BUFFER_BINDING;
			case 0x8126 -> POINT_SIZE_MIN;
			case 0x8127 -> POINT_SIZE_MAX;
			case 0x8128 -> POINT_FADE_THRESHOLD_SIZE;
			case 0x8129 -> DISTANCE_ATTENUATION_EXT;
			case 0x812b -> FOG_FUNC_POINTS_SGIS;
			case 0x812c -> MAX_FOG_FUNC_POINTS_SGIS;
			case 0x8130 -> PACK_SKIP_VOLUMES_SGIS;
			case 0x8131 -> PACK_IMAGE_DEPTH_SGIS;
			case 0x8132 -> UNPACK_SKIP_VOLUMES_SGIS;
			case 0x8133 -> UNPACK_IMAGE_DEPTH_SGIS;
			case 0x8134 -> TEXTURE_4D_SGIS;
			case 0x8138 -> MAX_4D_TEXTURE_SIZE_SGIS;
			case 0x8139 -> PIXEL_TEX_GEN_SGIX;
			case 0x813e -> PIXEL_TILE_BEST_ALIGNMENT_SGIX;
			case 0x813f -> PIXEL_TILE_CACHE_INCREMENT_SGIX;
			case 0x8140 -> PIXEL_TILE_WIDTH_SGIX;
			case 0x8141 -> PIXEL_TILE_HEIGHT_SGIX;
			case 0x8142 -> PIXEL_TILE_GRID_WIDTH_SGIX;
			case 0x8143 -> PIXEL_TILE_GRID_HEIGHT_SGIX;
			case 0x8144 -> PIXEL_TILE_GRID_DEPTH_SGIX;
			case 0x8145 -> PIXEL_TILE_CACHE_SIZE_SGIX;
			case 0x8148 -> SPRITE_SGIX;
			case 0x8149 -> SPRITE_MODE_SGIX;
			case 0x814a -> SPRITE_AXIS_SGIX;
			case 0x814b -> SPRITE_TRANSLATION_SGIX;
			case 0x814f -> TEXTURE_4D_BINDING_SGIS;
			case 0x8177 -> MAX_CLIPMAP_DEPTH_SGIX;
			case 0x8178 -> MAX_CLIPMAP_VIRTUAL_DEPTH_SGIX;
			case 0x817b -> POST_TEXTURE_FILTER_BIAS_RANGE_SGIX;
			case 0x817c -> POST_TEXTURE_FILTER_SCALE_RANGE_SGIX;
			case 0x817d -> REFERENCE_PLANE_SGIX;
			case 0x817e -> REFERENCE_PLANE_EQUATION_SGIX;
			case 0x817f -> IR_INSTRUMENT1_SGIX;
			case 0x8181 -> INSTRUMENT_MEASUREMENTS_SGIX;
			case 0x8183 -> CALLIGRAPHIC_FRAGMENT_SGIX;
			case 0x818b -> FRAMEZOOM_SGIX;
			case 0x818c -> FRAMEZOOM_FACTOR_SGIX;
			case 0x818d -> MAX_FRAMEZOOM_FACTOR_SGIX;
			case 0x8192 -> GENERATE_MIPMAP_HINT_SGIS;
			case 0x8196 -> DEFORMATIONS_MASK_SGIX;
			case 0x8198 -> FOG_OFFSET_SGIX;
			case 0x8199 -> FOG_OFFSET_VALUE_SGIX;
			case 0x81f8 -> LIGHT_MODEL_COLOR_CONTROL;
			case 0x81fb -> SHARED_TEXTURE_PALETTE_EXT;
			case 0x821b -> MAJOR_VERSION;
			case 0x821c -> MINOR_VERSION;
			case 0x821d -> NUM_EXTENSIONS;
			case 0x821e -> CONTEXT_FLAGS;
			case 0x825a -> PROGRAM_PIPELINE_BINDING;
			case 0x825b -> MAX_VIEWPORTS;
			case 0x825c -> VIEWPORT_SUBPIXEL_BITS;
			case 0x825d -> VIEWPORT_BOUNDS_RANGE;
			case 0x825e -> LAYER_PROVOKING_VERTEX;
			case 0x825f -> VIEWPORT_INDEX_PROVOKING_VERTEX;
			case 0x8263 -> MAX_COMPUTE_UNIFORM_COMPONENTS;
			case 0x8264 -> MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS;
			case 0x8265 -> MAX_COMPUTE_ATOMIC_COUNTERS;
			case 0x8266 -> MAX_COMBINED_COMPUTE_UNIFORM_COMPONENTS;
			case 0x826c -> MAX_DEBUG_GROUP_STACK_DEPTH;
			case 0x826d -> DEBUG_GROUP_STACK_DEPTH;
			case 0x826e -> MAX_UNIFORM_LOCATIONS;
			case 0x82d6 -> VERTEX_BINDING_DIVISOR;
			case 0x82d7 -> VERTEX_BINDING_OFFSET;
			case 0x82d8 -> VERTEX_BINDING_STRIDE;
			case 0x82d9 -> MAX_VERTEX_ATTRIB_RELATIVE_OFFSET;
			case 0x82da -> MAX_VERTEX_ATTRIB_BINDINGS;
			case 0x82e8 -> MAX_LABEL_LENGTH;
			case 0x8316 -> CONVOLUTION_HINT_SGIX;
			case 0x8329 -> ASYNC_MARKER_SGIX;
			case 0x832b -> PIXEL_TEX_GEN_MODE_SGIX;
			case 0x832c -> ASYNC_HISTOGRAM_SGIX;
			case 0x832d -> MAX_ASYNC_HISTOGRAM_SGIX;
			case 0x8353 -> PIXEL_TEXTURE_SGIS;
			case 0x835c -> ASYNC_TEX_IMAGE_SGIX;
			case 0x835d -> ASYNC_DRAW_PIXELS_SGIX;
			case 0x835e -> ASYNC_READ_PIXELS_SGIX;
			case 0x835f -> MAX_ASYNC_TEX_IMAGE_SGIX;
			case 0x8360 -> MAX_ASYNC_DRAW_PIXELS_SGIX;
			case 0x8361 -> MAX_ASYNC_READ_PIXELS_SGIX;
			case 0x83ee -> VERTEX_PRECLIP_SGIX;
			case 0x83ef -> VERTEX_PRECLIP_HINT_SGIX;
			case 0x8400 -> FRAGMENT_LIGHTING_SGIX;
			case 0x8401 -> FRAGMENT_COLOR_MATERIAL_SGIX;
			case 0x8402 -> FRAGMENT_COLOR_MATERIAL_FACE_SGIX;
			case 0x8403 -> FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX;
			case 0x8404 -> MAX_FRAGMENT_LIGHTS_SGIX;
			case 0x8405 -> MAX_ACTIVE_LIGHTS_SGIX;
			case 0x8407 -> LIGHT_ENV_MODE_SGIX;
			case 0x8408 -> FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX;
			case 0x8409 -> FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX;
			case 0x840a -> FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX;
			case 0x840b -> FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX;
			case 0x840c -> FRAGMENT_LIGHT0_SGIX;
			case 0x842e -> PACK_RESAMPLE_SGIX;
			case 0x842f -> UNPACK_RESAMPLE_SGIX;
			case 0x846d -> ALIASED_POINT_SIZE_RANGE;
			case 0x846e -> ALIASED_LINE_WIDTH_RANGE;
			case 0x84e0 -> ACTIVE_TEXTURE;
			case 0x84e8 -> MAX_RENDERBUFFER_SIZE;
			case 0x84ef -> TEXTURE_COMPRESSION_HINT;
			case 0x84f6 -> TEXTURE_BINDING_RECTANGLE;
			case 0x84f8 -> MAX_RECTANGLE_TEXTURE_SIZE;
			case 0x84fd -> MAX_TEXTURE_LOD_BIAS;
			case 0x8514 -> TEXTURE_BINDING_CUBE_MAP;
			case 0x851c -> MAX_CUBE_MAP_TEXTURE_SIZE;
			case 0x855a -> FOG_DISTANCE_MODE_NV;
			case 0x85a0 -> PACK_SUBSAMPLE_RATE_SGIX;
			case 0x85a1 -> UNPACK_SUBSAMPLE_RATE_SGIX;
			case 0x85b5 -> VERTEX_ARRAY_BINDING;
			case 0x8642 -> PROGRAM_POINT_SIZE;
			case 0x86a2 -> NUM_COMPRESSED_TEXTURE_FORMATS;
			case 0x86a3 -> COMPRESSED_TEXTURE_FORMATS;
			case 0x87fe -> NUM_PROGRAM_BINARY_FORMATS;
			case 0x87ff -> PROGRAM_BINARY_FORMATS;
			case 0x8800 -> STENCIL_BACK_FUNC;
			case 0x8801 -> STENCIL_BACK_FAIL;
			case 0x8802 -> STENCIL_BACK_PASS_DEPTH_FAIL;
			case 0x8803 -> STENCIL_BACK_PASS_DEPTH_PASS;
			case 0x8824 -> MAX_DRAW_BUFFERS;
			case 0x883d -> BLEND_EQUATION_ALPHA;
			case 0x8869 -> MAX_VERTEX_ATTRIBS;
			case 0x8872 -> MAX_TEXTURE_IMAGE_UNITS;
			case 0x8894 -> ARRAY_BUFFER_BINDING;
			case 0x8895 -> ELEMENT_ARRAY_BUFFER_BINDING;
			case 0x88ed -> PIXEL_PACK_BUFFER_BINDING;
			case 0x88ef -> PIXEL_UNPACK_BUFFER_BINDING;
			case 0x88fc -> MAX_DUAL_SOURCE_DRAW_BUFFERS;
			case 0x88ff -> MAX_ARRAY_TEXTURE_LAYERS;
			case 0x8904 -> MIN_PROGRAM_TEXEL_OFFSET;
			case 0x8905 -> MAX_PROGRAM_TEXEL_OFFSET;
			case 0x8919 -> SAMPLER_BINDING;
			case 0x8920 -> FRAGMENT_SHADER_ATI;
			case 0x8a28 -> UNIFORM_BUFFER_BINDING;
			case 0x8a29 -> UNIFORM_BUFFER_START;
			case 0x8a2a -> UNIFORM_BUFFER_SIZE;
			case 0x8a2b -> MAX_VERTEX_UNIFORM_BLOCKS;
			case 0x8a2c -> MAX_GEOMETRY_UNIFORM_BLOCKS;
			case 0x8a2d -> MAX_FRAGMENT_UNIFORM_BLOCKS;
			case 0x8a2e -> MAX_COMBINED_UNIFORM_BLOCKS;
			case 0x8a2f -> MAX_UNIFORM_BUFFER_BINDINGS;
			case 0x8a30 -> MAX_UNIFORM_BLOCK_SIZE;
			case 0x8a31 -> MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS;
			case 0x8a32 -> MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS;
			case 0x8a33 -> MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS;
			case 0x8a34 -> UNIFORM_BUFFER_OFFSET_ALIGNMENT;
			case 0x8b49 -> MAX_FRAGMENT_UNIFORM_COMPONENTS;
			case 0x8b4a -> MAX_VERTEX_UNIFORM_COMPONENTS;
			case 0x8b4b -> MAX_VARYING_FLOATS;
			case 0x8b4c -> MAX_VERTEX_TEXTURE_IMAGE_UNITS;
			case 0x8b4d -> MAX_COMBINED_TEXTURE_IMAGE_UNITS;
			case 0x8b8b -> FRAGMENT_SHADER_DERIVATIVE_HINT;
			case 0x8b8d -> CURRENT_PROGRAM;
			case 0x8b9a -> IMPLEMENTATION_COLOR_READ_TYPE;
			case 0x8b9b -> IMPLEMENTATION_COLOR_READ_FORMAT;
			case 0x8c1c -> TEXTURE_BINDING_1D_ARRAY;
			case 0x8c1d -> TEXTURE_BINDING_2D_ARRAY;
			case 0x8c29 -> MAX_GEOMETRY_TEXTURE_IMAGE_UNITS;
			case 0x8c2a -> TEXTURE_BUFFER_BINDING;
			case 0x8c2b -> MAX_TEXTURE_BUFFER_SIZE;
			case 0x8c2c -> TEXTURE_BINDING_BUFFER;
			case 0x8c84 -> TRANSFORM_FEEDBACK_BUFFER_START;
			case 0x8c85 -> TRANSFORM_FEEDBACK_BUFFER_SIZE;
			case 0x8c8f -> TRANSFORM_FEEDBACK_BUFFER_BINDING;
			case 0x8c90 -> MOTION_ESTIMATION_SEARCH_BLOCK_X_QCOM;
			case 0x8c91 -> MOTION_ESTIMATION_SEARCH_BLOCK_Y_QCOM;
			case 0x8ca3 -> STENCIL_BACK_REF;
			case 0x8ca4 -> STENCIL_BACK_VALUE_MASK;
			case 0x8ca5 -> STENCIL_BACK_WRITEMASK;
			case 0x8ca6 -> DRAW_FRAMEBUFFER_BINDING;
			case 0x8ca7 -> RENDERBUFFER_BINDING;
			case 0x8caa -> READ_FRAMEBUFFER_BINDING;
			case 0x8cdf -> MAX_COLOR_ATTACHMENTS;
			case 0x8d60 -> TEXTURE_GEN_STR_OES;
			case 0x8d6b -> MAX_ELEMENT_INDEX;
			case 0x8ddf -> MAX_GEOMETRY_UNIFORM_COMPONENTS;
			case 0x8df8 -> SHADER_BINARY_FORMATS;
			case 0x8df9 -> NUM_SHADER_BINARY_FORMATS;
			case 0x8dfa -> SHADER_COMPILER;
			case 0x8dfb -> MAX_VERTEX_UNIFORM_VECTORS;
			case 0x8dfc -> MAX_VARYING_VECTORS;
			case 0x8dfd -> MAX_FRAGMENT_UNIFORM_VECTORS;
			case 0x8e28 -> TIMESTAMP;
			case 0x8e4f -> PROVOKING_VERTEX;
			case 0x8e59 -> MAX_SAMPLE_MASK_WORDS;
			case 0x8e89 -> MAX_TESS_CONTROL_UNIFORM_BLOCKS;
			case 0x8e8a -> MAX_TESS_EVALUATION_UNIFORM_BLOCKS;
			case 0x8f36 -> COPY_READ_BUFFER_BINDING;
			case 0x8f37 -> COPY_WRITE_BUFFER_BINDING;
			case 0x8f43 -> DRAW_INDIRECT_BUFFER_BINDING;
			case 0x8f65 -> FETCH_PER_SAMPLE_ARM;
			case 0x8f66 -> FRAGMENT_SHADER_FRAMEBUFFER_FETCH_MRT_ARM;
			case 0x8f6f -> FRAGMENT_SHADING_RATE_NON_TRIVIAL_COMBINERS_SUPPORTED_EXT;
			case 0x8f9e -> PRIMITIVE_RESTART_INDEX;
			case 0x90bc -> MIN_MAP_BUFFER_ALIGNMENT;
			case 0x90d3 -> SHADER_STORAGE_BUFFER_BINDING;
			case 0x90d4 -> SHADER_STORAGE_BUFFER_START;
			case 0x90d5 -> SHADER_STORAGE_BUFFER_SIZE;
			case 0x90d6 -> MAX_VERTEX_SHADER_STORAGE_BLOCKS;
			case 0x90d7 -> MAX_GEOMETRY_SHADER_STORAGE_BLOCKS;
			case 0x90d8 -> MAX_TESS_CONTROL_SHADER_STORAGE_BLOCKS;
			case 0x90d9 -> MAX_TESS_EVALUATION_SHADER_STORAGE_BLOCKS;
			case 0x90da -> MAX_FRAGMENT_SHADER_STORAGE_BLOCKS;
			case 0x90db -> MAX_COMPUTE_SHADER_STORAGE_BLOCKS;
			case 0x90dc -> MAX_COMBINED_SHADER_STORAGE_BLOCKS;
			case 0x90dd -> MAX_SHADER_STORAGE_BUFFER_BINDINGS;
			case 0x90df -> SHADER_STORAGE_BUFFER_OFFSET_ALIGNMENT;
			case 0x90eb -> MAX_COMPUTE_WORK_GROUP_INVOCATIONS;
			case 0x90ef -> DISPATCH_INDIRECT_BUFFER_BINDING;
			case 0x9104 -> TEXTURE_BINDING_2D_MULTISAMPLE;
			case 0x9105 -> TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY;
			case 0x910e -> MAX_COLOR_TEXTURE_SAMPLES;
			case 0x910f -> MAX_DEPTH_TEXTURE_SAMPLES;
			case 0x9110 -> MAX_INTEGER_SAMPLES;
			case 0x9111 -> MAX_SERVER_WAIT_TIMEOUT;
			case 0x9122 -> MAX_VERTEX_OUTPUT_COMPONENTS;
			case 0x9123 -> MAX_GEOMETRY_INPUT_COMPONENTS;
			case 0x9124 -> MAX_GEOMETRY_OUTPUT_COMPONENTS;
			case 0x9125 -> MAX_FRAGMENT_INPUT_COMPONENTS;
			case 0x9126 -> CONTEXT_PROFILE_MASK;
			case 0x9193 -> QUERY_BUFFER_BINDING;
			case 0x919f -> TEXTURE_BUFFER_OFFSET_ALIGNMENT;
			case 0x91bb -> MAX_COMPUTE_UNIFORM_BLOCKS;
			case 0x91bc -> MAX_COMPUTE_TEXTURE_IMAGE_UNITS;
			case 0x91be -> MAX_COMPUTE_WORK_GROUP_COUNT;
			case 0x91bf -> MAX_COMPUTE_WORK_GROUP_SIZE;
			case 0x92d2 -> MAX_VERTEX_ATOMIC_COUNTERS;
			case 0x92d3 -> MAX_TESS_CONTROL_ATOMIC_COUNTERS;
			case 0x92d4 -> MAX_TESS_EVALUATION_ATOMIC_COUNTERS;
			case 0x92d5 -> MAX_GEOMETRY_ATOMIC_COUNTERS;
			case 0x92d6 -> MAX_FRAGMENT_ATOMIC_COUNTERS;
			case 0x92d7 -> MAX_COMBINED_ATOMIC_COUNTERS;
			case 0x9315 -> MAX_FRAMEBUFFER_WIDTH;
			case 0x9316 -> MAX_FRAMEBUFFER_HEIGHT;
			case 0x9317 -> MAX_FRAMEBUFFER_LAYERS;
			case 0x9318 -> MAX_FRAMEBUFFER_SAMPLES;
			case 0x9596 -> NUM_DEVICE_UUIDS_EXT;
			case 0x9597 -> DEVICE_UUID_EXT;
			case 0x9598 -> DRIVER_UUID_EXT;
			case 0x9599 -> DEVICE_LUID_EXT;
			case 0x959a -> DEVICE_NODE_MASK_EXT;
			case 0x95b1 -> SHADING_RATE_IMAGE_PER_PRIMITIVE_NV;
			case 0x95b2 -> SHADING_RATE_IMAGE_PALETTE_COUNT_NV;
			case 0x95b6 -> MAX_TIMELINE_SEMAPHORE_VALUE_DIFFERENCE_NV;
			case 0x96a2 -> FRAMEBUFFER_FETCH_NONCOHERENT_QCOM;
			case 0x96a4 -> SHADING_RATE_QCOM;
			case 0x96d0 -> SHADING_RATE_EXT;
			case 0x96d7 -> MIN_FRAGMENT_SHADING_RATE_ATTACHMENT_TEXEL_WIDTH_EXT;
			case 0x96d8 -> MAX_FRAGMENT_SHADING_RATE_ATTACHMENT_TEXEL_WIDTH_EXT;
			case 0x96d9 -> MIN_FRAGMENT_SHADING_RATE_ATTACHMENT_TEXEL_HEIGHT_EXT;
			case 0x96da -> MAX_FRAGMENT_SHADING_RATE_ATTACHMENT_TEXEL_HEIGHT_EXT;
			case 0x96db -> MAX_FRAGMENT_SHADING_RATE_ATTACHMENT_TEXEL_ASPECT_RATIO_EXT;
			case 0x96dc -> MAX_FRAGMENT_SHADING_RATE_ATTACHMENT_LAYERS_EXT;
			case 0x96dd -> FRAGMENT_SHADING_RATE_WITH_SHADER_DEPTH_STENCIL_WRITES_SUPPORTED_EXT;
			case 0x96de -> FRAGMENT_SHADING_RATE_WITH_SAMPLE_MASK_SUPPORTED_EXT;
			case 0x96df -> FRAGMENT_SHADING_RATE_ATTACHMENT_WITH_DEFAULT_FRAMEBUFFER_SUPPORTED_EXT;
			case 0x96f0 -> SHADER_CORE_COUNT_ARM;
			case 0x96f1 -> SHADER_CORE_ACTIVE_COUNT_ARM;
			case 0x96f2 -> SHADER_CORE_PRESENT_MASK_ARM;
			case 0x96f3 -> SHADER_CORE_MAX_WARP_COUNT_ARM;
			case 0x96f4 -> SHADER_CORE_PIXEL_RATE_ARM;
			case 0x96f5 -> SHADER_CORE_TEXEL_RATE_ARM;
			case 0x96f6 -> SHADER_CORE_FMA_RATE_ARM;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLGetPName");
		};
	}
}