package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLGetPointervPName implements GLEnum {
	FEEDBACK_BUFFER_POINTER(0xdf0),
	SELECTION_BUFFER_POINTER(0xdf3),
	VERTEX_ARRAY_POINTER(0x808e),
	NORMAL_ARRAY_POINTER(0x808f),
	COLOR_ARRAY_POINTER(0x8090),
	INDEX_ARRAY_POINTER(0x8091),
	TEXTURE_COORD_ARRAY_POINTER(0x8092),
	EDGE_FLAG_ARRAY_POINTER(0x8093),
	INSTRUMENT_BUFFER_POINTER_SGIX(0x8180),
	DEBUG_CALLBACK_FUNCTION(0x8244),
	DEBUG_CALLBACK_USER_PARAM(0x8245);
	
	private final int glEnum;

	GLGetPointervPName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLGetPointervPName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLGetPointervPName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0xdf0 -> FEEDBACK_BUFFER_POINTER;
			case 0xdf3 -> SELECTION_BUFFER_POINTER;
			case 0x808e -> VERTEX_ARRAY_POINTER;
			case 0x808f -> NORMAL_ARRAY_POINTER;
			case 0x8090 -> COLOR_ARRAY_POINTER;
			case 0x8091 -> INDEX_ARRAY_POINTER;
			case 0x8092 -> TEXTURE_COORD_ARRAY_POINTER;
			case 0x8093 -> EDGE_FLAG_ARRAY_POINTER;
			case 0x8180 -> INSTRUMENT_BUFFER_POINTER_SGIX;
			case 0x8244 -> DEBUG_CALLBACK_FUNCTION;
			case 0x8245 -> DEBUG_CALLBACK_USER_PARAM;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLGetPointervPName");
		};
	}
}