package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLHintMode implements GLEnum {
	DONT_CARE(0x1100),
	FASTEST(0x1101),
	NICEST(0x1102);
	
	private final int glEnum;

	GLHintMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLHintMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLHintMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1100 -> DONT_CARE;
			case 0x1101 -> FASTEST;
			case 0x1102 -> NICEST;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLHintMode");
		};
	}
}