package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLHintTargetPGI implements GLEnum {
	VERTEX_DATA_HINT_PGI(0x1a22a),
	VERTEX_CONSISTENT_HINT_PGI(0x1a22b),
	MATERIAL_SIDE_HINT_PGI(0x1a22c),
	MAX_VERTEX_HINT_PGI(0x1a22d);
	
	private final int glEnum;

	GLHintTargetPGI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLHintTargetPGI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLHintTargetPGI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1a22a -> VERTEX_DATA_HINT_PGI;
			case 0x1a22b -> VERTEX_CONSISTENT_HINT_PGI;
			case 0x1a22c -> MATERIAL_SIDE_HINT_PGI;
			case 0x1a22d -> MAX_VERTEX_HINT_PGI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLHintTargetPGI");
		};
	}
}