package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLInternalFormatPName implements GLEnum {
	SAMPLES(0x80a9),
	GENERATE_MIPMAP(0x8191),
	INTERNALFORMAT_SUPPORTED(0x826f),
	INTERNALFORMAT_PREFERRED(0x8270),
	INTERNALFORMAT_RED_SIZE(0x8271),
	INTERNALFORMAT_GREEN_SIZE(0x8272),
	INTERNALFORMAT_BLUE_SIZE(0x8273),
	INTERNALFORMAT_ALPHA_SIZE(0x8274),
	INTERNALFORMAT_DEPTH_SIZE(0x8275),
	INTERNALFORMAT_STENCIL_SIZE(0x8276),
	INTERNALFORMAT_SHARED_SIZE(0x8277),
	INTERNALFORMAT_RED_TYPE(0x8278),
	INTERNALFORMAT_GREEN_TYPE(0x8279),
	INTERNALFORMAT_BLUE_TYPE(0x827a),
	INTERNALFORMAT_ALPHA_TYPE(0x827b),
	INTERNALFORMAT_DEPTH_TYPE(0x827c),
	INTERNALFORMAT_STENCIL_TYPE(0x827d),
	MAX_WIDTH(0x827e),
	MAX_HEIGHT(0x827f),
	MAX_DEPTH(0x8280),
	MAX_LAYERS(0x8281),
	COLOR_COMPONENTS(0x8283),
	COLOR_RENDERABLE(0x8286),
	DEPTH_RENDERABLE(0x8287),
	STENCIL_RENDERABLE(0x8288),
	FRAMEBUFFER_RENDERABLE(0x8289),
	FRAMEBUFFER_RENDERABLE_LAYERED(0x828a),
	FRAMEBUFFER_BLEND(0x828b),
	READ_PIXELS(0x828c),
	READ_PIXELS_FORMAT(0x828d),
	READ_PIXELS_TYPE(0x828e),
	TEXTURE_IMAGE_FORMAT(0x828f),
	TEXTURE_IMAGE_TYPE(0x8290),
	GET_TEXTURE_IMAGE_FORMAT(0x8291),
	GET_TEXTURE_IMAGE_TYPE(0x8292),
	MIPMAP(0x8293),
	AUTO_GENERATE_MIPMAP(0x8295),
	COLOR_ENCODING(0x8296),
	SRGB_READ(0x8297),
	SRGB_WRITE(0x8298),
	FILTER(0x829a),
	VERTEX_TEXTURE(0x829b),
	TESS_CONTROL_TEXTURE(0x829c),
	TESS_EVALUATION_TEXTURE(0x829d),
	GEOMETRY_TEXTURE(0x829e),
	FRAGMENT_TEXTURE(0x829f),
	COMPUTE_TEXTURE(0x82a0),
	TEXTURE_SHADOW(0x82a1),
	TEXTURE_GATHER(0x82a2),
	TEXTURE_GATHER_SHADOW(0x82a3),
	SHADER_IMAGE_LOAD(0x82a4),
	SHADER_IMAGE_STORE(0x82a5),
	SHADER_IMAGE_ATOMIC(0x82a6),
	IMAGE_TEXEL_SIZE(0x82a7),
	IMAGE_COMPATIBILITY_CLASS(0x82a8),
	IMAGE_PIXEL_FORMAT(0x82a9),
	IMAGE_PIXEL_TYPE(0x82aa),
	SIMULTANEOUS_TEXTURE_AND_DEPTH_TEST(0x82ac),
	SIMULTANEOUS_TEXTURE_AND_STENCIL_TEST(0x82ad),
	SIMULTANEOUS_TEXTURE_AND_DEPTH_WRITE(0x82ae),
	SIMULTANEOUS_TEXTURE_AND_STENCIL_WRITE(0x82af),
	TEXTURE_COMPRESSED_BLOCK_WIDTH(0x82b1),
	TEXTURE_COMPRESSED_BLOCK_HEIGHT(0x82b2),
	TEXTURE_COMPRESSED_BLOCK_SIZE(0x82b3),
	CLEAR_BUFFER(0x82b4),
	TEXTURE_VIEW(0x82b5),
	VIEW_COMPATIBILITY_CLASS(0x82b6),
	TEXTURE_COMPRESSED(0x86a1),
	NUM_SURFACE_COMPRESSION_FIXED_RATES_EXT(0x8f6e),
	IMAGE_FORMAT_COMPATIBILITY_TYPE(0x90c7),
	CLEAR_TEXTURE(0x9365),
	NUM_SAMPLE_COUNTS(0x9380);
	
	private final int glEnum;

	GLInternalFormatPName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLInternalFormatPName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLInternalFormatPName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x80a9 -> SAMPLES;
			case 0x8191 -> GENERATE_MIPMAP;
			case 0x826f -> INTERNALFORMAT_SUPPORTED;
			case 0x8270 -> INTERNALFORMAT_PREFERRED;
			case 0x8271 -> INTERNALFORMAT_RED_SIZE;
			case 0x8272 -> INTERNALFORMAT_GREEN_SIZE;
			case 0x8273 -> INTERNALFORMAT_BLUE_SIZE;
			case 0x8274 -> INTERNALFORMAT_ALPHA_SIZE;
			case 0x8275 -> INTERNALFORMAT_DEPTH_SIZE;
			case 0x8276 -> INTERNALFORMAT_STENCIL_SIZE;
			case 0x8277 -> INTERNALFORMAT_SHARED_SIZE;
			case 0x8278 -> INTERNALFORMAT_RED_TYPE;
			case 0x8279 -> INTERNALFORMAT_GREEN_TYPE;
			case 0x827a -> INTERNALFORMAT_BLUE_TYPE;
			case 0x827b -> INTERNALFORMAT_ALPHA_TYPE;
			case 0x827c -> INTERNALFORMAT_DEPTH_TYPE;
			case 0x827d -> INTERNALFORMAT_STENCIL_TYPE;
			case 0x827e -> MAX_WIDTH;
			case 0x827f -> MAX_HEIGHT;
			case 0x8280 -> MAX_DEPTH;
			case 0x8281 -> MAX_LAYERS;
			case 0x8283 -> COLOR_COMPONENTS;
			case 0x8286 -> COLOR_RENDERABLE;
			case 0x8287 -> DEPTH_RENDERABLE;
			case 0x8288 -> STENCIL_RENDERABLE;
			case 0x8289 -> FRAMEBUFFER_RENDERABLE;
			case 0x828a -> FRAMEBUFFER_RENDERABLE_LAYERED;
			case 0x828b -> FRAMEBUFFER_BLEND;
			case 0x828c -> READ_PIXELS;
			case 0x828d -> READ_PIXELS_FORMAT;
			case 0x828e -> READ_PIXELS_TYPE;
			case 0x828f -> TEXTURE_IMAGE_FORMAT;
			case 0x8290 -> TEXTURE_IMAGE_TYPE;
			case 0x8291 -> GET_TEXTURE_IMAGE_FORMAT;
			case 0x8292 -> GET_TEXTURE_IMAGE_TYPE;
			case 0x8293 -> MIPMAP;
			case 0x8295 -> AUTO_GENERATE_MIPMAP;
			case 0x8296 -> COLOR_ENCODING;
			case 0x8297 -> SRGB_READ;
			case 0x8298 -> SRGB_WRITE;
			case 0x829a -> FILTER;
			case 0x829b -> VERTEX_TEXTURE;
			case 0x829c -> TESS_CONTROL_TEXTURE;
			case 0x829d -> TESS_EVALUATION_TEXTURE;
			case 0x829e -> GEOMETRY_TEXTURE;
			case 0x829f -> FRAGMENT_TEXTURE;
			case 0x82a0 -> COMPUTE_TEXTURE;
			case 0x82a1 -> TEXTURE_SHADOW;
			case 0x82a2 -> TEXTURE_GATHER;
			case 0x82a3 -> TEXTURE_GATHER_SHADOW;
			case 0x82a4 -> SHADER_IMAGE_LOAD;
			case 0x82a5 -> SHADER_IMAGE_STORE;
			case 0x82a6 -> SHADER_IMAGE_ATOMIC;
			case 0x82a7 -> IMAGE_TEXEL_SIZE;
			case 0x82a8 -> IMAGE_COMPATIBILITY_CLASS;
			case 0x82a9 -> IMAGE_PIXEL_FORMAT;
			case 0x82aa -> IMAGE_PIXEL_TYPE;
			case 0x82ac -> SIMULTANEOUS_TEXTURE_AND_DEPTH_TEST;
			case 0x82ad -> SIMULTANEOUS_TEXTURE_AND_STENCIL_TEST;
			case 0x82ae -> SIMULTANEOUS_TEXTURE_AND_DEPTH_WRITE;
			case 0x82af -> SIMULTANEOUS_TEXTURE_AND_STENCIL_WRITE;
			case 0x82b1 -> TEXTURE_COMPRESSED_BLOCK_WIDTH;
			case 0x82b2 -> TEXTURE_COMPRESSED_BLOCK_HEIGHT;
			case 0x82b3 -> TEXTURE_COMPRESSED_BLOCK_SIZE;
			case 0x82b4 -> CLEAR_BUFFER;
			case 0x82b5 -> TEXTURE_VIEW;
			case 0x82b6 -> VIEW_COMPATIBILITY_CLASS;
			case 0x86a1 -> TEXTURE_COMPRESSED;
			case 0x8f6e -> NUM_SURFACE_COMPRESSION_FIXED_RATES_EXT;
			case 0x90c7 -> IMAGE_FORMAT_COMPATIBILITY_TYPE;
			case 0x9365 -> CLEAR_TEXTURE;
			case 0x9380 -> NUM_SAMPLE_COUNTS;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLInternalFormatPName");
		};
	}
}