package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLLightModelParameter implements GLEnum {
	LIGHT_MODEL_LOCAL_VIEWER(0xb51),
	LIGHT_MODEL_TWO_SIDE(0xb52),
	LIGHT_MODEL_AMBIENT(0xb53),
	LIGHT_MODEL_COLOR_CONTROL(0x81f8);
	
	private final int glEnum;

	GLLightModelParameter(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLLightModelParameter> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLLightModelParameter fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0xb51 -> LIGHT_MODEL_LOCAL_VIEWER;
			case 0xb52 -> LIGHT_MODEL_TWO_SIDE;
			case 0xb53 -> LIGHT_MODEL_AMBIENT;
			case 0x81f8 -> LIGHT_MODEL_COLOR_CONTROL;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLLightModelParameter");
		};
	}
}