package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLLightName implements GLEnum {
	LIGHT0(0x4000),
	LIGHT1(0x4001),
	LIGHT2(0x4002),
	LIGHT3(0x4003),
	LIGHT4(0x4004),
	LIGHT5(0x4005),
	LIGHT6(0x4006),
	LIGHT7(0x4007),
	FRAGMENT_LIGHT0_SGIX(0x840c),
	FRAGMENT_LIGHT1_SGIX(0x840d),
	FRAGMENT_LIGHT2_SGIX(0x840e),
	FRAGMENT_LIGHT3_SGIX(0x840f),
	FRAGMENT_LIGHT4_SGIX(0x8410),
	FRAGMENT_LIGHT5_SGIX(0x8411),
	FRAGMENT_LIGHT6_SGIX(0x8412),
	FRAGMENT_LIGHT7_SGIX(0x8413);
	
	private final int glEnum;

	GLLightName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLLightName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLLightName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x4000 -> LIGHT0;
			case 0x4001 -> LIGHT1;
			case 0x4002 -> LIGHT2;
			case 0x4003 -> LIGHT3;
			case 0x4004 -> LIGHT4;
			case 0x4005 -> LIGHT5;
			case 0x4006 -> LIGHT6;
			case 0x4007 -> LIGHT7;
			case 0x840c -> FRAGMENT_LIGHT0_SGIX;
			case 0x840d -> FRAGMENT_LIGHT1_SGIX;
			case 0x840e -> FRAGMENT_LIGHT2_SGIX;
			case 0x840f -> FRAGMENT_LIGHT3_SGIX;
			case 0x8410 -> FRAGMENT_LIGHT4_SGIX;
			case 0x8411 -> FRAGMENT_LIGHT5_SGIX;
			case 0x8412 -> FRAGMENT_LIGHT6_SGIX;
			case 0x8413 -> FRAGMENT_LIGHT7_SGIX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLLightName");
		};
	}
}