package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLMapTextureFormatINTEL implements GLEnum {
	LAYOUT_DEFAULT_INTEL(0x0),
	LAYOUT_LINEAR_INTEL(0x1),
	LAYOUT_LINEAR_CPU_CACHED_INTEL(0x2);
	
	private final int glEnum;

	GLMapTextureFormatINTEL(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLMapTextureFormatINTEL> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLMapTextureFormatINTEL fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> LAYOUT_DEFAULT_INTEL;
			case 0x1 -> LAYOUT_LINEAR_INTEL;
			case 0x2 -> LAYOUT_LINEAR_CPU_CACHED_INTEL;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLMapTextureFormatINTEL");
		};
	}
}