package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLMatrixMode implements GLEnum {
	MODELVIEW(0x1700),
	PROJECTION(0x1701),
	TEXTURE(0x1702);
	
	private final int glEnum;

	GLMatrixMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLMatrixMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLMatrixMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1700 -> MODELVIEW;
			case 0x1701 -> PROJECTION;
			case 0x1702 -> TEXTURE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLMatrixMode");
		};
	}
}