package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLOcclusionQueryEventMaskAMD implements GLEnum {
	QUERY_DEPTH_PASS_EVENT_BIT_AMD(0x1),
	QUERY_DEPTH_FAIL_EVENT_BIT_AMD(0x2),
	QUERY_STENCIL_FAIL_EVENT_BIT_AMD(0x4),
	QUERY_DEPTH_BOUNDS_FAIL_EVENT_BIT_AMD(0x8),
	QUERY_ALL_EVENT_BITS_AMD(0xffffffff);
	
	private final int glEnum;

	GLOcclusionQueryEventMaskAMD(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLOcclusionQueryEventMaskAMD> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLOcclusionQueryEventMaskAMD fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1 -> QUERY_DEPTH_PASS_EVENT_BIT_AMD;
			case 0x2 -> QUERY_DEPTH_FAIL_EVENT_BIT_AMD;
			case 0x4 -> QUERY_STENCIL_FAIL_EVENT_BIT_AMD;
			case 0x8 -> QUERY_DEPTH_BOUNDS_FAIL_EVENT_BIT_AMD;
			case 0xffffffff -> QUERY_ALL_EVENT_BITS_AMD;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLOcclusionQueryEventMaskAMD");
		};
	}
}