package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPNTrianglesPNameATI implements GLEnum {
	PN_TRIANGLES_POINT_MODE_ATI(0x87f2),
	PN_TRIANGLES_NORMAL_MODE_ATI(0x87f3),
	PN_TRIANGLES_TESSELATION_LEVEL_ATI(0x87f4);
	
	private final int glEnum;

	GLPNTrianglesPNameATI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPNTrianglesPNameATI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPNTrianglesPNameATI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x87f2 -> PN_TRIANGLES_POINT_MODE_ATI;
			case 0x87f3 -> PN_TRIANGLES_NORMAL_MODE_ATI;
			case 0x87f4 -> PN_TRIANGLES_TESSELATION_LEVEL_ATI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPNTrianglesPNameATI");
		};
	}
}