package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPathHandleMissingGlyphs implements GLEnum {
	SKIP_MISSING_GLYPH_NV(0x90a9),
	USE_MISSING_GLYPH_NV(0x90aa);
	
	private final int glEnum;

	GLPathHandleMissingGlyphs(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPathHandleMissingGlyphs> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPathHandleMissingGlyphs fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x90a9 -> SKIP_MISSING_GLYPH_NV;
			case 0x90aa -> USE_MISSING_GLYPH_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPathHandleMissingGlyphs");
		};
	}
}