package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPathTransformType implements GLEnum {
	NONE(0x0),
	TRANSLATE_X_NV(0x908e),
	TRANSLATE_Y_NV(0x908f),
	TRANSLATE_2D_NV(0x9090),
	TRANSLATE_3D_NV(0x9091),
	AFFINE_2D_NV(0x9092),
	AFFINE_3D_NV(0x9094),
	TRANSPOSE_AFFINE_2D_NV(0x9096),
	TRANSPOSE_AFFINE_3D_NV(0x9098);
	
	private final int glEnum;

	GLPathTransformType(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPathTransformType> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPathTransformType fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> NONE;
			case 0x908e -> TRANSLATE_X_NV;
			case 0x908f -> TRANSLATE_Y_NV;
			case 0x9090 -> TRANSLATE_2D_NV;
			case 0x9091 -> TRANSLATE_3D_NV;
			case 0x9092 -> AFFINE_2D_NV;
			case 0x9094 -> AFFINE_3D_NV;
			case 0x9096 -> TRANSPOSE_AFFINE_2D_NV;
			case 0x9098 -> TRANSPOSE_AFFINE_3D_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPathTransformType");
		};
	}
}