package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPixelStoreSubsampleRate implements GLEnum {
	PIXEL_SUBSAMPLE_4444_SGIX(0x85a2),
	PIXEL_SUBSAMPLE_2424_SGIX(0x85a3),
	PIXEL_SUBSAMPLE_4242_SGIX(0x85a4);
	
	private final int glEnum;

	GLPixelStoreSubsampleRate(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPixelStoreSubsampleRate> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPixelStoreSubsampleRate fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x85a2 -> PIXEL_SUBSAMPLE_4444_SGIX;
			case 0x85a3 -> PIXEL_SUBSAMPLE_2424_SGIX;
			case 0x85a4 -> PIXEL_SUBSAMPLE_4242_SGIX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPixelStoreSubsampleRate");
		};
	}
}