package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLRenderbufferParameterName implements GLEnum {
	RENDERBUFFER_COVERAGE_SAMPLES_NV(0x8cab),
	RENDERBUFFER_WIDTH(0x8d42),
	RENDERBUFFER_HEIGHT(0x8d43),
	RENDERBUFFER_INTERNAL_FORMAT(0x8d44),
	RENDERBUFFER_RED_SIZE(0x8d50),
	RENDERBUFFER_GREEN_SIZE(0x8d51),
	RENDERBUFFER_BLUE_SIZE(0x8d52),
	RENDERBUFFER_ALPHA_SIZE(0x8d53),
	RENDERBUFFER_DEPTH_SIZE(0x8d54),
	RENDERBUFFER_STENCIL_SIZE(0x8d55),
	RENDERBUFFER_COLOR_SAMPLES_NV(0x8e10),
	RENDERBUFFER_SAMPLES_IMG(0x9133),
	RENDERBUFFER_STORAGE_SAMPLES_AMD(0x91b2);
	
	private final int glEnum;

	GLRenderbufferParameterName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLRenderbufferParameterName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLRenderbufferParameterName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8cab -> RENDERBUFFER_COVERAGE_SAMPLES_NV;
			case 0x8d42 -> RENDERBUFFER_WIDTH;
			case 0x8d43 -> RENDERBUFFER_HEIGHT;
			case 0x8d44 -> RENDERBUFFER_INTERNAL_FORMAT;
			case 0x8d50 -> RENDERBUFFER_RED_SIZE;
			case 0x8d51 -> RENDERBUFFER_GREEN_SIZE;
			case 0x8d52 -> RENDERBUFFER_BLUE_SIZE;
			case 0x8d53 -> RENDERBUFFER_ALPHA_SIZE;
			case 0x8d54 -> RENDERBUFFER_DEPTH_SIZE;
			case 0x8d55 -> RENDERBUFFER_STENCIL_SIZE;
			case 0x8e10 -> RENDERBUFFER_COLOR_SAMPLES_NV;
			case 0x9133 -> RENDERBUFFER_SAMPLES_IMG;
			case 0x91b2 -> RENDERBUFFER_STORAGE_SAMPLES_AMD;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLRenderbufferParameterName");
		};
	}
}