package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLRenderbufferTarget implements GLEnum {
	RENDERBUFFER(0x8d41);
	
	private final int glEnum;

	GLRenderbufferTarget(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLRenderbufferTarget> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLRenderbufferTarget fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8d41 -> RENDERBUFFER;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLRenderbufferTarget");
		};
	}
}