package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLSamplePatternSGIS implements GLEnum {
	_1PASS_EXT(0x80a1),
	_2PASS_0_EXT(0x80a2),
	_2PASS_1_EXT(0x80a3),
	_4PASS_0_EXT(0x80a4),
	_4PASS_1_EXT(0x80a5),
	_4PASS_2_EXT(0x80a6),
	_4PASS_3_EXT(0x80a7);
	
	private final int glEnum;

	GLSamplePatternSGIS(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLSamplePatternSGIS> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLSamplePatternSGIS fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x80a1 -> _1PASS_EXT;
			case 0x80a2 -> _2PASS_0_EXT;
			case 0x80a3 -> _2PASS_1_EXT;
			case 0x80a4 -> _4PASS_0_EXT;
			case 0x80a5 -> _4PASS_1_EXT;
			case 0x80a6 -> _4PASS_2_EXT;
			case 0x80a7 -> _4PASS_3_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLSamplePatternSGIS");
		};
	}
}