package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLShaderBinaryFormat implements GLEnum {
	SGX_BINARY_IMG(0x8c0a),
	MALI_SHADER_BINARY_ARM(0x8f60),
	SHADER_BINARY_VIV(0x8fc4),
	SHADER_BINARY_DMP(0x9250),
	GCCSO_SHADER_BINARY_FJ(0x9260),
	SHADER_BINARY_FORMAT_SPIR_V(0x9551);
	
	private final int glEnum;

	GLShaderBinaryFormat(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLShaderBinaryFormat> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLShaderBinaryFormat fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8c0a -> SGX_BINARY_IMG;
			case 0x8f60 -> MALI_SHADER_BINARY_ARM;
			case 0x8fc4 -> SHADER_BINARY_VIV;
			case 0x9250 -> SHADER_BINARY_DMP;
			case 0x9260 -> GCCSO_SHADER_BINARY_FJ;
			case 0x9551 -> SHADER_BINARY_FORMAT_SPIR_V;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLShaderBinaryFormat");
		};
	}
}