package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLShaderParameterName implements GLEnum {
	SHADER_TYPE(0x8b4f),
	DELETE_STATUS(0x8b80),
	COMPILE_STATUS(0x8b81),
	INFO_LOG_LENGTH(0x8b84),
	SHADER_SOURCE_LENGTH(0x8b88);
	
	private final int glEnum;

	GLShaderParameterName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLShaderParameterName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLShaderParameterName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8b4f -> SHADER_TYPE;
			case 0x8b80 -> DELETE_STATUS;
			case 0x8b81 -> COMPILE_STATUS;
			case 0x8b84 -> INFO_LOG_LENGTH;
			case 0x8b88 -> SHADER_SOURCE_LENGTH;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLShaderParameterName");
		};
	}
}