package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLSyncBehaviorFlags implements GLEnum {
	NONE(0x0);
	
	private final int glEnum;

	GLSyncBehaviorFlags(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLSyncBehaviorFlags> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLSyncBehaviorFlags fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> NONE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLSyncBehaviorFlags");
		};
	}
}