package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTextureLayout implements GLEnum {
	LAYOUT_DEPTH_READ_ONLY_STENCIL_ATTACHMENT_EXT(0x9530),
	LAYOUT_DEPTH_ATTACHMENT_STENCIL_READ_ONLY_EXT(0x9531),
	LAYOUT_GENERAL_EXT(0x958d),
	LAYOUT_COLOR_ATTACHMENT_EXT(0x958e),
	LAYOUT_DEPTH_STENCIL_ATTACHMENT_EXT(0x958f),
	LAYOUT_DEPTH_STENCIL_READ_ONLY_EXT(0x9590),
	LAYOUT_SHADER_READ_ONLY_EXT(0x9591),
	LAYOUT_TRANSFER_SRC_EXT(0x9592),
	LAYOUT_TRANSFER_DST_EXT(0x9593);
	
	private final int glEnum;

	GLTextureLayout(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTextureLayout> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTextureLayout fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x9530 -> LAYOUT_DEPTH_READ_ONLY_STENCIL_ATTACHMENT_EXT;
			case 0x9531 -> LAYOUT_DEPTH_ATTACHMENT_STENCIL_READ_ONLY_EXT;
			case 0x958d -> LAYOUT_GENERAL_EXT;
			case 0x958e -> LAYOUT_COLOR_ATTACHMENT_EXT;
			case 0x958f -> LAYOUT_DEPTH_STENCIL_ATTACHMENT_EXT;
			case 0x9590 -> LAYOUT_DEPTH_STENCIL_READ_ONLY_EXT;
			case 0x9591 -> LAYOUT_SHADER_READ_ONLY_EXT;
			case 0x9592 -> LAYOUT_TRANSFER_SRC_EXT;
			case 0x9593 -> LAYOUT_TRANSFER_DST_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTextureLayout");
		};
	}
}