package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTextureMagFilter implements GLEnum {
	NEAREST(0x2600),
	LINEAR(0x2601),
	LINEAR_DETAIL_SGIS(0x8097),
	LINEAR_DETAIL_ALPHA_SGIS(0x8098),
	LINEAR_DETAIL_COLOR_SGIS(0x8099),
	LINEAR_SHARPEN_SGIS(0x80ad),
	LINEAR_SHARPEN_ALPHA_SGIS(0x80ae),
	LINEAR_SHARPEN_COLOR_SGIS(0x80af),
	FILTER4_SGIS(0x8146),
	PIXEL_TEX_GEN_Q_CEILING_SGIX(0x8184),
	PIXEL_TEX_GEN_Q_ROUND_SGIX(0x8185),
	PIXEL_TEX_GEN_Q_FLOOR_SGIX(0x8186);
	
	private final int glEnum;

	GLTextureMagFilter(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTextureMagFilter> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTextureMagFilter fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x2600 -> NEAREST;
			case 0x2601 -> LINEAR;
			case 0x8097 -> LINEAR_DETAIL_SGIS;
			case 0x8098 -> LINEAR_DETAIL_ALPHA_SGIS;
			case 0x8099 -> LINEAR_DETAIL_COLOR_SGIS;
			case 0x80ad -> LINEAR_SHARPEN_SGIS;
			case 0x80ae -> LINEAR_SHARPEN_ALPHA_SGIS;
			case 0x80af -> LINEAR_SHARPEN_COLOR_SGIS;
			case 0x8146 -> FILTER4_SGIS;
			case 0x8184 -> PIXEL_TEX_GEN_Q_CEILING_SGIX;
			case 0x8185 -> PIXEL_TEX_GEN_Q_ROUND_SGIX;
			case 0x8186 -> PIXEL_TEX_GEN_Q_FLOOR_SGIX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTextureMagFilter");
		};
	}
}