package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTextureMinFilter implements GLEnum {
	NEAREST(0x2600),
	LINEAR(0x2601),
	NEAREST_MIPMAP_NEAREST(0x2700),
	LINEAR_MIPMAP_NEAREST(0x2701),
	NEAREST_MIPMAP_LINEAR(0x2702),
	LINEAR_MIPMAP_LINEAR(0x2703),
	FILTER4_SGIS(0x8146),
	LINEAR_CLIPMAP_LINEAR_SGIX(0x8170),
	PIXEL_TEX_GEN_Q_CEILING_SGIX(0x8184),
	PIXEL_TEX_GEN_Q_ROUND_SGIX(0x8185),
	PIXEL_TEX_GEN_Q_FLOOR_SGIX(0x8186),
	NEAREST_CLIPMAP_NEAREST_SGIX(0x844d),
	NEAREST_CLIPMAP_LINEAR_SGIX(0x844e),
	LINEAR_CLIPMAP_NEAREST_SGIX(0x844f);
	
	private final int glEnum;

	GLTextureMinFilter(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTextureMinFilter> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTextureMinFilter fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x2600 -> NEAREST;
			case 0x2601 -> LINEAR;
			case 0x2700 -> NEAREST_MIPMAP_NEAREST;
			case 0x2701 -> LINEAR_MIPMAP_NEAREST;
			case 0x2702 -> NEAREST_MIPMAP_LINEAR;
			case 0x2703 -> LINEAR_MIPMAP_LINEAR;
			case 0x8146 -> FILTER4_SGIS;
			case 0x8170 -> LINEAR_CLIPMAP_LINEAR_SGIX;
			case 0x8184 -> PIXEL_TEX_GEN_Q_CEILING_SGIX;
			case 0x8185 -> PIXEL_TEX_GEN_Q_ROUND_SGIX;
			case 0x8186 -> PIXEL_TEX_GEN_Q_FLOOR_SGIX;
			case 0x844d -> NEAREST_CLIPMAP_NEAREST_SGIX;
			case 0x844e -> NEAREST_CLIPMAP_LINEAR_SGIX;
			case 0x844f -> LINEAR_CLIPMAP_NEAREST_SGIX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTextureMinFilter");
		};
	}
}