package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTextureNormalModeEXT implements GLEnum {
	PERTURB_EXT(0x85ae);
	
	private final int glEnum;

	GLTextureNormalModeEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTextureNormalModeEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTextureNormalModeEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x85ae -> PERTURB_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTextureNormalModeEXT");
		};
	}
}