package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTextureParameter implements GLEnum {
	TEXTURE_Y_DEGAMMA_QCOM(0x9710),
	TEXTURE_CBCR_DEGAMMA_QCOM(0x9711);
	
	private final int glEnum;

	GLTextureParameter(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTextureParameter> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTextureParameter fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x9710 -> TEXTURE_Y_DEGAMMA_QCOM;
			case 0x9711 -> TEXTURE_CBCR_DEGAMMA_QCOM;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTextureParameter");
		};
	}
}