package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTextureParameterName implements GLEnum {
	TEXTURE_WIDTH(0x1000),
	TEXTURE_HEIGHT(0x1001),
	TEXTURE_INTERNAL_FORMAT(0x1003),
	TEXTURE_BORDER_COLOR(0x1004),
	TEXTURE_BORDER(0x1005),
	TEXTURE_MAG_FILTER(0x2800),
	TEXTURE_MIN_FILTER(0x2801),
	TEXTURE_WRAP_S(0x2802),
	TEXTURE_WRAP_T(0x2803),
	TEXTURE_RED_SIZE(0x805c),
	TEXTURE_GREEN_SIZE(0x805d),
	TEXTURE_BLUE_SIZE(0x805e),
	TEXTURE_ALPHA_SIZE(0x805f),
	TEXTURE_LUMINANCE_SIZE(0x8060),
	TEXTURE_INTENSITY_SIZE(0x8061),
	TEXTURE_PRIORITY(0x8066),
	TEXTURE_RESIDENT(0x8067),
	TEXTURE_DEPTH(0x8071),
	TEXTURE_WRAP_R(0x8072),
	DETAIL_TEXTURE_LEVEL_SGIS(0x809a),
	DETAIL_TEXTURE_MODE_SGIS(0x809b),
	DETAIL_TEXTURE_FUNC_POINTS_SGIS(0x809c),
	SHARPEN_TEXTURE_FUNC_POINTS_SGIS(0x80b0),
	SHADOW_AMBIENT_SGIX(0x80bf),
	DUAL_TEXTURE_SELECT_SGIS(0x8124),
	QUAD_TEXTURE_SELECT_SGIS(0x8125),
	TEXTURE_4DSIZE_SGIS(0x8136),
	TEXTURE_WRAP_Q_SGIS(0x8137),
	TEXTURE_MIN_LOD(0x813a),
	TEXTURE_MAX_LOD(0x813b),
	TEXTURE_BASE_LEVEL(0x813c),
	TEXTURE_MAX_LEVEL(0x813d),
	TEXTURE_FILTER4_SIZE_SGIS(0x8147),
	TEXTURE_CLIPMAP_CENTER_SGIX(0x8171),
	TEXTURE_CLIPMAP_FRAME_SGIX(0x8172),
	TEXTURE_CLIPMAP_OFFSET_SGIX(0x8173),
	TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX(0x8174),
	TEXTURE_CLIPMAP_LOD_OFFSET_SGIX(0x8175),
	TEXTURE_CLIPMAP_DEPTH_SGIX(0x8176),
	POST_TEXTURE_FILTER_BIAS_SGIX(0x8179),
	POST_TEXTURE_FILTER_SCALE_SGIX(0x817a),
	TEXTURE_LOD_BIAS_S_SGIX(0x818e),
	TEXTURE_LOD_BIAS_T_SGIX(0x818f),
	TEXTURE_LOD_BIAS_R_SGIX(0x8190),
	GENERATE_MIPMAP(0x8191),
	TEXTURE_COMPARE_SGIX(0x819a),
	TEXTURE_COMPARE_OPERATOR_SGIX(0x819b),
	TEXTURE_LEQUAL_R_SGIX(0x819c),
	TEXTURE_GEQUAL_R_SGIX(0x819d),
	TEXTURE_MAX_CLAMP_S_SGIX(0x8369),
	TEXTURE_MAX_CLAMP_T_SGIX(0x836a),
	TEXTURE_MAX_CLAMP_R_SGIX(0x836b),
	TEXTURE_MEMORY_LAYOUT_INTEL(0x83ff),
	TEXTURE_MAX_ANISOTROPY(0x84fe),
	TEXTURE_LOD_BIAS(0x8501),
	TEXTURE_COMPARE_MODE(0x884c),
	TEXTURE_COMPARE_FUNC(0x884d),
	TEXTURE_SWIZZLE_R(0x8e42),
	TEXTURE_SWIZZLE_G(0x8e43),
	TEXTURE_SWIZZLE_B(0x8e44),
	TEXTURE_SWIZZLE_A(0x8e45),
	TEXTURE_SWIZZLE_RGBA(0x8e46),
	TEXTURE_UNNORMALIZED_COORDINATES_ARM(0x8f6a),
	DEPTH_STENCIL_TEXTURE_MODE(0x90ea),
	TEXTURE_TILING_EXT(0x9580),
	TEXTURE_FOVEATED_CUTOFF_DENSITY_QCOM(0x96a0);
	
	private final int glEnum;

	GLTextureParameterName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTextureParameterName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTextureParameterName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1000 -> TEXTURE_WIDTH;
			case 0x1001 -> TEXTURE_HEIGHT;
			case 0x1003 -> TEXTURE_INTERNAL_FORMAT;
			case 0x1004 -> TEXTURE_BORDER_COLOR;
			case 0x1005 -> TEXTURE_BORDER;
			case 0x2800 -> TEXTURE_MAG_FILTER;
			case 0x2801 -> TEXTURE_MIN_FILTER;
			case 0x2802 -> TEXTURE_WRAP_S;
			case 0x2803 -> TEXTURE_WRAP_T;
			case 0x805c -> TEXTURE_RED_SIZE;
			case 0x805d -> TEXTURE_GREEN_SIZE;
			case 0x805e -> TEXTURE_BLUE_SIZE;
			case 0x805f -> TEXTURE_ALPHA_SIZE;
			case 0x8060 -> TEXTURE_LUMINANCE_SIZE;
			case 0x8061 -> TEXTURE_INTENSITY_SIZE;
			case 0x8066 -> TEXTURE_PRIORITY;
			case 0x8067 -> TEXTURE_RESIDENT;
			case 0x8071 -> TEXTURE_DEPTH;
			case 0x8072 -> TEXTURE_WRAP_R;
			case 0x809a -> DETAIL_TEXTURE_LEVEL_SGIS;
			case 0x809b -> DETAIL_TEXTURE_MODE_SGIS;
			case 0x809c -> DETAIL_TEXTURE_FUNC_POINTS_SGIS;
			case 0x80b0 -> SHARPEN_TEXTURE_FUNC_POINTS_SGIS;
			case 0x80bf -> SHADOW_AMBIENT_SGIX;
			case 0x8124 -> DUAL_TEXTURE_SELECT_SGIS;
			case 0x8125 -> QUAD_TEXTURE_SELECT_SGIS;
			case 0x8136 -> TEXTURE_4DSIZE_SGIS;
			case 0x8137 -> TEXTURE_WRAP_Q_SGIS;
			case 0x813a -> TEXTURE_MIN_LOD;
			case 0x813b -> TEXTURE_MAX_LOD;
			case 0x813c -> TEXTURE_BASE_LEVEL;
			case 0x813d -> TEXTURE_MAX_LEVEL;
			case 0x8147 -> TEXTURE_FILTER4_SIZE_SGIS;
			case 0x8171 -> TEXTURE_CLIPMAP_CENTER_SGIX;
			case 0x8172 -> TEXTURE_CLIPMAP_FRAME_SGIX;
			case 0x8173 -> TEXTURE_CLIPMAP_OFFSET_SGIX;
			case 0x8174 -> TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX;
			case 0x8175 -> TEXTURE_CLIPMAP_LOD_OFFSET_SGIX;
			case 0x8176 -> TEXTURE_CLIPMAP_DEPTH_SGIX;
			case 0x8179 -> POST_TEXTURE_FILTER_BIAS_SGIX;
			case 0x817a -> POST_TEXTURE_FILTER_SCALE_SGIX;
			case 0x818e -> TEXTURE_LOD_BIAS_S_SGIX;
			case 0x818f -> TEXTURE_LOD_BIAS_T_SGIX;
			case 0x8190 -> TEXTURE_LOD_BIAS_R_SGIX;
			case 0x8191 -> GENERATE_MIPMAP;
			case 0x819a -> TEXTURE_COMPARE_SGIX;
			case 0x819b -> TEXTURE_COMPARE_OPERATOR_SGIX;
			case 0x819c -> TEXTURE_LEQUAL_R_SGIX;
			case 0x819d -> TEXTURE_GEQUAL_R_SGIX;
			case 0x8369 -> TEXTURE_MAX_CLAMP_S_SGIX;
			case 0x836a -> TEXTURE_MAX_CLAMP_T_SGIX;
			case 0x836b -> TEXTURE_MAX_CLAMP_R_SGIX;
			case 0x83ff -> TEXTURE_MEMORY_LAYOUT_INTEL;
			case 0x84fe -> TEXTURE_MAX_ANISOTROPY;
			case 0x8501 -> TEXTURE_LOD_BIAS;
			case 0x884c -> TEXTURE_COMPARE_MODE;
			case 0x884d -> TEXTURE_COMPARE_FUNC;
			case 0x8e42 -> TEXTURE_SWIZZLE_R;
			case 0x8e43 -> TEXTURE_SWIZZLE_G;
			case 0x8e44 -> TEXTURE_SWIZZLE_B;
			case 0x8e45 -> TEXTURE_SWIZZLE_A;
			case 0x8e46 -> TEXTURE_SWIZZLE_RGBA;
			case 0x8f6a -> TEXTURE_UNNORMALIZED_COORDINATES_ARM;
			case 0x90ea -> DEPTH_STENCIL_TEXTURE_MODE;
			case 0x9580 -> TEXTURE_TILING_EXT;
			case 0x96a0 -> TEXTURE_FOVEATED_CUTOFF_DENSITY_QCOM;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTextureParameterName");
		};
	}
}