package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLUniformPName implements GLEnum {
	UNIFORM_TYPE(0x8a37),
	UNIFORM_SIZE(0x8a38),
	UNIFORM_NAME_LENGTH(0x8a39),
	UNIFORM_BLOCK_INDEX(0x8a3a),
	UNIFORM_OFFSET(0x8a3b),
	UNIFORM_ARRAY_STRIDE(0x8a3c),
	UNIFORM_MATRIX_STRIDE(0x8a3d),
	UNIFORM_IS_ROW_MAJOR(0x8a3e),
	UNIFORM_ATOMIC_COUNTER_BUFFER_INDEX(0x92da);
	
	private final int glEnum;

	GLUniformPName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLUniformPName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLUniformPName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8a37 -> UNIFORM_TYPE;
			case 0x8a38 -> UNIFORM_SIZE;
			case 0x8a39 -> UNIFORM_NAME_LENGTH;
			case 0x8a3a -> UNIFORM_BLOCK_INDEX;
			case 0x8a3b -> UNIFORM_OFFSET;
			case 0x8a3c -> UNIFORM_ARRAY_STRIDE;
			case 0x8a3d -> UNIFORM_MATRIX_STRIDE;
			case 0x8a3e -> UNIFORM_IS_ROW_MAJOR;
			case 0x92da -> UNIFORM_ATOMIC_COUNTER_BUFFER_INDEX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLUniformPName");
		};
	}
}