package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexBufferObjectUsage implements GLEnum {
	STREAM_DRAW(0x88e0),
	STREAM_READ(0x88e1),
	STREAM_COPY(0x88e2),
	STATIC_DRAW(0x88e4),
	STATIC_READ(0x88e5),
	STATIC_COPY(0x88e6),
	DYNAMIC_DRAW(0x88e8),
	DYNAMIC_READ(0x88e9),
	DYNAMIC_COPY(0x88ea);
	
	private final int glEnum;

	GLVertexBufferObjectUsage(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexBufferObjectUsage> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexBufferObjectUsage fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x88e0 -> STREAM_DRAW;
			case 0x88e1 -> STREAM_READ;
			case 0x88e2 -> STREAM_COPY;
			case 0x88e4 -> STATIC_DRAW;
			case 0x88e5 -> STATIC_READ;
			case 0x88e6 -> STATIC_COPY;
			case 0x88e8 -> DYNAMIC_DRAW;
			case 0x88e9 -> DYNAMIC_READ;
			case 0x88ea -> DYNAMIC_COPY;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexBufferObjectUsage");
		};
	}
}