package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexProvokingMode implements GLEnum {
	FIRST_VERTEX_CONVENTION(0x8e4d),
	LAST_VERTEX_CONVENTION(0x8e4e);
	
	private final int glEnum;

	GLVertexProvokingMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexProvokingMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexProvokingMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8e4d -> FIRST_VERTEX_CONVENTION;
			case 0x8e4e -> LAST_VERTEX_CONVENTION;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexProvokingMode");
		};
	}
}