package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexShaderStorageTypeEXT implements GLEnum {
	VARIANT_EXT(0x87c1),
	INVARIANT_EXT(0x87c2),
	LOCAL_CONSTANT_EXT(0x87c3),
	LOCAL_EXT(0x87c4);
	
	private final int glEnum;

	GLVertexShaderStorageTypeEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexShaderStorageTypeEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexShaderStorageTypeEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x87c1 -> VARIANT_EXT;
			case 0x87c2 -> INVARIANT_EXT;
			case 0x87c3 -> LOCAL_CONSTANT_EXT;
			case 0x87c4 -> LOCAL_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexShaderStorageTypeEXT");
		};
	}
}