package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexStreamATI implements GLEnum {
	VERTEX_STREAM0_ATI(0x876c),
	VERTEX_STREAM1_ATI(0x876d),
	VERTEX_STREAM2_ATI(0x876e),
	VERTEX_STREAM3_ATI(0x876f),
	VERTEX_STREAM4_ATI(0x8770),
	VERTEX_STREAM5_ATI(0x8771),
	VERTEX_STREAM6_ATI(0x8772),
	VERTEX_STREAM7_ATI(0x8773);
	
	private final int glEnum;

	GLVertexStreamATI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexStreamATI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexStreamATI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x876c -> VERTEX_STREAM0_ATI;
			case 0x876d -> VERTEX_STREAM1_ATI;
			case 0x876e -> VERTEX_STREAM2_ATI;
			case 0x876f -> VERTEX_STREAM3_ATI;
			case 0x8770 -> VERTEX_STREAM4_ATI;
			case 0x8771 -> VERTEX_STREAM5_ATI;
			case 0x8772 -> VERTEX_STREAM6_ATI;
			case 0x8773 -> VERTEX_STREAM7_ATI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexStreamATI");
		};
	}
}