package dev.pfaff.glass.opengl.enums;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public record RawGLEnum(int glEnum) implements GLEnum {
	public static RawGLEnum fromGLEnum(int glEnum) {
		return new RawGLEnum(glEnum);
	}

	@Override
	public String toString() {
		return FMT."RawGLEnum[0x%08x\{glEnum} / \{glEnum}]";
	}

	static IllegalArgumentException newUnrecognizedValueError(int value, String name) {
		return new IllegalArgumentException(STR."Unrecognized value \{new RawGLEnum(value)} for \{name}");
	}
}
