package dev.pfaff.glass.opengl;

import java.lang.foreign.*;
import java.lang.invoke.MethodHandle;
import java.lang.invoke.MethodHandles;
import java.util.List;
import java.util.Map;
import java.util.function.Supplier;

import dev.pfaff.glass.opengl.enums.*;

import static java.lang.foreign.ValueLayout.*;

import static dev.pfaff.glass.opengl.GLParamTypeSets.*;
import static dev.pfaff.glass.opengl.Util.*;

public final class GLLinker {
	public static MethodHandle glAccum(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAccum", MLS_LAccumOp_F(), PS_LAccumOp_F());
	}
	public static MethodHandle glAccumxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAccumxOES", MLS_EI(), PS_EI());
	}
	public static MethodHandle glActiveProgramEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glActiveProgramEXT", MLS_I(), PS_I());
	}
	public static MethodHandle glActiveShaderProgram(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glActiveShaderProgram", MLS_II(), PS_II());
	}
	public static MethodHandle glActiveShaderProgramEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glActiveShaderProgramEXT", MLS_II(), PS_II());
	}
	public static MethodHandle glActiveStencilFaceEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glActiveStencilFaceEXT", MLS_LTriangleFace_(), PS_LTriangleFace_());
	}
	public static MethodHandle glActiveTexture(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glActiveTexture", MLS_LTextureUnit_(), PS_LTextureUnit_());
	}
	public static MethodHandle glActiveTextureARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glActiveTextureARB", MLS_LTextureUnit_(), PS_LTextureUnit_());
	}
	public static MethodHandle glActiveVaryingNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glActiveVaryingNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glAlphaFragmentOp1ATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAlphaFragmentOp1ATI", MLS_LFragmentOp1ATI_IIIII(), PS_LFragmentOp1ATI_IIIII());
	}
	public static MethodHandle glAlphaFragmentOp2ATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAlphaFragmentOp2ATI", MLS_LFragmentOp2ATI_IIIIIIII(), PS_LFragmentOp2ATI_IIIIIIII());
	}
	public static MethodHandle glAlphaFragmentOp3ATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAlphaFragmentOp3ATI", MLS_LFragmentOp3ATI_IIIIIIIIIII(), PS_LFragmentOp3ATI_IIIIIIIIIII());
	}
	public static MethodHandle glAlphaFunc(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAlphaFunc", MLS_LAlphaFunction_F(), PS_LAlphaFunction_F());
	}
	public static MethodHandle glAlphaFuncQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAlphaFuncQCOM", MLS_EF(), PS_EF());
	}
	public static MethodHandle glAlphaFuncx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAlphaFuncx", MLS_LAlphaFunction_I(), PS_LAlphaFunction_I());
	}
	public static MethodHandle glAlphaFuncxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAlphaFuncxOES", MLS_LAlphaFunction_I(), PS_LAlphaFunction_I());
	}
	public static MethodHandle glAlphaToCoverageDitherControlNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAlphaToCoverageDitherControlNV", MLS_E(), PS_E());
	}
	public static MethodHandle glApplyFramebufferAttachmentCMAAINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glApplyFramebufferAttachmentCMAAINTEL", MLS_(), PS_());
	}
	public static MethodHandle glApplyTextureEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glApplyTextureEXT", MLS_LLightTextureModeEXT_(), PS_LLightTextureModeEXT_());
	}
	public static MethodHandle glAcquireKeyedMutexWin32EXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glAcquireKeyedMutexWin32EXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_IJI(), PS_IJI());
	}
	public static MethodHandle glAreProgramsResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glAreProgramsResidentNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_IpP(), PS_IpP());
	}
	public static MethodHandle glAreTexturesResident(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glAreTexturesResident", GLParamTypeSets.ML_Z(), boolean.class, MLS_IpP(), PS_IpP());
	}
	public static MethodHandle glAreTexturesResidentEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glAreTexturesResidentEXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_IpP(), PS_IpP());
	}
	public static MethodHandle glArrayElement(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glArrayElement", MLS_I(), PS_I());
	}
	public static MethodHandle glArrayElementEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glArrayElementEXT", MLS_I(), PS_I());
	}
	public static MethodHandle glArrayObjectATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glArrayObjectATI", MLS_LEnableCap_ILScalarType_III(), PS_LEnableCap_ILScalarType_III());
	}
	public static MethodHandle glAsyncCopyBufferSubDataNVX(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glAsyncCopyBufferSubDataNVX", GLParamTypeSets.ML_I(), int.class, MLS_IppIIIIJJJIpp(), PS_IppIIIIJJJIpp());
	}
	public static MethodHandle glAsyncCopyImageSubDataNVX(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glAsyncCopyImageSubDataNVX", GLParamTypeSets.ML_I(), int.class, MLS_IppIIIEIIIIIEIIIIIIIIpp(), PS_IppIIIEIIIIIEIIIIIIIIpp());
	}
	public static MethodHandle glAsyncMarkerSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAsyncMarkerSGIX", MLS_I(), PS_I());
	}
	public static MethodHandle glAttachObjectARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAttachObjectARB", MLS_II(), PS_II());
	}
	public static MethodHandle glAttachShader(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glAttachShader", MLS_II(), PS_II());
	}
	public static MethodHandle glBegin(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBegin", MLS_LPrimitiveType_(), PS_LPrimitiveType_());
	}
	public static MethodHandle glBeginConditionalRender(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginConditionalRender", MLS_ILConditionalRenderMode_(), PS_ILConditionalRenderMode_());
	}
	public static MethodHandle glBeginConditionalRenderNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginConditionalRenderNV", MLS_ILConditionalRenderMode_(), PS_ILConditionalRenderMode_());
	}
	public static MethodHandle glBeginConditionalRenderNVX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginConditionalRenderNVX", MLS_I(), PS_I());
	}
	public static MethodHandle glBeginFragmentShaderATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginFragmentShaderATI", MLS_(), PS_());
	}
	public static MethodHandle glBeginOcclusionQueryNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginOcclusionQueryNV", MLS_I(), PS_I());
	}
	public static MethodHandle glBeginPerfMonitorAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginPerfMonitorAMD", MLS_I(), PS_I());
	}
	public static MethodHandle glBeginPerfQueryINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginPerfQueryINTEL", MLS_I(), PS_I());
	}
	public static MethodHandle glBeginQuery(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginQuery", MLS_LQueryTarget_I(), PS_LQueryTarget_I());
	}
	public static MethodHandle glBeginQueryARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginQueryARB", MLS_LQueryTarget_I(), PS_LQueryTarget_I());
	}
	public static MethodHandle glBeginQueryEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginQueryEXT", MLS_LQueryTarget_I(), PS_LQueryTarget_I());
	}
	public static MethodHandle glBeginQueryIndexed(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginQueryIndexed", MLS_LQueryTarget_II(), PS_LQueryTarget_II());
	}
	public static MethodHandle glBeginTransformFeedback(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginTransformFeedback", MLS_LPrimitiveType_(), PS_LPrimitiveType_());
	}
	public static MethodHandle glBeginTransformFeedbackEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginTransformFeedbackEXT", MLS_LPrimitiveType_(), PS_LPrimitiveType_());
	}
	public static MethodHandle glBeginTransformFeedbackNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginTransformFeedbackNV", MLS_LPrimitiveType_(), PS_LPrimitiveType_());
	}
	public static MethodHandle glBeginVertexShaderEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginVertexShaderEXT", MLS_(), PS_());
	}
	public static MethodHandle glBeginVideoCaptureNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBeginVideoCaptureNV", MLS_I(), PS_I());
	}
	public static MethodHandle glBindAttribLocation(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindAttribLocation", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glBindAttribLocationARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindAttribLocationARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glBindBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindBuffer", MLS_LBufferTarget_I(), PS_LBufferTarget_I());
	}
	public static MethodHandle glBindBufferARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindBufferARB", MLS_LBufferTarget_I(), PS_LBufferTarget_I());
	}
	public static MethodHandle glBindBufferBase(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindBufferBase", MLS_LBufferTarget_II(), PS_LBufferTarget_II());
	}
	public static MethodHandle glBindBufferBaseEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindBufferBaseEXT", MLS_LBufferTarget_II(), PS_LBufferTarget_II());
	}
	public static MethodHandle glBindBufferBaseNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindBufferBaseNV", MLS_LBufferTarget_II(), PS_LBufferTarget_II());
	}
	public static MethodHandle glBindBufferOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindBufferOffsetEXT", MLS_LBufferTarget_IIJ(), PS_LBufferTarget_IIJ());
	}
	public static MethodHandle glBindBufferOffsetNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindBufferOffsetNV", MLS_LBufferTarget_IIJ(), PS_LBufferTarget_IIJ());
	}
	public static MethodHandle glBindBufferRange(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindBufferRange", MLS_LBufferTarget_IIJJ(), PS_LBufferTarget_IIJJ());
	}
	public static MethodHandle glBindBufferRangeEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindBufferRangeEXT", MLS_LBufferTarget_IIJJ(), PS_LBufferTarget_IIJJ());
	}
	public static MethodHandle glBindBufferRangeNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindBufferRangeNV", MLS_LBufferTarget_IIJJ(), PS_LBufferTarget_IIJJ());
	}
	public static MethodHandle glBindBuffersBase(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindBuffersBase", MLS_LBufferTarget_IIp(), PS_LBufferTarget_IIp());
	}
	public static MethodHandle glBindBuffersRange(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindBuffersRange", MLS_LBufferTarget_IIppp(), PS_LBufferTarget_IIppp());
	}
	public static MethodHandle glBindFragDataLocation(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindFragDataLocation", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glBindFragDataLocationEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindFragDataLocationEXT", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glBindFragDataLocationIndexed(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindFragDataLocationIndexed", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glBindFragDataLocationIndexedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindFragDataLocationIndexedEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glBindFragmentShaderATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindFragmentShaderATI", MLS_I(), PS_I());
	}
	public static MethodHandle glBindFramebuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindFramebuffer", MLS_LFramebufferTarget_I(), PS_LFramebufferTarget_I());
	}
	public static MethodHandle glBindFramebufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindFramebufferEXT", MLS_LFramebufferTarget_I(), PS_LFramebufferTarget_I());
	}
	public static MethodHandle glBindFramebufferOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindFramebufferOES", MLS_LFramebufferTarget_I(), PS_LFramebufferTarget_I());
	}
	public static MethodHandle glBindImageTexture(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindImageTexture", MLS_IIIZILBufferAccess_LInternalFormat_(), PS_IIIZILBufferAccess_LInternalFormat_());
	}
	public static MethodHandle glBindImageTextureEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindImageTextureEXT", MLS_IIIZILBufferAccess_I(), PS_IIIZILBufferAccess_I());
	}
	public static MethodHandle glBindImageTextures(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindImageTextures", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glBindLightParameterEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glBindLightParameterEXT", GLParamTypeSets.ML_I(), int.class, MLS_LLightName_LLightParameter_(), PS_LLightName_LLightParameter_());
	}
	public static MethodHandle glBindMaterialParameterEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glBindMaterialParameterEXT", GLParamTypeSets.ML_I(), int.class, MLS_LTriangleFace_LMaterialParameter_(), PS_LTriangleFace_LMaterialParameter_());
	}
	public static MethodHandle glBindMultiTextureEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindMultiTextureEXT", MLS_LTextureUnit_LTextureTarget_I(), PS_LTextureUnit_LTextureTarget_I());
	}
	public static MethodHandle glBindParameterEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glBindParameterEXT", GLParamTypeSets.ML_I(), int.class, MLS_LVertexShaderParameterEXT_(), PS_LVertexShaderParameterEXT_());
	}
	public static MethodHandle glBindProgramARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindProgramARB", MLS_LProgramTarget_I(), PS_LProgramTarget_I());
	}
	public static MethodHandle glBindProgramNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindProgramNV", MLS_LVertexAttribEnumNV_I(), PS_LVertexAttribEnumNV_I());
	}
	public static MethodHandle glBindProgramPipeline(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindProgramPipeline", MLS_I(), PS_I());
	}
	public static MethodHandle glBindProgramPipelineEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindProgramPipelineEXT", MLS_I(), PS_I());
	}
	public static MethodHandle glBindRenderbuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindRenderbuffer", MLS_LRenderbufferTarget_I(), PS_LRenderbufferTarget_I());
	}
	public static MethodHandle glBindRenderbufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindRenderbufferEXT", MLS_LRenderbufferTarget_I(), PS_LRenderbufferTarget_I());
	}
	public static MethodHandle glBindRenderbufferOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindRenderbufferOES", MLS_LRenderbufferTarget_I(), PS_LRenderbufferTarget_I());
	}
	public static MethodHandle glBindSampler(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindSampler", MLS_II(), PS_II());
	}
	public static MethodHandle glBindSamplers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindSamplers", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glBindShadingRateImageNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindShadingRateImageNV", MLS_I(), PS_I());
	}
	public static MethodHandle glBindTexGenParameterEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glBindTexGenParameterEXT", GLParamTypeSets.ML_I(), int.class, MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_(), PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_());
	}
	public static MethodHandle glBindTexture(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindTexture", MLS_LTextureTarget_I(), PS_LTextureTarget_I());
	}
	public static MethodHandle glBindTextureEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindTextureEXT", MLS_LTextureTarget_I(), PS_LTextureTarget_I());
	}
	public static MethodHandle glBindTextureUnit(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindTextureUnit", MLS_II(), PS_II());
	}
	public static MethodHandle glBindTextureUnitParameterEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glBindTextureUnitParameterEXT", GLParamTypeSets.ML_I(), int.class, MLS_LTextureUnit_LVertexShaderTextureUnitParameter_(), PS_LTextureUnit_LVertexShaderTextureUnitParameter_());
	}
	public static MethodHandle glBindTextures(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindTextures", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glBindTransformFeedback(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindTransformFeedback", MLS_LBindTransformFeedbackTarget_I(), PS_LBindTransformFeedbackTarget_I());
	}
	public static MethodHandle glBindTransformFeedbackNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindTransformFeedbackNV", MLS_LBufferTarget_I(), PS_LBufferTarget_I());
	}
	public static MethodHandle glBindVertexArray(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindVertexArray", MLS_I(), PS_I());
	}
	public static MethodHandle glBindVertexArrayAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindVertexArrayAPPLE", MLS_I(), PS_I());
	}
	public static MethodHandle glBindVertexArrayOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindVertexArrayOES", MLS_I(), PS_I());
	}
	public static MethodHandle glBindVertexBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindVertexBuffer", MLS_IIJI(), PS_IIJI());
	}
	public static MethodHandle glBindVertexBuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindVertexBuffers", MLS_IIppp(), PS_IIppp());
	}
	public static MethodHandle glBindVertexShaderEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindVertexShaderEXT", MLS_I(), PS_I());
	}
	public static MethodHandle glBindVideoCaptureStreamBufferNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindVideoCaptureStreamBufferNV", MLS_IIEJ(), PS_IIEJ());
	}
	public static MethodHandle glBindVideoCaptureStreamTextureNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBindVideoCaptureStreamTextureNV", MLS_IIEEI(), PS_IIEEI());
	}
	public static MethodHandle glBinormal3bEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBinormal3bEXT", MLS_BBB(), PS_BBB());
	}
	public static MethodHandle glBinormal3bvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBinormal3bvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glBinormal3dEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBinormal3dEXT", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glBinormal3dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBinormal3dvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glBinormal3fEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBinormal3fEXT", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glBinormal3fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBinormal3fvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glBinormal3iEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBinormal3iEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glBinormal3ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBinormal3ivEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glBinormal3sEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBinormal3sEXT", MLS_SSS(), PS_SSS());
	}
	public static MethodHandle glBinormal3svEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBinormal3svEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glBinormalPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBinormalPointerEXT", MLS_LBinormalPointerTypeEXT_Ip(), PS_LBinormalPointerTypeEXT_Ip());
	}
	public static MethodHandle glBitmap(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBitmap", MLS_IIFFFFp(), PS_IIFFFFp());
	}
	public static MethodHandle glBitmapxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBitmapxOES", MLS_IIIIIIp(), PS_IIIIIIp());
	}
	public static MethodHandle glBlendBarrier(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendBarrier", MLS_(), PS_());
	}
	public static MethodHandle glBlendBarrierKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendBarrierKHR", MLS_(), PS_());
	}
	public static MethodHandle glBlendBarrierNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendBarrierNV", MLS_(), PS_());
	}
	public static MethodHandle glBlendColor(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendColor", MLS_FFFF(), PS_FFFF());
	}
	public static MethodHandle glBlendColorEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendColorEXT", MLS_FFFF(), PS_FFFF());
	}
	public static MethodHandle glBlendColorxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendColorxOES", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glBlendEquation(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquation", MLS_LBlendEquationModeEXT_(), PS_LBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationEXT", MLS_LBlendEquationModeEXT_(), PS_LBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationIndexedAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationIndexedAMD", MLS_ILBlendEquationModeEXT_(), PS_ILBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationOES", MLS_LBlendEquationModeEXT_(), PS_LBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationSeparate(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationSeparate", MLS_LBlendEquationModeEXT_LBlendEquationModeEXT_(), PS_LBlendEquationModeEXT_LBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationSeparateEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationSeparateEXT", MLS_LBlendEquationModeEXT_LBlendEquationModeEXT_(), PS_LBlendEquationModeEXT_LBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationSeparateIndexedAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationSeparateIndexedAMD", MLS_ILBlendEquationModeEXT_LBlendEquationModeEXT_(), PS_ILBlendEquationModeEXT_LBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationSeparateOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationSeparateOES", MLS_LBlendEquationModeEXT_LBlendEquationModeEXT_(), PS_LBlendEquationModeEXT_LBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationSeparatei(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationSeparatei", MLS_ILBlendEquationModeEXT_LBlendEquationModeEXT_(), PS_ILBlendEquationModeEXT_LBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationSeparateiARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationSeparateiARB", MLS_ILBlendEquationModeEXT_LBlendEquationModeEXT_(), PS_ILBlendEquationModeEXT_LBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationSeparateiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationSeparateiEXT", MLS_ILBlendEquationModeEXT_LBlendEquationModeEXT_(), PS_ILBlendEquationModeEXT_LBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationSeparateiOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationSeparateiOES", MLS_ILBlendEquationModeEXT_LBlendEquationModeEXT_(), PS_ILBlendEquationModeEXT_LBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationi(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationi", MLS_ILBlendEquationModeEXT_(), PS_ILBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationiARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationiARB", MLS_ILBlendEquationModeEXT_(), PS_ILBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationiEXT", MLS_ILBlendEquationModeEXT_(), PS_ILBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendEquationiOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendEquationiOES", MLS_ILBlendEquationModeEXT_(), PS_ILBlendEquationModeEXT_());
	}
	public static MethodHandle glBlendFunc(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFunc", MLS_LBlendingFactor_LBlendingFactor_(), PS_LBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFuncIndexedAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFuncIndexedAMD", MLS_IEE(), PS_IEE());
	}
	public static MethodHandle glBlendFuncSeparate(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFuncSeparate", MLS_LBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(), PS_LBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFuncSeparateEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFuncSeparateEXT", MLS_LBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(), PS_LBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFuncSeparateINGR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFuncSeparateINGR", MLS_LBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(), PS_LBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFuncSeparateIndexedAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFuncSeparateIndexedAMD", MLS_ILBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(), PS_ILBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFuncSeparateOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFuncSeparateOES", MLS_LBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(), PS_LBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFuncSeparatei(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFuncSeparatei", MLS_ILBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(), PS_ILBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFuncSeparateiARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFuncSeparateiARB", MLS_ILBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(), PS_ILBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFuncSeparateiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFuncSeparateiEXT", MLS_ILBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(), PS_ILBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFuncSeparateiOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFuncSeparateiOES", MLS_ILBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(), PS_ILBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFunci(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFunci", MLS_ILBlendingFactor_LBlendingFactor_(), PS_ILBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFunciARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFunciARB", MLS_ILBlendingFactor_LBlendingFactor_(), PS_ILBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFunciEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFunciEXT", MLS_ILBlendingFactor_LBlendingFactor_(), PS_ILBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendFunciOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendFunciOES", MLS_ILBlendingFactor_LBlendingFactor_(), PS_ILBlendingFactor_LBlendingFactor_());
	}
	public static MethodHandle glBlendParameteriNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlendParameteriNV", MLS_EI(), PS_EI());
	}
	public static MethodHandle glBlitFramebuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlitFramebuffer", MLS_IIIIIIIIILBlitFramebufferFilter_(), PS_IIIIIIIIILBlitFramebufferFilter_());
	}
	public static MethodHandle glBlitFramebufferANGLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlitFramebufferANGLE", MLS_IIIIIIIIILBlitFramebufferFilter_(), PS_IIIIIIIIILBlitFramebufferFilter_());
	}
	public static MethodHandle glBlitFramebufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlitFramebufferEXT", MLS_IIIIIIIIILBlitFramebufferFilter_(), PS_IIIIIIIIILBlitFramebufferFilter_());
	}
	public static MethodHandle glBlitFramebufferLayerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlitFramebufferLayerEXT", MLS_IIIIIIIIIIILBlitFramebufferFilter_(), PS_IIIIIIIIIIILBlitFramebufferFilter_());
	}
	public static MethodHandle glBlitFramebufferLayersEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlitFramebufferLayersEXT", MLS_IIIIIIIIILBlitFramebufferFilter_(), PS_IIIIIIIIILBlitFramebufferFilter_());
	}
	public static MethodHandle glBlitFramebufferNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlitFramebufferNV", MLS_IIIIIIIIILBlitFramebufferFilter_(), PS_IIIIIIIIILBlitFramebufferFilter_());
	}
	public static MethodHandle glBlitNamedFramebuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBlitNamedFramebuffer", MLS_IIIIIIIIIIILBlitFramebufferFilter_(), PS_IIIIIIIIIIILBlitFramebufferFilter_());
	}
	public static MethodHandle glBufferAddressRangeNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferAddressRangeNV", MLS_EIJJ(), PS_EIJJ());
	}
	public static MethodHandle glBufferAttachMemoryNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferAttachMemoryNV", MLS_LBufferTarget_IJ(), PS_LBufferTarget_IJ());
	}
	public static MethodHandle glBufferData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferData", MLS_LBufferTarget_JpLBufferUsage_(), PS_LBufferTarget_JpLBufferUsage_());
	}
	public static MethodHandle glBufferDataARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferDataARB", MLS_LBufferTarget_JpLBufferUsage_(), PS_LBufferTarget_JpLBufferUsage_());
	}
	public static MethodHandle glBufferPageCommitmentARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferPageCommitmentARB", MLS_EJJZ(), PS_EJJZ());
	}
	public static MethodHandle glBufferPageCommitmentMemNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferPageCommitmentMemNV", MLS_LBufferStorageTarget_JJIJZ(), PS_LBufferStorageTarget_JJIJZ());
	}
	public static MethodHandle glBufferParameteriAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferParameteriAPPLE", MLS_EEI(), PS_EEI());
	}
	public static MethodHandle glBufferStorage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferStorage", MLS_LBufferStorageTarget_JpI(), PS_LBufferStorageTarget_JpI());
	}
	public static MethodHandle glBufferStorageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferStorageEXT", MLS_LBufferStorageTarget_JpI(), PS_LBufferStorageTarget_JpI());
	}
	public static MethodHandle glBufferStorageExternalEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferStorageExternalEXT", MLS_EJJII(), PS_EJJII());
	}
	public static MethodHandle glBufferStorageMemEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferStorageMemEXT", MLS_LBufferTarget_JIJ(), PS_LBufferTarget_JIJ());
	}
	public static MethodHandle glBufferSubData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferSubData", MLS_LBufferTarget_JJp(), PS_LBufferTarget_JJp());
	}
	public static MethodHandle glBufferSubDataARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glBufferSubDataARB", MLS_LBufferTarget_JJp(), PS_LBufferTarget_JJp());
	}
	public static MethodHandle glCallCommandListNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCallCommandListNV", MLS_I(), PS_I());
	}
	public static MethodHandle glCallList(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCallList", MLS_I(), PS_I());
	}
	public static MethodHandle glCallLists(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCallLists", MLS_ILListNameType_p(), PS_ILListNameType_p());
	}
	public static MethodHandle glCheckFramebufferStatus(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCheckFramebufferStatus", GLParamTypeSets.ML_LFramebufferStatus_(), GLFramebufferStatus.class, MLS_LFramebufferTarget_(), PS_LFramebufferTarget_());
	}
	public static MethodHandle glCheckFramebufferStatusEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCheckFramebufferStatusEXT", GLParamTypeSets.ML_LFramebufferStatus_(), GLFramebufferStatus.class, MLS_LFramebufferTarget_(), PS_LFramebufferTarget_());
	}
	public static MethodHandle glCheckFramebufferStatusOES(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCheckFramebufferStatusOES", GLParamTypeSets.ML_LFramebufferStatus_(), GLFramebufferStatus.class, MLS_LFramebufferTarget_(), PS_LFramebufferTarget_());
	}
	public static MethodHandle glCheckNamedFramebufferStatus(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCheckNamedFramebufferStatus", GLParamTypeSets.ML_LFramebufferStatus_(), GLFramebufferStatus.class, MLS_ILFramebufferTarget_(), PS_ILFramebufferTarget_());
	}
	public static MethodHandle glCheckNamedFramebufferStatusEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCheckNamedFramebufferStatusEXT", GLParamTypeSets.ML_LFramebufferStatus_(), GLFramebufferStatus.class, MLS_ILFramebufferTarget_(), PS_ILFramebufferTarget_());
	}
	public static MethodHandle glClampColor(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClampColor", MLS_LClampColorTargetARB_LClampColorModeARB_(), PS_LClampColorTargetARB_LClampColorModeARB_());
	}
	public static MethodHandle glClampColorARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClampColorARB", MLS_LClampColorTargetARB_LClampColorModeARB_(), PS_LClampColorTargetARB_LClampColorModeARB_());
	}
	public static MethodHandle glClear(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClear", MLS_I(), PS_I());
	}
	public static MethodHandle glClearAccum(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearAccum", MLS_FFFF(), PS_FFFF());
	}
	public static MethodHandle glClearAccumxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearAccumxOES", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glClearBufferData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearBufferData", MLS_LBufferStorageTarget_LSizedInternalFormat_LPixelFormat_LPixelType_p(), PS_LBufferStorageTarget_LSizedInternalFormat_LPixelFormat_LPixelType_p());
	}
	public static MethodHandle glClearBufferSubData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearBufferSubData", MLS_LBufferTarget_LSizedInternalFormat_JJLPixelFormat_LPixelType_p(), PS_LBufferTarget_LSizedInternalFormat_JJLPixelFormat_LPixelType_p());
	}
	public static MethodHandle glClearBufferfi(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearBufferfi", MLS_LBuffer_IFI(), PS_LBuffer_IFI());
	}
	public static MethodHandle glClearBufferfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearBufferfv", MLS_LBuffer_Ip(), PS_LBuffer_Ip());
	}
	public static MethodHandle glClearBufferiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearBufferiv", MLS_LBuffer_Ip(), PS_LBuffer_Ip());
	}
	public static MethodHandle glClearBufferuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearBufferuiv", MLS_LBuffer_Ip(), PS_LBuffer_Ip());
	}
	public static MethodHandle glClearColor(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearColor", MLS_FFFF(), PS_FFFF());
	}
	public static MethodHandle glClearColorIiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearColorIiEXT", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glClearColorIuiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearColorIuiEXT", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glClearColorx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearColorx", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glClearColorxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearColorxOES", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glClearDepth(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearDepth", MLS_D(), PS_D());
	}
	public static MethodHandle glClearDepthdNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearDepthdNV", MLS_D(), PS_D());
	}
	public static MethodHandle glClearDepthf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearDepthf", MLS_F(), PS_F());
	}
	public static MethodHandle glClearDepthfOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearDepthfOES", MLS_F(), PS_F());
	}
	public static MethodHandle glClearDepthx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearDepthx", MLS_I(), PS_I());
	}
	public static MethodHandle glClearDepthxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearDepthxOES", MLS_I(), PS_I());
	}
	public static MethodHandle glClearIndex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearIndex", MLS_F(), PS_F());
	}
	public static MethodHandle glClearNamedBufferData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearNamedBufferData", MLS_ILSizedInternalFormat_LPixelFormat_LPixelType_p(), PS_ILSizedInternalFormat_LPixelFormat_LPixelType_p());
	}
	public static MethodHandle glClearNamedBufferDataEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearNamedBufferDataEXT", MLS_ILSizedInternalFormat_LPixelFormat_LPixelType_p(), PS_ILSizedInternalFormat_LPixelFormat_LPixelType_p());
	}
	public static MethodHandle glClearNamedBufferSubData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearNamedBufferSubData", MLS_ILSizedInternalFormat_JJLPixelFormat_LPixelType_p(), PS_ILSizedInternalFormat_JJLPixelFormat_LPixelType_p());
	}
	public static MethodHandle glClearNamedBufferSubDataEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearNamedBufferSubDataEXT", MLS_ILSizedInternalFormat_JJLPixelFormat_LPixelType_p(), PS_ILSizedInternalFormat_JJLPixelFormat_LPixelType_p());
	}
	public static MethodHandle glClearNamedFramebufferfi(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearNamedFramebufferfi", MLS_ILBuffer_IFI(), PS_ILBuffer_IFI());
	}
	public static MethodHandle glClearNamedFramebufferfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearNamedFramebufferfv", MLS_ILBuffer_Ip(), PS_ILBuffer_Ip());
	}
	public static MethodHandle glClearNamedFramebufferiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearNamedFramebufferiv", MLS_ILBuffer_Ip(), PS_ILBuffer_Ip());
	}
	public static MethodHandle glClearNamedFramebufferuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearNamedFramebufferuiv", MLS_ILBuffer_Ip(), PS_ILBuffer_Ip());
	}
	public static MethodHandle glClearPixelLocalStorageuiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearPixelLocalStorageuiEXT", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glClearStencil(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearStencil", MLS_I(), PS_I());
	}
	public static MethodHandle glClearTexImage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearTexImage", MLS_IILPixelFormat_LPixelType_p(), PS_IILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glClearTexImageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearTexImageEXT", MLS_IILPixelFormat_LPixelType_p(), PS_IILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glClearTexSubImage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearTexSubImage", MLS_IIIIIIIILPixelFormat_LPixelType_p(), PS_IIIIIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glClearTexSubImageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClearTexSubImageEXT", MLS_IIIIIIIILPixelFormat_LPixelType_p(), PS_IIIIIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glClientActiveTexture(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClientActiveTexture", MLS_LTextureUnit_(), PS_LTextureUnit_());
	}
	public static MethodHandle glClientActiveTextureARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClientActiveTextureARB", MLS_LTextureUnit_(), PS_LTextureUnit_());
	}
	public static MethodHandle glClientActiveVertexStreamATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClientActiveVertexStreamATI", MLS_LVertexStreamATI_(), PS_LVertexStreamATI_());
	}
	public static MethodHandle glClientAttribDefaultEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClientAttribDefaultEXT", MLS_I(), PS_I());
	}
	public static MethodHandle glClientWaitSemaphoreui64NVX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClientWaitSemaphoreui64NVX", MLS_Ipp(), PS_Ipp());
	}
	public static MethodHandle glClientWaitSync(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glClientWaitSync", GLParamTypeSets.ML_LSyncStatus_(), GLSyncStatus.class, MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glClientWaitSyncAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glClientWaitSyncAPPLE", GLParamTypeSets.ML_LSyncStatus_(), GLSyncStatus.class, MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glClipControl(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClipControl", MLS_LClipControlOrigin_LClipControlDepth_(), PS_LClipControlOrigin_LClipControlDepth_());
	}
	public static MethodHandle glClipControlEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClipControlEXT", MLS_EE(), PS_EE());
	}
	public static MethodHandle glClipPlane(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClipPlane", MLS_LClipPlaneName_p(), PS_LClipPlaneName_p());
	}
	public static MethodHandle glClipPlanef(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClipPlanef", MLS_LClipPlaneName_p(), PS_LClipPlaneName_p());
	}
	public static MethodHandle glClipPlanefIMG(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClipPlanefIMG", MLS_LClipPlaneName_p(), PS_LClipPlaneName_p());
	}
	public static MethodHandle glClipPlanefOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClipPlanefOES", MLS_LClipPlaneName_p(), PS_LClipPlaneName_p());
	}
	public static MethodHandle glClipPlanex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClipPlanex", MLS_LClipPlaneName_p(), PS_LClipPlaneName_p());
	}
	public static MethodHandle glClipPlanexIMG(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClipPlanexIMG", MLS_LClipPlaneName_p(), PS_LClipPlaneName_p());
	}
	public static MethodHandle glClipPlanexOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glClipPlanexOES", MLS_LClipPlaneName_p(), PS_LClipPlaneName_p());
	}
	public static MethodHandle glColor3b(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3b", MLS_BBB(), PS_BBB());
	}
	public static MethodHandle glColor3bv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3bv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor3d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3d", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glColor3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3dv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor3f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3f", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glColor3fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3fVertex3fSUN", MLS_FFFFFF(), PS_FFFFFF());
	}
	public static MethodHandle glColor3fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3fVertex3fvSUN", MLS_pp(), PS_pp());
	}
	public static MethodHandle glColor3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3fv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor3hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3hNV", MLS_CCC(), PS_CCC());
	}
	public static MethodHandle glColor3hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3hvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glColor3i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3i", MLS_III(), PS_III());
	}
	public static MethodHandle glColor3iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3iv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor3s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3s", MLS_SSS(), PS_SSS());
	}
	public static MethodHandle glColor3sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3sv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor3ub(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3ub", MLS_BBB(), PS_BBB());
	}
	public static MethodHandle glColor3ubv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3ubv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor3ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3ui", MLS_III(), PS_III());
	}
	public static MethodHandle glColor3uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3uiv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor3us(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3us", MLS_CCC(), PS_CCC());
	}
	public static MethodHandle glColor3usv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3usv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor3xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3xOES", MLS_III(), PS_III());
	}
	public static MethodHandle glColor3xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor3xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glColor4b(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4b", MLS_BBBB(), PS_BBBB());
	}
	public static MethodHandle glColor4bv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4bv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor4d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4d", MLS_DDDD(), PS_DDDD());
	}
	public static MethodHandle glColor4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4dv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor4f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4f", MLS_FFFF(), PS_FFFF());
	}
	public static MethodHandle glColor4fNormal3fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4fNormal3fVertex3fSUN", MLS_FFFFFFFFFF(), PS_FFFFFFFFFF());
	}
	public static MethodHandle glColor4fNormal3fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4fNormal3fVertex3fvSUN", MLS_ppp(), PS_ppp());
	}
	public static MethodHandle glColor4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4fv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor4hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4hNV", MLS_CCCC(), PS_CCCC());
	}
	public static MethodHandle glColor4hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4hvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glColor4i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4i", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glColor4iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4iv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor4s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4s", MLS_SSSS(), PS_SSSS());
	}
	public static MethodHandle glColor4sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4sv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor4ub(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4ub", MLS_BBBB(), PS_BBBB());
	}
	public static MethodHandle glColor4ubVertex2fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4ubVertex2fSUN", MLS_BBBBFF(), PS_BBBBFF());
	}
	public static MethodHandle glColor4ubVertex2fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4ubVertex2fvSUN", MLS_pp(), PS_pp());
	}
	public static MethodHandle glColor4ubVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4ubVertex3fSUN", MLS_BBBBFFF(), PS_BBBBFFF());
	}
	public static MethodHandle glColor4ubVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4ubVertex3fvSUN", MLS_pp(), PS_pp());
	}
	public static MethodHandle glColor4ubv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4ubv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor4ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4ui", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glColor4uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4uiv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor4us(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4us", MLS_CCCC(), PS_CCCC());
	}
	public static MethodHandle glColor4usv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4usv", MLS_p(), PS_p());
	}
	public static MethodHandle glColor4x(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4x", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glColor4xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4xOES", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glColor4xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColor4xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glColorFormatNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorFormatNV", MLS_ILColorPointerType_I(), PS_ILColorPointerType_I());
	}
	public static MethodHandle glColorFragmentOp1ATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorFragmentOp1ATI", MLS_LFragmentOp1ATI_IIIIII(), PS_LFragmentOp1ATI_IIIIII());
	}
	public static MethodHandle glColorFragmentOp2ATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorFragmentOp2ATI", MLS_LFragmentOp2ATI_IIIIIIIII(), PS_LFragmentOp2ATI_IIIIIIIII());
	}
	public static MethodHandle glColorFragmentOp3ATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorFragmentOp3ATI", MLS_LFragmentOp3ATI_IIIIIIIIIIII(), PS_LFragmentOp3ATI_IIIIIIIIIIII());
	}
	public static MethodHandle glColorMask(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorMask", MLS_ZZZZ(), PS_ZZZZ());
	}
	public static MethodHandle glColorMaskIndexedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorMaskIndexedEXT", MLS_IZZZZ(), PS_IZZZZ());
	}
	public static MethodHandle glColorMaski(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorMaski", MLS_IZZZZ(), PS_IZZZZ());
	}
	public static MethodHandle glColorMaskiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorMaskiEXT", MLS_IZZZZ(), PS_IZZZZ());
	}
	public static MethodHandle glColorMaskiOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorMaskiOES", MLS_IZZZZ(), PS_IZZZZ());
	}
	public static MethodHandle glColorMaterial(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorMaterial", MLS_LTriangleFace_LColorMaterialParameter_(), PS_LTriangleFace_LColorMaterialParameter_());
	}
	public static MethodHandle glColorP3ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorP3ui", MLS_LColorPointerType_I(), PS_LColorPointerType_I());
	}
	public static MethodHandle glColorP3uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorP3uiv", MLS_LColorPointerType_p(), PS_LColorPointerType_p());
	}
	public static MethodHandle glColorP4ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorP4ui", MLS_LColorPointerType_I(), PS_LColorPointerType_I());
	}
	public static MethodHandle glColorP4uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorP4uiv", MLS_LColorPointerType_p(), PS_LColorPointerType_p());
	}
	public static MethodHandle glColorPointer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorPointer", MLS_ILColorPointerType_Ip(), PS_ILColorPointerType_Ip());
	}
	public static MethodHandle glColorPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorPointerEXT", MLS_ILColorPointerType_IIp(), PS_ILColorPointerType_IIp());
	}
	public static MethodHandle glColorPointerListIBM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorPointerListIBM", MLS_ILColorPointerType_IPI(), PS_ILColorPointerType_IPI());
	}
	public static MethodHandle glColorPointervINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorPointervINTEL", MLS_ILVertexPointerType_P(), PS_ILVertexPointerType_P());
	}
	public static MethodHandle glColorSubTable(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorSubTable", MLS_LColorTableTarget_IILPixelFormat_LPixelType_p(), PS_LColorTableTarget_IILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glColorSubTableEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorSubTableEXT", MLS_LColorTableTarget_IILPixelFormat_LPixelType_p(), PS_LColorTableTarget_IILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glColorTable(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorTable", MLS_LColorTableTarget_LInternalFormat_ILPixelFormat_LPixelType_p(), PS_LColorTableTarget_LInternalFormat_ILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glColorTableEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorTableEXT", MLS_LColorTableTarget_LInternalFormat_ILPixelFormat_LPixelType_p(), PS_LColorTableTarget_LInternalFormat_ILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glColorTableParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorTableParameterfv", MLS_LColorTableTarget_LColorTableParameterPName_p(), PS_LColorTableTarget_LColorTableParameterPName_p());
	}
	public static MethodHandle glColorTableParameterfvSGI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorTableParameterfvSGI", MLS_LColorTableTargetSGI_LColorTableParameterPName_p(), PS_LColorTableTargetSGI_LColorTableParameterPName_p());
	}
	public static MethodHandle glColorTableParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorTableParameteriv", MLS_LColorTableTarget_LColorTableParameterPName_p(), PS_LColorTableTarget_LColorTableParameterPName_p());
	}
	public static MethodHandle glColorTableParameterivSGI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorTableParameterivSGI", MLS_LColorTableTargetSGI_LColorTableParameterPName_p(), PS_LColorTableTargetSGI_LColorTableParameterPName_p());
	}
	public static MethodHandle glColorTableSGI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glColorTableSGI", MLS_LColorTableTargetSGI_LInternalFormat_ILPixelFormat_LPixelType_p(), PS_LColorTableTargetSGI_LInternalFormat_ILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glCombinerInputNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCombinerInputNV", MLS_LCombinerStageNV_LCombinerPortionNV_LCombinerVariableNV_LCombinerRegisterNV_LCombinerMappingNV_LCombinerComponentUsageNV_(), PS_LCombinerStageNV_LCombinerPortionNV_LCombinerVariableNV_LCombinerRegisterNV_LCombinerMappingNV_LCombinerComponentUsageNV_());
	}
	public static MethodHandle glCombinerOutputNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCombinerOutputNV", MLS_LCombinerStageNV_LCombinerPortionNV_LCombinerRegisterNV_LCombinerRegisterNV_LCombinerRegisterNV_LCombinerScaleNV_LCombinerBiasNV_ZZZ(), PS_LCombinerStageNV_LCombinerPortionNV_LCombinerRegisterNV_LCombinerRegisterNV_LCombinerRegisterNV_LCombinerScaleNV_LCombinerBiasNV_ZZZ());
	}
	public static MethodHandle glCombinerParameterfNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCombinerParameterfNV", MLS_LCombinerParameterNV_F(), PS_LCombinerParameterNV_F());
	}
	public static MethodHandle glCombinerParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCombinerParameterfvNV", MLS_LCombinerParameterNV_p(), PS_LCombinerParameterNV_p());
	}
	public static MethodHandle glCombinerParameteriNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCombinerParameteriNV", MLS_LCombinerParameterNV_I(), PS_LCombinerParameterNV_I());
	}
	public static MethodHandle glCombinerParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCombinerParameterivNV", MLS_LCombinerParameterNV_p(), PS_LCombinerParameterNV_p());
	}
	public static MethodHandle glCombinerStageParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCombinerStageParameterfvNV", MLS_LCombinerStageNV_LCombinerParameterNV_p(), PS_LCombinerStageNV_LCombinerParameterNV_p());
	}
	public static MethodHandle glCommandListSegmentsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCommandListSegmentsNV", MLS_II(), PS_II());
	}
	public static MethodHandle glCompileCommandListNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompileCommandListNV", MLS_I(), PS_I());
	}
	public static MethodHandle glCompileShader(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompileShader", MLS_I(), PS_I());
	}
	public static MethodHandle glCompileShaderARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompileShaderARB", MLS_I(), PS_I());
	}
	public static MethodHandle glCompileShaderIncludeARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompileShaderIncludeARB", MLS_IIpp(), PS_IIpp());
	}
	public static MethodHandle glCompressedMultiTexImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedMultiTexImage1DEXT", MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIp(), PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIp());
	}
	public static MethodHandle glCompressedMultiTexImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedMultiTexImage2DEXT", MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIIp(), PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIIp());
	}
	public static MethodHandle glCompressedMultiTexImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedMultiTexImage3DEXT", MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIIIp(), PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIIIp());
	}
	public static MethodHandle glCompressedMultiTexSubImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedMultiTexSubImage1DEXT", MLS_LTextureUnit_LTextureTarget_IIILInternalFormat_Ip(), PS_LTextureUnit_LTextureTarget_IIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedMultiTexSubImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedMultiTexSubImage2DEXT", MLS_LTextureUnit_LTextureTarget_IIIIILInternalFormat_Ip(), PS_LTextureUnit_LTextureTarget_IIIIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedMultiTexSubImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedMultiTexSubImage3DEXT", MLS_LTextureUnit_LTextureTarget_IIIIIIILInternalFormat_Ip(), PS_LTextureUnit_LTextureTarget_IIIIIIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTexImage1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexImage1D", MLS_LTextureTarget_ILInternalFormat_IIIp(), PS_LTextureTarget_ILInternalFormat_IIIp());
	}
	public static MethodHandle glCompressedTexImage1DARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexImage1DARB", MLS_LTextureTarget_ILInternalFormat_IIIp(), PS_LTextureTarget_ILInternalFormat_IIIp());
	}
	public static MethodHandle glCompressedTexImage2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexImage2D", MLS_LTextureTarget_ILInternalFormat_IIIIp(), PS_LTextureTarget_ILInternalFormat_IIIIp());
	}
	public static MethodHandle glCompressedTexImage2DARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexImage2DARB", MLS_LTextureTarget_ILInternalFormat_IIIIp(), PS_LTextureTarget_ILInternalFormat_IIIIp());
	}
	public static MethodHandle glCompressedTexImage3D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexImage3D", MLS_LTextureTarget_ILInternalFormat_IIIIIp(), PS_LTextureTarget_ILInternalFormat_IIIIIp());
	}
	public static MethodHandle glCompressedTexImage3DARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexImage3DARB", MLS_LTextureTarget_ILInternalFormat_IIIIIp(), PS_LTextureTarget_ILInternalFormat_IIIIIp());
	}
	public static MethodHandle glCompressedTexImage3DOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexImage3DOES", MLS_LTextureTarget_ILInternalFormat_IIIIIp(), PS_LTextureTarget_ILInternalFormat_IIIIIp());
	}
	public static MethodHandle glCompressedTexSubImage1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexSubImage1D", MLS_LTextureTarget_IIILInternalFormat_Ip(), PS_LTextureTarget_IIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTexSubImage1DARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexSubImage1DARB", MLS_LTextureTarget_IIILInternalFormat_Ip(), PS_LTextureTarget_IIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTexSubImage2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexSubImage2D", MLS_LTextureTarget_IIIIILInternalFormat_Ip(), PS_LTextureTarget_IIIIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTexSubImage2DARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexSubImage2DARB", MLS_LTextureTarget_IIIIILInternalFormat_Ip(), PS_LTextureTarget_IIIIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTexSubImage3D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexSubImage3D", MLS_LTextureTarget_IIIIIIILInternalFormat_Ip(), PS_LTextureTarget_IIIIIIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTexSubImage3DARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexSubImage3DARB", MLS_LTextureTarget_IIIIIIILInternalFormat_Ip(), PS_LTextureTarget_IIIIIIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTexSubImage3DOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTexSubImage3DOES", MLS_LTextureTarget_IIIIIIILInternalFormat_Ip(), PS_LTextureTarget_IIIIIIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTextureImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTextureImage1DEXT", MLS_ILTextureTarget_ILInternalFormat_IIIp(), PS_ILTextureTarget_ILInternalFormat_IIIp());
	}
	public static MethodHandle glCompressedTextureImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTextureImage2DEXT", MLS_ILTextureTarget_ILInternalFormat_IIIIp(), PS_ILTextureTarget_ILInternalFormat_IIIIp());
	}
	public static MethodHandle glCompressedTextureImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTextureImage3DEXT", MLS_ILTextureTarget_ILInternalFormat_IIIIIp(), PS_ILTextureTarget_ILInternalFormat_IIIIIp());
	}
	public static MethodHandle glCompressedTextureSubImage1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTextureSubImage1D", MLS_IIIILInternalFormat_Ip(), PS_IIIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTextureSubImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTextureSubImage1DEXT", MLS_ILTextureTarget_IIILInternalFormat_Ip(), PS_ILTextureTarget_IIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTextureSubImage2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTextureSubImage2D", MLS_IIIIIILInternalFormat_Ip(), PS_IIIIIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTextureSubImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTextureSubImage2DEXT", MLS_ILTextureTarget_IIIIILInternalFormat_Ip(), PS_ILTextureTarget_IIIIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTextureSubImage3D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTextureSubImage3D", MLS_IIIIIIIILInternalFormat_Ip(), PS_IIIIIIIILInternalFormat_Ip());
	}
	public static MethodHandle glCompressedTextureSubImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCompressedTextureSubImage3DEXT", MLS_ILTextureTarget_IIIIIIILInternalFormat_Ip(), PS_ILTextureTarget_IIIIIIILInternalFormat_Ip());
	}
	public static MethodHandle glConservativeRasterParameterfNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConservativeRasterParameterfNV", MLS_EF(), PS_EF());
	}
	public static MethodHandle glConservativeRasterParameteriNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConservativeRasterParameteriNV", MLS_EI(), PS_EI());
	}
	public static MethodHandle glConvolutionFilter1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionFilter1D", MLS_LConvolutionTarget_LInternalFormat_ILPixelFormat_LPixelType_p(), PS_LConvolutionTarget_LInternalFormat_ILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glConvolutionFilter1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionFilter1DEXT", MLS_LConvolutionTargetEXT_LInternalFormat_ILPixelFormat_LPixelType_p(), PS_LConvolutionTargetEXT_LInternalFormat_ILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glConvolutionFilter2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionFilter2D", MLS_LConvolutionTarget_LInternalFormat_IILPixelFormat_LPixelType_p(), PS_LConvolutionTarget_LInternalFormat_IILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glConvolutionFilter2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionFilter2DEXT", MLS_LConvolutionTargetEXT_LInternalFormat_IILPixelFormat_LPixelType_p(), PS_LConvolutionTargetEXT_LInternalFormat_IILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glConvolutionParameterf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionParameterf", MLS_LConvolutionTarget_LConvolutionParameter_F(), PS_LConvolutionTarget_LConvolutionParameter_F());
	}
	public static MethodHandle glConvolutionParameterfEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionParameterfEXT", MLS_LConvolutionTargetEXT_LConvolutionParameter_F(), PS_LConvolutionTargetEXT_LConvolutionParameter_F());
	}
	public static MethodHandle glConvolutionParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionParameterfv", MLS_LConvolutionTarget_LConvolutionParameter_p(), PS_LConvolutionTarget_LConvolutionParameter_p());
	}
	public static MethodHandle glConvolutionParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionParameterfvEXT", MLS_LConvolutionTargetEXT_LConvolutionParameter_p(), PS_LConvolutionTargetEXT_LConvolutionParameter_p());
	}
	public static MethodHandle glConvolutionParameteri(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionParameteri", MLS_LConvolutionTarget_LConvolutionParameter_I(), PS_LConvolutionTarget_LConvolutionParameter_I());
	}
	public static MethodHandle glConvolutionParameteriEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionParameteriEXT", MLS_LConvolutionTargetEXT_LConvolutionParameter_I(), PS_LConvolutionTargetEXT_LConvolutionParameter_I());
	}
	public static MethodHandle glConvolutionParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionParameteriv", MLS_LConvolutionTarget_LConvolutionParameter_p(), PS_LConvolutionTarget_LConvolutionParameter_p());
	}
	public static MethodHandle glConvolutionParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionParameterivEXT", MLS_LConvolutionTargetEXT_LConvolutionParameter_p(), PS_LConvolutionTargetEXT_LConvolutionParameter_p());
	}
	public static MethodHandle glConvolutionParameterxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionParameterxOES", MLS_LConvolutionTargetEXT_LConvolutionParameter_I(), PS_LConvolutionTargetEXT_LConvolutionParameter_I());
	}
	public static MethodHandle glConvolutionParameterxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glConvolutionParameterxvOES", MLS_LConvolutionTargetEXT_LConvolutionParameter_p(), PS_LConvolutionTargetEXT_LConvolutionParameter_p());
	}
	public static MethodHandle glCopyBufferSubData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyBufferSubData", MLS_LCopyBufferSubDataTarget_LCopyBufferSubDataTarget_JJJ(), PS_LCopyBufferSubDataTarget_LCopyBufferSubDataTarget_JJJ());
	}
	public static MethodHandle glCopyBufferSubDataNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyBufferSubDataNV", MLS_LCopyBufferSubDataTarget_LCopyBufferSubDataTarget_JJJ(), PS_LCopyBufferSubDataTarget_LCopyBufferSubDataTarget_JJJ());
	}
	public static MethodHandle glCopyColorSubTable(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyColorSubTable", MLS_LColorTableTarget_IIII(), PS_LColorTableTarget_IIII());
	}
	public static MethodHandle glCopyColorSubTableEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyColorSubTableEXT", MLS_LColorTableTarget_IIII(), PS_LColorTableTarget_IIII());
	}
	public static MethodHandle glCopyColorTable(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyColorTable", MLS_LColorTableTarget_LInternalFormat_III(), PS_LColorTableTarget_LInternalFormat_III());
	}
	public static MethodHandle glCopyColorTableSGI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyColorTableSGI", MLS_LColorTableTargetSGI_LInternalFormat_III(), PS_LColorTableTargetSGI_LInternalFormat_III());
	}
	public static MethodHandle glCopyConvolutionFilter1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyConvolutionFilter1D", MLS_LConvolutionTarget_LInternalFormat_III(), PS_LConvolutionTarget_LInternalFormat_III());
	}
	public static MethodHandle glCopyConvolutionFilter1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyConvolutionFilter1DEXT", MLS_LConvolutionTargetEXT_LInternalFormat_III(), PS_LConvolutionTargetEXT_LInternalFormat_III());
	}
	public static MethodHandle glCopyConvolutionFilter2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyConvolutionFilter2D", MLS_LConvolutionTarget_LInternalFormat_IIII(), PS_LConvolutionTarget_LInternalFormat_IIII());
	}
	public static MethodHandle glCopyConvolutionFilter2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyConvolutionFilter2DEXT", MLS_LConvolutionTargetEXT_LInternalFormat_IIII(), PS_LConvolutionTargetEXT_LInternalFormat_IIII());
	}
	public static MethodHandle glCopyImageSubData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyImageSubData", MLS_ILCopyImageSubDataTarget_IIIIILCopyImageSubDataTarget_IIIIIII(), PS_ILCopyImageSubDataTarget_IIIIILCopyImageSubDataTarget_IIIIIII());
	}
	public static MethodHandle glCopyImageSubDataEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyImageSubDataEXT", MLS_ILCopyBufferSubDataTarget_IIIIILCopyBufferSubDataTarget_IIIIIII(), PS_ILCopyBufferSubDataTarget_IIIIILCopyBufferSubDataTarget_IIIIIII());
	}
	public static MethodHandle glCopyImageSubDataNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyImageSubDataNV", MLS_ILCopyBufferSubDataTarget_IIIIILCopyBufferSubDataTarget_IIIIIII(), PS_ILCopyBufferSubDataTarget_IIIIILCopyBufferSubDataTarget_IIIIIII());
	}
	public static MethodHandle glCopyImageSubDataOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyImageSubDataOES", MLS_ILCopyBufferSubDataTarget_IIIIILCopyBufferSubDataTarget_IIIIIII(), PS_ILCopyBufferSubDataTarget_IIIIILCopyBufferSubDataTarget_IIIIIII());
	}
	public static MethodHandle glCopyMultiTexImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyMultiTexImage1DEXT", MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIII(), PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIII());
	}
	public static MethodHandle glCopyMultiTexImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyMultiTexImage2DEXT", MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIII(), PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIII());
	}
	public static MethodHandle glCopyMultiTexSubImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyMultiTexSubImage1DEXT", MLS_LTextureUnit_LTextureTarget_IIIII(), PS_LTextureUnit_LTextureTarget_IIIII());
	}
	public static MethodHandle glCopyMultiTexSubImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyMultiTexSubImage2DEXT", MLS_LTextureUnit_LTextureTarget_IIIIIII(), PS_LTextureUnit_LTextureTarget_IIIIIII());
	}
	public static MethodHandle glCopyMultiTexSubImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyMultiTexSubImage3DEXT", MLS_LTextureUnit_LTextureTarget_IIIIIIII(), PS_LTextureUnit_LTextureTarget_IIIIIIII());
	}
	public static MethodHandle glCopyNamedBufferSubData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyNamedBufferSubData", MLS_IIJJJ(), PS_IIJJJ());
	}
	public static MethodHandle glCopyPathNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyPathNV", MLS_II(), PS_II());
	}
	public static MethodHandle glCopyPixels(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyPixels", MLS_IIIILPixelCopyType_(), PS_IIIILPixelCopyType_());
	}
	public static MethodHandle glCopyTexImage1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTexImage1D", MLS_LTextureTarget_ILInternalFormat_IIII(), PS_LTextureTarget_ILInternalFormat_IIII());
	}
	public static MethodHandle glCopyTexImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTexImage1DEXT", MLS_LTextureTarget_ILInternalFormat_IIII(), PS_LTextureTarget_ILInternalFormat_IIII());
	}
	public static MethodHandle glCopyTexImage2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTexImage2D", MLS_LTextureTarget_ILInternalFormat_IIIII(), PS_LTextureTarget_ILInternalFormat_IIIII());
	}
	public static MethodHandle glCopyTexImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTexImage2DEXT", MLS_LTextureTarget_ILInternalFormat_IIIII(), PS_LTextureTarget_ILInternalFormat_IIIII());
	}
	public static MethodHandle glCopyTexSubImage1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTexSubImage1D", MLS_LTextureTarget_IIIII(), PS_LTextureTarget_IIIII());
	}
	public static MethodHandle glCopyTexSubImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTexSubImage1DEXT", MLS_LTextureTarget_IIIII(), PS_LTextureTarget_IIIII());
	}
	public static MethodHandle glCopyTexSubImage2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTexSubImage2D", MLS_LTextureTarget_IIIIIII(), PS_LTextureTarget_IIIIIII());
	}
	public static MethodHandle glCopyTexSubImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTexSubImage2DEXT", MLS_LTextureTarget_IIIIIII(), PS_LTextureTarget_IIIIIII());
	}
	public static MethodHandle glCopyTexSubImage3D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTexSubImage3D", MLS_LTextureTarget_IIIIIIII(), PS_LTextureTarget_IIIIIIII());
	}
	public static MethodHandle glCopyTexSubImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTexSubImage3DEXT", MLS_LTextureTarget_IIIIIIII(), PS_LTextureTarget_IIIIIIII());
	}
	public static MethodHandle glCopyTexSubImage3DOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTexSubImage3DOES", MLS_EIIIIIIII(), PS_EIIIIIIII());
	}
	public static MethodHandle glCopyTextureImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTextureImage1DEXT", MLS_ILTextureTarget_ILInternalFormat_IIII(), PS_ILTextureTarget_ILInternalFormat_IIII());
	}
	public static MethodHandle glCopyTextureImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTextureImage2DEXT", MLS_ILTextureTarget_ILInternalFormat_IIIII(), PS_ILTextureTarget_ILInternalFormat_IIIII());
	}
	public static MethodHandle glCopyTextureLevelsAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTextureLevelsAPPLE", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glCopyTextureSubImage1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTextureSubImage1D", MLS_IIIIII(), PS_IIIIII());
	}
	public static MethodHandle glCopyTextureSubImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTextureSubImage1DEXT", MLS_ILTextureTarget_IIIII(), PS_ILTextureTarget_IIIII());
	}
	public static MethodHandle glCopyTextureSubImage2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTextureSubImage2D", MLS_IIIIIIII(), PS_IIIIIIII());
	}
	public static MethodHandle glCopyTextureSubImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTextureSubImage2DEXT", MLS_ILTextureTarget_IIIIIII(), PS_ILTextureTarget_IIIIIII());
	}
	public static MethodHandle glCopyTextureSubImage3D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTextureSubImage3D", MLS_IIIIIIIII(), PS_IIIIIIIII());
	}
	public static MethodHandle glCopyTextureSubImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCopyTextureSubImage3DEXT", MLS_ILTextureTarget_IIIIIIII(), PS_ILTextureTarget_IIIIIIII());
	}
	public static MethodHandle glCoverFillPathInstancedNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCoverFillPathInstancedNV", MLS_ILPathElementType_pILInstancedPathCoverMode_LPathTransformType_p(), PS_ILPathElementType_pILInstancedPathCoverMode_LPathTransformType_p());
	}
	public static MethodHandle glCoverFillPathNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCoverFillPathNV", MLS_ILPathCoverMode_(), PS_ILPathCoverMode_());
	}
	public static MethodHandle glCoverStrokePathInstancedNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCoverStrokePathInstancedNV", MLS_ILPathElementType_pILInstancedPathCoverMode_LPathTransformType_p(), PS_ILPathElementType_pILInstancedPathCoverMode_LPathTransformType_p());
	}
	public static MethodHandle glCoverStrokePathNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCoverStrokePathNV", MLS_ILPathCoverMode_(), PS_ILPathCoverMode_());
	}
	public static MethodHandle glCoverageMaskNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCoverageMaskNV", MLS_Z(), PS_Z());
	}
	public static MethodHandle glCoverageModulationNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCoverageModulationNV", MLS_E(), PS_E());
	}
	public static MethodHandle glCoverageModulationTableNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCoverageModulationTableNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glCoverageOperationNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCoverageOperationNV", MLS_E(), PS_E());
	}
	public static MethodHandle glCreateBuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateBuffers", MLS_IP(), PS_IP());
	}
	public static MethodHandle glCreateCommandListsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateCommandListsNV", MLS_IP(), PS_IP());
	}
	public static MethodHandle glCreateFramebuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateFramebuffers", MLS_IP(), PS_IP());
	}
	public static MethodHandle glCreateMemoryObjectsEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateMemoryObjectsEXT", MLS_IP(), PS_IP());
	}
	public static MethodHandle glCreatePerfQueryINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreatePerfQueryINTEL", MLS_IP(), PS_IP());
	}
	public static MethodHandle glCreateProgram(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCreateProgram", GLParamTypeSets.ML_I(), int.class, MLS_(), PS_());
	}
	public static MethodHandle glCreateProgramObjectARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCreateProgramObjectARB", GLParamTypeSets.ML_I(), int.class, MLS_(), PS_());
	}
	public static MethodHandle glCreateProgramPipelines(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateProgramPipelines", MLS_IP(), PS_IP());
	}
	public static MethodHandle glCreateProgressFenceNVX(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCreateProgressFenceNVX", GLParamTypeSets.ML_I(), int.class, MLS_(), PS_());
	}
	public static MethodHandle glCreateQueries(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateQueries", MLS_LQueryTarget_IP(), PS_LQueryTarget_IP());
	}
	public static MethodHandle glCreateRenderbuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateRenderbuffers", MLS_IP(), PS_IP());
	}
	public static MethodHandle glCreateSamplers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateSamplers", MLS_IP(), PS_IP());
	}
	public static MethodHandle glCreateSemaphoresNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateSemaphoresNV", MLS_IP(), PS_IP());
	}
	public static MethodHandle glCreateShader(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCreateShader", GLParamTypeSets.ML_I(), int.class, MLS_LShaderType_(), PS_LShaderType_());
	}
	public static MethodHandle glCreateShaderObjectARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCreateShaderObjectARB", GLParamTypeSets.ML_I(), int.class, MLS_LShaderType_(), PS_LShaderType_());
	}
	public static MethodHandle glCreateShaderProgramEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCreateShaderProgramEXT", GLParamTypeSets.ML_I(), int.class, MLS_LShaderType_p(), PS_LShaderType_p());
	}
	public static MethodHandle glCreateShaderProgramv(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCreateShaderProgramv", GLParamTypeSets.ML_I(), int.class, MLS_LShaderType_Ip(), PS_LShaderType_Ip());
	}
	public static MethodHandle glCreateShaderProgramvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCreateShaderProgramvEXT", GLParamTypeSets.ML_I(), int.class, MLS_LShaderType_Ip(), PS_LShaderType_Ip());
	}
	public static MethodHandle glCreateStatesNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateStatesNV", MLS_IP(), PS_IP());
	}
	public static MethodHandle glCreateSyncFromCLeventARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glCreateSyncFromCLeventARB", GLParamTypeSets.ML_I(), int.class, MLS_PPI(), PS_PPI());
	}
	public static MethodHandle glCreateTextures(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateTextures", MLS_LTextureTarget_IP(), PS_LTextureTarget_IP());
	}
	public static MethodHandle glCreateTransformFeedbacks(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateTransformFeedbacks", MLS_IP(), PS_IP());
	}
	public static MethodHandle glCreateVertexArrays(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCreateVertexArrays", MLS_IP(), PS_IP());
	}
	public static MethodHandle glCullFace(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCullFace", MLS_LTriangleFace_(), PS_LTriangleFace_());
	}
	public static MethodHandle glCullParameterdvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCullParameterdvEXT", MLS_LCullParameterEXT_P(), PS_LCullParameterEXT_P());
	}
	public static MethodHandle glCullParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCullParameterfvEXT", MLS_LCullParameterEXT_P(), PS_LCullParameterEXT_P());
	}
	public static MethodHandle glCurrentPaletteMatrixARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCurrentPaletteMatrixARB", MLS_I(), PS_I());
	}
	public static MethodHandle glCurrentPaletteMatrixOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glCurrentPaletteMatrixOES", MLS_I(), PS_I());
	}
	public static MethodHandle glDebugMessageCallback(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDebugMessageCallback", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDebugMessageCallbackAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDebugMessageCallbackAMD", MLS_IP(), PS_IP());
	}
	public static MethodHandle glDebugMessageCallbackARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDebugMessageCallbackARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDebugMessageCallbackKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDebugMessageCallbackKHR", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDebugMessageControl(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDebugMessageControl", MLS_LDebugSource_LDebugType_LDebugSeverity_IpZ(), PS_LDebugSource_LDebugType_LDebugSeverity_IpZ());
	}
	public static MethodHandle glDebugMessageControlARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDebugMessageControlARB", MLS_LDebugSource_LDebugType_LDebugSeverity_IpZ(), PS_LDebugSource_LDebugType_LDebugSeverity_IpZ());
	}
	public static MethodHandle glDebugMessageControlKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDebugMessageControlKHR", MLS_LDebugSource_LDebugType_LDebugSeverity_IpZ(), PS_LDebugSource_LDebugType_LDebugSeverity_IpZ());
	}
	public static MethodHandle glDebugMessageEnableAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDebugMessageEnableAMD", MLS_ELDebugSeverity_IpZ(), PS_ELDebugSeverity_IpZ());
	}
	public static MethodHandle glDebugMessageInsert(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDebugMessageInsert", MLS_LDebugSource_LDebugType_ILDebugSeverity_Ip(), PS_LDebugSource_LDebugType_ILDebugSeverity_Ip());
	}
	public static MethodHandle glDebugMessageInsertAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDebugMessageInsertAMD", MLS_ELDebugSeverity_IIp(), PS_ELDebugSeverity_IIp());
	}
	public static MethodHandle glDebugMessageInsertARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDebugMessageInsertARB", MLS_LDebugSource_LDebugType_ILDebugSeverity_Ip(), PS_LDebugSource_LDebugType_ILDebugSeverity_Ip());
	}
	public static MethodHandle glDebugMessageInsertKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDebugMessageInsertKHR", MLS_LDebugSource_LDebugType_ILDebugSeverity_Ip(), PS_LDebugSource_LDebugType_ILDebugSeverity_Ip());
	}
	public static MethodHandle glDeformSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeformSGIX", MLS_I(), PS_I());
	}
	public static MethodHandle glDeformationMap3dSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeformationMap3dSGIX", MLS_LFfdTargetSGIX_DDIIDDIIDDIIp(), PS_LFfdTargetSGIX_DDIIDDIIDDIIp());
	}
	public static MethodHandle glDeformationMap3fSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeformationMap3fSGIX", MLS_LFfdTargetSGIX_FFIIFFIIFFIIp(), PS_LFfdTargetSGIX_FFIIFFIIFFIIp());
	}
	public static MethodHandle glDeleteAsyncMarkersSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteAsyncMarkersSGIX", MLS_II(), PS_II());
	}
	public static MethodHandle glDeleteBuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteBuffers", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteBuffersARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteBuffersARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteCommandListsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteCommandListsNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteFencesAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteFencesAPPLE", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteFencesNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteFencesNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteFragmentShaderATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteFragmentShaderATI", MLS_I(), PS_I());
	}
	public static MethodHandle glDeleteFramebuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteFramebuffers", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteFramebuffersEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteFramebuffersEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteFramebuffersOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteFramebuffersOES", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteLists(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteLists", MLS_II(), PS_II());
	}
	public static MethodHandle glDeleteMemoryObjectsEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteMemoryObjectsEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteNamedStringARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteNamedStringARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteNamesAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteNamesAMD", MLS_EIp(), PS_EIp());
	}
	public static MethodHandle glDeleteObjectARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteObjectARB", MLS_I(), PS_I());
	}
	public static MethodHandle glDeleteOcclusionQueriesNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteOcclusionQueriesNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeletePathsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeletePathsNV", MLS_II(), PS_II());
	}
	public static MethodHandle glDeletePerfMonitorsAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeletePerfMonitorsAMD", MLS_IP(), PS_IP());
	}
	public static MethodHandle glDeletePerfQueryINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeletePerfQueryINTEL", MLS_I(), PS_I());
	}
	public static MethodHandle glDeleteProgram(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteProgram", MLS_I(), PS_I());
	}
	public static MethodHandle glDeleteProgramPipelines(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteProgramPipelines", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteProgramPipelinesEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteProgramPipelinesEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteProgramsARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteProgramsARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteProgramsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteProgramsNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteQueries(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteQueries", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteQueriesARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteQueriesARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteQueriesEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteQueriesEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteQueryResourceTagNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteQueryResourceTagNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteRenderbuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteRenderbuffers", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteRenderbuffersEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteRenderbuffersEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteRenderbuffersOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteRenderbuffersOES", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteSamplers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteSamplers", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteSemaphoresEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteSemaphoresEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteShader(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteShader", MLS_I(), PS_I());
	}
	public static MethodHandle glDeleteStatesNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteStatesNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteSync(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteSync", MLS_I(), PS_I());
	}
	public static MethodHandle glDeleteSyncAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteSyncAPPLE", MLS_I(), PS_I());
	}
	public static MethodHandle glDeleteTextures(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteTextures", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteTexturesEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteTexturesEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteTransformFeedbacks(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteTransformFeedbacks", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteTransformFeedbacksNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteTransformFeedbacksNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteVertexArrays(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteVertexArrays", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteVertexArraysAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteVertexArraysAPPLE", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteVertexArraysOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteVertexArraysOES", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDeleteVertexShaderEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDeleteVertexShaderEXT", MLS_I(), PS_I());
	}
	public static MethodHandle glDepthBoundsEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthBoundsEXT", MLS_DD(), PS_DD());
	}
	public static MethodHandle glDepthBoundsdNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthBoundsdNV", MLS_DD(), PS_DD());
	}
	public static MethodHandle glDepthFunc(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthFunc", MLS_LDepthFunction_(), PS_LDepthFunction_());
	}
	public static MethodHandle glDepthMask(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthMask", MLS_Z(), PS_Z());
	}
	public static MethodHandle glDepthRange(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRange", MLS_DD(), PS_DD());
	}
	public static MethodHandle glDepthRangeArraydvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangeArraydvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glDepthRangeArrayfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangeArrayfvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glDepthRangeArrayfvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangeArrayfvOES", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glDepthRangeArrayv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangeArrayv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glDepthRangeIndexed(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangeIndexed", MLS_IDD(), PS_IDD());
	}
	public static MethodHandle glDepthRangeIndexeddNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangeIndexeddNV", MLS_IDD(), PS_IDD());
	}
	public static MethodHandle glDepthRangeIndexedfNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangeIndexedfNV", MLS_IFF(), PS_IFF());
	}
	public static MethodHandle glDepthRangeIndexedfOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangeIndexedfOES", MLS_IFF(), PS_IFF());
	}
	public static MethodHandle glDepthRangedNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangedNV", MLS_DD(), PS_DD());
	}
	public static MethodHandle glDepthRangef(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangef", MLS_FF(), PS_FF());
	}
	public static MethodHandle glDepthRangefOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangefOES", MLS_FF(), PS_FF());
	}
	public static MethodHandle glDepthRangex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangex", MLS_II(), PS_II());
	}
	public static MethodHandle glDepthRangexOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDepthRangexOES", MLS_II(), PS_II());
	}
	public static MethodHandle glDetachObjectARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDetachObjectARB", MLS_II(), PS_II());
	}
	public static MethodHandle glDetachShader(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDetachShader", MLS_II(), PS_II());
	}
	public static MethodHandle glDetailTexFuncSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDetailTexFuncSGIS", MLS_LTextureTarget_Ip(), PS_LTextureTarget_Ip());
	}
	public static MethodHandle glDisable(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisable", MLS_LEnableCap_(), PS_LEnableCap_());
	}
	public static MethodHandle glDisableClientState(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableClientState", MLS_LEnableCap_(), PS_LEnableCap_());
	}
	public static MethodHandle glDisableClientStateIndexedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableClientStateIndexedEXT", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glDisableClientStateiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableClientStateiEXT", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glDisableDriverControlQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableDriverControlQCOM", MLS_I(), PS_I());
	}
	public static MethodHandle glDisableIndexedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableIndexedEXT", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glDisableVariantClientStateEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableVariantClientStateEXT", MLS_I(), PS_I());
	}
	public static MethodHandle glDisableVertexArrayAttrib(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableVertexArrayAttrib", MLS_II(), PS_II());
	}
	public static MethodHandle glDisableVertexArrayAttribEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableVertexArrayAttribEXT", MLS_II(), PS_II());
	}
	public static MethodHandle glDisableVertexArrayEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableVertexArrayEXT", MLS_ILEnableCap_(), PS_ILEnableCap_());
	}
	public static MethodHandle glDisableVertexAttribAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableVertexAttribAPPLE", MLS_IE(), PS_IE());
	}
	public static MethodHandle glDisableVertexAttribArray(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableVertexAttribArray", MLS_I(), PS_I());
	}
	public static MethodHandle glDisableVertexAttribArrayARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableVertexAttribArrayARB", MLS_I(), PS_I());
	}
	public static MethodHandle glDisablei(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisablei", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glDisableiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableiEXT", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glDisableiNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableiNV", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glDisableiOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDisableiOES", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glDiscardFramebufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDiscardFramebufferEXT", MLS_LFramebufferTarget_Ip(), PS_LFramebufferTarget_Ip());
	}
	public static MethodHandle glDispatchCompute(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDispatchCompute", MLS_III(), PS_III());
	}
	public static MethodHandle glDispatchComputeGroupSizeARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDispatchComputeGroupSizeARB", MLS_IIIIII(), PS_IIIIII());
	}
	public static MethodHandle glDispatchComputeIndirect(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDispatchComputeIndirect", MLS_J(), PS_J());
	}
	public static MethodHandle glDrawArrays(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawArrays", MLS_LPrimitiveType_II(), PS_LPrimitiveType_II());
	}
	public static MethodHandle glDrawArraysEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawArraysEXT", MLS_LPrimitiveType_II(), PS_LPrimitiveType_II());
	}
	public static MethodHandle glDrawArraysIndirect(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawArraysIndirect", MLS_LPrimitiveType_p(), PS_LPrimitiveType_p());
	}
	public static MethodHandle glDrawArraysInstanced(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawArraysInstanced", MLS_LPrimitiveType_III(), PS_LPrimitiveType_III());
	}
	public static MethodHandle glDrawArraysInstancedANGLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawArraysInstancedANGLE", MLS_LPrimitiveType_III(), PS_LPrimitiveType_III());
	}
	public static MethodHandle glDrawArraysInstancedARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawArraysInstancedARB", MLS_LPrimitiveType_III(), PS_LPrimitiveType_III());
	}
	public static MethodHandle glDrawArraysInstancedBaseInstance(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawArraysInstancedBaseInstance", MLS_LPrimitiveType_IIII(), PS_LPrimitiveType_IIII());
	}
	public static MethodHandle glDrawArraysInstancedBaseInstanceEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawArraysInstancedBaseInstanceEXT", MLS_LPrimitiveType_IIII(), PS_LPrimitiveType_IIII());
	}
	public static MethodHandle glDrawArraysInstancedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawArraysInstancedEXT", MLS_LPrimitiveType_III(), PS_LPrimitiveType_III());
	}
	public static MethodHandle glDrawArraysInstancedNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawArraysInstancedNV", MLS_LPrimitiveType_III(), PS_LPrimitiveType_III());
	}
	public static MethodHandle glDrawBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawBuffer", MLS_LDrawBufferMode_(), PS_LDrawBufferMode_());
	}
	public static MethodHandle glDrawBuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawBuffers", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDrawBuffersARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawBuffersARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDrawBuffersATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawBuffersATI", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDrawBuffersEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawBuffersEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDrawBuffersIndexedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawBuffersIndexedEXT", MLS_Ipp(), PS_Ipp());
	}
	public static MethodHandle glDrawBuffersNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawBuffersNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glDrawCommandsAddressNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawCommandsAddressNV", MLS_EppI(), PS_EppI());
	}
	public static MethodHandle glDrawCommandsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawCommandsNV", MLS_EIppI(), PS_EIppI());
	}
	public static MethodHandle glDrawCommandsStatesAddressNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawCommandsStatesAddressNV", MLS_ppppI(), PS_ppppI());
	}
	public static MethodHandle glDrawCommandsStatesNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawCommandsStatesNV", MLS_IppppI(), PS_IppppI());
	}
	public static MethodHandle glDrawElementArrayAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementArrayAPPLE", MLS_LPrimitiveType_II(), PS_LPrimitiveType_II());
	}
	public static MethodHandle glDrawElementArrayATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementArrayATI", MLS_LPrimitiveType_I(), PS_LPrimitiveType_I());
	}
	public static MethodHandle glDrawElements(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElements", MLS_LPrimitiveType_ILDrawElementsType_p(), PS_LPrimitiveType_ILDrawElementsType_p());
	}
	public static MethodHandle glDrawElementsBaseVertex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsBaseVertex", MLS_LPrimitiveType_ILDrawElementsType_pI(), PS_LPrimitiveType_ILDrawElementsType_pI());
	}
	public static MethodHandle glDrawElementsBaseVertexEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsBaseVertexEXT", MLS_LPrimitiveType_ILDrawElementsType_pI(), PS_LPrimitiveType_ILDrawElementsType_pI());
	}
	public static MethodHandle glDrawElementsBaseVertexOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsBaseVertexOES", MLS_LPrimitiveType_ILDrawElementsType_pI(), PS_LPrimitiveType_ILDrawElementsType_pI());
	}
	public static MethodHandle glDrawElementsIndirect(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsIndirect", MLS_LPrimitiveType_LDrawElementsType_p(), PS_LPrimitiveType_LDrawElementsType_p());
	}
	public static MethodHandle glDrawElementsInstanced(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsInstanced", MLS_LPrimitiveType_ILDrawElementsType_pI(), PS_LPrimitiveType_ILDrawElementsType_pI());
	}
	public static MethodHandle glDrawElementsInstancedANGLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsInstancedANGLE", MLS_LPrimitiveType_ILDrawElementsType_pI(), PS_LPrimitiveType_ILDrawElementsType_pI());
	}
	public static MethodHandle glDrawElementsInstancedARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsInstancedARB", MLS_LPrimitiveType_ILDrawElementsType_pI(), PS_LPrimitiveType_ILDrawElementsType_pI());
	}
	public static MethodHandle glDrawElementsInstancedBaseInstance(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsInstancedBaseInstance", MLS_LPrimitiveType_ILDrawElementsType_pII(), PS_LPrimitiveType_ILDrawElementsType_pII());
	}
	public static MethodHandle glDrawElementsInstancedBaseInstanceEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsInstancedBaseInstanceEXT", MLS_LPrimitiveType_ILDrawElementsType_pII(), PS_LPrimitiveType_ILDrawElementsType_pII());
	}
	public static MethodHandle glDrawElementsInstancedBaseVertex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsInstancedBaseVertex", MLS_LPrimitiveType_ILDrawElementsType_pII(), PS_LPrimitiveType_ILDrawElementsType_pII());
	}
	public static MethodHandle glDrawElementsInstancedBaseVertexBaseInstance(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsInstancedBaseVertexBaseInstance", MLS_LPrimitiveType_ILDrawElementsType_pIII(), PS_LPrimitiveType_ILDrawElementsType_pIII());
	}
	public static MethodHandle glDrawElementsInstancedBaseVertexBaseInstanceEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsInstancedBaseVertexBaseInstanceEXT", MLS_LPrimitiveType_ILDrawElementsType_pIII(), PS_LPrimitiveType_ILDrawElementsType_pIII());
	}
	public static MethodHandle glDrawElementsInstancedBaseVertexEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsInstancedBaseVertexEXT", MLS_LPrimitiveType_ILDrawElementsType_pII(), PS_LPrimitiveType_ILDrawElementsType_pII());
	}
	public static MethodHandle glDrawElementsInstancedBaseVertexOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsInstancedBaseVertexOES", MLS_LPrimitiveType_ILDrawElementsType_pII(), PS_LPrimitiveType_ILDrawElementsType_pII());
	}
	public static MethodHandle glDrawElementsInstancedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsInstancedEXT", MLS_LPrimitiveType_ILDrawElementsType_pI(), PS_LPrimitiveType_ILDrawElementsType_pI());
	}
	public static MethodHandle glDrawElementsInstancedNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawElementsInstancedNV", MLS_LPrimitiveType_ILDrawElementsType_pI(), PS_LPrimitiveType_ILDrawElementsType_pI());
	}
	public static MethodHandle glDrawMeshArraysSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawMeshArraysSUN", MLS_LPrimitiveType_III(), PS_LPrimitiveType_III());
	}
	public static MethodHandle glDrawMeshTasksNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawMeshTasksNV", MLS_II(), PS_II());
	}
	public static MethodHandle glDrawMeshTasksIndirectNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawMeshTasksIndirectNV", MLS_J(), PS_J());
	}
	public static MethodHandle glDrawPixels(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawPixels", MLS_IILPixelFormat_LPixelType_p(), PS_IILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glDrawRangeElementArrayAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawRangeElementArrayAPPLE", MLS_LPrimitiveType_IIII(), PS_LPrimitiveType_IIII());
	}
	public static MethodHandle glDrawRangeElementArrayATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawRangeElementArrayATI", MLS_LPrimitiveType_III(), PS_LPrimitiveType_III());
	}
	public static MethodHandle glDrawRangeElements(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawRangeElements", MLS_LPrimitiveType_IIILDrawElementsType_p(), PS_LPrimitiveType_IIILDrawElementsType_p());
	}
	public static MethodHandle glDrawRangeElementsBaseVertex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawRangeElementsBaseVertex", MLS_LPrimitiveType_IIILDrawElementsType_pI(), PS_LPrimitiveType_IIILDrawElementsType_pI());
	}
	public static MethodHandle glDrawRangeElementsBaseVertexEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawRangeElementsBaseVertexEXT", MLS_LPrimitiveType_IIILDrawElementsType_pI(), PS_LPrimitiveType_IIILDrawElementsType_pI());
	}
	public static MethodHandle glDrawRangeElementsBaseVertexOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawRangeElementsBaseVertexOES", MLS_LPrimitiveType_IIILDrawElementsType_pI(), PS_LPrimitiveType_IIILDrawElementsType_pI());
	}
	public static MethodHandle glDrawRangeElementsEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawRangeElementsEXT", MLS_LPrimitiveType_IIILDrawElementsType_p(), PS_LPrimitiveType_IIILDrawElementsType_p());
	}
	public static MethodHandle glDrawTexfOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTexfOES", MLS_FFFFF(), PS_FFFFF());
	}
	public static MethodHandle glDrawTexfvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTexfvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glDrawTexiOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTexiOES", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glDrawTexivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTexivOES", MLS_p(), PS_p());
	}
	public static MethodHandle glDrawTexsOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTexsOES", MLS_SSSSS(), PS_SSSSS());
	}
	public static MethodHandle glDrawTexsvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTexsvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glDrawTextureNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTextureNV", MLS_IIFFFFFFFFF(), PS_IIFFFFFFFFF());
	}
	public static MethodHandle glDrawTexxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTexxOES", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glDrawTexxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTexxvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glDrawTransformFeedback(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTransformFeedback", MLS_LPrimitiveType_I(), PS_LPrimitiveType_I());
	}
	public static MethodHandle glDrawTransformFeedbackEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTransformFeedbackEXT", MLS_LPrimitiveType_I(), PS_LPrimitiveType_I());
	}
	public static MethodHandle glDrawTransformFeedbackInstanced(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTransformFeedbackInstanced", MLS_LPrimitiveType_II(), PS_LPrimitiveType_II());
	}
	public static MethodHandle glDrawTransformFeedbackInstancedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTransformFeedbackInstancedEXT", MLS_LPrimitiveType_II(), PS_LPrimitiveType_II());
	}
	public static MethodHandle glDrawTransformFeedbackNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTransformFeedbackNV", MLS_LPrimitiveType_I(), PS_LPrimitiveType_I());
	}
	public static MethodHandle glDrawTransformFeedbackStream(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTransformFeedbackStream", MLS_LPrimitiveType_II(), PS_LPrimitiveType_II());
	}
	public static MethodHandle glDrawTransformFeedbackStreamInstanced(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawTransformFeedbackStreamInstanced", MLS_LPrimitiveType_III(), PS_LPrimitiveType_III());
	}
	public static MethodHandle glEGLImageTargetRenderbufferStorageOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEGLImageTargetRenderbufferStorageOES", MLS_EI(), PS_EI());
	}
	public static MethodHandle glEGLImageTargetTexStorageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEGLImageTargetTexStorageEXT", MLS_EIp(), PS_EIp());
	}
	public static MethodHandle glEGLImageTargetTexture2DOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEGLImageTargetTexture2DOES", MLS_EI(), PS_EI());
	}
	public static MethodHandle glEGLImageTargetTextureStorageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEGLImageTargetTextureStorageEXT", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glEdgeFlag(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEdgeFlag", MLS_Z(), PS_Z());
	}
	public static MethodHandle glEdgeFlagFormatNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEdgeFlagFormatNV", MLS_I(), PS_I());
	}
	public static MethodHandle glEdgeFlagPointer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEdgeFlagPointer", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glEdgeFlagPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEdgeFlagPointerEXT", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glEdgeFlagPointerListIBM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEdgeFlagPointerListIBM", MLS_IPI(), PS_IPI());
	}
	public static MethodHandle glEdgeFlagv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEdgeFlagv", MLS_p(), PS_p());
	}
	public static MethodHandle glElementPointerAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glElementPointerAPPLE", MLS_LElementPointerTypeATI_p(), PS_LElementPointerTypeATI_p());
	}
	public static MethodHandle glElementPointerATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glElementPointerATI", MLS_LElementPointerTypeATI_p(), PS_LElementPointerTypeATI_p());
	}
	public static MethodHandle glEnable(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnable", MLS_LEnableCap_(), PS_LEnableCap_());
	}
	public static MethodHandle glEnableClientState(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableClientState", MLS_LEnableCap_(), PS_LEnableCap_());
	}
	public static MethodHandle glEnableClientStateIndexedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableClientStateIndexedEXT", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glEnableClientStateiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableClientStateiEXT", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glEnableDriverControlQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableDriverControlQCOM", MLS_I(), PS_I());
	}
	public static MethodHandle glEnableIndexedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableIndexedEXT", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glEnableVariantClientStateEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableVariantClientStateEXT", MLS_I(), PS_I());
	}
	public static MethodHandle glEnableVertexArrayAttrib(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableVertexArrayAttrib", MLS_II(), PS_II());
	}
	public static MethodHandle glEnableVertexArrayAttribEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableVertexArrayAttribEXT", MLS_II(), PS_II());
	}
	public static MethodHandle glEnableVertexArrayEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableVertexArrayEXT", MLS_ILEnableCap_(), PS_ILEnableCap_());
	}
	public static MethodHandle glEnableVertexAttribAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableVertexAttribAPPLE", MLS_IE(), PS_IE());
	}
	public static MethodHandle glEnableVertexAttribArray(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableVertexAttribArray", MLS_I(), PS_I());
	}
	public static MethodHandle glEnableVertexAttribArrayARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableVertexAttribArrayARB", MLS_I(), PS_I());
	}
	public static MethodHandle glEnablei(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnablei", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glEnableiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableiEXT", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glEnableiNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableiNV", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glEnableiOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnableiOES", MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glEnd(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEnd", MLS_(), PS_());
	}
	public static MethodHandle glEndConditionalRender(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndConditionalRender", MLS_(), PS_());
	}
	public static MethodHandle glEndConditionalRenderNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndConditionalRenderNV", MLS_(), PS_());
	}
	public static MethodHandle glEndConditionalRenderNVX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndConditionalRenderNVX", MLS_(), PS_());
	}
	public static MethodHandle glEndFragmentShaderATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndFragmentShaderATI", MLS_(), PS_());
	}
	public static MethodHandle glEndList(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndList", MLS_(), PS_());
	}
	public static MethodHandle glEndOcclusionQueryNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndOcclusionQueryNV", MLS_(), PS_());
	}
	public static MethodHandle glEndPerfMonitorAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndPerfMonitorAMD", MLS_I(), PS_I());
	}
	public static MethodHandle glEndPerfQueryINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndPerfQueryINTEL", MLS_I(), PS_I());
	}
	public static MethodHandle glEndQuery(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndQuery", MLS_LQueryTarget_(), PS_LQueryTarget_());
	}
	public static MethodHandle glEndQueryARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndQueryARB", MLS_LQueryTarget_(), PS_LQueryTarget_());
	}
	public static MethodHandle glEndQueryEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndQueryEXT", MLS_LQueryTarget_(), PS_LQueryTarget_());
	}
	public static MethodHandle glEndQueryIndexed(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndQueryIndexed", MLS_LQueryTarget_I(), PS_LQueryTarget_I());
	}
	public static MethodHandle glEndTilingQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndTilingQCOM", MLS_I(), PS_I());
	}
	public static MethodHandle glEndTransformFeedback(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndTransformFeedback", MLS_(), PS_());
	}
	public static MethodHandle glEndTransformFeedbackEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndTransformFeedbackEXT", MLS_(), PS_());
	}
	public static MethodHandle glEndTransformFeedbackNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndTransformFeedbackNV", MLS_(), PS_());
	}
	public static MethodHandle glEndVertexShaderEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndVertexShaderEXT", MLS_(), PS_());
	}
	public static MethodHandle glEndVideoCaptureNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEndVideoCaptureNV", MLS_I(), PS_I());
	}
	public static MethodHandle glEvalCoord1d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalCoord1d", MLS_D(), PS_D());
	}
	public static MethodHandle glEvalCoord1dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalCoord1dv", MLS_p(), PS_p());
	}
	public static MethodHandle glEvalCoord1f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalCoord1f", MLS_F(), PS_F());
	}
	public static MethodHandle glEvalCoord1fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalCoord1fv", MLS_p(), PS_p());
	}
	public static MethodHandle glEvalCoord1xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalCoord1xOES", MLS_I(), PS_I());
	}
	public static MethodHandle glEvalCoord1xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalCoord1xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glEvalCoord2d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalCoord2d", MLS_DD(), PS_DD());
	}
	public static MethodHandle glEvalCoord2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalCoord2dv", MLS_p(), PS_p());
	}
	public static MethodHandle glEvalCoord2f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalCoord2f", MLS_FF(), PS_FF());
	}
	public static MethodHandle glEvalCoord2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalCoord2fv", MLS_p(), PS_p());
	}
	public static MethodHandle glEvalCoord2xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalCoord2xOES", MLS_II(), PS_II());
	}
	public static MethodHandle glEvalCoord2xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalCoord2xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glEvalMapsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalMapsNV", MLS_LEvalTargetNV_LEvalMapsModeNV_(), PS_LEvalTargetNV_LEvalMapsModeNV_());
	}
	public static MethodHandle glEvalMesh1(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalMesh1", MLS_LMeshMode1_II(), PS_LMeshMode1_II());
	}
	public static MethodHandle glEvalMesh2(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalMesh2", MLS_LMeshMode2_IIII(), PS_LMeshMode2_IIII());
	}
	public static MethodHandle glEvalPoint1(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalPoint1", MLS_I(), PS_I());
	}
	public static MethodHandle glEvalPoint2(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvalPoint2", MLS_II(), PS_II());
	}
	public static MethodHandle glEvaluateDepthValuesARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glEvaluateDepthValuesARB", MLS_(), PS_());
	}
	public static MethodHandle glExecuteProgramNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExecuteProgramNV", MLS_LVertexAttribEnumNV_Ip(), PS_LVertexAttribEnumNV_Ip());
	}
	public static MethodHandle glExtGetBufferPointervQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtGetBufferPointervQCOM", MLS_EP(), PS_EP());
	}
	public static MethodHandle glExtGetBuffersQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtGetBuffersQCOM", MLS_PIP(), PS_PIP());
	}
	public static MethodHandle glExtGetFramebuffersQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtGetFramebuffersQCOM", MLS_PIP(), PS_PIP());
	}
	public static MethodHandle glExtGetProgramBinarySourceQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtGetProgramBinarySourceQCOM", MLS_ILShaderType_PP(), PS_ILShaderType_PP());
	}
	public static MethodHandle glExtGetProgramsQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtGetProgramsQCOM", MLS_PIP(), PS_PIP());
	}
	public static MethodHandle glExtGetRenderbuffersQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtGetRenderbuffersQCOM", MLS_PIP(), PS_PIP());
	}
	public static MethodHandle glExtGetShadersQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtGetShadersQCOM", MLS_PIP(), PS_PIP());
	}
	public static MethodHandle glExtGetTexLevelParameterivQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtGetTexLevelParameterivQCOM", MLS_IEIEP(), PS_IEIEP());
	}
	public static MethodHandle glExtGetTexSubImageQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtGetTexSubImageQCOM", MLS_EIIIIIIILPixelFormat_LPixelType_P(), PS_EIIIIIIILPixelFormat_LPixelType_P());
	}
	public static MethodHandle glExtGetTexturesQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtGetTexturesQCOM", MLS_PIP(), PS_PIP());
	}
	public static MethodHandle glExtIsProgramBinaryQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glExtIsProgramBinaryQCOM", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glExtTexObjectStateOverrideiQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtTexObjectStateOverrideiQCOM", MLS_EEI(), PS_EEI());
	}
	public static MethodHandle glExtractComponentEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtractComponentEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glFeedbackBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFeedbackBuffer", MLS_ILFeedbackType_P(), PS_ILFeedbackType_P());
	}
	public static MethodHandle glFeedbackBufferxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFeedbackBufferxOES", MLS_IEp(), PS_IEp());
	}
	public static MethodHandle glFenceSync(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glFenceSync", GLParamTypeSets.ML_I(), int.class, MLS_LSyncCondition_I(), PS_LSyncCondition_I());
	}
	public static MethodHandle glFenceSyncAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glFenceSyncAPPLE", GLParamTypeSets.ML_I(), int.class, MLS_LSyncCondition_I(), PS_LSyncCondition_I());
	}
	public static MethodHandle glFinalCombinerInputNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFinalCombinerInputNV", MLS_LCombinerVariableNV_LCombinerRegisterNV_LCombinerMappingNV_LCombinerComponentUsageNV_(), PS_LCombinerVariableNV_LCombinerRegisterNV_LCombinerMappingNV_LCombinerComponentUsageNV_());
	}
	public static MethodHandle glFinish(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFinish", MLS_(), PS_());
	}
	public static MethodHandle glFinishAsyncSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glFinishAsyncSGIX", GLParamTypeSets.ML_I(), int.class, MLS_P(), PS_P());
	}
	public static MethodHandle glFinishFenceAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFinishFenceAPPLE", MLS_I(), PS_I());
	}
	public static MethodHandle glFinishFenceNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFinishFenceNV", MLS_I(), PS_I());
	}
	public static MethodHandle glFinishObjectAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFinishObjectAPPLE", MLS_LObjectTypeAPPLE_I(), PS_LObjectTypeAPPLE_I());
	}
	public static MethodHandle glFinishTextureSUNX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFinishTextureSUNX", MLS_(), PS_());
	}
	public static MethodHandle glFlush(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFlush", MLS_(), PS_());
	}
	public static MethodHandle glFlushMappedBufferRange(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFlushMappedBufferRange", MLS_LBufferTarget_JJ(), PS_LBufferTarget_JJ());
	}
	public static MethodHandle glFlushMappedBufferRangeAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFlushMappedBufferRangeAPPLE", MLS_LBufferTarget_JJ(), PS_LBufferTarget_JJ());
	}
	public static MethodHandle glFlushMappedBufferRangeEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFlushMappedBufferRangeEXT", MLS_LBufferTarget_JJ(), PS_LBufferTarget_JJ());
	}
	public static MethodHandle glFlushMappedNamedBufferRange(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFlushMappedNamedBufferRange", MLS_IJJ(), PS_IJJ());
	}
	public static MethodHandle glFlushMappedNamedBufferRangeEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFlushMappedNamedBufferRangeEXT", MLS_IJJ(), PS_IJJ());
	}
	public static MethodHandle glFlushPixelDataRangeNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFlushPixelDataRangeNV", MLS_LPixelDataRangeTargetNV_(), PS_LPixelDataRangeTargetNV_());
	}
	public static MethodHandle glFlushRasterSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFlushRasterSGIX", MLS_(), PS_());
	}
	public static MethodHandle glFlushStaticDataIBM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFlushStaticDataIBM", MLS_E(), PS_E());
	}
	public static MethodHandle glFlushVertexArrayRangeAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFlushVertexArrayRangeAPPLE", MLS_IP(), PS_IP());
	}
	public static MethodHandle glFlushVertexArrayRangeNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFlushVertexArrayRangeNV", MLS_(), PS_());
	}
	public static MethodHandle glFogCoordFormatNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoordFormatNV", MLS_EI(), PS_EI());
	}
	public static MethodHandle glFogCoordPointer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoordPointer", MLS_LFogPointerTypeEXT_Ip(), PS_LFogPointerTypeEXT_Ip());
	}
	public static MethodHandle glFogCoordPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoordPointerEXT", MLS_LFogPointerTypeEXT_Ip(), PS_LFogPointerTypeEXT_Ip());
	}
	public static MethodHandle glFogCoordPointerListIBM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoordPointerListIBM", MLS_LFogPointerTypeIBM_IPI(), PS_LFogPointerTypeIBM_IPI());
	}
	public static MethodHandle glFogCoordd(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoordd", MLS_D(), PS_D());
	}
	public static MethodHandle glFogCoorddEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoorddEXT", MLS_D(), PS_D());
	}
	public static MethodHandle glFogCoorddv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoorddv", MLS_p(), PS_p());
	}
	public static MethodHandle glFogCoorddvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoorddvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glFogCoordf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoordf", MLS_F(), PS_F());
	}
	public static MethodHandle glFogCoordfEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoordfEXT", MLS_F(), PS_F());
	}
	public static MethodHandle glFogCoordfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoordfv", MLS_p(), PS_p());
	}
	public static MethodHandle glFogCoordfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoordfvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glFogCoordhNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoordhNV", MLS_C(), PS_C());
	}
	public static MethodHandle glFogCoordhvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogCoordhvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glFogFuncSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogFuncSGIS", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glFogf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogf", MLS_LFogParameter_F(), PS_LFogParameter_F());
	}
	public static MethodHandle glFogfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogfv", MLS_LFogParameter_p(), PS_LFogParameter_p());
	}
	public static MethodHandle glFogi(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogi", MLS_LFogParameter_I(), PS_LFogParameter_I());
	}
	public static MethodHandle glFogiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogiv", MLS_LFogParameter_p(), PS_LFogParameter_p());
	}
	public static MethodHandle glFogx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogx", MLS_LFogPName_I(), PS_LFogPName_I());
	}
	public static MethodHandle glFogxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogxOES", MLS_LFogPName_I(), PS_LFogPName_I());
	}
	public static MethodHandle glFogxv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogxv", MLS_LFogPName_p(), PS_LFogPName_p());
	}
	public static MethodHandle glFogxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFogxvOES", MLS_LFogPName_p(), PS_LFogPName_p());
	}
	public static MethodHandle glFragmentColorMaterialSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentColorMaterialSGIX", MLS_LTriangleFace_LMaterialParameter_(), PS_LTriangleFace_LMaterialParameter_());
	}
	public static MethodHandle glFragmentCoverageColorNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentCoverageColorNV", MLS_I(), PS_I());
	}
	public static MethodHandle glFragmentLightModelfSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentLightModelfSGIX", MLS_LFragmentLightModelParameterSGIX_F(), PS_LFragmentLightModelParameterSGIX_F());
	}
	public static MethodHandle glFragmentLightModelfvSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentLightModelfvSGIX", MLS_LFragmentLightModelParameterSGIX_p(), PS_LFragmentLightModelParameterSGIX_p());
	}
	public static MethodHandle glFragmentLightModeliSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentLightModeliSGIX", MLS_LFragmentLightModelParameterSGIX_I(), PS_LFragmentLightModelParameterSGIX_I());
	}
	public static MethodHandle glFragmentLightModelivSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentLightModelivSGIX", MLS_LFragmentLightModelParameterSGIX_p(), PS_LFragmentLightModelParameterSGIX_p());
	}
	public static MethodHandle glFragmentLightfSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentLightfSGIX", MLS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_F(), PS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_F());
	}
	public static MethodHandle glFragmentLightfvSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentLightfvSGIX", MLS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_p(), PS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_p());
	}
	public static MethodHandle glFragmentLightiSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentLightiSGIX", MLS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_I(), PS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_I());
	}
	public static MethodHandle glFragmentLightivSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentLightivSGIX", MLS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_p(), PS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_p());
	}
	public static MethodHandle glFragmentMaterialfSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentMaterialfSGIX", MLS_LTriangleFace_LMaterialParameter_F(), PS_LTriangleFace_LMaterialParameter_F());
	}
	public static MethodHandle glFragmentMaterialfvSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentMaterialfvSGIX", MLS_LTriangleFace_LMaterialParameter_p(), PS_LTriangleFace_LMaterialParameter_p());
	}
	public static MethodHandle glFragmentMaterialiSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentMaterialiSGIX", MLS_LTriangleFace_LMaterialParameter_I(), PS_LTriangleFace_LMaterialParameter_I());
	}
	public static MethodHandle glFragmentMaterialivSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFragmentMaterialivSGIX", MLS_LTriangleFace_LMaterialParameter_p(), PS_LTriangleFace_LMaterialParameter_p());
	}
	public static MethodHandle glFrameTerminatorGREMEDY(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFrameTerminatorGREMEDY", MLS_(), PS_());
	}
	public static MethodHandle glFrameZoomSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFrameZoomSGIX", MLS_I(), PS_I());
	}
	public static MethodHandle glFramebufferDrawBufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferDrawBufferEXT", MLS_ILDrawBufferMode_(), PS_ILDrawBufferMode_());
	}
	public static MethodHandle glFramebufferDrawBuffersEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferDrawBuffersEXT", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glFramebufferFetchBarrierEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferFetchBarrierEXT", MLS_(), PS_());
	}
	public static MethodHandle glFramebufferFetchBarrierQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferFetchBarrierQCOM", MLS_(), PS_());
	}
	public static MethodHandle glFramebufferFoveationConfigQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferFoveationConfigQCOM", MLS_IIIIP(), PS_IIIIP());
	}
	public static MethodHandle glFramebufferFoveationParametersQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferFoveationParametersQCOM", MLS_IIIFFFFF(), PS_IIIFFFFF());
	}
	public static MethodHandle glFramebufferParameteri(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferParameteri", MLS_LFramebufferTarget_LFramebufferParameterName_I(), PS_LFramebufferTarget_LFramebufferParameterName_I());
	}
	public static MethodHandle glFramebufferPixelLocalStorageSizeEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferPixelLocalStorageSizeEXT", MLS_II(), PS_II());
	}
	public static MethodHandle glFramebufferReadBufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferReadBufferEXT", MLS_ILReadBufferMode_(), PS_ILReadBufferMode_());
	}
	public static MethodHandle glFramebufferRenderbuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferRenderbuffer", MLS_LFramebufferTarget_LFramebufferAttachment_LRenderbufferTarget_I(), PS_LFramebufferTarget_LFramebufferAttachment_LRenderbufferTarget_I());
	}
	public static MethodHandle glFramebufferRenderbufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferRenderbufferEXT", MLS_LFramebufferTarget_LFramebufferAttachment_LRenderbufferTarget_I(), PS_LFramebufferTarget_LFramebufferAttachment_LRenderbufferTarget_I());
	}
	public static MethodHandle glFramebufferRenderbufferOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferRenderbufferOES", MLS_LFramebufferTarget_LFramebufferAttachment_LRenderbufferTarget_I(), PS_LFramebufferTarget_LFramebufferAttachment_LRenderbufferTarget_I());
	}
	public static MethodHandle glFramebufferSampleLocationsfvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferSampleLocationsfvARB", MLS_LFramebufferTarget_IIp(), PS_LFramebufferTarget_IIp());
	}
	public static MethodHandle glFramebufferSampleLocationsfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferSampleLocationsfvNV", MLS_LFramebufferTarget_IIp(), PS_LFramebufferTarget_IIp());
	}
	public static MethodHandle glFramebufferSamplePositionsfvAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferSamplePositionsfvAMD", MLS_LFramebufferTarget_IIp(), PS_LFramebufferTarget_IIp());
	}
	public static MethodHandle glFramebufferShadingRateEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferShadingRateEXT", MLS_LFramebufferTarget_LFramebufferAttachment_IIIII(), PS_LFramebufferTarget_LFramebufferAttachment_IIIII());
	}
	public static MethodHandle glFramebufferTexture(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTexture", MLS_LFramebufferTarget_LFramebufferAttachment_II(), PS_LFramebufferTarget_LFramebufferAttachment_II());
	}
	public static MethodHandle glFramebufferTexture1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTexture1D", MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_II(), PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_II());
	}
	public static MethodHandle glFramebufferTexture1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTexture1DEXT", MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_II(), PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_II());
	}
	public static MethodHandle glFramebufferTexture2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTexture2D", MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_II(), PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_II());
	}
	public static MethodHandle glFramebufferTexture2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTexture2DEXT", MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_II(), PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_II());
	}
	public static MethodHandle glFramebufferTexture2DDownsampleIMG(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTexture2DDownsampleIMG", MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_IIII(), PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_IIII());
	}
	public static MethodHandle glFramebufferTexture2DMultisampleEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTexture2DMultisampleEXT", MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_III(), PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_III());
	}
	public static MethodHandle glFramebufferTexture2DMultisampleIMG(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTexture2DMultisampleIMG", MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_III(), PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_III());
	}
	public static MethodHandle glFramebufferTexture2DOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTexture2DOES", MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_II(), PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_II());
	}
	public static MethodHandle glFramebufferTexture3D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTexture3D", MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_III(), PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_III());
	}
	public static MethodHandle glFramebufferTexture3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTexture3DEXT", MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_III(), PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_III());
	}
	public static MethodHandle glFramebufferTexture3DOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTexture3DOES", MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_III(), PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_III());
	}
	public static MethodHandle glFramebufferTextureARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTextureARB", MLS_LFramebufferTarget_LFramebufferAttachment_II(), PS_LFramebufferTarget_LFramebufferAttachment_II());
	}
	public static MethodHandle glFramebufferTextureEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTextureEXT", MLS_LFramebufferTarget_LFramebufferAttachment_II(), PS_LFramebufferTarget_LFramebufferAttachment_II());
	}
	public static MethodHandle glFramebufferTextureFaceARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTextureFaceARB", MLS_LFramebufferTarget_LFramebufferAttachment_IILTextureTarget_(), PS_LFramebufferTarget_LFramebufferAttachment_IILTextureTarget_());
	}
	public static MethodHandle glFramebufferTextureFaceEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTextureFaceEXT", MLS_LFramebufferTarget_LFramebufferAttachment_IILTextureTarget_(), PS_LFramebufferTarget_LFramebufferAttachment_IILTextureTarget_());
	}
	public static MethodHandle glFramebufferTextureLayer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTextureLayer", MLS_LFramebufferTarget_LFramebufferAttachment_III(), PS_LFramebufferTarget_LFramebufferAttachment_III());
	}
	public static MethodHandle glFramebufferTextureLayerARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTextureLayerARB", MLS_LFramebufferTarget_LFramebufferAttachment_III(), PS_LFramebufferTarget_LFramebufferAttachment_III());
	}
	public static MethodHandle glFramebufferTextureLayerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTextureLayerEXT", MLS_LFramebufferTarget_LFramebufferAttachment_III(), PS_LFramebufferTarget_LFramebufferAttachment_III());
	}
	public static MethodHandle glFramebufferTextureLayerDownsampleIMG(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTextureLayerDownsampleIMG", MLS_LFramebufferTarget_LFramebufferAttachment_IIIII(), PS_LFramebufferTarget_LFramebufferAttachment_IIIII());
	}
	public static MethodHandle glFramebufferTextureMultisampleMultiviewOVR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTextureMultisampleMultiviewOVR", MLS_LFramebufferTarget_LFramebufferAttachment_IIIII(), PS_LFramebufferTarget_LFramebufferAttachment_IIIII());
	}
	public static MethodHandle glFramebufferTextureMultiviewOVR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTextureMultiviewOVR", MLS_LFramebufferTarget_LFramebufferAttachment_IIII(), PS_LFramebufferTarget_LFramebufferAttachment_IIII());
	}
	public static MethodHandle glFramebufferTextureOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferTextureOES", MLS_LFramebufferTarget_LFramebufferAttachment_II(), PS_LFramebufferTarget_LFramebufferAttachment_II());
	}
	public static MethodHandle glFreeObjectBufferATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFreeObjectBufferATI", MLS_I(), PS_I());
	}
	public static MethodHandle glFrontFace(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFrontFace", MLS_LFrontFaceDirection_(), PS_LFrontFaceDirection_());
	}
	public static MethodHandle glFrustum(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFrustum", MLS_DDDDDD(), PS_DDDDDD());
	}
	public static MethodHandle glFrustumf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFrustumf", MLS_FFFFFF(), PS_FFFFFF());
	}
	public static MethodHandle glFrustumfOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFrustumfOES", MLS_FFFFFF(), PS_FFFFFF());
	}
	public static MethodHandle glFrustumx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFrustumx", MLS_IIIIII(), PS_IIIIII());
	}
	public static MethodHandle glFrustumxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFrustumxOES", MLS_IIIIII(), PS_IIIIII());
	}
	public static MethodHandle glGenAsyncMarkersSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGenAsyncMarkersSGIX", GLParamTypeSets.ML_I(), int.class, MLS_I(), PS_I());
	}
	public static MethodHandle glGenBuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenBuffers", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenBuffersARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenBuffersARB", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenFencesAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenFencesAPPLE", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenFencesNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenFencesNV", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenFragmentShadersATI(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGenFragmentShadersATI", GLParamTypeSets.ML_I(), int.class, MLS_I(), PS_I());
	}
	public static MethodHandle glGenFramebuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenFramebuffers", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenFramebuffersEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenFramebuffersEXT", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenFramebuffersOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenFramebuffersOES", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenLists(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGenLists", GLParamTypeSets.ML_I(), int.class, MLS_I(), PS_I());
	}
	public static MethodHandle glGenNamesAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenNamesAMD", MLS_EIP(), PS_EIP());
	}
	public static MethodHandle glGenOcclusionQueriesNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenOcclusionQueriesNV", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenPathsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGenPathsNV", GLParamTypeSets.ML_I(), int.class, MLS_I(), PS_I());
	}
	public static MethodHandle glGenPerfMonitorsAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenPerfMonitorsAMD", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenProgramPipelines(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenProgramPipelines", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenProgramPipelinesEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenProgramPipelinesEXT", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenProgramsARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenProgramsARB", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenProgramsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenProgramsNV", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenQueries(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenQueries", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenQueriesARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenQueriesARB", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenQueriesEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenQueriesEXT", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenQueryResourceTagNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenQueryResourceTagNV", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenRenderbuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenRenderbuffers", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenRenderbuffersEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenRenderbuffersEXT", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenRenderbuffersOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenRenderbuffersOES", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenSamplers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenSamplers", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenSemaphoresEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenSemaphoresEXT", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenSymbolsEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGenSymbolsEXT", GLParamTypeSets.ML_I(), int.class, MLS_LDataTypeEXT_LVertexShaderStorageTypeEXT_LParameterRangeEXT_I(), PS_LDataTypeEXT_LVertexShaderStorageTypeEXT_LParameterRangeEXT_I());
	}
	public static MethodHandle glGenTextures(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenTextures", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenTexturesEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenTexturesEXT", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenTransformFeedbacks(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenTransformFeedbacks", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenTransformFeedbacksNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenTransformFeedbacksNV", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenVertexArrays(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenVertexArrays", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenVertexArraysAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenVertexArraysAPPLE", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenVertexArraysOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenVertexArraysOES", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGenVertexShadersEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGenVertexShadersEXT", GLParamTypeSets.ML_I(), int.class, MLS_I(), PS_I());
	}
	public static MethodHandle glGenerateMipmap(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenerateMipmap", MLS_LTextureTarget_(), PS_LTextureTarget_());
	}
	public static MethodHandle glGenerateMipmapEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenerateMipmapEXT", MLS_LTextureTarget_(), PS_LTextureTarget_());
	}
	public static MethodHandle glGenerateMipmapOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenerateMipmapOES", MLS_LTextureTarget_(), PS_LTextureTarget_());
	}
	public static MethodHandle glGenerateMultiTexMipmapEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenerateMultiTexMipmapEXT", MLS_LTextureUnit_LTextureTarget_(), PS_LTextureUnit_LTextureTarget_());
	}
	public static MethodHandle glGenerateTextureMipmap(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenerateTextureMipmap", MLS_I(), PS_I());
	}
	public static MethodHandle glGenerateTextureMipmapEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGenerateTextureMipmapEXT", MLS_ILTextureTarget_(), PS_ILTextureTarget_());
	}
	public static MethodHandle glGetActiveAtomicCounterBufferiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveAtomicCounterBufferiv", MLS_IILAtomicCounterBufferPName_P(), PS_IILAtomicCounterBufferPName_P());
	}
	public static MethodHandle glGetActiveAttrib(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveAttrib", MLS_IIIPPPP(), PS_IIIPPPP());
	}
	public static MethodHandle glGetActiveAttribARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveAttribARB", MLS_IIIPPPP(), PS_IIIPPPP());
	}
	public static MethodHandle glGetActiveSubroutineName(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveSubroutineName", MLS_ILShaderType_IIPP(), PS_ILShaderType_IIPP());
	}
	public static MethodHandle glGetActiveSubroutineUniformName(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveSubroutineUniformName", MLS_ILShaderType_IIPP(), PS_ILShaderType_IIPP());
	}
	public static MethodHandle glGetActiveSubroutineUniformiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveSubroutineUniformiv", MLS_ILShaderType_ILSubroutineParameterName_P(), PS_ILShaderType_ILSubroutineParameterName_P());
	}
	public static MethodHandle glGetActiveUniform(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveUniform", MLS_IIIPPPP(), PS_IIIPPPP());
	}
	public static MethodHandle glGetActiveUniformARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveUniformARB", MLS_IIIPPPP(), PS_IIIPPPP());
	}
	public static MethodHandle glGetActiveUniformBlockName(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveUniformBlockName", MLS_IIIPP(), PS_IIIPP());
	}
	public static MethodHandle glGetActiveUniformBlockiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveUniformBlockiv", MLS_IILUniformBlockPName_P(), PS_IILUniformBlockPName_P());
	}
	public static MethodHandle glGetActiveUniformName(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveUniformName", MLS_IIIPP(), PS_IIIPP());
	}
	public static MethodHandle glGetActiveUniformsiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveUniformsiv", MLS_IIpLUniformPName_P(), PS_IIpLUniformPName_P());
	}
	public static MethodHandle glGetActiveVaryingNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetActiveVaryingNV", MLS_IIIPPPP(), PS_IIIPPPP());
	}
	public static MethodHandle glGetArrayObjectfvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetArrayObjectfvATI", MLS_LEnableCap_LArrayObjectPNameATI_P(), PS_LEnableCap_LArrayObjectPNameATI_P());
	}
	public static MethodHandle glGetArrayObjectivATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetArrayObjectivATI", MLS_LEnableCap_LArrayObjectPNameATI_P(), PS_LEnableCap_LArrayObjectPNameATI_P());
	}
	public static MethodHandle glGetAttachedObjectsARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetAttachedObjectsARB", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetAttachedShaders(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetAttachedShaders", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetAttribLocation(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetAttribLocation", GLParamTypeSets.ML_I(), int.class, MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glGetAttribLocationARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetAttribLocationARB", GLParamTypeSets.ML_I(), int.class, MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glGetBooleanIndexedvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetBooleanIndexedvEXT", MLS_LBufferTarget_IP(), PS_LBufferTarget_IP());
	}
	public static MethodHandle glGetBooleani_v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetBooleani_v", MLS_LBufferTarget_IP(), PS_LBufferTarget_IP());
	}
	public static MethodHandle glGetBooleanv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetBooleanv", MLS_LGetPName_P(), PS_LGetPName_P());
	}
	public static MethodHandle glGetBufferParameteri64v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetBufferParameteri64v", MLS_LBufferTarget_LBufferPNameARB_P(), PS_LBufferTarget_LBufferPNameARB_P());
	}
	public static MethodHandle glGetBufferParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetBufferParameteriv", MLS_LBufferTarget_LBufferPNameARB_P(), PS_LBufferTarget_LBufferPNameARB_P());
	}
	public static MethodHandle glGetBufferParameterivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetBufferParameterivARB", MLS_LBufferTarget_LBufferPNameARB_P(), PS_LBufferTarget_LBufferPNameARB_P());
	}
	public static MethodHandle glGetBufferParameterui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetBufferParameterui64vNV", MLS_LBufferTarget_EP(), PS_LBufferTarget_EP());
	}
	public static MethodHandle glGetBufferPointerv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetBufferPointerv", MLS_LBufferTarget_LBufferPointerNameARB_P(), PS_LBufferTarget_LBufferPointerNameARB_P());
	}
	public static MethodHandle glGetBufferPointervARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetBufferPointervARB", MLS_LBufferTarget_LBufferPointerNameARB_P(), PS_LBufferTarget_LBufferPointerNameARB_P());
	}
	public static MethodHandle glGetBufferPointervOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetBufferPointervOES", MLS_LBufferTarget_LBufferPointerNameARB_P(), PS_LBufferTarget_LBufferPointerNameARB_P());
	}
	public static MethodHandle glGetBufferSubData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetBufferSubData", MLS_LBufferTarget_JJP(), PS_LBufferTarget_JJP());
	}
	public static MethodHandle glGetBufferSubDataARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetBufferSubDataARB", MLS_LBufferTarget_JJP(), PS_LBufferTarget_JJP());
	}
	public static MethodHandle glGetClipPlane(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetClipPlane", MLS_LClipPlaneName_P(), PS_LClipPlaneName_P());
	}
	public static MethodHandle glGetClipPlanef(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetClipPlanef", MLS_LClipPlaneName_P(), PS_LClipPlaneName_P());
	}
	public static MethodHandle glGetClipPlanefOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetClipPlanefOES", MLS_LClipPlaneName_P(), PS_LClipPlaneName_P());
	}
	public static MethodHandle glGetClipPlanex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetClipPlanex", MLS_LClipPlaneName_P(), PS_LClipPlaneName_P());
	}
	public static MethodHandle glGetClipPlanexOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetClipPlanexOES", MLS_LClipPlaneName_P(), PS_LClipPlaneName_P());
	}
	public static MethodHandle glGetColorTable(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetColorTable", MLS_LColorTableTarget_LPixelFormat_LPixelType_P(), PS_LColorTableTarget_LPixelFormat_LPixelType_P());
	}
	public static MethodHandle glGetColorTableEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetColorTableEXT", MLS_LColorTableTarget_LPixelFormat_LPixelType_P(), PS_LColorTableTarget_LPixelFormat_LPixelType_P());
	}
	public static MethodHandle glGetColorTableParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetColorTableParameterfv", MLS_LColorTableTarget_LColorTableParameterPName_P(), PS_LColorTableTarget_LColorTableParameterPName_P());
	}
	public static MethodHandle glGetColorTableParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetColorTableParameterfvEXT", MLS_LColorTableTarget_LColorTableParameterPName_P(), PS_LColorTableTarget_LColorTableParameterPName_P());
	}
	public static MethodHandle glGetColorTableParameterfvSGI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetColorTableParameterfvSGI", MLS_LColorTableTargetSGI_LColorTableParameterPName_P(), PS_LColorTableTargetSGI_LColorTableParameterPName_P());
	}
	public static MethodHandle glGetColorTableParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetColorTableParameteriv", MLS_LColorTableTarget_LColorTableParameterPName_P(), PS_LColorTableTarget_LColorTableParameterPName_P());
	}
	public static MethodHandle glGetColorTableParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetColorTableParameterivEXT", MLS_LColorTableTarget_LColorTableParameterPName_P(), PS_LColorTableTarget_LColorTableParameterPName_P());
	}
	public static MethodHandle glGetColorTableParameterivSGI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetColorTableParameterivSGI", MLS_LColorTableTargetSGI_LColorTableParameterPName_P(), PS_LColorTableTargetSGI_LColorTableParameterPName_P());
	}
	public static MethodHandle glGetColorTableSGI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetColorTableSGI", MLS_LColorTableTargetSGI_LPixelFormat_LPixelType_P(), PS_LColorTableTargetSGI_LPixelFormat_LPixelType_P());
	}
	public static MethodHandle glGetCombinerInputParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetCombinerInputParameterfvNV", MLS_LCombinerStageNV_LCombinerPortionNV_LCombinerVariableNV_LCombinerParameterNV_P(), PS_LCombinerStageNV_LCombinerPortionNV_LCombinerVariableNV_LCombinerParameterNV_P());
	}
	public static MethodHandle glGetCombinerInputParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetCombinerInputParameterivNV", MLS_LCombinerStageNV_LCombinerPortionNV_LCombinerVariableNV_LCombinerParameterNV_P(), PS_LCombinerStageNV_LCombinerPortionNV_LCombinerVariableNV_LCombinerParameterNV_P());
	}
	public static MethodHandle glGetCombinerOutputParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetCombinerOutputParameterfvNV", MLS_LCombinerStageNV_LCombinerPortionNV_LCombinerParameterNV_P(), PS_LCombinerStageNV_LCombinerPortionNV_LCombinerParameterNV_P());
	}
	public static MethodHandle glGetCombinerOutputParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetCombinerOutputParameterivNV", MLS_LCombinerStageNV_LCombinerPortionNV_LCombinerParameterNV_P(), PS_LCombinerStageNV_LCombinerPortionNV_LCombinerParameterNV_P());
	}
	public static MethodHandle glGetCombinerStageParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetCombinerStageParameterfvNV", MLS_LCombinerStageNV_LCombinerParameterNV_P(), PS_LCombinerStageNV_LCombinerParameterNV_P());
	}
	public static MethodHandle glGetCommandHeaderNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetCommandHeaderNV", GLParamTypeSets.ML_I(), int.class, MLS_LCommandOpcodesNV_I(), PS_LCommandOpcodesNV_I());
	}
	public static MethodHandle glGetCompressedMultiTexImageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetCompressedMultiTexImageEXT", MLS_LTextureUnit_LTextureTarget_IP(), PS_LTextureUnit_LTextureTarget_IP());
	}
	public static MethodHandle glGetCompressedTexImage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetCompressedTexImage", MLS_LTextureTarget_IP(), PS_LTextureTarget_IP());
	}
	public static MethodHandle glGetCompressedTexImageARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetCompressedTexImageARB", MLS_LTextureTarget_IP(), PS_LTextureTarget_IP());
	}
	public static MethodHandle glGetCompressedTextureImage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetCompressedTextureImage", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetCompressedTextureImageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetCompressedTextureImageEXT", MLS_ILTextureTarget_IP(), PS_ILTextureTarget_IP());
	}
	public static MethodHandle glGetCompressedTextureSubImage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetCompressedTextureSubImage", MLS_IIIIIIIIIP(), PS_IIIIIIIIIP());
	}
	public static MethodHandle glGetConvolutionFilter(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetConvolutionFilter", MLS_LConvolutionTarget_LPixelFormat_LPixelType_P(), PS_LConvolutionTarget_LPixelFormat_LPixelType_P());
	}
	public static MethodHandle glGetConvolutionFilterEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetConvolutionFilterEXT", MLS_LConvolutionTargetEXT_LPixelFormat_LPixelType_P(), PS_LConvolutionTargetEXT_LPixelFormat_LPixelType_P());
	}
	public static MethodHandle glGetConvolutionParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetConvolutionParameterfv", MLS_LConvolutionTarget_LConvolutionParameter_P(), PS_LConvolutionTarget_LConvolutionParameter_P());
	}
	public static MethodHandle glGetConvolutionParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetConvolutionParameterfvEXT", MLS_LConvolutionTargetEXT_LConvolutionParameter_P(), PS_LConvolutionTargetEXT_LConvolutionParameter_P());
	}
	public static MethodHandle glGetConvolutionParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetConvolutionParameteriv", MLS_LConvolutionTarget_LConvolutionParameter_P(), PS_LConvolutionTarget_LConvolutionParameter_P());
	}
	public static MethodHandle glGetConvolutionParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetConvolutionParameterivEXT", MLS_LConvolutionTargetEXT_LConvolutionParameter_P(), PS_LConvolutionTargetEXT_LConvolutionParameter_P());
	}
	public static MethodHandle glGetConvolutionParameterxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetConvolutionParameterxvOES", MLS_EEP(), PS_EEP());
	}
	public static MethodHandle glGetCoverageModulationTableNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetCoverageModulationTableNV", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGetDebugMessageLog(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetDebugMessageLog", GLParamTypeSets.ML_I(), int.class, MLS_IIPPPPPP(), PS_IIPPPPPP());
	}
	public static MethodHandle glGetDebugMessageLogAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetDebugMessageLogAMD", GLParamTypeSets.ML_I(), int.class, MLS_IIPPPPP(), PS_IIPPPPP());
	}
	public static MethodHandle glGetDebugMessageLogARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetDebugMessageLogARB", GLParamTypeSets.ML_I(), int.class, MLS_IIPPPPPP(), PS_IIPPPPPP());
	}
	public static MethodHandle glGetDebugMessageLogKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetDebugMessageLogKHR", GLParamTypeSets.ML_I(), int.class, MLS_IIPPPPPP(), PS_IIPPPPPP());
	}
	public static MethodHandle glGetDetailTexFuncSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetDetailTexFuncSGIS", MLS_LTextureTarget_P(), PS_LTextureTarget_P());
	}
	public static MethodHandle glGetDoubleIndexedvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetDoubleIndexedvEXT", MLS_LGetPName_IP(), PS_LGetPName_IP());
	}
	public static MethodHandle glGetDoublei_v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetDoublei_v", MLS_LGetPName_IP(), PS_LGetPName_IP());
	}
	public static MethodHandle glGetDoublei_vEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetDoublei_vEXT", MLS_LGetPName_IP(), PS_LGetPName_IP());
	}
	public static MethodHandle glGetDoublev(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetDoublev", MLS_LGetPName_P(), PS_LGetPName_P());
	}
	public static MethodHandle glGetDriverControlStringQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetDriverControlStringQCOM", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetDriverControlsQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetDriverControlsQCOM", MLS_PIP(), PS_PIP());
	}
	public static MethodHandle glGetError(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetError", GLParamTypeSets.ML_LErrorCode_(), GLErrorCode.class, MLS_(), PS_());
	}
	public static MethodHandle glGetFenceivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFenceivNV", MLS_ILFenceParameterNameNV_P(), PS_ILFenceParameterNameNV_P());
	}
	public static MethodHandle glGetFinalCombinerInputParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFinalCombinerInputParameterfvNV", MLS_LCombinerVariableNV_LCombinerParameterNV_P(), PS_LCombinerVariableNV_LCombinerParameterNV_P());
	}
	public static MethodHandle glGetFinalCombinerInputParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFinalCombinerInputParameterivNV", MLS_LCombinerVariableNV_LCombinerParameterNV_P(), PS_LCombinerVariableNV_LCombinerParameterNV_P());
	}
	public static MethodHandle glGetFirstPerfQueryIdINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFirstPerfQueryIdINTEL", MLS_P(), PS_P());
	}
	public static MethodHandle glGetFixedv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFixedv", MLS_LGetPName_P(), PS_LGetPName_P());
	}
	public static MethodHandle glGetFixedvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFixedvOES", MLS_LGetPName_P(), PS_LGetPName_P());
	}
	public static MethodHandle glGetFloatIndexedvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFloatIndexedvEXT", MLS_LGetPName_IP(), PS_LGetPName_IP());
	}
	public static MethodHandle glGetFloati_v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFloati_v", MLS_LGetPName_IP(), PS_LGetPName_IP());
	}
	public static MethodHandle glGetFloati_vEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFloati_vEXT", MLS_LGetPName_IP(), PS_LGetPName_IP());
	}
	public static MethodHandle glGetFloati_vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFloati_vNV", MLS_LGetPName_IP(), PS_LGetPName_IP());
	}
	public static MethodHandle glGetFloati_vOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFloati_vOES", MLS_LGetPName_IP(), PS_LGetPName_IP());
	}
	public static MethodHandle glGetFloatv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFloatv", MLS_LGetPName_P(), PS_LGetPName_P());
	}
	public static MethodHandle glGetFogFuncSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFogFuncSGIS", MLS_P(), PS_P());
	}
	public static MethodHandle glGetFragDataIndex(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetFragDataIndex", GLParamTypeSets.ML_I(), int.class, MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glGetFragDataIndexEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetFragDataIndexEXT", GLParamTypeSets.ML_I(), int.class, MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glGetFragDataLocation(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetFragDataLocation", GLParamTypeSets.ML_I(), int.class, MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glGetFragDataLocationEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetFragDataLocationEXT", GLParamTypeSets.ML_I(), int.class, MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glGetFragmentLightfvSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFragmentLightfvSGIX", MLS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_P(), PS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_P());
	}
	public static MethodHandle glGetFragmentLightivSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFragmentLightivSGIX", MLS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_P(), PS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_P());
	}
	public static MethodHandle glGetFragmentMaterialfvSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFragmentMaterialfvSGIX", MLS_LTriangleFace_LMaterialParameter_P(), PS_LTriangleFace_LMaterialParameter_P());
	}
	public static MethodHandle glGetFragmentMaterialivSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFragmentMaterialivSGIX", MLS_LTriangleFace_LMaterialParameter_P(), PS_LTriangleFace_LMaterialParameter_P());
	}
	public static MethodHandle glGetFragmentShadingRatesEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFragmentShadingRatesEXT", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetFramebufferAttachmentParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFramebufferAttachmentParameteriv", MLS_LFramebufferTarget_LFramebufferAttachment_LFramebufferAttachmentParameterName_P(), PS_LFramebufferTarget_LFramebufferAttachment_LFramebufferAttachmentParameterName_P());
	}
	public static MethodHandle glGetFramebufferAttachmentParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFramebufferAttachmentParameterivEXT", MLS_LFramebufferTarget_LFramebufferAttachment_LFramebufferAttachmentParameterName_P(), PS_LFramebufferTarget_LFramebufferAttachment_LFramebufferAttachmentParameterName_P());
	}
	public static MethodHandle glGetFramebufferAttachmentParameterivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFramebufferAttachmentParameterivOES", MLS_LFramebufferTarget_LFramebufferAttachment_LFramebufferAttachmentParameterName_P(), PS_LFramebufferTarget_LFramebufferAttachment_LFramebufferAttachmentParameterName_P());
	}
	public static MethodHandle glGetFramebufferParameterfvAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFramebufferParameterfvAMD", MLS_LFramebufferTarget_LFramebufferAttachmentParameterName_IIIP(), PS_LFramebufferTarget_LFramebufferAttachmentParameterName_IIIP());
	}
	public static MethodHandle glGetFramebufferParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFramebufferParameteriv", MLS_LFramebufferTarget_LFramebufferAttachmentParameterName_P(), PS_LFramebufferTarget_LFramebufferAttachmentParameterName_P());
	}
	public static MethodHandle glGetFramebufferParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFramebufferParameterivEXT", MLS_ILGetFramebufferParameter_P(), PS_ILGetFramebufferParameter_P());
	}
	public static MethodHandle glGetFramebufferPixelLocalStorageSizeEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetFramebufferPixelLocalStorageSizeEXT", GLParamTypeSets.ML_I(), int.class, MLS_I(), PS_I());
	}
	public static MethodHandle glGetGraphicsResetStatus(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetGraphicsResetStatus", GLParamTypeSets.ML_LGraphicsResetStatus_(), GLGraphicsResetStatus.class, MLS_(), PS_());
	}
	public static MethodHandle glGetGraphicsResetStatusARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetGraphicsResetStatusARB", GLParamTypeSets.ML_LGraphicsResetStatus_(), GLGraphicsResetStatus.class, MLS_(), PS_());
	}
	public static MethodHandle glGetGraphicsResetStatusEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetGraphicsResetStatusEXT", GLParamTypeSets.ML_LGraphicsResetStatus_(), GLGraphicsResetStatus.class, MLS_(), PS_());
	}
	public static MethodHandle glGetGraphicsResetStatusKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetGraphicsResetStatusKHR", GLParamTypeSets.ML_LGraphicsResetStatus_(), GLGraphicsResetStatus.class, MLS_(), PS_());
	}
	public static MethodHandle glGetHandleARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetHandleARB", GLParamTypeSets.ML_I(), int.class, MLS_LContainerType_(), PS_LContainerType_());
	}
	public static MethodHandle glGetHistogram(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetHistogram", MLS_LHistogramTargetEXT_ZLPixelFormat_LPixelType_P(), PS_LHistogramTargetEXT_ZLPixelFormat_LPixelType_P());
	}
	public static MethodHandle glGetHistogramEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetHistogramEXT", MLS_LHistogramTargetEXT_ZLPixelFormat_LPixelType_P(), PS_LHistogramTargetEXT_ZLPixelFormat_LPixelType_P());
	}
	public static MethodHandle glGetHistogramParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetHistogramParameterfv", MLS_LHistogramTargetEXT_LGetHistogramParameterPNameEXT_P(), PS_LHistogramTargetEXT_LGetHistogramParameterPNameEXT_P());
	}
	public static MethodHandle glGetHistogramParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetHistogramParameterfvEXT", MLS_LHistogramTargetEXT_LGetHistogramParameterPNameEXT_P(), PS_LHistogramTargetEXT_LGetHistogramParameterPNameEXT_P());
	}
	public static MethodHandle glGetHistogramParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetHistogramParameteriv", MLS_LHistogramTargetEXT_LGetHistogramParameterPNameEXT_P(), PS_LHistogramTargetEXT_LGetHistogramParameterPNameEXT_P());
	}
	public static MethodHandle glGetHistogramParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetHistogramParameterivEXT", MLS_LHistogramTargetEXT_LGetHistogramParameterPNameEXT_P(), PS_LHistogramTargetEXT_LGetHistogramParameterPNameEXT_P());
	}
	public static MethodHandle glGetHistogramParameterxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetHistogramParameterxvOES", MLS_LHistogramTargetEXT_LGetHistogramParameterPNameEXT_P(), PS_LHistogramTargetEXT_LGetHistogramParameterPNameEXT_P());
	}
	public static MethodHandle glGetImageHandleARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetImageHandleARB", GLParamTypeSets.ML_J(), long.class, MLS_IIZILPixelFormat_(), PS_IIZILPixelFormat_());
	}
	public static MethodHandle glGetImageHandleNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetImageHandleNV", GLParamTypeSets.ML_J(), long.class, MLS_IIZILPixelFormat_(), PS_IIZILPixelFormat_());
	}
	public static MethodHandle glGetImageTransformParameterfvHP(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetImageTransformParameterfvHP", MLS_LImageTransformTargetHP_LImageTransformPNameHP_P(), PS_LImageTransformTargetHP_LImageTransformPNameHP_P());
	}
	public static MethodHandle glGetImageTransformParameterivHP(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetImageTransformParameterivHP", MLS_LImageTransformTargetHP_LImageTransformPNameHP_P(), PS_LImageTransformTargetHP_LImageTransformPNameHP_P());
	}
	public static MethodHandle glGetInfoLogARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetInfoLogARB", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetInstrumentsSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetInstrumentsSGIX", GLParamTypeSets.ML_I(), int.class, MLS_(), PS_());
	}
	public static MethodHandle glGetInteger64i_v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetInteger64i_v", MLS_LGetPName_IP(), PS_LGetPName_IP());
	}
	public static MethodHandle glGetInteger64v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetInteger64v", MLS_LGetPName_P(), PS_LGetPName_P());
	}
	public static MethodHandle glGetInteger64vAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetInteger64vAPPLE", MLS_LGetPName_P(), PS_LGetPName_P());
	}
	public static MethodHandle glGetInteger64vEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetInteger64vEXT", MLS_LGetPName_P(), PS_LGetPName_P());
	}
	public static MethodHandle glGetIntegerIndexedvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetIntegerIndexedvEXT", MLS_LGetPName_IP(), PS_LGetPName_IP());
	}
	public static MethodHandle glGetIntegeri_v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetIntegeri_v", MLS_LGetPName_IP(), PS_LGetPName_IP());
	}
	public static MethodHandle glGetIntegeri_vEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetIntegeri_vEXT", MLS_LGetPName_IP(), PS_LGetPName_IP());
	}
	public static MethodHandle glGetIntegerui64i_vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetIntegerui64i_vNV", MLS_EIP(), PS_EIP());
	}
	public static MethodHandle glGetIntegerui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetIntegerui64vNV", MLS_EP(), PS_EP());
	}
	public static MethodHandle glGetIntegerv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetIntegerv", MLS_LGetPName_P(), PS_LGetPName_P());
	}
	public static MethodHandle glGetInternalformatSampleivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetInternalformatSampleivNV", MLS_LTextureTarget_LInternalFormat_ILInternalFormatPName_IP(), PS_LTextureTarget_LInternalFormat_ILInternalFormatPName_IP());
	}
	public static MethodHandle glGetInternalformati64v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetInternalformati64v", MLS_LTextureTarget_LInternalFormat_LInternalFormatPName_IP(), PS_LTextureTarget_LInternalFormat_LInternalFormatPName_IP());
	}
	public static MethodHandle glGetInternalformativ(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetInternalformativ", MLS_LTextureTarget_LInternalFormat_LInternalFormatPName_IP(), PS_LTextureTarget_LInternalFormat_LInternalFormatPName_IP());
	}
	public static MethodHandle glGetInvariantBooleanvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetInvariantBooleanvEXT", MLS_ILGetVariantValueEXT_P(), PS_ILGetVariantValueEXT_P());
	}
	public static MethodHandle glGetInvariantFloatvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetInvariantFloatvEXT", MLS_ILGetVariantValueEXT_P(), PS_ILGetVariantValueEXT_P());
	}
	public static MethodHandle glGetInvariantIntegervEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetInvariantIntegervEXT", MLS_ILGetVariantValueEXT_P(), PS_ILGetVariantValueEXT_P());
	}
	public static MethodHandle glGetLightfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetLightfv", MLS_LLightName_LLightParameter_P(), PS_LLightName_LLightParameter_P());
	}
	public static MethodHandle glGetLightiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetLightiv", MLS_LLightName_LLightParameter_P(), PS_LLightName_LLightParameter_P());
	}
	public static MethodHandle glGetLightxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetLightxOES", MLS_LLightName_LLightParameter_P(), PS_LLightName_LLightParameter_P());
	}
	public static MethodHandle glGetLightxv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetLightxv", MLS_LLightName_LLightParameter_P(), PS_LLightName_LLightParameter_P());
	}
	public static MethodHandle glGetLightxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetLightxvOES", MLS_LLightName_LLightParameter_P(), PS_LLightName_LLightParameter_P());
	}
	public static MethodHandle glGetListParameterfvSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetListParameterfvSGIX", MLS_ILListParameterName_P(), PS_ILListParameterName_P());
	}
	public static MethodHandle glGetListParameterivSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetListParameterivSGIX", MLS_ILListParameterName_P(), PS_ILListParameterName_P());
	}
	public static MethodHandle glGetLocalConstantBooleanvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetLocalConstantBooleanvEXT", MLS_ILGetVariantValueEXT_P(), PS_ILGetVariantValueEXT_P());
	}
	public static MethodHandle glGetLocalConstantFloatvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetLocalConstantFloatvEXT", MLS_ILGetVariantValueEXT_P(), PS_ILGetVariantValueEXT_P());
	}
	public static MethodHandle glGetLocalConstantIntegervEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetLocalConstantIntegervEXT", MLS_ILGetVariantValueEXT_P(), PS_ILGetVariantValueEXT_P());
	}
	public static MethodHandle glGetMapAttribParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMapAttribParameterfvNV", MLS_LEvalTargetNV_ILMapAttribParameterNV_P(), PS_LEvalTargetNV_ILMapAttribParameterNV_P());
	}
	public static MethodHandle glGetMapAttribParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMapAttribParameterivNV", MLS_LEvalTargetNV_ILMapAttribParameterNV_P(), PS_LEvalTargetNV_ILMapAttribParameterNV_P());
	}
	public static MethodHandle glGetMapControlPointsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMapControlPointsNV", MLS_LEvalTargetNV_ILMapTypeNV_IIZP(), PS_LEvalTargetNV_ILMapTypeNV_IIZP());
	}
	public static MethodHandle glGetMapParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMapParameterfvNV", MLS_LEvalTargetNV_LMapParameterNV_P(), PS_LEvalTargetNV_LMapParameterNV_P());
	}
	public static MethodHandle glGetMapParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMapParameterivNV", MLS_LEvalTargetNV_LMapParameterNV_P(), PS_LEvalTargetNV_LMapParameterNV_P());
	}
	public static MethodHandle glGetMapdv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMapdv", MLS_LMapTarget_LGetMapQuery_P(), PS_LMapTarget_LGetMapQuery_P());
	}
	public static MethodHandle glGetMapfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMapfv", MLS_LMapTarget_LGetMapQuery_P(), PS_LMapTarget_LGetMapQuery_P());
	}
	public static MethodHandle glGetMapiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMapiv", MLS_LMapTarget_LGetMapQuery_P(), PS_LMapTarget_LGetMapQuery_P());
	}
	public static MethodHandle glGetMapxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMapxvOES", MLS_LMapTarget_LGetMapQuery_P(), PS_LMapTarget_LGetMapQuery_P());
	}
	public static MethodHandle glGetMaterialfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMaterialfv", MLS_LTriangleFace_LMaterialParameter_P(), PS_LTriangleFace_LMaterialParameter_P());
	}
	public static MethodHandle glGetMaterialiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMaterialiv", MLS_LTriangleFace_LMaterialParameter_P(), PS_LTriangleFace_LMaterialParameter_P());
	}
	public static MethodHandle glGetMaterialxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMaterialxOES", MLS_LTriangleFace_LMaterialParameter_I(), PS_LTriangleFace_LMaterialParameter_I());
	}
	public static MethodHandle glGetMaterialxv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMaterialxv", MLS_LTriangleFace_LMaterialParameter_P(), PS_LTriangleFace_LMaterialParameter_P());
	}
	public static MethodHandle glGetMaterialxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMaterialxvOES", MLS_LTriangleFace_LMaterialParameter_P(), PS_LTriangleFace_LMaterialParameter_P());
	}
	public static MethodHandle glGetMemoryObjectDetachedResourcesuivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMemoryObjectDetachedResourcesuivNV", MLS_IEIIP(), PS_IEIIP());
	}
	public static MethodHandle glGetMemoryObjectParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMemoryObjectParameterivEXT", MLS_ILMemoryObjectParameterName_P(), PS_ILMemoryObjectParameterName_P());
	}
	public static MethodHandle glGetMinmax(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMinmax", MLS_LMinmaxTargetEXT_ZLPixelFormat_LPixelType_P(), PS_LMinmaxTargetEXT_ZLPixelFormat_LPixelType_P());
	}
	public static MethodHandle glGetMinmaxEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMinmaxEXT", MLS_LMinmaxTargetEXT_ZLPixelFormat_LPixelType_P(), PS_LMinmaxTargetEXT_ZLPixelFormat_LPixelType_P());
	}
	public static MethodHandle glGetMinmaxParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMinmaxParameterfv", MLS_LMinmaxTargetEXT_LGetMinmaxParameterPNameEXT_P(), PS_LMinmaxTargetEXT_LGetMinmaxParameterPNameEXT_P());
	}
	public static MethodHandle glGetMinmaxParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMinmaxParameterfvEXT", MLS_LMinmaxTargetEXT_LGetMinmaxParameterPNameEXT_P(), PS_LMinmaxTargetEXT_LGetMinmaxParameterPNameEXT_P());
	}
	public static MethodHandle glGetMinmaxParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMinmaxParameteriv", MLS_LMinmaxTargetEXT_LGetMinmaxParameterPNameEXT_P(), PS_LMinmaxTargetEXT_LGetMinmaxParameterPNameEXT_P());
	}
	public static MethodHandle glGetMinmaxParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMinmaxParameterivEXT", MLS_LMinmaxTargetEXT_LGetMinmaxParameterPNameEXT_P(), PS_LMinmaxTargetEXT_LGetMinmaxParameterPNameEXT_P());
	}
	public static MethodHandle glGetMultiTexEnvfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultiTexEnvfvEXT", MLS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_P(), PS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_P());
	}
	public static MethodHandle glGetMultiTexEnvivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultiTexEnvivEXT", MLS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_P(), PS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_P());
	}
	public static MethodHandle glGetMultiTexGendvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultiTexGendvEXT", MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_P(), PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_P());
	}
	public static MethodHandle glGetMultiTexGenfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultiTexGenfvEXT", MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_P(), PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_P());
	}
	public static MethodHandle glGetMultiTexGenivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultiTexGenivEXT", MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_P(), PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_P());
	}
	public static MethodHandle glGetMultiTexImageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultiTexImageEXT", MLS_LTextureUnit_LTextureTarget_ILPixelFormat_LPixelType_P(), PS_LTextureUnit_LTextureTarget_ILPixelFormat_LPixelType_P());
	}
	public static MethodHandle glGetMultiTexLevelParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultiTexLevelParameterfvEXT", MLS_LTextureUnit_LTextureTarget_ILGetTextureParameter_P(), PS_LTextureUnit_LTextureTarget_ILGetTextureParameter_P());
	}
	public static MethodHandle glGetMultiTexLevelParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultiTexLevelParameterivEXT", MLS_LTextureUnit_LTextureTarget_ILGetTextureParameter_P(), PS_LTextureUnit_LTextureTarget_ILGetTextureParameter_P());
	}
	public static MethodHandle glGetMultiTexParameterIivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultiTexParameterIivEXT", MLS_LTextureUnit_LTextureTarget_LGetTextureParameter_P(), PS_LTextureUnit_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetMultiTexParameterIuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultiTexParameterIuivEXT", MLS_LTextureUnit_LTextureTarget_LGetTextureParameter_P(), PS_LTextureUnit_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetMultiTexParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultiTexParameterfvEXT", MLS_LTextureUnit_LTextureTarget_LGetTextureParameter_P(), PS_LTextureUnit_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetMultiTexParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultiTexParameterivEXT", MLS_LTextureUnit_LTextureTarget_LGetTextureParameter_P(), PS_LTextureUnit_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetMultisamplefv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultisamplefv", MLS_LGetMultisamplePNameNV_IP(), PS_LGetMultisamplePNameNV_IP());
	}
	public static MethodHandle glGetMultisamplefvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetMultisamplefvNV", MLS_LGetMultisamplePNameNV_IP(), PS_LGetMultisamplePNameNV_IP());
	}
	public static MethodHandle glGetNamedBufferParameteri64v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedBufferParameteri64v", MLS_ILBufferPNameARB_P(), PS_ILBufferPNameARB_P());
	}
	public static MethodHandle glGetNamedBufferParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedBufferParameteriv", MLS_ILBufferPNameARB_P(), PS_ILBufferPNameARB_P());
	}
	public static MethodHandle glGetNamedBufferParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedBufferParameterivEXT", MLS_ILBufferPNameARB_P(), PS_ILBufferPNameARB_P());
	}
	public static MethodHandle glGetNamedBufferParameterui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedBufferParameterui64vNV", MLS_ILBufferPNameARB_P(), PS_ILBufferPNameARB_P());
	}
	public static MethodHandle glGetNamedBufferPointerv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedBufferPointerv", MLS_ILBufferPointerNameARB_P(), PS_ILBufferPointerNameARB_P());
	}
	public static MethodHandle glGetNamedBufferPointervEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedBufferPointervEXT", MLS_ILBufferPointerNameARB_P(), PS_ILBufferPointerNameARB_P());
	}
	public static MethodHandle glGetNamedBufferSubData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedBufferSubData", MLS_IJJP(), PS_IJJP());
	}
	public static MethodHandle glGetNamedBufferSubDataEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedBufferSubDataEXT", MLS_IJJP(), PS_IJJP());
	}
	public static MethodHandle glGetNamedFramebufferParameterfvAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedFramebufferParameterfvAMD", MLS_IEIIIP(), PS_IEIIIP());
	}
	public static MethodHandle glGetNamedFramebufferAttachmentParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedFramebufferAttachmentParameteriv", MLS_ILFramebufferAttachment_LFramebufferAttachmentParameterName_P(), PS_ILFramebufferAttachment_LFramebufferAttachmentParameterName_P());
	}
	public static MethodHandle glGetNamedFramebufferAttachmentParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedFramebufferAttachmentParameterivEXT", MLS_ILFramebufferAttachment_LFramebufferAttachmentParameterName_P(), PS_ILFramebufferAttachment_LFramebufferAttachmentParameterName_P());
	}
	public static MethodHandle glGetNamedFramebufferParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedFramebufferParameteriv", MLS_ILGetFramebufferParameter_P(), PS_ILGetFramebufferParameter_P());
	}
	public static MethodHandle glGetNamedFramebufferParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedFramebufferParameterivEXT", MLS_ILGetFramebufferParameter_P(), PS_ILGetFramebufferParameter_P());
	}
	public static MethodHandle glGetNamedProgramLocalParameterIivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedProgramLocalParameterIivEXT", MLS_ILProgramTarget_IP(), PS_ILProgramTarget_IP());
	}
	public static MethodHandle glGetNamedProgramLocalParameterIuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedProgramLocalParameterIuivEXT", MLS_ILProgramTarget_IP(), PS_ILProgramTarget_IP());
	}
	public static MethodHandle glGetNamedProgramLocalParameterdvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedProgramLocalParameterdvEXT", MLS_ILProgramTarget_IP(), PS_ILProgramTarget_IP());
	}
	public static MethodHandle glGetNamedProgramLocalParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedProgramLocalParameterfvEXT", MLS_ILProgramTarget_IP(), PS_ILProgramTarget_IP());
	}
	public static MethodHandle glGetNamedProgramStringEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedProgramStringEXT", MLS_ILProgramTarget_LProgramStringProperty_P(), PS_ILProgramTarget_LProgramStringProperty_P());
	}
	public static MethodHandle glGetNamedProgramivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedProgramivEXT", MLS_ILProgramTarget_LProgramPropertyARB_P(), PS_ILProgramTarget_LProgramPropertyARB_P());
	}
	public static MethodHandle glGetNamedRenderbufferParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedRenderbufferParameteriv", MLS_ILRenderbufferParameterName_P(), PS_ILRenderbufferParameterName_P());
	}
	public static MethodHandle glGetNamedRenderbufferParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedRenderbufferParameterivEXT", MLS_ILRenderbufferParameterName_P(), PS_ILRenderbufferParameterName_P());
	}
	public static MethodHandle glGetNamedStringARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedStringARB", MLS_IpIPP(), PS_IpIPP());
	}
	public static MethodHandle glGetNamedStringivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNamedStringivARB", MLS_IpEP(), PS_IpEP());
	}
	public static MethodHandle glGetNextPerfQueryIdINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetNextPerfQueryIdINTEL", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGetObjectBufferfvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetObjectBufferfvATI", MLS_ILArrayObjectPNameATI_P(), PS_ILArrayObjectPNameATI_P());
	}
	public static MethodHandle glGetObjectBufferivATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetObjectBufferivATI", MLS_ILArrayObjectPNameATI_P(), PS_ILArrayObjectPNameATI_P());
	}
	public static MethodHandle glGetObjectLabel(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetObjectLabel", MLS_LObjectIdentifier_IIPP(), PS_LObjectIdentifier_IIPP());
	}
	public static MethodHandle glGetObjectLabelEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetObjectLabelEXT", MLS_EIIPP(), PS_EIIPP());
	}
	public static MethodHandle glGetObjectLabelKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetObjectLabelKHR", MLS_EIIPP(), PS_EIIPP());
	}
	public static MethodHandle glGetObjectParameterfvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetObjectParameterfvARB", MLS_IEP(), PS_IEP());
	}
	public static MethodHandle glGetObjectParameterivAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetObjectParameterivAPPLE", MLS_EIEP(), PS_EIEP());
	}
	public static MethodHandle glGetObjectParameterivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetObjectParameterivARB", MLS_IEP(), PS_IEP());
	}
	public static MethodHandle glGetObjectPtrLabel(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetObjectPtrLabel", MLS_pIPP(), PS_pIPP());
	}
	public static MethodHandle glGetObjectPtrLabelKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetObjectPtrLabelKHR", MLS_pIPP(), PS_pIPP());
	}
	public static MethodHandle glGetOcclusionQueryivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetOcclusionQueryivNV", MLS_ILOcclusionQueryParameterNameNV_P(), PS_ILOcclusionQueryParameterNameNV_P());
	}
	public static MethodHandle glGetOcclusionQueryuivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetOcclusionQueryuivNV", MLS_ILOcclusionQueryParameterNameNV_P(), PS_ILOcclusionQueryParameterNameNV_P());
	}
	public static MethodHandle glGetPathColorGenfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPathColorGenfvNV", MLS_LPathColor_LPathGenMode_P(), PS_LPathColor_LPathGenMode_P());
	}
	public static MethodHandle glGetPathColorGenivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPathColorGenivNV", MLS_LPathColor_LPathGenMode_P(), PS_LPathColor_LPathGenMode_P());
	}
	public static MethodHandle glGetPathCommandsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPathCommandsNV", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGetPathCoordsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPathCoordsNV", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGetPathDashArrayNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPathDashArrayNV", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGetPathLengthNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetPathLengthNV", GLParamTypeSets.ML_F(), float.class, MLS_III(), PS_III());
	}
	public static MethodHandle glGetPathMetricRangeNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPathMetricRangeNV", MLS_IIIIP(), PS_IIIIP());
	}
	public static MethodHandle glGetPathMetricsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPathMetricsNV", MLS_IILPathElementType_pIIP(), PS_IILPathElementType_pIIP());
	}
	public static MethodHandle glGetPathParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPathParameterfvNV", MLS_ILPathParameter_P(), PS_ILPathParameter_P());
	}
	public static MethodHandle glGetPathParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPathParameterivNV", MLS_ILPathParameter_P(), PS_ILPathParameter_P());
	}
	public static MethodHandle glGetPathSpacingNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPathSpacingNV", MLS_LPathListMode_ILPathElementType_pIFFLPathTransformType_P(), PS_LPathListMode_ILPathElementType_pIFFLPathTransformType_P());
	}
	public static MethodHandle glGetPathTexGenfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPathTexGenfvNV", MLS_LTextureUnit_LPathGenMode_P(), PS_LTextureUnit_LPathGenMode_P());
	}
	public static MethodHandle glGetPathTexGenivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPathTexGenivNV", MLS_LTextureUnit_LPathGenMode_P(), PS_LTextureUnit_LPathGenMode_P());
	}
	public static MethodHandle glGetPerfCounterInfoINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPerfCounterInfoINTEL", MLS_IIIPIPPPPPP(), PS_IIIPIPPPPPP());
	}
	public static MethodHandle glGetPerfMonitorCounterDataAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPerfMonitorCounterDataAMD", MLS_IEIPP(), PS_IEIPP());
	}
	public static MethodHandle glGetPerfMonitorCounterInfoAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPerfMonitorCounterInfoAMD", MLS_IIEP(), PS_IIEP());
	}
	public static MethodHandle glGetPerfMonitorCounterStringAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPerfMonitorCounterStringAMD", MLS_IIIPP(), PS_IIIPP());
	}
	public static MethodHandle glGetPerfMonitorCountersAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPerfMonitorCountersAMD", MLS_IPPIP(), PS_IPPIP());
	}
	public static MethodHandle glGetPerfMonitorGroupStringAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPerfMonitorGroupStringAMD", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetPerfMonitorGroupsAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPerfMonitorGroupsAMD", MLS_PIP(), PS_PIP());
	}
	public static MethodHandle glGetPerfQueryDataINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPerfQueryDataINTEL", MLS_IIIPP(), PS_IIIPP());
	}
	public static MethodHandle glGetPerfQueryIdByNameINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPerfQueryIdByNameINTEL", MLS_PP(), PS_PP());
	}
	public static MethodHandle glGetPerfQueryInfoINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPerfQueryInfoINTEL", MLS_IIPPPPP(), PS_IIPPPPP());
	}
	public static MethodHandle glGetPixelMapfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPixelMapfv", MLS_LPixelMap_P(), PS_LPixelMap_P());
	}
	public static MethodHandle glGetPixelMapuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPixelMapuiv", MLS_LPixelMap_P(), PS_LPixelMap_P());
	}
	public static MethodHandle glGetPixelMapusv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPixelMapusv", MLS_LPixelMap_P(), PS_LPixelMap_P());
	}
	public static MethodHandle glGetPixelMapxv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPixelMapxv", MLS_LPixelMap_IP(), PS_LPixelMap_IP());
	}
	public static MethodHandle glGetPixelTexGenParameterfvSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPixelTexGenParameterfvSGIS", MLS_LPixelTexGenParameterNameSGIS_P(), PS_LPixelTexGenParameterNameSGIS_P());
	}
	public static MethodHandle glGetPixelTexGenParameterivSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPixelTexGenParameterivSGIS", MLS_LPixelTexGenParameterNameSGIS_P(), PS_LPixelTexGenParameterNameSGIS_P());
	}
	public static MethodHandle glGetPixelTransformParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPixelTransformParameterfvEXT", MLS_EEP(), PS_EEP());
	}
	public static MethodHandle glGetPixelTransformParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPixelTransformParameterivEXT", MLS_EEP(), PS_EEP());
	}
	public static MethodHandle glGetPointerIndexedvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPointerIndexedvEXT", MLS_EIP(), PS_EIP());
	}
	public static MethodHandle glGetPointeri_vEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPointeri_vEXT", MLS_EIP(), PS_EIP());
	}
	public static MethodHandle glGetPointerv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPointerv", MLS_LGetPointervPName_P(), PS_LGetPointervPName_P());
	}
	public static MethodHandle glGetPointervEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPointervEXT", MLS_LGetPointervPName_P(), PS_LGetPointervPName_P());
	}
	public static MethodHandle glGetPointervKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPointervKHR", MLS_EP(), PS_EP());
	}
	public static MethodHandle glGetPolygonStipple(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetPolygonStipple", MLS_P(), PS_P());
	}
	public static MethodHandle glGetProgramBinary(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramBinary", MLS_IIPPP(), PS_IIPPP());
	}
	public static MethodHandle glGetProgramBinaryOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramBinaryOES", MLS_IIPPP(), PS_IIPPP());
	}
	public static MethodHandle glGetProgramEnvParameterIivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramEnvParameterIivNV", MLS_LProgramTarget_IP(), PS_LProgramTarget_IP());
	}
	public static MethodHandle glGetProgramEnvParameterIuivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramEnvParameterIuivNV", MLS_LProgramTarget_IP(), PS_LProgramTarget_IP());
	}
	public static MethodHandle glGetProgramEnvParameterdvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramEnvParameterdvARB", MLS_LProgramTarget_IP(), PS_LProgramTarget_IP());
	}
	public static MethodHandle glGetProgramEnvParameterfvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramEnvParameterfvARB", MLS_LProgramTarget_IP(), PS_LProgramTarget_IP());
	}
	public static MethodHandle glGetProgramInfoLog(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramInfoLog", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetProgramInterfaceiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramInterfaceiv", MLS_ILProgramInterface_LProgramInterfacePName_P(), PS_ILProgramInterface_LProgramInterfacePName_P());
	}
	public static MethodHandle glGetProgramLocalParameterIivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramLocalParameterIivNV", MLS_LProgramTarget_IP(), PS_LProgramTarget_IP());
	}
	public static MethodHandle glGetProgramLocalParameterIuivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramLocalParameterIuivNV", MLS_LProgramTarget_IP(), PS_LProgramTarget_IP());
	}
	public static MethodHandle glGetProgramLocalParameterdvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramLocalParameterdvARB", MLS_LProgramTarget_IP(), PS_LProgramTarget_IP());
	}
	public static MethodHandle glGetProgramLocalParameterfvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramLocalParameterfvARB", MLS_LProgramTarget_IP(), PS_LProgramTarget_IP());
	}
	public static MethodHandle glGetProgramNamedParameterdvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramNamedParameterdvNV", MLS_IIpP(), PS_IIpP());
	}
	public static MethodHandle glGetProgramNamedParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramNamedParameterfvNV", MLS_IIpP(), PS_IIpP());
	}
	public static MethodHandle glGetProgramParameterdvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramParameterdvNV", MLS_LVertexAttribEnumNV_ILVertexAttribEnumNV_P(), PS_LVertexAttribEnumNV_ILVertexAttribEnumNV_P());
	}
	public static MethodHandle glGetProgramParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramParameterfvNV", MLS_LVertexAttribEnumNV_ILVertexAttribEnumNV_P(), PS_LVertexAttribEnumNV_ILVertexAttribEnumNV_P());
	}
	public static MethodHandle glGetProgramPipelineInfoLog(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramPipelineInfoLog", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetProgramPipelineInfoLogEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramPipelineInfoLogEXT", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetProgramPipelineiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramPipelineiv", MLS_ILPipelineParameterName_P(), PS_ILPipelineParameterName_P());
	}
	public static MethodHandle glGetProgramPipelineivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramPipelineivEXT", MLS_ILPipelineParameterName_P(), PS_ILPipelineParameterName_P());
	}
	public static MethodHandle glGetProgramResourceIndex(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetProgramResourceIndex", GLParamTypeSets.ML_I(), int.class, MLS_ILProgramInterface_p(), PS_ILProgramInterface_p());
	}
	public static MethodHandle glGetProgramResourceLocation(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetProgramResourceLocation", GLParamTypeSets.ML_I(), int.class, MLS_ILProgramInterface_p(), PS_ILProgramInterface_p());
	}
	public static MethodHandle glGetProgramResourceLocationIndex(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetProgramResourceLocationIndex", GLParamTypeSets.ML_I(), int.class, MLS_ILProgramInterface_p(), PS_ILProgramInterface_p());
	}
	public static MethodHandle glGetProgramResourceLocationIndexEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetProgramResourceLocationIndexEXT", GLParamTypeSets.ML_I(), int.class, MLS_ILProgramInterface_p(), PS_ILProgramInterface_p());
	}
	public static MethodHandle glGetProgramResourceName(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramResourceName", MLS_ILProgramInterface_IIPP(), PS_ILProgramInterface_IIPP());
	}
	public static MethodHandle glGetProgramResourcefvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramResourcefvNV", MLS_ILProgramInterface_IIpIPP(), PS_ILProgramInterface_IIpIPP());
	}
	public static MethodHandle glGetProgramResourceiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramResourceiv", MLS_ILProgramInterface_IIpIPP(), PS_ILProgramInterface_IIpIPP());
	}
	public static MethodHandle glGetProgramStageiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramStageiv", MLS_ILShaderType_LProgramStagePName_P(), PS_ILShaderType_LProgramStagePName_P());
	}
	public static MethodHandle glGetProgramStringARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramStringARB", MLS_LProgramTarget_LProgramStringProperty_P(), PS_LProgramTarget_LProgramStringProperty_P());
	}
	public static MethodHandle glGetProgramStringNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramStringNV", MLS_ILVertexAttribEnumNV_P(), PS_ILVertexAttribEnumNV_P());
	}
	public static MethodHandle glGetProgramSubroutineParameteruivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramSubroutineParameteruivNV", MLS_EIP(), PS_EIP());
	}
	public static MethodHandle glGetProgramiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramiv", MLS_ILProgramPropertyARB_P(), PS_ILProgramPropertyARB_P());
	}
	public static MethodHandle glGetProgramivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramivARB", MLS_LProgramTarget_LProgramPropertyARB_P(), PS_LProgramTarget_LProgramPropertyARB_P());
	}
	public static MethodHandle glGetProgramivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetProgramivNV", MLS_ILVertexAttribEnumNV_P(), PS_ILVertexAttribEnumNV_P());
	}
	public static MethodHandle glGetQueryBufferObjecti64v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryBufferObjecti64v", MLS_IILQueryObjectParameterName_J(), PS_IILQueryObjectParameterName_J());
	}
	public static MethodHandle glGetQueryBufferObjectiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryBufferObjectiv", MLS_IILQueryObjectParameterName_J(), PS_IILQueryObjectParameterName_J());
	}
	public static MethodHandle glGetQueryBufferObjectui64v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryBufferObjectui64v", MLS_IILQueryObjectParameterName_J(), PS_IILQueryObjectParameterName_J());
	}
	public static MethodHandle glGetQueryBufferObjectuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryBufferObjectuiv", MLS_IILQueryObjectParameterName_J(), PS_IILQueryObjectParameterName_J());
	}
	public static MethodHandle glGetQueryIndexediv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryIndexediv", MLS_LQueryTarget_ILQueryParameterName_P(), PS_LQueryTarget_ILQueryParameterName_P());
	}
	public static MethodHandle glGetQueryObjecti64v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryObjecti64v", MLS_ILQueryObjectParameterName_P(), PS_ILQueryObjectParameterName_P());
	}
	public static MethodHandle glGetQueryObjecti64vEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryObjecti64vEXT", MLS_ILQueryObjectParameterName_P(), PS_ILQueryObjectParameterName_P());
	}
	public static MethodHandle glGetQueryObjectiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryObjectiv", MLS_ILQueryObjectParameterName_P(), PS_ILQueryObjectParameterName_P());
	}
	public static MethodHandle glGetQueryObjectivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryObjectivARB", MLS_ILQueryObjectParameterName_P(), PS_ILQueryObjectParameterName_P());
	}
	public static MethodHandle glGetQueryObjectivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryObjectivEXT", MLS_ILQueryObjectParameterName_P(), PS_ILQueryObjectParameterName_P());
	}
	public static MethodHandle glGetQueryObjectui64v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryObjectui64v", MLS_ILQueryObjectParameterName_P(), PS_ILQueryObjectParameterName_P());
	}
	public static MethodHandle glGetQueryObjectui64vEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryObjectui64vEXT", MLS_ILQueryObjectParameterName_P(), PS_ILQueryObjectParameterName_P());
	}
	public static MethodHandle glGetQueryObjectuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryObjectuiv", MLS_ILQueryObjectParameterName_P(), PS_ILQueryObjectParameterName_P());
	}
	public static MethodHandle glGetQueryObjectuivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryObjectuivARB", MLS_ILQueryObjectParameterName_P(), PS_ILQueryObjectParameterName_P());
	}
	public static MethodHandle glGetQueryObjectuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryObjectuivEXT", MLS_ILQueryObjectParameterName_P(), PS_ILQueryObjectParameterName_P());
	}
	public static MethodHandle glGetQueryiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryiv", MLS_LQueryTarget_LQueryParameterName_P(), PS_LQueryTarget_LQueryParameterName_P());
	}
	public static MethodHandle glGetQueryivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryivARB", MLS_LQueryTarget_LQueryParameterName_P(), PS_LQueryTarget_LQueryParameterName_P());
	}
	public static MethodHandle glGetQueryivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetQueryivEXT", MLS_LQueryTarget_LQueryParameterName_P(), PS_LQueryTarget_LQueryParameterName_P());
	}
	public static MethodHandle glGetRenderbufferParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetRenderbufferParameteriv", MLS_LRenderbufferTarget_LRenderbufferParameterName_P(), PS_LRenderbufferTarget_LRenderbufferParameterName_P());
	}
	public static MethodHandle glGetRenderbufferParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetRenderbufferParameterivEXT", MLS_LRenderbufferTarget_LRenderbufferParameterName_P(), PS_LRenderbufferTarget_LRenderbufferParameterName_P());
	}
	public static MethodHandle glGetRenderbufferParameterivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetRenderbufferParameterivOES", MLS_LRenderbufferTarget_LRenderbufferParameterName_P(), PS_LRenderbufferTarget_LRenderbufferParameterName_P());
	}
	public static MethodHandle glGetSamplerParameterIiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSamplerParameterIiv", MLS_ILSamplerParameterI_P(), PS_ILSamplerParameterI_P());
	}
	public static MethodHandle glGetSamplerParameterIivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSamplerParameterIivEXT", MLS_ILSamplerParameterI_P(), PS_ILSamplerParameterI_P());
	}
	public static MethodHandle glGetSamplerParameterIivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSamplerParameterIivOES", MLS_ILSamplerParameterI_P(), PS_ILSamplerParameterI_P());
	}
	public static MethodHandle glGetSamplerParameterIuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSamplerParameterIuiv", MLS_ILSamplerParameterI_P(), PS_ILSamplerParameterI_P());
	}
	public static MethodHandle glGetSamplerParameterIuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSamplerParameterIuivEXT", MLS_ILSamplerParameterI_P(), PS_ILSamplerParameterI_P());
	}
	public static MethodHandle glGetSamplerParameterIuivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSamplerParameterIuivOES", MLS_ILSamplerParameterI_P(), PS_ILSamplerParameterI_P());
	}
	public static MethodHandle glGetSamplerParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSamplerParameterfv", MLS_ILSamplerParameterF_P(), PS_ILSamplerParameterF_P());
	}
	public static MethodHandle glGetSamplerParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSamplerParameteriv", MLS_ILSamplerParameterI_P(), PS_ILSamplerParameterI_P());
	}
	public static MethodHandle glGetSemaphoreParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSemaphoreParameterivNV", MLS_ILSemaphoreParameterName_P(), PS_ILSemaphoreParameterName_P());
	}
	public static MethodHandle glGetSemaphoreParameterui64vEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSemaphoreParameterui64vEXT", MLS_ILSemaphoreParameterName_P(), PS_ILSemaphoreParameterName_P());
	}
	public static MethodHandle glGetSeparableFilter(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSeparableFilter", MLS_LSeparableTargetEXT_LPixelFormat_LPixelType_PPP(), PS_LSeparableTargetEXT_LPixelFormat_LPixelType_PPP());
	}
	public static MethodHandle glGetSeparableFilterEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSeparableFilterEXT", MLS_LSeparableTargetEXT_LPixelFormat_LPixelType_PPP(), PS_LSeparableTargetEXT_LPixelFormat_LPixelType_PPP());
	}
	public static MethodHandle glGetShaderInfoLog(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetShaderInfoLog", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetShaderPrecisionFormat(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetShaderPrecisionFormat", MLS_LShaderType_LPrecisionType_PP(), PS_LShaderType_LPrecisionType_PP());
	}
	public static MethodHandle glGetShaderSource(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetShaderSource", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetShaderSourceARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetShaderSourceARB", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetShaderiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetShaderiv", MLS_ILShaderParameterName_P(), PS_ILShaderParameterName_P());
	}
	public static MethodHandle glGetShadingRateImagePaletteNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetShadingRateImagePaletteNV", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetShadingRateSampleLocationivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetShadingRateSampleLocationivNV", MLS_EIIP(), PS_EIIP());
	}
	public static MethodHandle glGetSharpenTexFuncSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSharpenTexFuncSGIS", MLS_LTextureTarget_P(), PS_LTextureTarget_P());
	}
	public static MethodHandle glGetStageIndexNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetStageIndexNV", GLParamTypeSets.ML_C(), char.class, MLS_LShaderType_(), PS_LShaderType_());
	}
	public static MethodHandle glGetString(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetString", GLParamTypeSets.ML_p(), ConstPointer.class, MLS_LStringName_(), PS_LStringName_());
	}
	public static MethodHandle glGetStringi(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetStringi", GLParamTypeSets.ML_p(), ConstPointer.class, MLS_LStringName_I(), PS_LStringName_I());
	}
	public static MethodHandle glGetSubroutineIndex(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetSubroutineIndex", GLParamTypeSets.ML_I(), int.class, MLS_ILShaderType_p(), PS_ILShaderType_p());
	}
	public static MethodHandle glGetSubroutineUniformLocation(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetSubroutineUniformLocation", GLParamTypeSets.ML_I(), int.class, MLS_ILShaderType_p(), PS_ILShaderType_p());
	}
	public static MethodHandle glGetSynciv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSynciv", MLS_ILSyncParameterName_IPP(), PS_ILSyncParameterName_IPP());
	}
	public static MethodHandle glGetSyncivAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetSyncivAPPLE", MLS_ILSyncParameterName_IPP(), PS_ILSyncParameterName_IPP());
	}
	public static MethodHandle glGetTexBumpParameterfvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexBumpParameterfvATI", MLS_LGetTexBumpParameterATI_P(), PS_LGetTexBumpParameterATI_P());
	}
	public static MethodHandle glGetTexBumpParameterivATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexBumpParameterivATI", MLS_LGetTexBumpParameterATI_P(), PS_LGetTexBumpParameterATI_P());
	}
	public static MethodHandle glGetTexEnvfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexEnvfv", MLS_LTextureEnvTarget_LTextureEnvParameter_P(), PS_LTextureEnvTarget_LTextureEnvParameter_P());
	}
	public static MethodHandle glGetTexEnviv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexEnviv", MLS_LTextureEnvTarget_LTextureEnvParameter_P(), PS_LTextureEnvTarget_LTextureEnvParameter_P());
	}
	public static MethodHandle glGetTexEnvxv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexEnvxv", MLS_LTextureEnvTarget_LTextureEnvParameter_P(), PS_LTextureEnvTarget_LTextureEnvParameter_P());
	}
	public static MethodHandle glGetTexEnvxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexEnvxvOES", MLS_LTextureEnvTarget_LTextureEnvParameter_P(), PS_LTextureEnvTarget_LTextureEnvParameter_P());
	}
	public static MethodHandle glGetTexFilterFuncSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexFilterFuncSGIS", MLS_LTextureTarget_LTextureFilterSGIS_P(), PS_LTextureTarget_LTextureFilterSGIS_P());
	}
	public static MethodHandle glGetTexGendv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexGendv", MLS_LTextureCoordName_LTextureGenParameter_P(), PS_LTextureCoordName_LTextureGenParameter_P());
	}
	public static MethodHandle glGetTexGenfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexGenfv", MLS_LTextureCoordName_LTextureGenParameter_P(), PS_LTextureCoordName_LTextureGenParameter_P());
	}
	public static MethodHandle glGetTexGenfvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexGenfvOES", MLS_LTextureCoordName_LTextureGenParameter_P(), PS_LTextureCoordName_LTextureGenParameter_P());
	}
	public static MethodHandle glGetTexGeniv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexGeniv", MLS_LTextureCoordName_LTextureGenParameter_P(), PS_LTextureCoordName_LTextureGenParameter_P());
	}
	public static MethodHandle glGetTexGenivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexGenivOES", MLS_LTextureCoordName_LTextureGenParameter_P(), PS_LTextureCoordName_LTextureGenParameter_P());
	}
	public static MethodHandle glGetTexGenxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexGenxvOES", MLS_LTextureCoordName_LTextureGenParameter_P(), PS_LTextureCoordName_LTextureGenParameter_P());
	}
	public static MethodHandle glGetTexImage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexImage", MLS_LTextureTarget_ILPixelFormat_LPixelType_P(), PS_LTextureTarget_ILPixelFormat_LPixelType_P());
	}
	public static MethodHandle glGetTexLevelParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexLevelParameterfv", MLS_LTextureTarget_ILGetTextureParameter_P(), PS_LTextureTarget_ILGetTextureParameter_P());
	}
	public static MethodHandle glGetTexLevelParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexLevelParameteriv", MLS_LTextureTarget_ILGetTextureParameter_P(), PS_LTextureTarget_ILGetTextureParameter_P());
	}
	public static MethodHandle glGetTexLevelParameterxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexLevelParameterxvOES", MLS_LTextureTarget_ILGetTextureParameter_P(), PS_LTextureTarget_ILGetTextureParameter_P());
	}
	public static MethodHandle glGetTexParameterIiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexParameterIiv", MLS_LTextureTarget_LGetTextureParameter_P(), PS_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTexParameterIivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexParameterIivEXT", MLS_LTextureTarget_LGetTextureParameter_P(), PS_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTexParameterIivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexParameterIivOES", MLS_LTextureTarget_LGetTextureParameter_P(), PS_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTexParameterIuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexParameterIuiv", MLS_LTextureTarget_LGetTextureParameter_P(), PS_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTexParameterIuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexParameterIuivEXT", MLS_LTextureTarget_LGetTextureParameter_P(), PS_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTexParameterIuivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexParameterIuivOES", MLS_LTextureTarget_LGetTextureParameter_P(), PS_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTexParameterPointervAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexParameterPointervAPPLE", MLS_EEP(), PS_EEP());
	}
	public static MethodHandle glGetTexParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexParameterfv", MLS_LTextureTarget_LGetTextureParameter_P(), PS_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTexParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexParameteriv", MLS_LTextureTarget_LGetTextureParameter_P(), PS_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTexParameterxv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexParameterxv", MLS_LTextureTarget_LGetTextureParameter_P(), PS_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTexParameterxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTexParameterxvOES", MLS_LTextureTarget_LGetTextureParameter_P(), PS_LTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureHandleARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetTextureHandleARB", GLParamTypeSets.ML_J(), long.class, MLS_I(), PS_I());
	}
	public static MethodHandle glGetTextureHandleIMG(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetTextureHandleIMG", GLParamTypeSets.ML_J(), long.class, MLS_I(), PS_I());
	}
	public static MethodHandle glGetTextureHandleNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetTextureHandleNV", GLParamTypeSets.ML_J(), long.class, MLS_I(), PS_I());
	}
	public static MethodHandle glGetTextureImage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureImage", MLS_IILPixelFormat_LPixelType_IP(), PS_IILPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glGetTextureImageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureImageEXT", MLS_ILTextureTarget_ILPixelFormat_LPixelType_P(), PS_ILTextureTarget_ILPixelFormat_LPixelType_P());
	}
	public static MethodHandle glGetTextureLevelParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureLevelParameterfv", MLS_IILGetTextureParameter_P(), PS_IILGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureLevelParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureLevelParameterfvEXT", MLS_ILTextureTarget_ILGetTextureParameter_P(), PS_ILTextureTarget_ILGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureLevelParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureLevelParameteriv", MLS_IILGetTextureParameter_P(), PS_IILGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureLevelParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureLevelParameterivEXT", MLS_ILTextureTarget_ILGetTextureParameter_P(), PS_ILTextureTarget_ILGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureParameterIiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureParameterIiv", MLS_ILGetTextureParameter_P(), PS_ILGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureParameterIivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureParameterIivEXT", MLS_ILTextureTarget_LGetTextureParameter_P(), PS_ILTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureParameterIuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureParameterIuiv", MLS_ILGetTextureParameter_P(), PS_ILGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureParameterIuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureParameterIuivEXT", MLS_ILTextureTarget_LGetTextureParameter_P(), PS_ILTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureParameterfv", MLS_ILGetTextureParameter_P(), PS_ILGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureParameterfvEXT", MLS_ILTextureTarget_LGetTextureParameter_P(), PS_ILTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureParameteriv", MLS_ILGetTextureParameter_P(), PS_ILGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureParameterivEXT", MLS_ILTextureTarget_LGetTextureParameter_P(), PS_ILTextureTarget_LGetTextureParameter_P());
	}
	public static MethodHandle glGetTextureSamplerHandleARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetTextureSamplerHandleARB", GLParamTypeSets.ML_J(), long.class, MLS_II(), PS_II());
	}
	public static MethodHandle glGetTextureSamplerHandleIMG(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetTextureSamplerHandleIMG", GLParamTypeSets.ML_J(), long.class, MLS_II(), PS_II());
	}
	public static MethodHandle glGetTextureSamplerHandleNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetTextureSamplerHandleNV", GLParamTypeSets.ML_J(), long.class, MLS_II(), PS_II());
	}
	public static MethodHandle glGetTextureSubImage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTextureSubImage", MLS_IIIIIIIILPixelFormat_LPixelType_IP(), PS_IIIIIIIILPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glGetTrackMatrixivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTrackMatrixivNV", MLS_LVertexAttribEnumNV_ILVertexAttribEnumNV_P(), PS_LVertexAttribEnumNV_ILVertexAttribEnumNV_P());
	}
	public static MethodHandle glGetTransformFeedbackVarying(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTransformFeedbackVarying", MLS_IIIPPPP(), PS_IIIPPPP());
	}
	public static MethodHandle glGetTransformFeedbackVaryingEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTransformFeedbackVaryingEXT", MLS_IIIPPPP(), PS_IIIPPPP());
	}
	public static MethodHandle glGetTransformFeedbackVaryingNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTransformFeedbackVaryingNV", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetTransformFeedbacki64_v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTransformFeedbacki64_v", MLS_ILTransformFeedbackPName_IP(), PS_ILTransformFeedbackPName_IP());
	}
	public static MethodHandle glGetTransformFeedbacki_v(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTransformFeedbacki_v", MLS_ILTransformFeedbackPName_IP(), PS_ILTransformFeedbackPName_IP());
	}
	public static MethodHandle glGetTransformFeedbackiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTransformFeedbackiv", MLS_ILTransformFeedbackPName_P(), PS_ILTransformFeedbackPName_P());
	}
	public static MethodHandle glGetTranslatedShaderSourceANGLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetTranslatedShaderSourceANGLE", MLS_IIPP(), PS_IIPP());
	}
	public static MethodHandle glGetUniformBlockIndex(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetUniformBlockIndex", GLParamTypeSets.ML_I(), int.class, MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glGetUniformBufferSizeEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetUniformBufferSizeEXT", GLParamTypeSets.ML_I(), int.class, MLS_II(), PS_II());
	}
	public static MethodHandle glGetUniformIndices(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformIndices", MLS_IIpP(), PS_IIpP());
	}
	public static MethodHandle glGetUniformLocation(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetUniformLocation", GLParamTypeSets.ML_I(), int.class, MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glGetUniformLocationARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetUniformLocationARB", GLParamTypeSets.ML_I(), int.class, MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glGetUniformOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetUniformOffsetEXT", GLParamTypeSets.ML_J(), long.class, MLS_II(), PS_II());
	}
	public static MethodHandle glGetUniformSubroutineuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformSubroutineuiv", MLS_LShaderType_IP(), PS_LShaderType_IP());
	}
	public static MethodHandle glGetUniformdv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformdv", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetUniformfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformfv", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetUniformfvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformfvARB", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetUniformi64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformi64vARB", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetUniformi64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformi64vNV", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetUniformiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformiv", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetUniformivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformivARB", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetUniformui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformui64vARB", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetUniformui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformui64vNV", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetUniformuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformuiv", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetUniformuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUniformuivEXT", MLS_IIP(), PS_IIP());
	}
	public static MethodHandle glGetUnsignedBytevEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUnsignedBytevEXT", MLS_LGetPName_P(), PS_LGetPName_P());
	}
	public static MethodHandle glGetUnsignedBytei_vEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetUnsignedBytei_vEXT", MLS_EIP(), PS_EIP());
	}
	public static MethodHandle glGetVariantArrayObjectfvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVariantArrayObjectfvATI", MLS_ILArrayObjectPNameATI_P(), PS_ILArrayObjectPNameATI_P());
	}
	public static MethodHandle glGetVariantArrayObjectivATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVariantArrayObjectivATI", MLS_ILArrayObjectPNameATI_P(), PS_ILArrayObjectPNameATI_P());
	}
	public static MethodHandle glGetVariantBooleanvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVariantBooleanvEXT", MLS_ILGetVariantValueEXT_P(), PS_ILGetVariantValueEXT_P());
	}
	public static MethodHandle glGetVariantFloatvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVariantFloatvEXT", MLS_ILGetVariantValueEXT_P(), PS_ILGetVariantValueEXT_P());
	}
	public static MethodHandle glGetVariantIntegervEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVariantIntegervEXT", MLS_ILGetVariantValueEXT_P(), PS_ILGetVariantValueEXT_P());
	}
	public static MethodHandle glGetVariantPointervEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVariantPointervEXT", MLS_ILGetVariantValueEXT_P(), PS_ILGetVariantValueEXT_P());
	}
	public static MethodHandle glGetVaryingLocationNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetVaryingLocationNV", GLParamTypeSets.ML_I(), int.class, MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glGetVertexArrayIndexed64iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexArrayIndexed64iv", MLS_IILVertexArrayPName_P(), PS_IILVertexArrayPName_P());
	}
	public static MethodHandle glGetVertexArrayIndexediv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexArrayIndexediv", MLS_IILVertexArrayPName_P(), PS_IILVertexArrayPName_P());
	}
	public static MethodHandle glGetVertexArrayIntegeri_vEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexArrayIntegeri_vEXT", MLS_IILVertexArrayPName_P(), PS_IILVertexArrayPName_P());
	}
	public static MethodHandle glGetVertexArrayIntegervEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexArrayIntegervEXT", MLS_ILVertexArrayPName_P(), PS_ILVertexArrayPName_P());
	}
	public static MethodHandle glGetVertexArrayPointeri_vEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexArrayPointeri_vEXT", MLS_IILVertexArrayPName_P(), PS_IILVertexArrayPName_P());
	}
	public static MethodHandle glGetVertexArrayPointervEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexArrayPointervEXT", MLS_ILVertexArrayPName_P(), PS_ILVertexArrayPName_P());
	}
	public static MethodHandle glGetVertexArrayiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexArrayiv", MLS_ILVertexArrayPName_P(), PS_ILVertexArrayPName_P());
	}
	public static MethodHandle glGetVertexAttribArrayObjectfvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribArrayObjectfvATI", MLS_ILArrayObjectPNameATI_P(), PS_ILArrayObjectPNameATI_P());
	}
	public static MethodHandle glGetVertexAttribArrayObjectivATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribArrayObjectivATI", MLS_ILArrayObjectPNameATI_P(), PS_ILArrayObjectPNameATI_P());
	}
	public static MethodHandle glGetVertexAttribIiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribIiv", MLS_ILVertexAttribEnum_P(), PS_ILVertexAttribEnum_P());
	}
	public static MethodHandle glGetVertexAttribIivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribIivEXT", MLS_ILVertexAttribEnum_P(), PS_ILVertexAttribEnum_P());
	}
	public static MethodHandle glGetVertexAttribIuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribIuiv", MLS_ILVertexAttribEnum_P(), PS_ILVertexAttribEnum_P());
	}
	public static MethodHandle glGetVertexAttribIuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribIuivEXT", MLS_ILVertexAttribEnum_P(), PS_ILVertexAttribEnum_P());
	}
	public static MethodHandle glGetVertexAttribLdv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribLdv", MLS_ILVertexAttribEnum_P(), PS_ILVertexAttribEnum_P());
	}
	public static MethodHandle glGetVertexAttribLdvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribLdvEXT", MLS_ILVertexAttribEnum_P(), PS_ILVertexAttribEnum_P());
	}
	public static MethodHandle glGetVertexAttribLi64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribLi64vNV", MLS_ILVertexAttribEnum_P(), PS_ILVertexAttribEnum_P());
	}
	public static MethodHandle glGetVertexAttribLui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribLui64vARB", MLS_ILVertexAttribEnum_P(), PS_ILVertexAttribEnum_P());
	}
	public static MethodHandle glGetVertexAttribLui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribLui64vNV", MLS_ILVertexAttribEnum_P(), PS_ILVertexAttribEnum_P());
	}
	public static MethodHandle glGetVertexAttribPointerv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribPointerv", MLS_ILVertexAttribPointerPropertyARB_P(), PS_ILVertexAttribPointerPropertyARB_P());
	}
	public static MethodHandle glGetVertexAttribPointervARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribPointervARB", MLS_ILVertexAttribPointerPropertyARB_P(), PS_ILVertexAttribPointerPropertyARB_P());
	}
	public static MethodHandle glGetVertexAttribPointervNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribPointervNV", MLS_ILVertexAttribEnumNV_P(), PS_ILVertexAttribEnumNV_P());
	}
	public static MethodHandle glGetVertexAttribdv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribdv", MLS_ILVertexAttribPropertyARB_P(), PS_ILVertexAttribPropertyARB_P());
	}
	public static MethodHandle glGetVertexAttribdvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribdvARB", MLS_ILVertexAttribPropertyARB_P(), PS_ILVertexAttribPropertyARB_P());
	}
	public static MethodHandle glGetVertexAttribdvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribdvNV", MLS_ILVertexAttribEnumNV_P(), PS_ILVertexAttribEnumNV_P());
	}
	public static MethodHandle glGetVertexAttribfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribfv", MLS_ILVertexAttribPropertyARB_P(), PS_ILVertexAttribPropertyARB_P());
	}
	public static MethodHandle glGetVertexAttribfvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribfvARB", MLS_ILVertexAttribPropertyARB_P(), PS_ILVertexAttribPropertyARB_P());
	}
	public static MethodHandle glGetVertexAttribfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribfvNV", MLS_ILVertexAttribEnumNV_P(), PS_ILVertexAttribEnumNV_P());
	}
	public static MethodHandle glGetVertexAttribiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribiv", MLS_ILVertexAttribPropertyARB_P(), PS_ILVertexAttribPropertyARB_P());
	}
	public static MethodHandle glGetVertexAttribivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribivARB", MLS_ILVertexAttribPropertyARB_P(), PS_ILVertexAttribPropertyARB_P());
	}
	public static MethodHandle glGetVertexAttribivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVertexAttribivNV", MLS_ILVertexAttribEnumNV_P(), PS_ILVertexAttribEnumNV_P());
	}
	public static MethodHandle glGetVideoCaptureStreamdvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVideoCaptureStreamdvNV", MLS_IIEP(), PS_IIEP());
	}
	public static MethodHandle glGetVideoCaptureStreamfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVideoCaptureStreamfvNV", MLS_IIEP(), PS_IIEP());
	}
	public static MethodHandle glGetVideoCaptureStreamivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVideoCaptureStreamivNV", MLS_IIEP(), PS_IIEP());
	}
	public static MethodHandle glGetVideoCaptureivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVideoCaptureivNV", MLS_IEP(), PS_IEP());
	}
	public static MethodHandle glGetVideoi64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVideoi64vNV", MLS_IEP(), PS_IEP());
	}
	public static MethodHandle glGetVideoivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVideoivNV", MLS_IEP(), PS_IEP());
	}
	public static MethodHandle glGetVideoui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVideoui64vNV", MLS_IEP(), PS_IEP());
	}
	public static MethodHandle glGetVideouivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetVideouivNV", MLS_IEP(), PS_IEP());
	}
	public static MethodHandle glGetnColorTable(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnColorTable", MLS_LColorTableTarget_LPixelFormat_LPixelType_IP(), PS_LColorTableTarget_LPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glGetnColorTableARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnColorTableARB", MLS_LColorTableTarget_LPixelFormat_LPixelType_IP(), PS_LColorTableTarget_LPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glGetnCompressedTexImage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnCompressedTexImage", MLS_LTextureTarget_IIP(), PS_LTextureTarget_IIP());
	}
	public static MethodHandle glGetnCompressedTexImageARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnCompressedTexImageARB", MLS_LTextureTarget_IIP(), PS_LTextureTarget_IIP());
	}
	public static MethodHandle glGetnConvolutionFilter(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnConvolutionFilter", MLS_LConvolutionTarget_LPixelFormat_LPixelType_IP(), PS_LConvolutionTarget_LPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glGetnConvolutionFilterARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnConvolutionFilterARB", MLS_LConvolutionTarget_LPixelFormat_LPixelType_IP(), PS_LConvolutionTarget_LPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glGetnHistogram(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnHistogram", MLS_LHistogramTarget_ZLPixelFormat_LPixelType_IP(), PS_LHistogramTarget_ZLPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glGetnHistogramARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnHistogramARB", MLS_LHistogramTargetEXT_ZLPixelFormat_LPixelType_IP(), PS_LHistogramTargetEXT_ZLPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glGetnMapdv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnMapdv", MLS_LMapTarget_LMapQuery_IP(), PS_LMapTarget_LMapQuery_IP());
	}
	public static MethodHandle glGetnMapdvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnMapdvARB", MLS_LMapTarget_LMapQuery_IP(), PS_LMapTarget_LMapQuery_IP());
	}
	public static MethodHandle glGetnMapfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnMapfv", MLS_LMapTarget_LMapQuery_IP(), PS_LMapTarget_LMapQuery_IP());
	}
	public static MethodHandle glGetnMapfvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnMapfvARB", MLS_LMapTarget_LMapQuery_IP(), PS_LMapTarget_LMapQuery_IP());
	}
	public static MethodHandle glGetnMapiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnMapiv", MLS_LMapTarget_LMapQuery_IP(), PS_LMapTarget_LMapQuery_IP());
	}
	public static MethodHandle glGetnMapivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnMapivARB", MLS_LMapTarget_LMapQuery_IP(), PS_LMapTarget_LMapQuery_IP());
	}
	public static MethodHandle glGetnMinmax(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnMinmax", MLS_LMinmaxTarget_ZLPixelFormat_LPixelType_IP(), PS_LMinmaxTarget_ZLPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glGetnMinmaxARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnMinmaxARB", MLS_LMinmaxTargetEXT_ZLPixelFormat_LPixelType_IP(), PS_LMinmaxTargetEXT_ZLPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glGetnPixelMapfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnPixelMapfv", MLS_LPixelMap_IP(), PS_LPixelMap_IP());
	}
	public static MethodHandle glGetnPixelMapfvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnPixelMapfvARB", MLS_LPixelMap_IP(), PS_LPixelMap_IP());
	}
	public static MethodHandle glGetnPixelMapuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnPixelMapuiv", MLS_LPixelMap_IP(), PS_LPixelMap_IP());
	}
	public static MethodHandle glGetnPixelMapuivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnPixelMapuivARB", MLS_LPixelMap_IP(), PS_LPixelMap_IP());
	}
	public static MethodHandle glGetnPixelMapusv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnPixelMapusv", MLS_LPixelMap_IP(), PS_LPixelMap_IP());
	}
	public static MethodHandle glGetnPixelMapusvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnPixelMapusvARB", MLS_LPixelMap_IP(), PS_LPixelMap_IP());
	}
	public static MethodHandle glGetnPolygonStipple(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnPolygonStipple", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGetnPolygonStippleARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnPolygonStippleARB", MLS_IP(), PS_IP());
	}
	public static MethodHandle glGetnSeparableFilter(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnSeparableFilter", MLS_LSeparableTarget_LPixelFormat_LPixelType_IPIPP(), PS_LSeparableTarget_LPixelFormat_LPixelType_IPIPP());
	}
	public static MethodHandle glGetnSeparableFilterARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnSeparableFilterARB", MLS_LSeparableTargetEXT_LPixelFormat_LPixelType_IPIPP(), PS_LSeparableTargetEXT_LPixelFormat_LPixelType_IPIPP());
	}
	public static MethodHandle glGetnTexImage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnTexImage", MLS_LTextureTarget_ILPixelFormat_LPixelType_IP(), PS_LTextureTarget_ILPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glGetnTexImageARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnTexImageARB", MLS_LTextureTarget_ILPixelFormat_LPixelType_IP(), PS_LTextureTarget_ILPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glGetnUniformdv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformdv", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformdvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformdvARB", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformfv", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformfvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformfvARB", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformfvEXT", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformfvKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformfvKHR", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformi64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformi64vARB", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformiv", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformivARB", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformivEXT", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformivKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformivKHR", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformui64vARB", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformuiv", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformuivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformuivARB", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGetnUniformuivKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetnUniformuivKHR", MLS_IIIP(), PS_IIIP());
	}
	public static MethodHandle glGlobalAlphaFactorbSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGlobalAlphaFactorbSUN", MLS_B(), PS_B());
	}
	public static MethodHandle glGlobalAlphaFactordSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGlobalAlphaFactordSUN", MLS_D(), PS_D());
	}
	public static MethodHandle glGlobalAlphaFactorfSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGlobalAlphaFactorfSUN", MLS_F(), PS_F());
	}
	public static MethodHandle glGlobalAlphaFactoriSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGlobalAlphaFactoriSUN", MLS_I(), PS_I());
	}
	public static MethodHandle glGlobalAlphaFactorsSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGlobalAlphaFactorsSUN", MLS_S(), PS_S());
	}
	public static MethodHandle glGlobalAlphaFactorubSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGlobalAlphaFactorubSUN", MLS_B(), PS_B());
	}
	public static MethodHandle glGlobalAlphaFactoruiSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGlobalAlphaFactoruiSUN", MLS_I(), PS_I());
	}
	public static MethodHandle glGlobalAlphaFactorusSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGlobalAlphaFactorusSUN", MLS_C(), PS_C());
	}
	public static MethodHandle glHint(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glHint", MLS_LHintTarget_LHintMode_(), PS_LHintTarget_LHintMode_());
	}
	public static MethodHandle glHintPGI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glHintPGI", MLS_LHintTargetPGI_LVertexHintsMaskPGI_(), PS_LHintTargetPGI_LVertexHintsMaskPGI_());
	}
	public static MethodHandle glHistogram(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glHistogram", MLS_LHistogramTargetEXT_ILInternalFormat_Z(), PS_LHistogramTargetEXT_ILInternalFormat_Z());
	}
	public static MethodHandle glHistogramEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glHistogramEXT", MLS_LHistogramTargetEXT_ILInternalFormat_Z(), PS_LHistogramTargetEXT_ILInternalFormat_Z());
	}
	public static MethodHandle glIglooInterfaceSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIglooInterfaceSGIX", MLS_Ep(), PS_Ep());
	}
	public static MethodHandle glImageTransformParameterfHP(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glImageTransformParameterfHP", MLS_LImageTransformTargetHP_LImageTransformPNameHP_F(), PS_LImageTransformTargetHP_LImageTransformPNameHP_F());
	}
	public static MethodHandle glImageTransformParameterfvHP(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glImageTransformParameterfvHP", MLS_LImageTransformTargetHP_LImageTransformPNameHP_p(), PS_LImageTransformTargetHP_LImageTransformPNameHP_p());
	}
	public static MethodHandle glImageTransformParameteriHP(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glImageTransformParameteriHP", MLS_LImageTransformTargetHP_LImageTransformPNameHP_I(), PS_LImageTransformTargetHP_LImageTransformPNameHP_I());
	}
	public static MethodHandle glImageTransformParameterivHP(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glImageTransformParameterivHP", MLS_LImageTransformTargetHP_LImageTransformPNameHP_p(), PS_LImageTransformTargetHP_LImageTransformPNameHP_p());
	}
	public static MethodHandle glImportMemoryFdEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glImportMemoryFdEXT", MLS_IJLExternalHandleType_I(), PS_IJLExternalHandleType_I());
	}
	public static MethodHandle glImportMemoryWin32HandleEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glImportMemoryWin32HandleEXT", MLS_IJLExternalHandleType_P(), PS_IJLExternalHandleType_P());
	}
	public static MethodHandle glImportMemoryWin32NameEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glImportMemoryWin32NameEXT", MLS_IJLExternalHandleType_p(), PS_IJLExternalHandleType_p());
	}
	public static MethodHandle glImportSemaphoreFdEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glImportSemaphoreFdEXT", MLS_ILExternalHandleType_I(), PS_ILExternalHandleType_I());
	}
	public static MethodHandle glImportSemaphoreWin32HandleEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glImportSemaphoreWin32HandleEXT", MLS_ILExternalHandleType_P(), PS_ILExternalHandleType_P());
	}
	public static MethodHandle glImportSemaphoreWin32NameEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glImportSemaphoreWin32NameEXT", MLS_ILExternalHandleType_p(), PS_ILExternalHandleType_p());
	}
	public static MethodHandle glImportSyncEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glImportSyncEXT", GLParamTypeSets.ML_I(), int.class, MLS_EJI(), PS_EJI());
	}
	public static MethodHandle glIndexFormatNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexFormatNV", MLS_EI(), PS_EI());
	}
	public static MethodHandle glIndexFuncEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexFuncEXT", MLS_LIndexFunctionEXT_F(), PS_LIndexFunctionEXT_F());
	}
	public static MethodHandle glIndexMask(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexMask", MLS_I(), PS_I());
	}
	public static MethodHandle glIndexMaterialEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexMaterialEXT", MLS_LTriangleFace_LIndexMaterialParameterEXT_(), PS_LTriangleFace_LIndexMaterialParameterEXT_());
	}
	public static MethodHandle glIndexPointer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexPointer", MLS_LIndexPointerType_Ip(), PS_LIndexPointerType_Ip());
	}
	public static MethodHandle glIndexPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexPointerEXT", MLS_LIndexPointerType_IIp(), PS_LIndexPointerType_IIp());
	}
	public static MethodHandle glIndexPointerListIBM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexPointerListIBM", MLS_LIndexPointerType_IPI(), PS_LIndexPointerType_IPI());
	}
	public static MethodHandle glIndexd(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexd", MLS_D(), PS_D());
	}
	public static MethodHandle glIndexdv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexdv", MLS_p(), PS_p());
	}
	public static MethodHandle glIndexf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexf", MLS_F(), PS_F());
	}
	public static MethodHandle glIndexfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexfv", MLS_p(), PS_p());
	}
	public static MethodHandle glIndexi(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexi", MLS_I(), PS_I());
	}
	public static MethodHandle glIndexiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexiv", MLS_p(), PS_p());
	}
	public static MethodHandle glIndexs(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexs", MLS_S(), PS_S());
	}
	public static MethodHandle glIndexsv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexsv", MLS_p(), PS_p());
	}
	public static MethodHandle glIndexub(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexub", MLS_B(), PS_B());
	}
	public static MethodHandle glIndexubv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexubv", MLS_p(), PS_p());
	}
	public static MethodHandle glIndexxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexxOES", MLS_I(), PS_I());
	}
	public static MethodHandle glIndexxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glIndexxvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glInitNames(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInitNames", MLS_(), PS_());
	}
	public static MethodHandle glInsertComponentEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInsertComponentEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glInsertEventMarkerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInsertEventMarkerEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glInstrumentsBufferSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInstrumentsBufferSGIX", MLS_IP(), PS_IP());
	}
	public static MethodHandle glInterleavedArrays(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInterleavedArrays", MLS_LInterleavedArrayFormat_Ip(), PS_LInterleavedArrayFormat_Ip());
	}
	public static MethodHandle glInterpolatePathsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInterpolatePathsNV", MLS_IIIF(), PS_IIIF());
	}
	public static MethodHandle glInvalidateBufferData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInvalidateBufferData", MLS_I(), PS_I());
	}
	public static MethodHandle glInvalidateBufferSubData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInvalidateBufferSubData", MLS_IJJ(), PS_IJJ());
	}
	public static MethodHandle glInvalidateFramebuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInvalidateFramebuffer", MLS_LFramebufferTarget_Ip(), PS_LFramebufferTarget_Ip());
	}
	public static MethodHandle glInvalidateNamedFramebufferData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInvalidateNamedFramebufferData", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glInvalidateNamedFramebufferSubData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInvalidateNamedFramebufferSubData", MLS_IIpIIII(), PS_IIpIIII());
	}
	public static MethodHandle glInvalidateSubFramebuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInvalidateSubFramebuffer", MLS_LFramebufferTarget_IpIIII(), PS_LFramebufferTarget_IpIIII());
	}
	public static MethodHandle glInvalidateTexImage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInvalidateTexImage", MLS_II(), PS_II());
	}
	public static MethodHandle glInvalidateTexSubImage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glInvalidateTexSubImage", MLS_IIIIIIII(), PS_IIIIIIII());
	}
	public static MethodHandle glIsAsyncMarkerSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsAsyncMarkerSGIX", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsBuffer", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsBufferARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsBufferARB", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsBufferResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsBufferResidentNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_E(), PS_E());
	}
	public static MethodHandle glIsCommandListNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsCommandListNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsEnabled(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsEnabled", GLParamTypeSets.ML_Z(), boolean.class, MLS_LEnableCap_(), PS_LEnableCap_());
	}
	public static MethodHandle glIsEnabledIndexedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsEnabledIndexedEXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glIsEnabledi(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsEnabledi", GLParamTypeSets.ML_Z(), boolean.class, MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glIsEnablediEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsEnablediEXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glIsEnablediNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsEnablediNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glIsEnablediOES(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsEnablediOES", GLParamTypeSets.ML_Z(), boolean.class, MLS_LEnableCap_I(), PS_LEnableCap_I());
	}
	public static MethodHandle glIsFenceAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsFenceAPPLE", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsFenceNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsFenceNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsFramebuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsFramebuffer", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsFramebufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsFramebufferEXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsFramebufferOES(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsFramebufferOES", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsImageHandleResidentARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsImageHandleResidentARB", GLParamTypeSets.ML_Z(), boolean.class, MLS_J(), PS_J());
	}
	public static MethodHandle glIsImageHandleResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsImageHandleResidentNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_J(), PS_J());
	}
	public static MethodHandle glIsList(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsList", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsMemoryObjectEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsMemoryObjectEXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsNameAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsNameAMD", GLParamTypeSets.ML_Z(), boolean.class, MLS_EI(), PS_EI());
	}
	public static MethodHandle glIsNamedBufferResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsNamedBufferResidentNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsNamedStringARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsNamedStringARB", GLParamTypeSets.ML_Z(), boolean.class, MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glIsObjectBufferATI(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsObjectBufferATI", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsOcclusionQueryNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsOcclusionQueryNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsPathNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsPathNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsPointInFillPathNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsPointInFillPathNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_IIFF(), PS_IIFF());
	}
	public static MethodHandle glIsPointInStrokePathNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsPointInStrokePathNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_IFF(), PS_IFF());
	}
	public static MethodHandle glIsProgram(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsProgram", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsProgramARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsProgramARB", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsProgramNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsProgramNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsProgramPipeline(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsProgramPipeline", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsProgramPipelineEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsProgramPipelineEXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsQuery(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsQuery", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsQueryARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsQueryARB", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsQueryEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsQueryEXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsRenderbuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsRenderbuffer", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsRenderbufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsRenderbufferEXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsRenderbufferOES(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsRenderbufferOES", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsSemaphoreEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsSemaphoreEXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsSampler(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsSampler", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsShader(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsShader", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsStateNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsStateNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsSync(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsSync", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsSyncAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsSyncAPPLE", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsTexture(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsTexture", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsTextureEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsTextureEXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsTextureHandleResidentARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsTextureHandleResidentARB", GLParamTypeSets.ML_Z(), boolean.class, MLS_J(), PS_J());
	}
	public static MethodHandle glIsTextureHandleResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsTextureHandleResidentNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_J(), PS_J());
	}
	public static MethodHandle glIsTransformFeedback(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsTransformFeedback", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsTransformFeedbackNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsTransformFeedbackNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsVariantEnabledEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsVariantEnabledEXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_ILVariantCapEXT_(), PS_ILVariantCapEXT_());
	}
	public static MethodHandle glIsVertexArray(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsVertexArray", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsVertexArrayAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsVertexArrayAPPLE", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsVertexArrayOES(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsVertexArrayOES", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glIsVertexAttribEnabledAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glIsVertexAttribEnabledAPPLE", GLParamTypeSets.ML_Z(), boolean.class, MLS_IE(), PS_IE());
	}
	public static MethodHandle glLGPUCopyImageSubDataNVX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLGPUCopyImageSubDataNVX", MLS_IIIEIIIIIEIIIIIII(), PS_IIIEIIIIIEIIIIIII());
	}
	public static MethodHandle glLGPUInterlockNVX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLGPUInterlockNVX", MLS_(), PS_());
	}
	public static MethodHandle glLGPUNamedBufferSubDataNVX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLGPUNamedBufferSubDataNVX", MLS_IIJJp(), PS_IIJJp());
	}
	public static MethodHandle glLabelObjectEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLabelObjectEXT", MLS_EIIp(), PS_EIIp());
	}
	public static MethodHandle glLightEnviSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightEnviSGIX", MLS_LLightEnvParameterSGIX_LLightEnvModeSGIX_(), PS_LLightEnvParameterSGIX_LLightEnvModeSGIX_());
	}
	public static MethodHandle glLightModelf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightModelf", MLS_LLightModelParameter_F(), PS_LLightModelParameter_F());
	}
	public static MethodHandle glLightModelfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightModelfv", MLS_LLightModelParameter_p(), PS_LLightModelParameter_p());
	}
	public static MethodHandle glLightModeli(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightModeli", MLS_LLightModelParameter_I(), PS_LLightModelParameter_I());
	}
	public static MethodHandle glLightModeliv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightModeliv", MLS_LLightModelParameter_p(), PS_LLightModelParameter_p());
	}
	public static MethodHandle glLightModelx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightModelx", MLS_LLightModelParameter_I(), PS_LLightModelParameter_I());
	}
	public static MethodHandle glLightModelxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightModelxOES", MLS_LLightModelParameter_I(), PS_LLightModelParameter_I());
	}
	public static MethodHandle glLightModelxv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightModelxv", MLS_LLightModelParameter_p(), PS_LLightModelParameter_p());
	}
	public static MethodHandle glLightModelxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightModelxvOES", MLS_LLightModelParameter_p(), PS_LLightModelParameter_p());
	}
	public static MethodHandle glLightf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightf", MLS_LLightName_LLightParameter_F(), PS_LLightName_LLightParameter_F());
	}
	public static MethodHandle glLightfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightfv", MLS_LLightName_LLightParameter_p(), PS_LLightName_LLightParameter_p());
	}
	public static MethodHandle glLighti(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLighti", MLS_LLightName_LLightParameter_I(), PS_LLightName_LLightParameter_I());
	}
	public static MethodHandle glLightiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightiv", MLS_LLightName_LLightParameter_p(), PS_LLightName_LLightParameter_p());
	}
	public static MethodHandle glLightx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightx", MLS_LLightName_LLightParameter_I(), PS_LLightName_LLightParameter_I());
	}
	public static MethodHandle glLightxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightxOES", MLS_LLightName_LLightParameter_I(), PS_LLightName_LLightParameter_I());
	}
	public static MethodHandle glLightxv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightxv", MLS_LLightName_LLightParameter_p(), PS_LLightName_LLightParameter_p());
	}
	public static MethodHandle glLightxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLightxvOES", MLS_LLightName_LLightParameter_p(), PS_LLightName_LLightParameter_p());
	}
	public static MethodHandle glLineStipple(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLineStipple", MLS_IC(), PS_IC());
	}
	public static MethodHandle glLineWidth(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLineWidth", MLS_F(), PS_F());
	}
	public static MethodHandle glLineWidthx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLineWidthx", MLS_I(), PS_I());
	}
	public static MethodHandle glLineWidthxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLineWidthxOES", MLS_I(), PS_I());
	}
	public static MethodHandle glLinkProgram(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLinkProgram", MLS_I(), PS_I());
	}
	public static MethodHandle glLinkProgramARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLinkProgramARB", MLS_I(), PS_I());
	}
	public static MethodHandle glListBase(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glListBase", MLS_I(), PS_I());
	}
	public static MethodHandle glListDrawCommandsStatesClientNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glListDrawCommandsStatesClientNV", MLS_IIPpppI(), PS_IIPpppI());
	}
	public static MethodHandle glListParameterfSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glListParameterfSGIX", MLS_ILListParameterName_F(), PS_ILListParameterName_F());
	}
	public static MethodHandle glListParameterfvSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glListParameterfvSGIX", MLS_ILListParameterName_p(), PS_ILListParameterName_p());
	}
	public static MethodHandle glListParameteriSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glListParameteriSGIX", MLS_ILListParameterName_I(), PS_ILListParameterName_I());
	}
	public static MethodHandle glListParameterivSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glListParameterivSGIX", MLS_ILListParameterName_p(), PS_ILListParameterName_p());
	}
	public static MethodHandle glLoadIdentity(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadIdentity", MLS_(), PS_());
	}
	public static MethodHandle glLoadIdentityDeformationMapSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadIdentityDeformationMapSGIX", MLS_I(), PS_I());
	}
	public static MethodHandle glLoadMatrixd(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadMatrixd", MLS_p(), PS_p());
	}
	public static MethodHandle glLoadMatrixf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadMatrixf", MLS_p(), PS_p());
	}
	public static MethodHandle glLoadMatrixx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadMatrixx", MLS_p(), PS_p());
	}
	public static MethodHandle glLoadMatrixxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadMatrixxOES", MLS_p(), PS_p());
	}
	public static MethodHandle glLoadName(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadName", MLS_I(), PS_I());
	}
	public static MethodHandle glLoadPaletteFromModelViewMatrixOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadPaletteFromModelViewMatrixOES", MLS_(), PS_());
	}
	public static MethodHandle glLoadProgramNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadProgramNV", MLS_LVertexAttribEnumNV_IIp(), PS_LVertexAttribEnumNV_IIp());
	}
	public static MethodHandle glLoadTransposeMatrixd(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadTransposeMatrixd", MLS_p(), PS_p());
	}
	public static MethodHandle glLoadTransposeMatrixdARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadTransposeMatrixdARB", MLS_p(), PS_p());
	}
	public static MethodHandle glLoadTransposeMatrixf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadTransposeMatrixf", MLS_p(), PS_p());
	}
	public static MethodHandle glLoadTransposeMatrixfARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadTransposeMatrixfARB", MLS_p(), PS_p());
	}
	public static MethodHandle glLoadTransposeMatrixxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLoadTransposeMatrixxOES", MLS_p(), PS_p());
	}
	public static MethodHandle glLockArraysEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLockArraysEXT", MLS_II(), PS_II());
	}
	public static MethodHandle glLogicOp(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glLogicOp", MLS_LLogicOp_(), PS_LLogicOp_());
	}
	public static MethodHandle glMakeBufferNonResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMakeBufferNonResidentNV", MLS_E(), PS_E());
	}
	public static MethodHandle glMakeBufferResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMakeBufferResidentNV", MLS_EE(), PS_EE());
	}
	public static MethodHandle glMakeImageHandleNonResidentARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMakeImageHandleNonResidentARB", MLS_J(), PS_J());
	}
	public static MethodHandle glMakeImageHandleNonResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMakeImageHandleNonResidentNV", MLS_J(), PS_J());
	}
	public static MethodHandle glMakeImageHandleResidentARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMakeImageHandleResidentARB", MLS_JE(), PS_JE());
	}
	public static MethodHandle glMakeImageHandleResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMakeImageHandleResidentNV", MLS_JE(), PS_JE());
	}
	public static MethodHandle glMakeNamedBufferNonResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMakeNamedBufferNonResidentNV", MLS_I(), PS_I());
	}
	public static MethodHandle glMakeNamedBufferResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMakeNamedBufferResidentNV", MLS_IE(), PS_IE());
	}
	public static MethodHandle glMakeTextureHandleNonResidentARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMakeTextureHandleNonResidentARB", MLS_J(), PS_J());
	}
	public static MethodHandle glMakeTextureHandleNonResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMakeTextureHandleNonResidentNV", MLS_J(), PS_J());
	}
	public static MethodHandle glMakeTextureHandleResidentARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMakeTextureHandleResidentARB", MLS_J(), PS_J());
	}
	public static MethodHandle glMakeTextureHandleResidentNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMakeTextureHandleResidentNV", MLS_J(), PS_J());
	}
	public static MethodHandle glMap1d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMap1d", MLS_LMapTarget_DDIIp(), PS_LMapTarget_DDIIp());
	}
	public static MethodHandle glMap1f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMap1f", MLS_LMapTarget_FFIIp(), PS_LMapTarget_FFIIp());
	}
	public static MethodHandle glMap1xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMap1xOES", MLS_LMapTarget_IIIII(), PS_LMapTarget_IIIII());
	}
	public static MethodHandle glMap2d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMap2d", MLS_LMapTarget_DDIIDDIIp(), PS_LMapTarget_DDIIDDIIp());
	}
	public static MethodHandle glMap2f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMap2f", MLS_LMapTarget_FFIIFFIIp(), PS_LMapTarget_FFIIFFIIp());
	}
	public static MethodHandle glMap2xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMap2xOES", MLS_LMapTarget_IIIIIIIII(), PS_LMapTarget_IIIIIIIII());
	}
	public static MethodHandle glMapBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glMapBuffer", GLParamTypeSets.ML_P(), MutPointer.class, MLS_LBufferTarget_LBufferAccess_(), PS_LBufferTarget_LBufferAccess_());
	}
	public static MethodHandle glMapBufferARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glMapBufferARB", GLParamTypeSets.ML_P(), MutPointer.class, MLS_LBufferTarget_LBufferAccess_(), PS_LBufferTarget_LBufferAccess_());
	}
	public static MethodHandle glMapBufferOES(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glMapBufferOES", GLParamTypeSets.ML_P(), MutPointer.class, MLS_LBufferTarget_LBufferAccess_(), PS_LBufferTarget_LBufferAccess_());
	}
	public static MethodHandle glMapBufferRange(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glMapBufferRange", GLParamTypeSets.ML_P(), MutPointer.class, MLS_LBufferTarget_JJI(), PS_LBufferTarget_JJI());
	}
	public static MethodHandle glMapBufferRangeEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glMapBufferRangeEXT", GLParamTypeSets.ML_P(), MutPointer.class, MLS_LBufferTarget_JJI(), PS_LBufferTarget_JJI());
	}
	public static MethodHandle glMapControlPointsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapControlPointsNV", MLS_LEvalTargetNV_ILMapTypeNV_IIIIZp(), PS_LEvalTargetNV_ILMapTypeNV_IIIIZp());
	}
	public static MethodHandle glMapGrid1d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapGrid1d", MLS_IDD(), PS_IDD());
	}
	public static MethodHandle glMapGrid1f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapGrid1f", MLS_IFF(), PS_IFF());
	}
	public static MethodHandle glMapGrid1xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapGrid1xOES", MLS_III(), PS_III());
	}
	public static MethodHandle glMapGrid2d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapGrid2d", MLS_IDDIDD(), PS_IDDIDD());
	}
	public static MethodHandle glMapGrid2f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapGrid2f", MLS_IFFIFF(), PS_IFFIFF());
	}
	public static MethodHandle glMapGrid2xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapGrid2xOES", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glMapNamedBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glMapNamedBuffer", GLParamTypeSets.ML_P(), MutPointer.class, MLS_ILBufferAccess_(), PS_ILBufferAccess_());
	}
	public static MethodHandle glMapNamedBufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glMapNamedBufferEXT", GLParamTypeSets.ML_P(), MutPointer.class, MLS_ILBufferAccess_(), PS_ILBufferAccess_());
	}
	public static MethodHandle glMapNamedBufferRange(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glMapNamedBufferRange", GLParamTypeSets.ML_P(), MutPointer.class, MLS_IJJI(), PS_IJJI());
	}
	public static MethodHandle glMapNamedBufferRangeEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glMapNamedBufferRangeEXT", GLParamTypeSets.ML_P(), MutPointer.class, MLS_IJJI(), PS_IJJI());
	}
	public static MethodHandle glMapObjectBufferATI(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glMapObjectBufferATI", GLParamTypeSets.ML_P(), MutPointer.class, MLS_I(), PS_I());
	}
	public static MethodHandle glMapParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapParameterfvNV", MLS_LEvalTargetNV_LMapParameterNV_p(), PS_LEvalTargetNV_LMapParameterNV_p());
	}
	public static MethodHandle glMapParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapParameterivNV", MLS_LEvalTargetNV_LMapParameterNV_p(), PS_LEvalTargetNV_LMapParameterNV_p());
	}
	public static MethodHandle glMapTexture2DINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glMapTexture2DINTEL", GLParamTypeSets.ML_P(), MutPointer.class, MLS_IIIPP(), PS_IIIPP());
	}
	public static MethodHandle glMapVertexAttrib1dAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapVertexAttrib1dAPPLE", MLS_IIDDIIp(), PS_IIDDIIp());
	}
	public static MethodHandle glMapVertexAttrib1fAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapVertexAttrib1fAPPLE", MLS_IIFFIIp(), PS_IIFFIIp());
	}
	public static MethodHandle glMapVertexAttrib2dAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapVertexAttrib2dAPPLE", MLS_IIDDIIDDIIp(), PS_IIDDIIDDIIp());
	}
	public static MethodHandle glMapVertexAttrib2fAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMapVertexAttrib2fAPPLE", MLS_IIFFIIFFIIp(), PS_IIFFIIFFIIp());
	}
	public static MethodHandle glMaterialf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMaterialf", MLS_LTriangleFace_LMaterialParameter_F(), PS_LTriangleFace_LMaterialParameter_F());
	}
	public static MethodHandle glMaterialfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMaterialfv", MLS_LTriangleFace_LMaterialParameter_p(), PS_LTriangleFace_LMaterialParameter_p());
	}
	public static MethodHandle glMateriali(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMateriali", MLS_LTriangleFace_LMaterialParameter_I(), PS_LTriangleFace_LMaterialParameter_I());
	}
	public static MethodHandle glMaterialiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMaterialiv", MLS_LTriangleFace_LMaterialParameter_p(), PS_LTriangleFace_LMaterialParameter_p());
	}
	public static MethodHandle glMaterialx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMaterialx", MLS_LTriangleFace_LMaterialParameter_I(), PS_LTriangleFace_LMaterialParameter_I());
	}
	public static MethodHandle glMaterialxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMaterialxOES", MLS_LTriangleFace_LMaterialParameter_I(), PS_LTriangleFace_LMaterialParameter_I());
	}
	public static MethodHandle glMaterialxv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMaterialxv", MLS_LTriangleFace_LMaterialParameter_p(), PS_LTriangleFace_LMaterialParameter_p());
	}
	public static MethodHandle glMaterialxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMaterialxvOES", MLS_LTriangleFace_LMaterialParameter_p(), PS_LTriangleFace_LMaterialParameter_p());
	}
	public static MethodHandle glMatrixFrustumEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixFrustumEXT", MLS_LMatrixMode_DDDDDD(), PS_LMatrixMode_DDDDDD());
	}
	public static MethodHandle glMatrixIndexPointerARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixIndexPointerARB", MLS_ILMatrixIndexPointerTypeARB_Ip(), PS_ILMatrixIndexPointerTypeARB_Ip());
	}
	public static MethodHandle glMatrixIndexPointerOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixIndexPointerOES", MLS_ILMatrixIndexPointerTypeARB_Ip(), PS_ILMatrixIndexPointerTypeARB_Ip());
	}
	public static MethodHandle glMatrixIndexubvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixIndexubvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glMatrixIndexuivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixIndexuivARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glMatrixIndexusvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixIndexusvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glMatrixLoad3x2fNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixLoad3x2fNV", MLS_Ep(), PS_Ep());
	}
	public static MethodHandle glMatrixLoad3x3fNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixLoad3x3fNV", MLS_Ep(), PS_Ep());
	}
	public static MethodHandle glMatrixLoadIdentityEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixLoadIdentityEXT", MLS_LMatrixMode_(), PS_LMatrixMode_());
	}
	public static MethodHandle glMatrixLoadTranspose3x3fNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixLoadTranspose3x3fNV", MLS_Ep(), PS_Ep());
	}
	public static MethodHandle glMatrixLoadTransposedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixLoadTransposedEXT", MLS_LMatrixMode_p(), PS_LMatrixMode_p());
	}
	public static MethodHandle glMatrixLoadTransposefEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixLoadTransposefEXT", MLS_LMatrixMode_p(), PS_LMatrixMode_p());
	}
	public static MethodHandle glMatrixLoaddEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixLoaddEXT", MLS_LMatrixMode_p(), PS_LMatrixMode_p());
	}
	public static MethodHandle glMatrixLoadfEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixLoadfEXT", MLS_LMatrixMode_p(), PS_LMatrixMode_p());
	}
	public static MethodHandle glMatrixMode(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixMode", MLS_LMatrixMode_(), PS_LMatrixMode_());
	}
	public static MethodHandle glMatrixMult3x2fNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixMult3x2fNV", MLS_Ep(), PS_Ep());
	}
	public static MethodHandle glMatrixMult3x3fNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixMult3x3fNV", MLS_Ep(), PS_Ep());
	}
	public static MethodHandle glMatrixMultTranspose3x3fNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixMultTranspose3x3fNV", MLS_Ep(), PS_Ep());
	}
	public static MethodHandle glMatrixMultTransposedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixMultTransposedEXT", MLS_LMatrixMode_p(), PS_LMatrixMode_p());
	}
	public static MethodHandle glMatrixMultTransposefEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixMultTransposefEXT", MLS_LMatrixMode_p(), PS_LMatrixMode_p());
	}
	public static MethodHandle glMatrixMultdEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixMultdEXT", MLS_LMatrixMode_p(), PS_LMatrixMode_p());
	}
	public static MethodHandle glMatrixMultfEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixMultfEXT", MLS_LMatrixMode_p(), PS_LMatrixMode_p());
	}
	public static MethodHandle glMatrixOrthoEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixOrthoEXT", MLS_LMatrixMode_DDDDDD(), PS_LMatrixMode_DDDDDD());
	}
	public static MethodHandle glMatrixPopEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixPopEXT", MLS_LMatrixMode_(), PS_LMatrixMode_());
	}
	public static MethodHandle glMatrixPushEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixPushEXT", MLS_LMatrixMode_(), PS_LMatrixMode_());
	}
	public static MethodHandle glMatrixRotatedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixRotatedEXT", MLS_LMatrixMode_DDDD(), PS_LMatrixMode_DDDD());
	}
	public static MethodHandle glMatrixRotatefEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixRotatefEXT", MLS_LMatrixMode_FFFF(), PS_LMatrixMode_FFFF());
	}
	public static MethodHandle glMatrixScaledEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixScaledEXT", MLS_LMatrixMode_DDD(), PS_LMatrixMode_DDD());
	}
	public static MethodHandle glMatrixScalefEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixScalefEXT", MLS_LMatrixMode_FFF(), PS_LMatrixMode_FFF());
	}
	public static MethodHandle glMatrixTranslatedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixTranslatedEXT", MLS_LMatrixMode_DDD(), PS_LMatrixMode_DDD());
	}
	public static MethodHandle glMatrixTranslatefEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMatrixTranslatefEXT", MLS_LMatrixMode_FFF(), PS_LMatrixMode_FFF());
	}
	public static MethodHandle glMaxActiveShaderCoresARM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMaxActiveShaderCoresARM", MLS_I(), PS_I());
	}
	public static MethodHandle glMaxShaderCompilerThreadsKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMaxShaderCompilerThreadsKHR", MLS_I(), PS_I());
	}
	public static MethodHandle glMaxShaderCompilerThreadsARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMaxShaderCompilerThreadsARB", MLS_I(), PS_I());
	}
	public static MethodHandle glMemoryBarrier(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMemoryBarrier", MLS_I(), PS_I());
	}
	public static MethodHandle glMemoryBarrierByRegion(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMemoryBarrierByRegion", MLS_I(), PS_I());
	}
	public static MethodHandle glMemoryBarrierEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMemoryBarrierEXT", MLS_I(), PS_I());
	}
	public static MethodHandle glMemoryObjectParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMemoryObjectParameterivEXT", MLS_ILMemoryObjectParameterName_p(), PS_ILMemoryObjectParameterName_p());
	}
	public static MethodHandle glMinSampleShading(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMinSampleShading", MLS_F(), PS_F());
	}
	public static MethodHandle glMinSampleShadingARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMinSampleShadingARB", MLS_F(), PS_F());
	}
	public static MethodHandle glMinSampleShadingOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMinSampleShadingOES", MLS_F(), PS_F());
	}
	public static MethodHandle glMinmax(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMinmax", MLS_LMinmaxTargetEXT_LInternalFormat_Z(), PS_LMinmaxTargetEXT_LInternalFormat_Z());
	}
	public static MethodHandle glMinmaxEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMinmaxEXT", MLS_LMinmaxTargetEXT_LInternalFormat_Z(), PS_LMinmaxTargetEXT_LInternalFormat_Z());
	}
	public static MethodHandle glMultMatrixd(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultMatrixd", MLS_p(), PS_p());
	}
	public static MethodHandle glMultMatrixf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultMatrixf", MLS_p(), PS_p());
	}
	public static MethodHandle glMultMatrixx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultMatrixx", MLS_p(), PS_p());
	}
	public static MethodHandle glMultMatrixxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultMatrixxOES", MLS_p(), PS_p());
	}
	public static MethodHandle glMultTransposeMatrixd(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultTransposeMatrixd", MLS_p(), PS_p());
	}
	public static MethodHandle glMultTransposeMatrixdARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultTransposeMatrixdARB", MLS_p(), PS_p());
	}
	public static MethodHandle glMultTransposeMatrixf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultTransposeMatrixf", MLS_p(), PS_p());
	}
	public static MethodHandle glMultTransposeMatrixfARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultTransposeMatrixfARB", MLS_p(), PS_p());
	}
	public static MethodHandle glMultTransposeMatrixxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultTransposeMatrixxOES", MLS_p(), PS_p());
	}
	public static MethodHandle glMultiDrawArrays(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawArrays", MLS_LPrimitiveType_ppI(), PS_LPrimitiveType_ppI());
	}
	public static MethodHandle glMultiDrawArraysEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawArraysEXT", MLS_LPrimitiveType_ppI(), PS_LPrimitiveType_ppI());
	}
	public static MethodHandle glMultiDrawArraysIndirect(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawArraysIndirect", MLS_LPrimitiveType_pII(), PS_LPrimitiveType_pII());
	}
	public static MethodHandle glMultiDrawArraysIndirectAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawArraysIndirectAMD", MLS_LPrimitiveType_pII(), PS_LPrimitiveType_pII());
	}
	public static MethodHandle glMultiDrawArraysIndirectBindlessCountNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawArraysIndirectBindlessCountNV", MLS_LPrimitiveType_pIIII(), PS_LPrimitiveType_pIIII());
	}
	public static MethodHandle glMultiDrawArraysIndirectBindlessNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawArraysIndirectBindlessNV", MLS_LPrimitiveType_pIII(), PS_LPrimitiveType_pIII());
	}
	public static MethodHandle glMultiDrawArraysIndirectCount(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawArraysIndirectCount", MLS_LPrimitiveType_pJII(), PS_LPrimitiveType_pJII());
	}
	public static MethodHandle glMultiDrawArraysIndirectCountARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawArraysIndirectCountARB", MLS_LPrimitiveType_pJII(), PS_LPrimitiveType_pJII());
	}
	public static MethodHandle glMultiDrawArraysIndirectEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawArraysIndirectEXT", MLS_LPrimitiveType_pII(), PS_LPrimitiveType_pII());
	}
	public static MethodHandle glMultiDrawElementArrayAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawElementArrayAPPLE", MLS_LPrimitiveType_ppI(), PS_LPrimitiveType_ppI());
	}
	public static MethodHandle glMultiDrawElements(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawElements", MLS_LPrimitiveType_pLDrawElementsType_pI(), PS_LPrimitiveType_pLDrawElementsType_pI());
	}
	public static MethodHandle glMultiDrawElementsBaseVertex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawElementsBaseVertex", MLS_LPrimitiveType_pLDrawElementsType_pIp(), PS_LPrimitiveType_pLDrawElementsType_pIp());
	}
	public static MethodHandle glMultiDrawElementsBaseVertexEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawElementsBaseVertexEXT", MLS_LPrimitiveType_pLDrawElementsType_pIp(), PS_LPrimitiveType_pLDrawElementsType_pIp());
	}
	public static MethodHandle glMultiDrawElementsEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawElementsEXT", MLS_LPrimitiveType_pLDrawElementsType_pI(), PS_LPrimitiveType_pLDrawElementsType_pI());
	}
	public static MethodHandle glMultiDrawElementsIndirect(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawElementsIndirect", MLS_LPrimitiveType_LDrawElementsType_pII(), PS_LPrimitiveType_LDrawElementsType_pII());
	}
	public static MethodHandle glMultiDrawElementsIndirectAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawElementsIndirectAMD", MLS_LPrimitiveType_LDrawElementsType_pII(), PS_LPrimitiveType_LDrawElementsType_pII());
	}
	public static MethodHandle glMultiDrawElementsIndirectBindlessCountNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawElementsIndirectBindlessCountNV", MLS_LPrimitiveType_LDrawElementsType_pIIII(), PS_LPrimitiveType_LDrawElementsType_pIIII());
	}
	public static MethodHandle glMultiDrawElementsIndirectBindlessNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawElementsIndirectBindlessNV", MLS_LPrimitiveType_LDrawElementsType_pIII(), PS_LPrimitiveType_LDrawElementsType_pIII());
	}
	public static MethodHandle glMultiDrawElementsIndirectCount(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawElementsIndirectCount", MLS_LPrimitiveType_LDrawElementsType_pJII(), PS_LPrimitiveType_LDrawElementsType_pJII());
	}
	public static MethodHandle glMultiDrawElementsIndirectCountARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawElementsIndirectCountARB", MLS_LPrimitiveType_LDrawElementsType_pJII(), PS_LPrimitiveType_LDrawElementsType_pJII());
	}
	public static MethodHandle glMultiDrawElementsIndirectEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawElementsIndirectEXT", MLS_LPrimitiveType_LDrawElementsType_pII(), PS_LPrimitiveType_LDrawElementsType_pII());
	}
	public static MethodHandle glMultiDrawMeshTasksIndirectNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawMeshTasksIndirectNV", MLS_JII(), PS_JII());
	}
	public static MethodHandle glMultiDrawMeshTasksIndirectCountNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawMeshTasksIndirectCountNV", MLS_JJII(), PS_JJII());
	}
	public static MethodHandle glMultiDrawRangeElementArrayAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiDrawRangeElementArrayAPPLE", MLS_LPrimitiveType_IIppI(), PS_LPrimitiveType_IIppI());
	}
	public static MethodHandle glMultiModeDrawArraysIBM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiModeDrawArraysIBM", MLS_pppII(), PS_pppII());
	}
	public static MethodHandle glMultiModeDrawElementsIBM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiModeDrawElementsIBM", MLS_ppLDrawElementsType_pII(), PS_ppLDrawElementsType_pII());
	}
	public static MethodHandle glMultiTexBufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexBufferEXT", MLS_LTextureUnit_LTextureTarget_LInternalFormat_I(), PS_LTextureUnit_LTextureTarget_LInternalFormat_I());
	}
	public static MethodHandle glMultiTexCoord1bOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1bOES", MLS_LTextureUnit_B(), PS_LTextureUnit_B());
	}
	public static MethodHandle glMultiTexCoord1bvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1bvOES", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord1d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1d", MLS_LTextureUnit_D(), PS_LTextureUnit_D());
	}
	public static MethodHandle glMultiTexCoord1dARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1dARB", MLS_LTextureUnit_D(), PS_LTextureUnit_D());
	}
	public static MethodHandle glMultiTexCoord1dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1dv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord1dvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1dvARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord1f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1f", MLS_LTextureUnit_F(), PS_LTextureUnit_F());
	}
	public static MethodHandle glMultiTexCoord1fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1fARB", MLS_LTextureUnit_F(), PS_LTextureUnit_F());
	}
	public static MethodHandle glMultiTexCoord1fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1fv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord1fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1fvARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord1hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1hNV", MLS_LTextureUnit_C(), PS_LTextureUnit_C());
	}
	public static MethodHandle glMultiTexCoord1hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1hvNV", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord1i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1i", MLS_LTextureUnit_I(), PS_LTextureUnit_I());
	}
	public static MethodHandle glMultiTexCoord1iARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1iARB", MLS_LTextureUnit_I(), PS_LTextureUnit_I());
	}
	public static MethodHandle glMultiTexCoord1iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1iv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord1ivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1ivARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord1s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1s", MLS_LTextureUnit_S(), PS_LTextureUnit_S());
	}
	public static MethodHandle glMultiTexCoord1sARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1sARB", MLS_LTextureUnit_S(), PS_LTextureUnit_S());
	}
	public static MethodHandle glMultiTexCoord1sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1sv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord1svARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1svARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord1xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1xOES", MLS_LTextureUnit_I(), PS_LTextureUnit_I());
	}
	public static MethodHandle glMultiTexCoord1xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord1xvOES", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord2bOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2bOES", MLS_LTextureUnit_BB(), PS_LTextureUnit_BB());
	}
	public static MethodHandle glMultiTexCoord2bvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2bvOES", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord2d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2d", MLS_LTextureUnit_DD(), PS_LTextureUnit_DD());
	}
	public static MethodHandle glMultiTexCoord2dARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2dARB", MLS_LTextureUnit_DD(), PS_LTextureUnit_DD());
	}
	public static MethodHandle glMultiTexCoord2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2dv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord2dvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2dvARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord2f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2f", MLS_LTextureUnit_FF(), PS_LTextureUnit_FF());
	}
	public static MethodHandle glMultiTexCoord2fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2fARB", MLS_LTextureUnit_FF(), PS_LTextureUnit_FF());
	}
	public static MethodHandle glMultiTexCoord2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2fv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord2fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2fvARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord2hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2hNV", MLS_LTextureUnit_CC(), PS_LTextureUnit_CC());
	}
	public static MethodHandle glMultiTexCoord2hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2hvNV", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord2i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2i", MLS_LTextureUnit_II(), PS_LTextureUnit_II());
	}
	public static MethodHandle glMultiTexCoord2iARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2iARB", MLS_LTextureUnit_II(), PS_LTextureUnit_II());
	}
	public static MethodHandle glMultiTexCoord2iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2iv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord2ivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2ivARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord2s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2s", MLS_LTextureUnit_SS(), PS_LTextureUnit_SS());
	}
	public static MethodHandle glMultiTexCoord2sARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2sARB", MLS_LTextureUnit_SS(), PS_LTextureUnit_SS());
	}
	public static MethodHandle glMultiTexCoord2sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2sv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord2svARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2svARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord2xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2xOES", MLS_LTextureUnit_II(), PS_LTextureUnit_II());
	}
	public static MethodHandle glMultiTexCoord2xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord2xvOES", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord3bOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3bOES", MLS_LTextureUnit_BBB(), PS_LTextureUnit_BBB());
	}
	public static MethodHandle glMultiTexCoord3bvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3bvOES", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord3d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3d", MLS_LTextureUnit_DDD(), PS_LTextureUnit_DDD());
	}
	public static MethodHandle glMultiTexCoord3dARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3dARB", MLS_LTextureUnit_DDD(), PS_LTextureUnit_DDD());
	}
	public static MethodHandle glMultiTexCoord3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3dv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord3dvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3dvARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord3f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3f", MLS_LTextureUnit_FFF(), PS_LTextureUnit_FFF());
	}
	public static MethodHandle glMultiTexCoord3fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3fARB", MLS_LTextureUnit_FFF(), PS_LTextureUnit_FFF());
	}
	public static MethodHandle glMultiTexCoord3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3fv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord3fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3fvARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord3hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3hNV", MLS_LTextureUnit_CCC(), PS_LTextureUnit_CCC());
	}
	public static MethodHandle glMultiTexCoord3hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3hvNV", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord3i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3i", MLS_LTextureUnit_III(), PS_LTextureUnit_III());
	}
	public static MethodHandle glMultiTexCoord3iARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3iARB", MLS_LTextureUnit_III(), PS_LTextureUnit_III());
	}
	public static MethodHandle glMultiTexCoord3iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3iv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord3ivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3ivARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord3s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3s", MLS_LTextureUnit_SSS(), PS_LTextureUnit_SSS());
	}
	public static MethodHandle glMultiTexCoord3sARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3sARB", MLS_LTextureUnit_SSS(), PS_LTextureUnit_SSS());
	}
	public static MethodHandle glMultiTexCoord3sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3sv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord3svARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3svARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord3xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3xOES", MLS_LTextureUnit_III(), PS_LTextureUnit_III());
	}
	public static MethodHandle glMultiTexCoord3xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord3xvOES", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord4bOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4bOES", MLS_LTextureUnit_BBBB(), PS_LTextureUnit_BBBB());
	}
	public static MethodHandle glMultiTexCoord4bvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4bvOES", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord4d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4d", MLS_LTextureUnit_DDDD(), PS_LTextureUnit_DDDD());
	}
	public static MethodHandle glMultiTexCoord4dARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4dARB", MLS_LTextureUnit_DDDD(), PS_LTextureUnit_DDDD());
	}
	public static MethodHandle glMultiTexCoord4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4dv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord4dvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4dvARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord4f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4f", MLS_LTextureUnit_FFFF(), PS_LTextureUnit_FFFF());
	}
	public static MethodHandle glMultiTexCoord4fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4fARB", MLS_LTextureUnit_FFFF(), PS_LTextureUnit_FFFF());
	}
	public static MethodHandle glMultiTexCoord4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4fv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord4fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4fvARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord4hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4hNV", MLS_LTextureUnit_CCCC(), PS_LTextureUnit_CCCC());
	}
	public static MethodHandle glMultiTexCoord4hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4hvNV", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord4i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4i", MLS_LTextureUnit_IIII(), PS_LTextureUnit_IIII());
	}
	public static MethodHandle glMultiTexCoord4iARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4iARB", MLS_LTextureUnit_IIII(), PS_LTextureUnit_IIII());
	}
	public static MethodHandle glMultiTexCoord4iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4iv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord4ivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4ivARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord4s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4s", MLS_LTextureUnit_SSSS(), PS_LTextureUnit_SSSS());
	}
	public static MethodHandle glMultiTexCoord4sARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4sARB", MLS_LTextureUnit_SSSS(), PS_LTextureUnit_SSSS());
	}
	public static MethodHandle glMultiTexCoord4sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4sv", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord4svARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4svARB", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoord4x(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4x", MLS_LTextureUnit_IIII(), PS_LTextureUnit_IIII());
	}
	public static MethodHandle glMultiTexCoord4xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4xOES", MLS_LTextureUnit_IIII(), PS_LTextureUnit_IIII());
	}
	public static MethodHandle glMultiTexCoord4xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoord4xvOES", MLS_LTextureUnit_p(), PS_LTextureUnit_p());
	}
	public static MethodHandle glMultiTexCoordP1ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoordP1ui", MLS_LTextureUnit_LTexCoordPointerType_I(), PS_LTextureUnit_LTexCoordPointerType_I());
	}
	public static MethodHandle glMultiTexCoordP1uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoordP1uiv", MLS_LTextureUnit_LTexCoordPointerType_p(), PS_LTextureUnit_LTexCoordPointerType_p());
	}
	public static MethodHandle glMultiTexCoordP2ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoordP2ui", MLS_LTextureUnit_LTexCoordPointerType_I(), PS_LTextureUnit_LTexCoordPointerType_I());
	}
	public static MethodHandle glMultiTexCoordP2uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoordP2uiv", MLS_LTextureUnit_LTexCoordPointerType_p(), PS_LTextureUnit_LTexCoordPointerType_p());
	}
	public static MethodHandle glMultiTexCoordP3ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoordP3ui", MLS_LTextureUnit_LTexCoordPointerType_I(), PS_LTextureUnit_LTexCoordPointerType_I());
	}
	public static MethodHandle glMultiTexCoordP3uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoordP3uiv", MLS_LTextureUnit_LTexCoordPointerType_p(), PS_LTextureUnit_LTexCoordPointerType_p());
	}
	public static MethodHandle glMultiTexCoordP4ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoordP4ui", MLS_LTextureUnit_LTexCoordPointerType_I(), PS_LTextureUnit_LTexCoordPointerType_I());
	}
	public static MethodHandle glMultiTexCoordP4uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoordP4uiv", MLS_LTextureUnit_LTexCoordPointerType_p(), PS_LTextureUnit_LTexCoordPointerType_p());
	}
	public static MethodHandle glMultiTexCoordPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexCoordPointerEXT", MLS_LTextureUnit_ILTexCoordPointerType_Ip(), PS_LTextureUnit_ILTexCoordPointerType_Ip());
	}
	public static MethodHandle glMultiTexEnvfEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexEnvfEXT", MLS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_F(), PS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_F());
	}
	public static MethodHandle glMultiTexEnvfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexEnvfvEXT", MLS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_p(), PS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_p());
	}
	public static MethodHandle glMultiTexEnviEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexEnviEXT", MLS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_I(), PS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_I());
	}
	public static MethodHandle glMultiTexEnvivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexEnvivEXT", MLS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_p(), PS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_p());
	}
	public static MethodHandle glMultiTexGendEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexGendEXT", MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_D(), PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_D());
	}
	public static MethodHandle glMultiTexGendvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexGendvEXT", MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_p(), PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_p());
	}
	public static MethodHandle glMultiTexGenfEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexGenfEXT", MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_F(), PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_F());
	}
	public static MethodHandle glMultiTexGenfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexGenfvEXT", MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_p(), PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_p());
	}
	public static MethodHandle glMultiTexGeniEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexGeniEXT", MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_I(), PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_I());
	}
	public static MethodHandle glMultiTexGenivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexGenivEXT", MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_p(), PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_p());
	}
	public static MethodHandle glMultiTexImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexImage1DEXT", MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IILPixelFormat_LPixelType_p(), PS_LTextureUnit_LTextureTarget_ILInternalFormat_IILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glMultiTexImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexImage2DEXT", MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIILPixelFormat_LPixelType_p(), PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glMultiTexImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexImage3DEXT", MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p(), PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glMultiTexParameterIivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexParameterIivEXT", MLS_LTextureUnit_LTextureTarget_LTextureParameterName_p(), PS_LTextureUnit_LTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glMultiTexParameterIuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexParameterIuivEXT", MLS_LTextureUnit_LTextureTarget_LTextureParameterName_p(), PS_LTextureUnit_LTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glMultiTexParameterfEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexParameterfEXT", MLS_LTextureUnit_LTextureTarget_LTextureParameterName_F(), PS_LTextureUnit_LTextureTarget_LTextureParameterName_F());
	}
	public static MethodHandle glMultiTexParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexParameterfvEXT", MLS_LTextureUnit_LTextureTarget_LTextureParameterName_p(), PS_LTextureUnit_LTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glMultiTexParameteriEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexParameteriEXT", MLS_LTextureUnit_LTextureTarget_LTextureParameterName_I(), PS_LTextureUnit_LTextureTarget_LTextureParameterName_I());
	}
	public static MethodHandle glMultiTexParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexParameterivEXT", MLS_LTextureUnit_LTextureTarget_LTextureParameterName_p(), PS_LTextureUnit_LTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glMultiTexRenderbufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexRenderbufferEXT", MLS_LTextureUnit_LTextureTarget_I(), PS_LTextureUnit_LTextureTarget_I());
	}
	public static MethodHandle glMultiTexSubImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexSubImage1DEXT", MLS_LTextureUnit_LTextureTarget_IIILPixelFormat_LPixelType_p(), PS_LTextureUnit_LTextureTarget_IIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glMultiTexSubImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexSubImage2DEXT", MLS_LTextureUnit_LTextureTarget_IIIIILPixelFormat_LPixelType_p(), PS_LTextureUnit_LTextureTarget_IIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glMultiTexSubImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMultiTexSubImage3DEXT", MLS_LTextureUnit_LTextureTarget_IIIIIIILPixelFormat_LPixelType_p(), PS_LTextureUnit_LTextureTarget_IIIIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glMulticastBarrierNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastBarrierNV", MLS_(), PS_());
	}
	public static MethodHandle glMulticastBlitFramebufferNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastBlitFramebufferNV", MLS_IIIIIIIIIIIE(), PS_IIIIIIIIIIIE());
	}
	public static MethodHandle glMulticastBufferSubDataNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastBufferSubDataNV", MLS_IIJJp(), PS_IIJJp());
	}
	public static MethodHandle glMulticastCopyBufferSubDataNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastCopyBufferSubDataNV", MLS_IIIIJJJ(), PS_IIIIJJJ());
	}
	public static MethodHandle glMulticastCopyImageSubDataNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastCopyImageSubDataNV", MLS_IIIEIIIIIEIIIIIII(), PS_IIIEIIIIIEIIIIIII());
	}
	public static MethodHandle glMulticastFramebufferSampleLocationsfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastFramebufferSampleLocationsfvNV", MLS_IIIIp(), PS_IIIIp());
	}
	public static MethodHandle glMulticastGetQueryObjecti64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastGetQueryObjecti64vNV", MLS_IIEP(), PS_IIEP());
	}
	public static MethodHandle glMulticastGetQueryObjectivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastGetQueryObjectivNV", MLS_IIEP(), PS_IIEP());
	}
	public static MethodHandle glMulticastGetQueryObjectui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastGetQueryObjectui64vNV", MLS_IIEP(), PS_IIEP());
	}
	public static MethodHandle glMulticastGetQueryObjectuivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastGetQueryObjectuivNV", MLS_IIEP(), PS_IIEP());
	}
	public static MethodHandle glMulticastScissorArrayvNVX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastScissorArrayvNVX", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glMulticastViewportArrayvNVX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastViewportArrayvNVX", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glMulticastViewportPositionWScaleNVX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastViewportPositionWScaleNVX", MLS_IIFF(), PS_IIFF());
	}
	public static MethodHandle glMulticastWaitSyncNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glMulticastWaitSyncNV", MLS_II(), PS_II());
	}
	public static MethodHandle glNamedBufferAttachMemoryNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedBufferAttachMemoryNV", MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glNamedBufferData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedBufferData", MLS_IJpLVertexBufferObjectUsage_(), PS_IJpLVertexBufferObjectUsage_());
	}
	public static MethodHandle glNamedBufferDataEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedBufferDataEXT", MLS_IJpLVertexBufferObjectUsage_(), PS_IJpLVertexBufferObjectUsage_());
	}
	public static MethodHandle glNamedBufferPageCommitmentARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedBufferPageCommitmentARB", MLS_IJJZ(), PS_IJJZ());
	}
	public static MethodHandle glNamedBufferPageCommitmentEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedBufferPageCommitmentEXT", MLS_IJJZ(), PS_IJJZ());
	}
	public static MethodHandle glNamedBufferPageCommitmentMemNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedBufferPageCommitmentMemNV", MLS_IJJIJZ(), PS_IJJIJZ());
	}
	public static MethodHandle glNamedBufferStorage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedBufferStorage", MLS_IJpI(), PS_IJpI());
	}
	public static MethodHandle glNamedBufferStorageExternalEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedBufferStorageExternalEXT", MLS_IJJII(), PS_IJJII());
	}
	public static MethodHandle glNamedBufferStorageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedBufferStorageEXT", MLS_IJpI(), PS_IJpI());
	}
	public static MethodHandle glNamedBufferStorageMemEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedBufferStorageMemEXT", MLS_IJIJ(), PS_IJIJ());
	}
	public static MethodHandle glNamedBufferSubData(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedBufferSubData", MLS_IJJp(), PS_IJJp());
	}
	public static MethodHandle glNamedBufferSubDataEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedBufferSubDataEXT", MLS_IJJp(), PS_IJJp());
	}
	public static MethodHandle glNamedCopyBufferSubDataEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedCopyBufferSubDataEXT", MLS_IIJJJ(), PS_IIJJJ());
	}
	public static MethodHandle glNamedFramebufferDrawBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferDrawBuffer", MLS_ILColorBuffer_(), PS_ILColorBuffer_());
	}
	public static MethodHandle glNamedFramebufferDrawBuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferDrawBuffers", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glNamedFramebufferParameteri(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferParameteri", MLS_ILFramebufferParameterName_I(), PS_ILFramebufferParameterName_I());
	}
	public static MethodHandle glNamedFramebufferParameteriEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferParameteriEXT", MLS_ILFramebufferParameterName_I(), PS_ILFramebufferParameterName_I());
	}
	public static MethodHandle glNamedFramebufferReadBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferReadBuffer", MLS_ILColorBuffer_(), PS_ILColorBuffer_());
	}
	public static MethodHandle glNamedFramebufferRenderbuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferRenderbuffer", MLS_ILFramebufferAttachment_LRenderbufferTarget_I(), PS_ILFramebufferAttachment_LRenderbufferTarget_I());
	}
	public static MethodHandle glNamedFramebufferRenderbufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferRenderbufferEXT", MLS_ILFramebufferAttachment_LRenderbufferTarget_I(), PS_ILFramebufferAttachment_LRenderbufferTarget_I());
	}
	public static MethodHandle glNamedFramebufferSampleLocationsfvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferSampleLocationsfvARB", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glNamedFramebufferSampleLocationsfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferSampleLocationsfvNV", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glNamedFramebufferTexture(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferTexture", MLS_ILFramebufferAttachment_II(), PS_ILFramebufferAttachment_II());
	}
	public static MethodHandle glNamedFramebufferSamplePositionsfvAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferSamplePositionsfvAMD", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glNamedFramebufferTexture1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferTexture1DEXT", MLS_ILFramebufferAttachment_LTextureTarget_II(), PS_ILFramebufferAttachment_LTextureTarget_II());
	}
	public static MethodHandle glNamedFramebufferTexture2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferTexture2DEXT", MLS_ILFramebufferAttachment_LTextureTarget_II(), PS_ILFramebufferAttachment_LTextureTarget_II());
	}
	public static MethodHandle glNamedFramebufferTexture3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferTexture3DEXT", MLS_ILFramebufferAttachment_LTextureTarget_III(), PS_ILFramebufferAttachment_LTextureTarget_III());
	}
	public static MethodHandle glNamedFramebufferTextureEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferTextureEXT", MLS_ILFramebufferAttachment_II(), PS_ILFramebufferAttachment_II());
	}
	public static MethodHandle glNamedFramebufferTextureFaceEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferTextureFaceEXT", MLS_ILFramebufferAttachment_IILTextureTarget_(), PS_ILFramebufferAttachment_IILTextureTarget_());
	}
	public static MethodHandle glNamedFramebufferTextureLayer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferTextureLayer", MLS_ILFramebufferAttachment_III(), PS_ILFramebufferAttachment_III());
	}
	public static MethodHandle glNamedFramebufferTextureLayerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferTextureLayerEXT", MLS_ILFramebufferAttachment_III(), PS_ILFramebufferAttachment_III());
	}
	public static MethodHandle glNamedFramebufferTextureMultiviewOVR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedFramebufferTextureMultiviewOVR", MLS_ILFramebufferAttachment_IIII(), PS_ILFramebufferAttachment_IIII());
	}
	public static MethodHandle glNamedProgramLocalParameter4dEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedProgramLocalParameter4dEXT", MLS_ILProgramTarget_IDDDD(), PS_ILProgramTarget_IDDDD());
	}
	public static MethodHandle glNamedProgramLocalParameter4dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedProgramLocalParameter4dvEXT", MLS_ILProgramTarget_Ip(), PS_ILProgramTarget_Ip());
	}
	public static MethodHandle glNamedProgramLocalParameter4fEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedProgramLocalParameter4fEXT", MLS_ILProgramTarget_IFFFF(), PS_ILProgramTarget_IFFFF());
	}
	public static MethodHandle glNamedProgramLocalParameter4fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedProgramLocalParameter4fvEXT", MLS_ILProgramTarget_Ip(), PS_ILProgramTarget_Ip());
	}
	public static MethodHandle glNamedProgramLocalParameterI4iEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedProgramLocalParameterI4iEXT", MLS_ILProgramTarget_IIIII(), PS_ILProgramTarget_IIIII());
	}
	public static MethodHandle glNamedProgramLocalParameterI4ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedProgramLocalParameterI4ivEXT", MLS_ILProgramTarget_Ip(), PS_ILProgramTarget_Ip());
	}
	public static MethodHandle glNamedProgramLocalParameterI4uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedProgramLocalParameterI4uiEXT", MLS_ILProgramTarget_IIIII(), PS_ILProgramTarget_IIIII());
	}
	public static MethodHandle glNamedProgramLocalParameterI4uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedProgramLocalParameterI4uivEXT", MLS_ILProgramTarget_Ip(), PS_ILProgramTarget_Ip());
	}
	public static MethodHandle glNamedProgramLocalParameters4fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedProgramLocalParameters4fvEXT", MLS_ILProgramTarget_IIp(), PS_ILProgramTarget_IIp());
	}
	public static MethodHandle glNamedProgramLocalParametersI4ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedProgramLocalParametersI4ivEXT", MLS_ILProgramTarget_IIp(), PS_ILProgramTarget_IIp());
	}
	public static MethodHandle glNamedProgramLocalParametersI4uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedProgramLocalParametersI4uivEXT", MLS_ILProgramTarget_IIp(), PS_ILProgramTarget_IIp());
	}
	public static MethodHandle glNamedProgramStringEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedProgramStringEXT", MLS_ILProgramTarget_LProgramFormat_Ip(), PS_ILProgramTarget_LProgramFormat_Ip());
	}
	public static MethodHandle glNamedRenderbufferStorage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedRenderbufferStorage", MLS_ILInternalFormat_II(), PS_ILInternalFormat_II());
	}
	public static MethodHandle glNamedRenderbufferStorageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedRenderbufferStorageEXT", MLS_ILInternalFormat_II(), PS_ILInternalFormat_II());
	}
	public static MethodHandle glNamedRenderbufferStorageMultisample(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedRenderbufferStorageMultisample", MLS_IILInternalFormat_II(), PS_IILInternalFormat_II());
	}
	public static MethodHandle glNamedRenderbufferStorageMultisampleAdvancedAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedRenderbufferStorageMultisampleAdvancedAMD", MLS_IIILInternalFormat_II(), PS_IIILInternalFormat_II());
	}
	public static MethodHandle glNamedRenderbufferStorageMultisampleCoverageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedRenderbufferStorageMultisampleCoverageEXT", MLS_IIILInternalFormat_II(), PS_IIILInternalFormat_II());
	}
	public static MethodHandle glNamedRenderbufferStorageMultisampleEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedRenderbufferStorageMultisampleEXT", MLS_IILInternalFormat_II(), PS_IILInternalFormat_II());
	}
	public static MethodHandle glNamedStringARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNamedStringARB", MLS_EIpIp(), PS_EIpIp());
	}
	public static MethodHandle glNewList(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNewList", MLS_ILListMode_(), PS_ILListMode_());
	}
	public static MethodHandle glNewObjectBufferATI(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glNewObjectBufferATI", GLParamTypeSets.ML_I(), int.class, MLS_IpLArrayObjectUsageATI_(), PS_IpLArrayObjectUsageATI_());
	}
	public static MethodHandle glNormal3b(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3b", MLS_BBB(), PS_BBB());
	}
	public static MethodHandle glNormal3bv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3bv", MLS_p(), PS_p());
	}
	public static MethodHandle glNormal3d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3d", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glNormal3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3dv", MLS_p(), PS_p());
	}
	public static MethodHandle glNormal3f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3f", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glNormal3fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3fVertex3fSUN", MLS_FFFFFF(), PS_FFFFFF());
	}
	public static MethodHandle glNormal3fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3fVertex3fvSUN", MLS_pp(), PS_pp());
	}
	public static MethodHandle glNormal3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3fv", MLS_p(), PS_p());
	}
	public static MethodHandle glNormal3hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3hNV", MLS_CCC(), PS_CCC());
	}
	public static MethodHandle glNormal3hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3hvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glNormal3i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3i", MLS_III(), PS_III());
	}
	public static MethodHandle glNormal3iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3iv", MLS_p(), PS_p());
	}
	public static MethodHandle glNormal3s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3s", MLS_SSS(), PS_SSS());
	}
	public static MethodHandle glNormal3sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3sv", MLS_p(), PS_p());
	}
	public static MethodHandle glNormal3x(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3x", MLS_III(), PS_III());
	}
	public static MethodHandle glNormal3xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3xOES", MLS_III(), PS_III());
	}
	public static MethodHandle glNormal3xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormal3xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glNormalFormatNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalFormatNV", MLS_EI(), PS_EI());
	}
	public static MethodHandle glNormalP3ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalP3ui", MLS_LNormalPointerType_I(), PS_LNormalPointerType_I());
	}
	public static MethodHandle glNormalP3uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalP3uiv", MLS_LNormalPointerType_p(), PS_LNormalPointerType_p());
	}
	public static MethodHandle glNormalPointer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalPointer", MLS_LNormalPointerType_Ip(), PS_LNormalPointerType_Ip());
	}
	public static MethodHandle glNormalPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalPointerEXT", MLS_LNormalPointerType_IIp(), PS_LNormalPointerType_IIp());
	}
	public static MethodHandle glNormalPointerListIBM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalPointerListIBM", MLS_LNormalPointerType_IPI(), PS_LNormalPointerType_IPI());
	}
	public static MethodHandle glNormalPointervINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalPointervINTEL", MLS_LNormalPointerType_P(), PS_LNormalPointerType_P());
	}
	public static MethodHandle glNormalStream3bATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalStream3bATI", MLS_LVertexStreamATI_BBB(), PS_LVertexStreamATI_BBB());
	}
	public static MethodHandle glNormalStream3bvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalStream3bvATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glNormalStream3dATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalStream3dATI", MLS_LVertexStreamATI_DDD(), PS_LVertexStreamATI_DDD());
	}
	public static MethodHandle glNormalStream3dvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalStream3dvATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glNormalStream3fATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalStream3fATI", MLS_LVertexStreamATI_FFF(), PS_LVertexStreamATI_FFF());
	}
	public static MethodHandle glNormalStream3fvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalStream3fvATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glNormalStream3iATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalStream3iATI", MLS_LVertexStreamATI_III(), PS_LVertexStreamATI_III());
	}
	public static MethodHandle glNormalStream3ivATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalStream3ivATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glNormalStream3sATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalStream3sATI", MLS_LVertexStreamATI_SSS(), PS_LVertexStreamATI_SSS());
	}
	public static MethodHandle glNormalStream3svATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glNormalStream3svATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glObjectLabel(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glObjectLabel", MLS_LObjectIdentifier_IIp(), PS_LObjectIdentifier_IIp());
	}
	public static MethodHandle glObjectLabelKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glObjectLabelKHR", MLS_LObjectIdentifier_IIp(), PS_LObjectIdentifier_IIp());
	}
	public static MethodHandle glObjectPtrLabel(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glObjectPtrLabel", MLS_pIp(), PS_pIp());
	}
	public static MethodHandle glObjectPtrLabelKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glObjectPtrLabelKHR", MLS_pIp(), PS_pIp());
	}
	public static MethodHandle glObjectPurgeableAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glObjectPurgeableAPPLE", GLParamTypeSets.ML_E(), GLEnum.class, MLS_EIE(), PS_EIE());
	}
	public static MethodHandle glObjectUnpurgeableAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glObjectUnpurgeableAPPLE", GLParamTypeSets.ML_E(), GLEnum.class, MLS_EIE(), PS_EIE());
	}
	public static MethodHandle glOrtho(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glOrtho", MLS_DDDDDD(), PS_DDDDDD());
	}
	public static MethodHandle glOrthof(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glOrthof", MLS_FFFFFF(), PS_FFFFFF());
	}
	public static MethodHandle glOrthofOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glOrthofOES", MLS_FFFFFF(), PS_FFFFFF());
	}
	public static MethodHandle glOrthox(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glOrthox", MLS_IIIIII(), PS_IIIIII());
	}
	public static MethodHandle glOrthoxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glOrthoxOES", MLS_IIIIII(), PS_IIIIII());
	}
	public static MethodHandle glPNTrianglesfATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPNTrianglesfATI", MLS_LPNTrianglesPNameATI_F(), PS_LPNTrianglesPNameATI_F());
	}
	public static MethodHandle glPNTrianglesiATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPNTrianglesiATI", MLS_LPNTrianglesPNameATI_I(), PS_LPNTrianglesPNameATI_I());
	}
	public static MethodHandle glPassTexCoordATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPassTexCoordATI", MLS_IILSwizzleOpATI_(), PS_IILSwizzleOpATI_());
	}
	public static MethodHandle glPassThrough(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPassThrough", MLS_F(), PS_F());
	}
	public static MethodHandle glPassThroughxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPassThroughxOES", MLS_I(), PS_I());
	}
	public static MethodHandle glPatchParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPatchParameterfv", MLS_LPatchParameterName_p(), PS_LPatchParameterName_p());
	}
	public static MethodHandle glPatchParameteri(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPatchParameteri", MLS_LPatchParameterName_I(), PS_LPatchParameterName_I());
	}
	public static MethodHandle glPatchParameteriEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPatchParameteriEXT", MLS_LPatchParameterName_I(), PS_LPatchParameterName_I());
	}
	public static MethodHandle glPatchParameteriOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPatchParameteriOES", MLS_LPatchParameterName_I(), PS_LPatchParameterName_I());
	}
	public static MethodHandle glPathColorGenNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathColorGenNV", MLS_LPathColor_LPathGenMode_LPathColorFormat_p(), PS_LPathColor_LPathGenMode_LPathColorFormat_p());
	}
	public static MethodHandle glPathCommandsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathCommandsNV", MLS_IIpILPathCoordType_p(), PS_IIpILPathCoordType_p());
	}
	public static MethodHandle glPathCoordsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathCoordsNV", MLS_IILPathCoordType_p(), PS_IILPathCoordType_p());
	}
	public static MethodHandle glPathCoverDepthFuncNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathCoverDepthFuncNV", MLS_LDepthFunction_(), PS_LDepthFunction_());
	}
	public static MethodHandle glPathDashArrayNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathDashArrayNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glPathFogGenNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathFogGenNV", MLS_LPathGenMode_(), PS_LPathGenMode_());
	}
	public static MethodHandle glPathGlyphIndexArrayNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glPathGlyphIndexArrayNV", GLParamTypeSets.ML_E(), GLEnum.class, MLS_IEpIIIIF(), PS_IEpIIIIF());
	}
	public static MethodHandle glPathGlyphIndexRangeNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glPathGlyphIndexRangeNV", GLParamTypeSets.ML_E(), GLEnum.class, MLS_EpIIFP(), PS_EpIIFP());
	}
	public static MethodHandle glPathGlyphRangeNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathGlyphRangeNV", MLS_ILPathFontTarget_pIIILPathHandleMissingGlyphs_IF(), PS_ILPathFontTarget_pIIILPathHandleMissingGlyphs_IF());
	}
	public static MethodHandle glPathGlyphsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathGlyphsNV", MLS_ILPathFontTarget_pIILPathElementType_pLPathHandleMissingGlyphs_IF(), PS_ILPathFontTarget_pIILPathElementType_pLPathHandleMissingGlyphs_IF());
	}
	public static MethodHandle glPathMemoryGlyphIndexArrayNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glPathMemoryGlyphIndexArrayNV", GLParamTypeSets.ML_E(), GLEnum.class, MLS_IEJpIIIIF(), PS_IEJpIIIIF());
	}
	public static MethodHandle glPathParameterfNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathParameterfNV", MLS_ILPathParameter_F(), PS_ILPathParameter_F());
	}
	public static MethodHandle glPathParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathParameterfvNV", MLS_ILPathParameter_p(), PS_ILPathParameter_p());
	}
	public static MethodHandle glPathParameteriNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathParameteriNV", MLS_ILPathParameter_I(), PS_ILPathParameter_I());
	}
	public static MethodHandle glPathParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathParameterivNV", MLS_ILPathParameter_p(), PS_ILPathParameter_p());
	}
	public static MethodHandle glPathStencilDepthOffsetNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathStencilDepthOffsetNV", MLS_FF(), PS_FF());
	}
	public static MethodHandle glPathStencilFuncNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathStencilFuncNV", MLS_LStencilFunction_II(), PS_LStencilFunction_II());
	}
	public static MethodHandle glPathStringNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathStringNV", MLS_ILPathStringFormat_Ip(), PS_ILPathStringFormat_Ip());
	}
	public static MethodHandle glPathSubCommandsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathSubCommandsNV", MLS_IIIIpILPathCoordType_p(), PS_IIIIpILPathCoordType_p());
	}
	public static MethodHandle glPathSubCoordsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathSubCoordsNV", MLS_IIILPathCoordType_p(), PS_IIILPathCoordType_p());
	}
	public static MethodHandle glPathTexGenNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPathTexGenNV", MLS_LPathColor_LPathGenMode_Ip(), PS_LPathColor_LPathGenMode_Ip());
	}
	public static MethodHandle glPauseTransformFeedback(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPauseTransformFeedback", MLS_(), PS_());
	}
	public static MethodHandle glPauseTransformFeedbackNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPauseTransformFeedbackNV", MLS_(), PS_());
	}
	public static MethodHandle glPixelDataRangeNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelDataRangeNV", MLS_LPixelDataRangeTargetNV_Ip(), PS_LPixelDataRangeTargetNV_Ip());
	}
	public static MethodHandle glPixelMapfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelMapfv", MLS_LPixelMap_Ip(), PS_LPixelMap_Ip());
	}
	public static MethodHandle glPixelMapuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelMapuiv", MLS_LPixelMap_Ip(), PS_LPixelMap_Ip());
	}
	public static MethodHandle glPixelMapusv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelMapusv", MLS_LPixelMap_Ip(), PS_LPixelMap_Ip());
	}
	public static MethodHandle glPixelMapx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelMapx", MLS_LPixelMap_Ip(), PS_LPixelMap_Ip());
	}
	public static MethodHandle glPixelStoref(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelStoref", MLS_LPixelStoreParameter_F(), PS_LPixelStoreParameter_F());
	}
	public static MethodHandle glPixelStorei(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelStorei", MLS_LPixelStoreParameter_I(), PS_LPixelStoreParameter_I());
	}
	public static MethodHandle glPixelStorex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelStorex", MLS_LPixelStoreParameter_I(), PS_LPixelStoreParameter_I());
	}
	public static MethodHandle glPixelTexGenParameterfSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelTexGenParameterfSGIS", MLS_LPixelTexGenParameterNameSGIS_F(), PS_LPixelTexGenParameterNameSGIS_F());
	}
	public static MethodHandle glPixelTexGenParameterfvSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelTexGenParameterfvSGIS", MLS_LPixelTexGenParameterNameSGIS_p(), PS_LPixelTexGenParameterNameSGIS_p());
	}
	public static MethodHandle glPixelTexGenParameteriSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelTexGenParameteriSGIS", MLS_LPixelTexGenParameterNameSGIS_I(), PS_LPixelTexGenParameterNameSGIS_I());
	}
	public static MethodHandle glPixelTexGenParameterivSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelTexGenParameterivSGIS", MLS_LPixelTexGenParameterNameSGIS_p(), PS_LPixelTexGenParameterNameSGIS_p());
	}
	public static MethodHandle glPixelTexGenSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelTexGenSGIX", MLS_LPixelTexGenModeSGIX_(), PS_LPixelTexGenModeSGIX_());
	}
	public static MethodHandle glPixelTransferf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelTransferf", MLS_LPixelTransferParameter_F(), PS_LPixelTransferParameter_F());
	}
	public static MethodHandle glPixelTransferi(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelTransferi", MLS_LPixelTransferParameter_I(), PS_LPixelTransferParameter_I());
	}
	public static MethodHandle glPixelTransferxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelTransferxOES", MLS_LPixelTransferParameter_I(), PS_LPixelTransferParameter_I());
	}
	public static MethodHandle glPixelTransformParameterfEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelTransformParameterfEXT", MLS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_F(), PS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_F());
	}
	public static MethodHandle glPixelTransformParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelTransformParameterfvEXT", MLS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_p(), PS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_p());
	}
	public static MethodHandle glPixelTransformParameteriEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelTransformParameteriEXT", MLS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_I(), PS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_I());
	}
	public static MethodHandle glPixelTransformParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelTransformParameterivEXT", MLS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_p(), PS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_p());
	}
	public static MethodHandle glPixelZoom(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelZoom", MLS_FF(), PS_FF());
	}
	public static MethodHandle glPixelZoomxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPixelZoomxOES", MLS_II(), PS_II());
	}
	public static MethodHandle glPointAlongPathNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glPointAlongPathNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_IIIFPPPP(), PS_IIIFPPPP());
	}
	public static MethodHandle glPointParameterf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterf", MLS_LPointParameterNameARB_F(), PS_LPointParameterNameARB_F());
	}
	public static MethodHandle glPointParameterfARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterfARB", MLS_LPointParameterNameARB_F(), PS_LPointParameterNameARB_F());
	}
	public static MethodHandle glPointParameterfEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterfEXT", MLS_LPointParameterNameARB_F(), PS_LPointParameterNameARB_F());
	}
	public static MethodHandle glPointParameterfSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterfSGIS", MLS_LPointParameterNameARB_F(), PS_LPointParameterNameARB_F());
	}
	public static MethodHandle glPointParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterfv", MLS_LPointParameterNameARB_p(), PS_LPointParameterNameARB_p());
	}
	public static MethodHandle glPointParameterfvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterfvARB", MLS_LPointParameterNameARB_p(), PS_LPointParameterNameARB_p());
	}
	public static MethodHandle glPointParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterfvEXT", MLS_LPointParameterNameARB_p(), PS_LPointParameterNameARB_p());
	}
	public static MethodHandle glPointParameterfvSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterfvSGIS", MLS_LPointParameterNameARB_p(), PS_LPointParameterNameARB_p());
	}
	public static MethodHandle glPointParameteri(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameteri", MLS_LPointParameterNameARB_I(), PS_LPointParameterNameARB_I());
	}
	public static MethodHandle glPointParameteriNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameteriNV", MLS_LPointParameterNameARB_I(), PS_LPointParameterNameARB_I());
	}
	public static MethodHandle glPointParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameteriv", MLS_LPointParameterNameARB_p(), PS_LPointParameterNameARB_p());
	}
	public static MethodHandle glPointParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterivNV", MLS_LPointParameterNameARB_p(), PS_LPointParameterNameARB_p());
	}
	public static MethodHandle glPointParameterx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterx", MLS_LPointParameterNameARB_I(), PS_LPointParameterNameARB_I());
	}
	public static MethodHandle glPointParameterxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterxOES", MLS_LPointParameterNameARB_I(), PS_LPointParameterNameARB_I());
	}
	public static MethodHandle glPointParameterxv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterxv", MLS_LPointParameterNameARB_p(), PS_LPointParameterNameARB_p());
	}
	public static MethodHandle glPointParameterxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointParameterxvOES", MLS_LPointParameterNameARB_p(), PS_LPointParameterNameARB_p());
	}
	public static MethodHandle glPointSize(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointSize", MLS_F(), PS_F());
	}
	public static MethodHandle glPointSizePointerOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointSizePointerOES", MLS_EIp(), PS_EIp());
	}
	public static MethodHandle glPointSizex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointSizex", MLS_I(), PS_I());
	}
	public static MethodHandle glPointSizexOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPointSizexOES", MLS_I(), PS_I());
	}
	public static MethodHandle glPollAsyncSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glPollAsyncSGIX", GLParamTypeSets.ML_I(), int.class, MLS_P(), PS_P());
	}
	public static MethodHandle glPollInstrumentsSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glPollInstrumentsSGIX", GLParamTypeSets.ML_I(), int.class, MLS_P(), PS_P());
	}
	public static MethodHandle glPolygonMode(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPolygonMode", MLS_LTriangleFace_LPolygonMode_(), PS_LTriangleFace_LPolygonMode_());
	}
	public static MethodHandle glPolygonModeNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPolygonModeNV", MLS_LTriangleFace_LPolygonMode_(), PS_LTriangleFace_LPolygonMode_());
	}
	public static MethodHandle glPolygonOffset(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPolygonOffset", MLS_FF(), PS_FF());
	}
	public static MethodHandle glPolygonOffsetClamp(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPolygonOffsetClamp", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glPolygonOffsetClampEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPolygonOffsetClampEXT", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glPolygonOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPolygonOffsetEXT", MLS_FF(), PS_FF());
	}
	public static MethodHandle glPolygonOffsetx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPolygonOffsetx", MLS_II(), PS_II());
	}
	public static MethodHandle glPolygonOffsetxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPolygonOffsetxOES", MLS_II(), PS_II());
	}
	public static MethodHandle glPolygonStipple(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPolygonStipple", MLS_p(), PS_p());
	}
	public static MethodHandle glPopAttrib(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPopAttrib", MLS_(), PS_());
	}
	public static MethodHandle glPopClientAttrib(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPopClientAttrib", MLS_(), PS_());
	}
	public static MethodHandle glPopDebugGroup(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPopDebugGroup", MLS_(), PS_());
	}
	public static MethodHandle glPopDebugGroupKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPopDebugGroupKHR", MLS_(), PS_());
	}
	public static MethodHandle glPopGroupMarkerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPopGroupMarkerEXT", MLS_(), PS_());
	}
	public static MethodHandle glPopMatrix(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPopMatrix", MLS_(), PS_());
	}
	public static MethodHandle glPopName(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPopName", MLS_(), PS_());
	}
	public static MethodHandle glPresentFrameDualFillNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPresentFrameDualFillNV", MLS_IJIIEEIEIEIEI(), PS_IJIIEEIEIEIEI());
	}
	public static MethodHandle glPresentFrameKeyedNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPresentFrameKeyedNV", MLS_IJIIEEIIEII(), PS_IJIIEEIIEII());
	}
	public static MethodHandle glPrimitiveBoundingBox(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPrimitiveBoundingBox", MLS_FFFFFFFF(), PS_FFFFFFFF());
	}
	public static MethodHandle glPrimitiveBoundingBoxARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPrimitiveBoundingBoxARB", MLS_FFFFFFFF(), PS_FFFFFFFF());
	}
	public static MethodHandle glPrimitiveBoundingBoxEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPrimitiveBoundingBoxEXT", MLS_FFFFFFFF(), PS_FFFFFFFF());
	}
	public static MethodHandle glPrimitiveBoundingBoxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPrimitiveBoundingBoxOES", MLS_FFFFFFFF(), PS_FFFFFFFF());
	}
	public static MethodHandle glPrimitiveRestartIndex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPrimitiveRestartIndex", MLS_I(), PS_I());
	}
	public static MethodHandle glPrimitiveRestartIndexNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPrimitiveRestartIndexNV", MLS_I(), PS_I());
	}
	public static MethodHandle glPrimitiveRestartNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPrimitiveRestartNV", MLS_(), PS_());
	}
	public static MethodHandle glPrioritizeTextures(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPrioritizeTextures", MLS_Ipp(), PS_Ipp());
	}
	public static MethodHandle glPrioritizeTexturesEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPrioritizeTexturesEXT", MLS_Ipp(), PS_Ipp());
	}
	public static MethodHandle glPrioritizeTexturesxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPrioritizeTexturesxOES", MLS_Ipp(), PS_Ipp());
	}
	public static MethodHandle glProgramBinary(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramBinary", MLS_IEpI(), PS_IEpI());
	}
	public static MethodHandle glProgramBinaryOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramBinaryOES", MLS_IEpI(), PS_IEpI());
	}
	public static MethodHandle glProgramBufferParametersIivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramBufferParametersIivNV", MLS_LProgramTarget_IIIp(), PS_LProgramTarget_IIIp());
	}
	public static MethodHandle glProgramBufferParametersIuivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramBufferParametersIuivNV", MLS_LProgramTarget_IIIp(), PS_LProgramTarget_IIIp());
	}
	public static MethodHandle glProgramBufferParametersfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramBufferParametersfvNV", MLS_LProgramTarget_IIIp(), PS_LProgramTarget_IIIp());
	}
	public static MethodHandle glProgramEnvParameter4dARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramEnvParameter4dARB", MLS_LProgramTarget_IDDDD(), PS_LProgramTarget_IDDDD());
	}
	public static MethodHandle glProgramEnvParameter4dvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramEnvParameter4dvARB", MLS_LProgramTarget_Ip(), PS_LProgramTarget_Ip());
	}
	public static MethodHandle glProgramEnvParameter4fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramEnvParameter4fARB", MLS_LProgramTarget_IFFFF(), PS_LProgramTarget_IFFFF());
	}
	public static MethodHandle glProgramEnvParameter4fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramEnvParameter4fvARB", MLS_LProgramTarget_Ip(), PS_LProgramTarget_Ip());
	}
	public static MethodHandle glProgramEnvParameterI4iNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramEnvParameterI4iNV", MLS_LProgramTarget_IIIII(), PS_LProgramTarget_IIIII());
	}
	public static MethodHandle glProgramEnvParameterI4ivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramEnvParameterI4ivNV", MLS_LProgramTarget_Ip(), PS_LProgramTarget_Ip());
	}
	public static MethodHandle glProgramEnvParameterI4uiNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramEnvParameterI4uiNV", MLS_LProgramTarget_IIIII(), PS_LProgramTarget_IIIII());
	}
	public static MethodHandle glProgramEnvParameterI4uivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramEnvParameterI4uivNV", MLS_LProgramTarget_Ip(), PS_LProgramTarget_Ip());
	}
	public static MethodHandle glProgramEnvParameters4fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramEnvParameters4fvEXT", MLS_LProgramTarget_IIp(), PS_LProgramTarget_IIp());
	}
	public static MethodHandle glProgramEnvParametersI4ivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramEnvParametersI4ivNV", MLS_LProgramTarget_IIp(), PS_LProgramTarget_IIp());
	}
	public static MethodHandle glProgramEnvParametersI4uivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramEnvParametersI4uivNV", MLS_LProgramTarget_IIp(), PS_LProgramTarget_IIp());
	}
	public static MethodHandle glProgramLocalParameter4dARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramLocalParameter4dARB", MLS_LProgramTarget_IDDDD(), PS_LProgramTarget_IDDDD());
	}
	public static MethodHandle glProgramLocalParameter4dvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramLocalParameter4dvARB", MLS_LProgramTarget_Ip(), PS_LProgramTarget_Ip());
	}
	public static MethodHandle glProgramLocalParameter4fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramLocalParameter4fARB", MLS_LProgramTarget_IFFFF(), PS_LProgramTarget_IFFFF());
	}
	public static MethodHandle glProgramLocalParameter4fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramLocalParameter4fvARB", MLS_LProgramTarget_Ip(), PS_LProgramTarget_Ip());
	}
	public static MethodHandle glProgramLocalParameterI4iNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramLocalParameterI4iNV", MLS_LProgramTarget_IIIII(), PS_LProgramTarget_IIIII());
	}
	public static MethodHandle glProgramLocalParameterI4ivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramLocalParameterI4ivNV", MLS_LProgramTarget_Ip(), PS_LProgramTarget_Ip());
	}
	public static MethodHandle glProgramLocalParameterI4uiNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramLocalParameterI4uiNV", MLS_LProgramTarget_IIIII(), PS_LProgramTarget_IIIII());
	}
	public static MethodHandle glProgramLocalParameterI4uivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramLocalParameterI4uivNV", MLS_LProgramTarget_Ip(), PS_LProgramTarget_Ip());
	}
	public static MethodHandle glProgramLocalParameters4fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramLocalParameters4fvEXT", MLS_LProgramTarget_IIp(), PS_LProgramTarget_IIp());
	}
	public static MethodHandle glProgramLocalParametersI4ivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramLocalParametersI4ivNV", MLS_LProgramTarget_IIp(), PS_LProgramTarget_IIp());
	}
	public static MethodHandle glProgramLocalParametersI4uivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramLocalParametersI4uivNV", MLS_LProgramTarget_IIp(), PS_LProgramTarget_IIp());
	}
	public static MethodHandle glProgramNamedParameter4dNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramNamedParameter4dNV", MLS_IIpDDDD(), PS_IIpDDDD());
	}
	public static MethodHandle glProgramNamedParameter4dvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramNamedParameter4dvNV", MLS_IIpp(), PS_IIpp());
	}
	public static MethodHandle glProgramNamedParameter4fNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramNamedParameter4fNV", MLS_IIpFFFF(), PS_IIpFFFF());
	}
	public static MethodHandle glProgramNamedParameter4fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramNamedParameter4fvNV", MLS_IIpp(), PS_IIpp());
	}
	public static MethodHandle glProgramParameter4dNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramParameter4dNV", MLS_LVertexAttribEnumNV_IDDDD(), PS_LVertexAttribEnumNV_IDDDD());
	}
	public static MethodHandle glProgramParameter4dvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramParameter4dvNV", MLS_LVertexAttribEnumNV_Ip(), PS_LVertexAttribEnumNV_Ip());
	}
	public static MethodHandle glProgramParameter4fNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramParameter4fNV", MLS_LVertexAttribEnumNV_IFFFF(), PS_LVertexAttribEnumNV_IFFFF());
	}
	public static MethodHandle glProgramParameter4fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramParameter4fvNV", MLS_LVertexAttribEnumNV_Ip(), PS_LVertexAttribEnumNV_Ip());
	}
	public static MethodHandle glProgramParameteri(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramParameteri", MLS_ILProgramParameterPName_I(), PS_ILProgramParameterPName_I());
	}
	public static MethodHandle glProgramParameteriARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramParameteriARB", MLS_ILProgramParameterPName_I(), PS_ILProgramParameterPName_I());
	}
	public static MethodHandle glProgramParameteriEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramParameteriEXT", MLS_ILProgramParameterPName_I(), PS_ILProgramParameterPName_I());
	}
	public static MethodHandle glProgramParameters4dvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramParameters4dvNV", MLS_LVertexAttribEnumNV_IIp(), PS_LVertexAttribEnumNV_IIp());
	}
	public static MethodHandle glProgramParameters4fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramParameters4fvNV", MLS_LVertexAttribEnumNV_IIp(), PS_LVertexAttribEnumNV_IIp());
	}
	public static MethodHandle glProgramPathFragmentInputGenNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramPathFragmentInputGenNV", MLS_IIEIp(), PS_IIEIp());
	}
	public static MethodHandle glProgramStringARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramStringARB", MLS_LProgramTarget_LProgramFormat_Ip(), PS_LProgramTarget_LProgramFormat_Ip());
	}
	public static MethodHandle glProgramSubroutineParametersuivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramSubroutineParametersuivNV", MLS_EIp(), PS_EIp());
	}
	public static MethodHandle glProgramUniform1d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1d", MLS_IID(), PS_IID());
	}
	public static MethodHandle glProgramUniform1dEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1dEXT", MLS_IID(), PS_IID());
	}
	public static MethodHandle glProgramUniform1dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1dv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform1dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1dvEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform1f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1f", MLS_IIF(), PS_IIF());
	}
	public static MethodHandle glProgramUniform1fEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1fEXT", MLS_IIF(), PS_IIF());
	}
	public static MethodHandle glProgramUniform1fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1fv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform1fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1fvEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform1i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1i", MLS_III(), PS_III());
	}
	public static MethodHandle glProgramUniform1i64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1i64ARB", MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glProgramUniform1i64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1i64NV", MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glProgramUniform1i64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1i64vARB", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform1i64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1i64vNV", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform1iEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1iEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glProgramUniform1iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1iv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform1ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1ivEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform1ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1ui", MLS_III(), PS_III());
	}
	public static MethodHandle glProgramUniform1ui64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1ui64ARB", MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glProgramUniform1ui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1ui64NV", MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glProgramUniform1ui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1ui64vARB", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform1ui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1ui64vNV", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform1uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1uiEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glProgramUniform1uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1uiv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform1uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform1uivEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform2d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2d", MLS_IIDD(), PS_IIDD());
	}
	public static MethodHandle glProgramUniform2dEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2dEXT", MLS_IIDD(), PS_IIDD());
	}
	public static MethodHandle glProgramUniform2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2dv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform2dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2dvEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform2f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2f", MLS_IIFF(), PS_IIFF());
	}
	public static MethodHandle glProgramUniform2fEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2fEXT", MLS_IIFF(), PS_IIFF());
	}
	public static MethodHandle glProgramUniform2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2fv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform2fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2fvEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform2i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2i", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glProgramUniform2i64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2i64ARB", MLS_IIJJ(), PS_IIJJ());
	}
	public static MethodHandle glProgramUniform2i64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2i64NV", MLS_IIJJ(), PS_IIJJ());
	}
	public static MethodHandle glProgramUniform2i64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2i64vARB", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform2i64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2i64vNV", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform2iEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2iEXT", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glProgramUniform2iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2iv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform2ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2ivEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform2ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2ui", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glProgramUniform2ui64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2ui64ARB", MLS_IIJJ(), PS_IIJJ());
	}
	public static MethodHandle glProgramUniform2ui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2ui64NV", MLS_IIJJ(), PS_IIJJ());
	}
	public static MethodHandle glProgramUniform2ui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2ui64vARB", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform2ui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2ui64vNV", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform2uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2uiEXT", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glProgramUniform2uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2uiv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform2uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform2uivEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform3d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3d", MLS_IIDDD(), PS_IIDDD());
	}
	public static MethodHandle glProgramUniform3dEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3dEXT", MLS_IIDDD(), PS_IIDDD());
	}
	public static MethodHandle glProgramUniform3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3dv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform3dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3dvEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform3f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3f", MLS_IIFFF(), PS_IIFFF());
	}
	public static MethodHandle glProgramUniform3fEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3fEXT", MLS_IIFFF(), PS_IIFFF());
	}
	public static MethodHandle glProgramUniform3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3fv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform3fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3fvEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform3i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3i", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glProgramUniform3i64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3i64ARB", MLS_IIJJJ(), PS_IIJJJ());
	}
	public static MethodHandle glProgramUniform3i64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3i64NV", MLS_IIJJJ(), PS_IIJJJ());
	}
	public static MethodHandle glProgramUniform3i64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3i64vARB", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform3i64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3i64vNV", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform3iEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3iEXT", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glProgramUniform3iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3iv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform3ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3ivEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform3ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3ui", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glProgramUniform3ui64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3ui64ARB", MLS_IIJJJ(), PS_IIJJJ());
	}
	public static MethodHandle glProgramUniform3ui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3ui64NV", MLS_IIJJJ(), PS_IIJJJ());
	}
	public static MethodHandle glProgramUniform3ui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3ui64vARB", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform3ui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3ui64vNV", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform3uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3uiEXT", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glProgramUniform3uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3uiv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform3uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform3uivEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform4d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4d", MLS_IIDDDD(), PS_IIDDDD());
	}
	public static MethodHandle glProgramUniform4dEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4dEXT", MLS_IIDDDD(), PS_IIDDDD());
	}
	public static MethodHandle glProgramUniform4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4dv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform4dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4dvEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform4f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4f", MLS_IIFFFF(), PS_IIFFFF());
	}
	public static MethodHandle glProgramUniform4fEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4fEXT", MLS_IIFFFF(), PS_IIFFFF());
	}
	public static MethodHandle glProgramUniform4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4fv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform4fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4fvEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform4i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4i", MLS_IIIIII(), PS_IIIIII());
	}
	public static MethodHandle glProgramUniform4i64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4i64ARB", MLS_IIJJJJ(), PS_IIJJJJ());
	}
	public static MethodHandle glProgramUniform4i64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4i64NV", MLS_IIJJJJ(), PS_IIJJJJ());
	}
	public static MethodHandle glProgramUniform4i64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4i64vARB", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform4i64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4i64vNV", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform4iEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4iEXT", MLS_IIIIII(), PS_IIIIII());
	}
	public static MethodHandle glProgramUniform4iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4iv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform4ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4ivEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform4ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4ui", MLS_IIIIII(), PS_IIIIII());
	}
	public static MethodHandle glProgramUniform4ui64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4ui64ARB", MLS_IIJJJJ(), PS_IIJJJJ());
	}
	public static MethodHandle glProgramUniform4ui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4ui64NV", MLS_IIJJJJ(), PS_IIJJJJ());
	}
	public static MethodHandle glProgramUniform4ui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4ui64vARB", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform4ui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4ui64vNV", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform4uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4uiEXT", MLS_IIIIII(), PS_IIIIII());
	}
	public static MethodHandle glProgramUniform4uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4uiv", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniform4uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniform4uivEXT", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniformHandleui64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformHandleui64ARB", MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glProgramUniformHandleui64IMG(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformHandleui64IMG", MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glProgramUniformHandleui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformHandleui64NV", MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glProgramUniformHandleui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformHandleui64vARB", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniformHandleui64vIMG(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformHandleui64vIMG", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniformHandleui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformHandleui64vNV", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramUniformMatrix2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix2dv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix2dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix2dvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix2fv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix2fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix2fvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix2x3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix2x3dv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix2x3dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix2x3dvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix2x3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix2x3fv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix2x3fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix2x3fvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix2x4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix2x4dv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix2x4dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix2x4dvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix2x4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix2x4fv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix2x4fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix2x4fvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix3dv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix3dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix3dvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix3fv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix3fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix3fvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix3x2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix3x2dv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix3x2dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix3x2dvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix3x2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix3x2fv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix3x2fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix3x2fvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix3x4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix3x4dv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix3x4dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix3x4dvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix3x4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix3x4fv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix3x4fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix3x4fvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix4dv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix4dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix4dvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix4fv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix4fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix4fvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix4x2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix4x2dv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix4x2dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix4x2dvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix4x2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix4x2fv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix4x2fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix4x2fvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix4x3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix4x3dv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix4x3dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix4x3dvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix4x3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix4x3fv", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformMatrix4x3fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformMatrix4x3fvEXT", MLS_IIIZp(), PS_IIIZp());
	}
	public static MethodHandle glProgramUniformui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformui64NV", MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glProgramUniformui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramUniformui64vNV", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glProgramVertexLimitNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProgramVertexLimitNV", MLS_LProgramTarget_I(), PS_LProgramTarget_I());
	}
	public static MethodHandle glProvokingVertex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProvokingVertex", MLS_LVertexProvokingMode_(), PS_LVertexProvokingMode_());
	}
	public static MethodHandle glProvokingVertexEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glProvokingVertexEXT", MLS_LVertexProvokingMode_(), PS_LVertexProvokingMode_());
	}
	public static MethodHandle glPushAttrib(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPushAttrib", MLS_I(), PS_I());
	}
	public static MethodHandle glPushClientAttrib(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPushClientAttrib", MLS_I(), PS_I());
	}
	public static MethodHandle glPushClientAttribDefaultEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPushClientAttribDefaultEXT", MLS_I(), PS_I());
	}
	public static MethodHandle glPushDebugGroup(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPushDebugGroup", MLS_LDebugSource_IIp(), PS_LDebugSource_IIp());
	}
	public static MethodHandle glPushDebugGroupKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPushDebugGroupKHR", MLS_LDebugSource_IIp(), PS_LDebugSource_IIp());
	}
	public static MethodHandle glPushGroupMarkerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPushGroupMarkerEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glPushMatrix(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPushMatrix", MLS_(), PS_());
	}
	public static MethodHandle glPushName(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glPushName", MLS_I(), PS_I());
	}
	public static MethodHandle glQueryCounter(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glQueryCounter", MLS_ILQueryCounterTarget_(), PS_ILQueryCounterTarget_());
	}
	public static MethodHandle glQueryCounterEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glQueryCounterEXT", MLS_ILQueryCounterTarget_(), PS_ILQueryCounterTarget_());
	}
	public static MethodHandle glQueryMatrixxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glQueryMatrixxOES", GLParamTypeSets.ML_I(), int.class, MLS_PP(), PS_PP());
	}
	public static MethodHandle glQueryObjectParameteruiAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glQueryObjectParameteruiAMD", MLS_LQueryTarget_IEI(), PS_LQueryTarget_IEI());
	}
	public static MethodHandle glQueryResourceNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glQueryResourceNV", GLParamTypeSets.ML_I(), int.class, MLS_EIIP(), PS_EIIP());
	}
	public static MethodHandle glQueryResourceTagNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glQueryResourceTagNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glRasterPos2d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos2d", MLS_DD(), PS_DD());
	}
	public static MethodHandle glRasterPos2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos2dv", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos2f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos2f", MLS_FF(), PS_FF());
	}
	public static MethodHandle glRasterPos2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos2fv", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos2i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos2i", MLS_II(), PS_II());
	}
	public static MethodHandle glRasterPos2iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos2iv", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos2s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos2s", MLS_SS(), PS_SS());
	}
	public static MethodHandle glRasterPos2sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos2sv", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos2xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos2xOES", MLS_II(), PS_II());
	}
	public static MethodHandle glRasterPos2xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos2xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos3d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos3d", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glRasterPos3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos3dv", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos3f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos3f", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glRasterPos3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos3fv", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos3i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos3i", MLS_III(), PS_III());
	}
	public static MethodHandle glRasterPos3iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos3iv", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos3s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos3s", MLS_SSS(), PS_SSS());
	}
	public static MethodHandle glRasterPos3sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos3sv", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos3xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos3xOES", MLS_III(), PS_III());
	}
	public static MethodHandle glRasterPos3xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos3xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos4d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos4d", MLS_DDDD(), PS_DDDD());
	}
	public static MethodHandle glRasterPos4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos4dv", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos4f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos4f", MLS_FFFF(), PS_FFFF());
	}
	public static MethodHandle glRasterPos4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos4fv", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos4i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos4i", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glRasterPos4iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos4iv", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos4s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos4s", MLS_SSSS(), PS_SSSS());
	}
	public static MethodHandle glRasterPos4sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos4sv", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterPos4xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos4xOES", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glRasterPos4xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterPos4xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glRasterSamplesEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRasterSamplesEXT", MLS_IZ(), PS_IZ());
	}
	public static MethodHandle glReadBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReadBuffer", MLS_LReadBufferMode_(), PS_LReadBufferMode_());
	}
	public static MethodHandle glReadBufferIndexedEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReadBufferIndexedEXT", MLS_LReadBufferMode_I(), PS_LReadBufferMode_I());
	}
	public static MethodHandle glReadBufferNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReadBufferNV", MLS_E(), PS_E());
	}
	public static MethodHandle glReadInstrumentsSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReadInstrumentsSGIX", MLS_I(), PS_I());
	}
	public static MethodHandle glReadPixels(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReadPixels", MLS_IIIILPixelFormat_LPixelType_P(), PS_IIIILPixelFormat_LPixelType_P());
	}
	public static MethodHandle glReadnPixels(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReadnPixels", MLS_IIIILPixelFormat_LPixelType_IP(), PS_IIIILPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glReadnPixelsARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReadnPixelsARB", MLS_IIIILPixelFormat_LPixelType_IP(), PS_IIIILPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glReadnPixelsEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReadnPixelsEXT", MLS_IIIILPixelFormat_LPixelType_IP(), PS_IIIILPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glReadnPixelsKHR(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReadnPixelsKHR", MLS_IIIILPixelFormat_LPixelType_IP(), PS_IIIILPixelFormat_LPixelType_IP());
	}
	public static MethodHandle glReleaseKeyedMutexWin32EXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glReleaseKeyedMutexWin32EXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_IJ(), PS_IJ());
	}
	public static MethodHandle glRectd(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRectd", MLS_DDDD(), PS_DDDD());
	}
	public static MethodHandle glRectdv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRectdv", MLS_pp(), PS_pp());
	}
	public static MethodHandle glRectf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRectf", MLS_FFFF(), PS_FFFF());
	}
	public static MethodHandle glRectfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRectfv", MLS_pp(), PS_pp());
	}
	public static MethodHandle glRecti(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRecti", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glRectiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRectiv", MLS_pp(), PS_pp());
	}
	public static MethodHandle glRects(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRects", MLS_SSSS(), PS_SSSS());
	}
	public static MethodHandle glRectsv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRectsv", MLS_pp(), PS_pp());
	}
	public static MethodHandle glRectxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRectxOES", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glRectxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRectxvOES", MLS_pp(), PS_pp());
	}
	public static MethodHandle glReferencePlaneSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReferencePlaneSGIX", MLS_p(), PS_p());
	}
	public static MethodHandle glReleaseShaderCompiler(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReleaseShaderCompiler", MLS_(), PS_());
	}
	public static MethodHandle glRenderGpuMaskNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRenderGpuMaskNV", MLS_I(), PS_I());
	}
	public static MethodHandle glRenderMode(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glRenderMode", GLParamTypeSets.ML_I(), int.class, MLS_LRenderingMode_(), PS_LRenderingMode_());
	}
	public static MethodHandle glRenderbufferStorage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRenderbufferStorage", MLS_LRenderbufferTarget_LInternalFormat_II(), PS_LRenderbufferTarget_LInternalFormat_II());
	}
	public static MethodHandle glRenderbufferStorageEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRenderbufferStorageEXT", MLS_LRenderbufferTarget_LInternalFormat_II(), PS_LRenderbufferTarget_LInternalFormat_II());
	}
	public static MethodHandle glRenderbufferStorageMultisample(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRenderbufferStorageMultisample", MLS_LRenderbufferTarget_ILInternalFormat_II(), PS_LRenderbufferTarget_ILInternalFormat_II());
	}
	public static MethodHandle glRenderbufferStorageMultisampleANGLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRenderbufferStorageMultisampleANGLE", MLS_LRenderbufferTarget_ILInternalFormat_II(), PS_LRenderbufferTarget_ILInternalFormat_II());
	}
	public static MethodHandle glRenderbufferStorageMultisampleAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRenderbufferStorageMultisampleAPPLE", MLS_LRenderbufferTarget_ILInternalFormat_II(), PS_LRenderbufferTarget_ILInternalFormat_II());
	}
	public static MethodHandle glRenderbufferStorageMultisampleAdvancedAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRenderbufferStorageMultisampleAdvancedAMD", MLS_LRenderbufferTarget_IILInternalFormat_II(), PS_LRenderbufferTarget_IILInternalFormat_II());
	}
	public static MethodHandle glRenderbufferStorageMultisampleCoverageNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRenderbufferStorageMultisampleCoverageNV", MLS_LRenderbufferTarget_IILInternalFormat_II(), PS_LRenderbufferTarget_IILInternalFormat_II());
	}
	public static MethodHandle glRenderbufferStorageMultisampleEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRenderbufferStorageMultisampleEXT", MLS_LRenderbufferTarget_ILInternalFormat_II(), PS_LRenderbufferTarget_ILInternalFormat_II());
	}
	public static MethodHandle glRenderbufferStorageMultisampleIMG(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRenderbufferStorageMultisampleIMG", MLS_LRenderbufferTarget_ILInternalFormat_II(), PS_LRenderbufferTarget_ILInternalFormat_II());
	}
	public static MethodHandle glRenderbufferStorageMultisampleNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRenderbufferStorageMultisampleNV", MLS_LRenderbufferTarget_ILInternalFormat_II(), PS_LRenderbufferTarget_ILInternalFormat_II());
	}
	public static MethodHandle glRenderbufferStorageOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRenderbufferStorageOES", MLS_LRenderbufferTarget_LInternalFormat_II(), PS_LRenderbufferTarget_LInternalFormat_II());
	}
	public static MethodHandle glReplacementCodePointerSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodePointerSUN", MLS_LReplacementCodeTypeSUN_IP(), PS_LReplacementCodeTypeSUN_IP());
	}
	public static MethodHandle glReplacementCodeubSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeubSUN", MLS_B(), PS_B());
	}
	public static MethodHandle glReplacementCodeubvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeubvSUN", MLS_p(), PS_p());
	}
	public static MethodHandle glReplacementCodeuiColor3fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiColor3fVertex3fSUN", MLS_IFFFFFF(), PS_IFFFFFF());
	}
	public static MethodHandle glReplacementCodeuiColor3fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiColor3fVertex3fvSUN", MLS_ppp(), PS_ppp());
	}
	public static MethodHandle glReplacementCodeuiColor4fNormal3fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiColor4fNormal3fVertex3fSUN", MLS_IFFFFFFFFFF(), PS_IFFFFFFFFFF());
	}
	public static MethodHandle glReplacementCodeuiColor4fNormal3fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiColor4fNormal3fVertex3fvSUN", MLS_pppp(), PS_pppp());
	}
	public static MethodHandle glReplacementCodeuiColor4ubVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiColor4ubVertex3fSUN", MLS_IBBBBFFF(), PS_IBBBBFFF());
	}
	public static MethodHandle glReplacementCodeuiColor4ubVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiColor4ubVertex3fvSUN", MLS_ppp(), PS_ppp());
	}
	public static MethodHandle glReplacementCodeuiNormal3fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiNormal3fVertex3fSUN", MLS_IFFFFFF(), PS_IFFFFFF());
	}
	public static MethodHandle glReplacementCodeuiNormal3fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiNormal3fVertex3fvSUN", MLS_ppp(), PS_ppp());
	}
	public static MethodHandle glReplacementCodeuiSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiSUN", MLS_I(), PS_I());
	}
	public static MethodHandle glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN", MLS_IFFFFFFFFFFFF(), PS_IFFFFFFFFFFFF());
	}
	public static MethodHandle glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN", MLS_ppppp(), PS_ppppp());
	}
	public static MethodHandle glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN", MLS_IFFFFFFFF(), PS_IFFFFFFFF());
	}
	public static MethodHandle glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN", MLS_pppp(), PS_pppp());
	}
	public static MethodHandle glReplacementCodeuiTexCoord2fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiTexCoord2fVertex3fSUN", MLS_IFFFFF(), PS_IFFFFF());
	}
	public static MethodHandle glReplacementCodeuiTexCoord2fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiTexCoord2fVertex3fvSUN", MLS_ppp(), PS_ppp());
	}
	public static MethodHandle glReplacementCodeuiVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiVertex3fSUN", MLS_IFFF(), PS_IFFF());
	}
	public static MethodHandle glReplacementCodeuiVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuiVertex3fvSUN", MLS_pp(), PS_pp());
	}
	public static MethodHandle glReplacementCodeuivSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeuivSUN", MLS_p(), PS_p());
	}
	public static MethodHandle glReplacementCodeusSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeusSUN", MLS_C(), PS_C());
	}
	public static MethodHandle glReplacementCodeusvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glReplacementCodeusvSUN", MLS_p(), PS_p());
	}
	public static MethodHandle glRequestResidentProgramsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRequestResidentProgramsNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glResetHistogram(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glResetHistogram", MLS_LHistogramTargetEXT_(), PS_LHistogramTargetEXT_());
	}
	public static MethodHandle glResetHistogramEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glResetHistogramEXT", MLS_LHistogramTargetEXT_(), PS_LHistogramTargetEXT_());
	}
	public static MethodHandle glResetMemoryObjectParameterNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glResetMemoryObjectParameterNV", MLS_IE(), PS_IE());
	}
	public static MethodHandle glResetMinmax(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glResetMinmax", MLS_LMinmaxTargetEXT_(), PS_LMinmaxTargetEXT_());
	}
	public static MethodHandle glResetMinmaxEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glResetMinmaxEXT", MLS_LMinmaxTargetEXT_(), PS_LMinmaxTargetEXT_());
	}
	public static MethodHandle glResizeBuffersMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glResizeBuffersMESA", MLS_(), PS_());
	}
	public static MethodHandle glResolveDepthValuesNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glResolveDepthValuesNV", MLS_(), PS_());
	}
	public static MethodHandle glResolveMultisampleFramebufferAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glResolveMultisampleFramebufferAPPLE", MLS_(), PS_());
	}
	public static MethodHandle glResumeTransformFeedback(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glResumeTransformFeedback", MLS_(), PS_());
	}
	public static MethodHandle glResumeTransformFeedbackNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glResumeTransformFeedbackNV", MLS_(), PS_());
	}
	public static MethodHandle glRotated(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRotated", MLS_DDDD(), PS_DDDD());
	}
	public static MethodHandle glRotatef(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRotatef", MLS_FFFF(), PS_FFFF());
	}
	public static MethodHandle glRotatex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRotatex", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glRotatexOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glRotatexOES", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glSampleCoverage(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSampleCoverage", MLS_FZ(), PS_FZ());
	}
	public static MethodHandle glSampleCoverageARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSampleCoverageARB", MLS_FZ(), PS_FZ());
	}
	public static MethodHandle glSampleCoveragex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSampleCoveragex", MLS_IZ(), PS_IZ());
	}
	public static MethodHandle glSampleCoveragexOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSampleCoveragexOES", MLS_IZ(), PS_IZ());
	}
	public static MethodHandle glSampleMapATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSampleMapATI", MLS_IILSwizzleOpATI_(), PS_IILSwizzleOpATI_());
	}
	public static MethodHandle glSampleMaskEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSampleMaskEXT", MLS_FZ(), PS_FZ());
	}
	public static MethodHandle glSampleMaskIndexedNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSampleMaskIndexedNV", MLS_II(), PS_II());
	}
	public static MethodHandle glSampleMaskSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSampleMaskSGIS", MLS_FZ(), PS_FZ());
	}
	public static MethodHandle glSampleMaski(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSampleMaski", MLS_II(), PS_II());
	}
	public static MethodHandle glSamplePatternEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSamplePatternEXT", MLS_LSamplePatternEXT_(), PS_LSamplePatternEXT_());
	}
	public static MethodHandle glSamplePatternSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSamplePatternSGIS", MLS_LSamplePatternSGIS_(), PS_LSamplePatternSGIS_());
	}
	public static MethodHandle glSamplerParameterIiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSamplerParameterIiv", MLS_ILSamplerParameterI_p(), PS_ILSamplerParameterI_p());
	}
	public static MethodHandle glSamplerParameterIivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSamplerParameterIivEXT", MLS_ILSamplerParameterI_p(), PS_ILSamplerParameterI_p());
	}
	public static MethodHandle glSamplerParameterIivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSamplerParameterIivOES", MLS_ILSamplerParameterI_p(), PS_ILSamplerParameterI_p());
	}
	public static MethodHandle glSamplerParameterIuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSamplerParameterIuiv", MLS_ILSamplerParameterI_p(), PS_ILSamplerParameterI_p());
	}
	public static MethodHandle glSamplerParameterIuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSamplerParameterIuivEXT", MLS_ILSamplerParameterI_p(), PS_ILSamplerParameterI_p());
	}
	public static MethodHandle glSamplerParameterIuivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSamplerParameterIuivOES", MLS_ILSamplerParameterI_p(), PS_ILSamplerParameterI_p());
	}
	public static MethodHandle glSamplerParameterf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSamplerParameterf", MLS_ILSamplerParameterF_F(), PS_ILSamplerParameterF_F());
	}
	public static MethodHandle glSamplerParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSamplerParameterfv", MLS_ILSamplerParameterF_p(), PS_ILSamplerParameterF_p());
	}
	public static MethodHandle glSamplerParameteri(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSamplerParameteri", MLS_ILSamplerParameterI_I(), PS_ILSamplerParameterI_I());
	}
	public static MethodHandle glSamplerParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSamplerParameteriv", MLS_ILSamplerParameterI_p(), PS_ILSamplerParameterI_p());
	}
	public static MethodHandle glScaled(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScaled", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glScalef(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScalef", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glScalex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScalex", MLS_III(), PS_III());
	}
	public static MethodHandle glScalexOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScalexOES", MLS_III(), PS_III());
	}
	public static MethodHandle glScissor(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScissor", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glScissorArrayv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScissorArrayv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glScissorArrayvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScissorArrayvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glScissorArrayvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScissorArrayvOES", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glScissorExclusiveArrayvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScissorExclusiveArrayvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glScissorExclusiveNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScissorExclusiveNV", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glScissorIndexed(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScissorIndexed", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glScissorIndexedNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScissorIndexedNV", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glScissorIndexedOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScissorIndexedOES", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glScissorIndexedv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScissorIndexedv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glScissorIndexedvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScissorIndexedvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glScissorIndexedvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glScissorIndexedvOES", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glSecondaryColor3b(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3b", MLS_BBB(), PS_BBB());
	}
	public static MethodHandle glSecondaryColor3bEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3bEXT", MLS_BBB(), PS_BBB());
	}
	public static MethodHandle glSecondaryColor3bv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3bv", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3bvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3bvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3d", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glSecondaryColor3dEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3dEXT", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glSecondaryColor3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3dv", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3dvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3f", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glSecondaryColor3fEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3fEXT", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glSecondaryColor3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3fv", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3fvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3hNV", MLS_CCC(), PS_CCC());
	}
	public static MethodHandle glSecondaryColor3hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3hvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3i", MLS_III(), PS_III());
	}
	public static MethodHandle glSecondaryColor3iEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3iEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glSecondaryColor3iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3iv", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3ivEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3s", MLS_SSS(), PS_SSS());
	}
	public static MethodHandle glSecondaryColor3sEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3sEXT", MLS_SSS(), PS_SSS());
	}
	public static MethodHandle glSecondaryColor3sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3sv", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3svEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3svEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3ub(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3ub", MLS_BBB(), PS_BBB());
	}
	public static MethodHandle glSecondaryColor3ubEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3ubEXT", MLS_BBB(), PS_BBB());
	}
	public static MethodHandle glSecondaryColor3ubv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3ubv", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3ubvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3ubvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3ui", MLS_III(), PS_III());
	}
	public static MethodHandle glSecondaryColor3uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3uiEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glSecondaryColor3uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3uiv", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3uivEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3us(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3us", MLS_CCC(), PS_CCC());
	}
	public static MethodHandle glSecondaryColor3usEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3usEXT", MLS_CCC(), PS_CCC());
	}
	public static MethodHandle glSecondaryColor3usv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3usv", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColor3usvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColor3usvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glSecondaryColorFormatNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColorFormatNV", MLS_ILColorPointerType_I(), PS_ILColorPointerType_I());
	}
	public static MethodHandle glSecondaryColorP3ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColorP3ui", MLS_LColorPointerType_I(), PS_LColorPointerType_I());
	}
	public static MethodHandle glSecondaryColorP3uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColorP3uiv", MLS_LColorPointerType_p(), PS_LColorPointerType_p());
	}
	public static MethodHandle glSecondaryColorPointer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColorPointer", MLS_ILColorPointerType_Ip(), PS_ILColorPointerType_Ip());
	}
	public static MethodHandle glSecondaryColorPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColorPointerEXT", MLS_ILColorPointerType_Ip(), PS_ILColorPointerType_Ip());
	}
	public static MethodHandle glSecondaryColorPointerListIBM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSecondaryColorPointerListIBM", MLS_ILSecondaryColorPointerTypeIBM_IPI(), PS_ILSecondaryColorPointerTypeIBM_IPI());
	}
	public static MethodHandle glSelectBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSelectBuffer", MLS_IP(), PS_IP());
	}
	public static MethodHandle glSelectPerfMonitorCountersAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSelectPerfMonitorCountersAMD", MLS_IZIIP(), PS_IZIIP());
	}
	public static MethodHandle glSemaphoreParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSemaphoreParameterivNV", MLS_ILSemaphoreParameterName_p(), PS_ILSemaphoreParameterName_p());
	}
	public static MethodHandle glSemaphoreParameterui64vEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSemaphoreParameterui64vEXT", MLS_ILSemaphoreParameterName_p(), PS_ILSemaphoreParameterName_p());
	}
	public static MethodHandle glSeparableFilter2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSeparableFilter2D", MLS_LSeparableTargetEXT_LInternalFormat_IILPixelFormat_LPixelType_pp(), PS_LSeparableTargetEXT_LInternalFormat_IILPixelFormat_LPixelType_pp());
	}
	public static MethodHandle glSeparableFilter2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSeparableFilter2DEXT", MLS_LSeparableTargetEXT_LInternalFormat_IILPixelFormat_LPixelType_pp(), PS_LSeparableTargetEXT_LInternalFormat_IILPixelFormat_LPixelType_pp());
	}
	public static MethodHandle glSetFenceAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSetFenceAPPLE", MLS_I(), PS_I());
	}
	public static MethodHandle glSetFenceNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSetFenceNV", MLS_ILFenceConditionNV_(), PS_ILFenceConditionNV_());
	}
	public static MethodHandle glSetFragmentShaderConstantATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSetFragmentShaderConstantATI", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glSetInvariantEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSetInvariantEXT", MLS_ILScalarType_p(), PS_ILScalarType_p());
	}
	public static MethodHandle glSetLocalConstantEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSetLocalConstantEXT", MLS_ILScalarType_p(), PS_ILScalarType_p());
	}
	public static MethodHandle glSetMultisamplefvAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSetMultisamplefvAMD", MLS_EIp(), PS_EIp());
	}
	public static MethodHandle glShadeModel(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShadeModel", MLS_LShadingModel_(), PS_LShadingModel_());
	}
	public static MethodHandle glShaderBinary(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShaderBinary", MLS_IpLShaderBinaryFormat_pI(), PS_IpLShaderBinaryFormat_pI());
	}
	public static MethodHandle glShaderOp1EXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShaderOp1EXT", MLS_LVertexShaderOpEXT_II(), PS_LVertexShaderOpEXT_II());
	}
	public static MethodHandle glShaderOp2EXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShaderOp2EXT", MLS_LVertexShaderOpEXT_III(), PS_LVertexShaderOpEXT_III());
	}
	public static MethodHandle glShaderOp3EXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShaderOp3EXT", MLS_LVertexShaderOpEXT_IIII(), PS_LVertexShaderOpEXT_IIII());
	}
	public static MethodHandle glShaderSource(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShaderSource", MLS_IIpp(), PS_IIpp());
	}
	public static MethodHandle glShaderSourceARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShaderSourceARB", MLS_IIPp(), PS_IIPp());
	}
	public static MethodHandle glShaderStorageBlockBinding(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShaderStorageBlockBinding", MLS_III(), PS_III());
	}
	public static MethodHandle glShadingRateEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShadingRateEXT", MLS_LShadingRate_(), PS_LShadingRate_());
	}
	public static MethodHandle glShadingRateCombinerOpsEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShadingRateCombinerOpsEXT", MLS_LShadingRateCombinerOp_LShadingRateCombinerOp_(), PS_LShadingRateCombinerOp_LShadingRateCombinerOp_());
	}
	public static MethodHandle glShadingRateImageBarrierNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShadingRateImageBarrierNV", MLS_Z(), PS_Z());
	}
	public static MethodHandle glShadingRateQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShadingRateQCOM", MLS_LShadingRateQCOM_(), PS_LShadingRateQCOM_());
	}
	public static MethodHandle glShadingRateImagePaletteNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShadingRateImagePaletteNV", MLS_IIIp(), PS_IIIp());
	}
	public static MethodHandle glShadingRateSampleOrderNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShadingRateSampleOrderNV", MLS_E(), PS_E());
	}
	public static MethodHandle glShadingRateSampleOrderCustomNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glShadingRateSampleOrderCustomNV", MLS_EIp(), PS_EIp());
	}
	public static MethodHandle glSharpenTexFuncSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSharpenTexFuncSGIS", MLS_LTextureTarget_Ip(), PS_LTextureTarget_Ip());
	}
	public static MethodHandle glSignalSemaphoreEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSignalSemaphoreEXT", MLS_IIpIpp(), PS_IIpIpp());
	}
	public static MethodHandle glSignalSemaphoreui64NVX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSignalSemaphoreui64NVX", MLS_IIpp(), PS_IIpp());
	}
	public static MethodHandle glSpecializeShader(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSpecializeShader", MLS_IpIpp(), PS_IpIpp());
	}
	public static MethodHandle glSpecializeShaderARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSpecializeShaderARB", MLS_IpIpp(), PS_IpIpp());
	}
	public static MethodHandle glSpriteParameterfSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSpriteParameterfSGIX", MLS_LSpriteParameterNameSGIX_F(), PS_LSpriteParameterNameSGIX_F());
	}
	public static MethodHandle glSpriteParameterfvSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSpriteParameterfvSGIX", MLS_LSpriteParameterNameSGIX_p(), PS_LSpriteParameterNameSGIX_p());
	}
	public static MethodHandle glSpriteParameteriSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSpriteParameteriSGIX", MLS_LSpriteParameterNameSGIX_LSpriteModeSGIX_(), PS_LSpriteParameterNameSGIX_LSpriteModeSGIX_());
	}
	public static MethodHandle glSpriteParameterivSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSpriteParameterivSGIX", MLS_LSpriteParameterNameSGIX_p(), PS_LSpriteParameterNameSGIX_p());
	}
	public static MethodHandle glStartInstrumentsSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStartInstrumentsSGIX", MLS_(), PS_());
	}
	public static MethodHandle glStartTilingQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStartTilingQCOM", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glStateCaptureNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStateCaptureNV", MLS_IE(), PS_IE());
	}
	public static MethodHandle glStencilClearTagEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilClearTagEXT", MLS_II(), PS_II());
	}
	public static MethodHandle glStencilFillPathInstancedNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilFillPathInstancedNV", MLS_ILPathElementType_pILPathFillMode_ILPathTransformType_p(), PS_ILPathElementType_pILPathFillMode_ILPathTransformType_p());
	}
	public static MethodHandle glStencilFillPathNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilFillPathNV", MLS_ILPathFillMode_I(), PS_ILPathFillMode_I());
	}
	public static MethodHandle glStencilFunc(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilFunc", MLS_LStencilFunction_II(), PS_LStencilFunction_II());
	}
	public static MethodHandle glStencilFuncSeparate(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilFuncSeparate", MLS_LTriangleFace_LStencilFunction_II(), PS_LTriangleFace_LStencilFunction_II());
	}
	public static MethodHandle glStencilFuncSeparateATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilFuncSeparateATI", MLS_LStencilFunction_LStencilFunction_II(), PS_LStencilFunction_LStencilFunction_II());
	}
	public static MethodHandle glStencilMask(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilMask", MLS_I(), PS_I());
	}
	public static MethodHandle glStencilMaskSeparate(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilMaskSeparate", MLS_LTriangleFace_I(), PS_LTriangleFace_I());
	}
	public static MethodHandle glStencilOp(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilOp", MLS_LStencilOp_LStencilOp_LStencilOp_(), PS_LStencilOp_LStencilOp_LStencilOp_());
	}
	public static MethodHandle glStencilOpSeparate(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilOpSeparate", MLS_LTriangleFace_LStencilOp_LStencilOp_LStencilOp_(), PS_LTriangleFace_LStencilOp_LStencilOp_LStencilOp_());
	}
	public static MethodHandle glStencilOpSeparateATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilOpSeparateATI", MLS_LTriangleFace_LStencilOp_LStencilOp_LStencilOp_(), PS_LTriangleFace_LStencilOp_LStencilOp_LStencilOp_());
	}
	public static MethodHandle glStencilOpValueAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilOpValueAMD", MLS_LTriangleFace_I(), PS_LTriangleFace_I());
	}
	public static MethodHandle glStencilStrokePathInstancedNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilStrokePathInstancedNV", MLS_ILPathElementType_pIIILPathTransformType_p(), PS_ILPathElementType_pIIILPathTransformType_p());
	}
	public static MethodHandle glStencilStrokePathNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilStrokePathNV", MLS_III(), PS_III());
	}
	public static MethodHandle glStencilThenCoverFillPathInstancedNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilThenCoverFillPathInstancedNV", MLS_ILPathElementType_pILPathFillMode_ILInstancedPathCoverMode_LPathTransformType_p(), PS_ILPathElementType_pILPathFillMode_ILInstancedPathCoverMode_LPathTransformType_p());
	}
	public static MethodHandle glStencilThenCoverFillPathNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilThenCoverFillPathNV", MLS_ILPathFillMode_ILPathCoverMode_(), PS_ILPathFillMode_ILPathCoverMode_());
	}
	public static MethodHandle glStencilThenCoverStrokePathInstancedNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilThenCoverStrokePathInstancedNV", MLS_ILPathElementType_pIIILInstancedPathCoverMode_LPathTransformType_p(), PS_ILPathElementType_pIIILInstancedPathCoverMode_LPathTransformType_p());
	}
	public static MethodHandle glStencilThenCoverStrokePathNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStencilThenCoverStrokePathNV", MLS_IIILPathCoverMode_(), PS_IIILPathCoverMode_());
	}
	public static MethodHandle glStopInstrumentsSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStopInstrumentsSGIX", MLS_I(), PS_I());
	}
	public static MethodHandle glStringMarkerGREMEDY(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glStringMarkerGREMEDY", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glSubpixelPrecisionBiasNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSubpixelPrecisionBiasNV", MLS_II(), PS_II());
	}
	public static MethodHandle glSwizzleEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSwizzleEXT", MLS_IILVertexShaderCoordOutEXT_LVertexShaderCoordOutEXT_LVertexShaderCoordOutEXT_LVertexShaderCoordOutEXT_(), PS_IILVertexShaderCoordOutEXT_LVertexShaderCoordOutEXT_LVertexShaderCoordOutEXT_LVertexShaderCoordOutEXT_());
	}
	public static MethodHandle glSyncTextureINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSyncTextureINTEL", MLS_I(), PS_I());
	}
	public static MethodHandle glTagSampleBufferSGIX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTagSampleBufferSGIX", MLS_(), PS_());
	}
	public static MethodHandle glTangent3bEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTangent3bEXT", MLS_BBB(), PS_BBB());
	}
	public static MethodHandle glTangent3bvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTangent3bvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glTangent3dEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTangent3dEXT", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glTangent3dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTangent3dvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glTangent3fEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTangent3fEXT", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glTangent3fvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTangent3fvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glTangent3iEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTangent3iEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glTangent3ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTangent3ivEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glTangent3sEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTangent3sEXT", MLS_SSS(), PS_SSS());
	}
	public static MethodHandle glTangent3svEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTangent3svEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glTangentPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTangentPointerEXT", MLS_LTangentPointerTypeEXT_Ip(), PS_LTangentPointerTypeEXT_Ip());
	}
	public static MethodHandle glTbufferMask3DFX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTbufferMask3DFX", MLS_I(), PS_I());
	}
	public static MethodHandle glTessellationFactorAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTessellationFactorAMD", MLS_F(), PS_F());
	}
	public static MethodHandle glTessellationModeAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTessellationModeAMD", MLS_E(), PS_E());
	}
	public static MethodHandle glTestFenceAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glTestFenceAPPLE", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glTestFenceNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glTestFenceNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glTestObjectAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glTestObjectAPPLE", GLParamTypeSets.ML_Z(), boolean.class, MLS_LObjectTypeAPPLE_I(), PS_LObjectTypeAPPLE_I());
	}
	public static MethodHandle glTexAttachMemoryNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexAttachMemoryNV", MLS_LTextureTarget_IJ(), PS_LTextureTarget_IJ());
	}
	public static MethodHandle glTexBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexBuffer", MLS_LTextureTarget_LSizedInternalFormat_I(), PS_LTextureTarget_LSizedInternalFormat_I());
	}
	public static MethodHandle glTexBufferARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexBufferARB", MLS_LTextureTarget_LSizedInternalFormat_I(), PS_LTextureTarget_LSizedInternalFormat_I());
	}
	public static MethodHandle glTexBufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexBufferEXT", MLS_LTextureTarget_LSizedInternalFormat_I(), PS_LTextureTarget_LSizedInternalFormat_I());
	}
	public static MethodHandle glTexBufferOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexBufferOES", MLS_LTextureTarget_LSizedInternalFormat_I(), PS_LTextureTarget_LSizedInternalFormat_I());
	}
	public static MethodHandle glTexBufferRange(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexBufferRange", MLS_LTextureTarget_LSizedInternalFormat_IJJ(), PS_LTextureTarget_LSizedInternalFormat_IJJ());
	}
	public static MethodHandle glTexBufferRangeEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexBufferRangeEXT", MLS_LTextureTarget_LSizedInternalFormat_IJJ(), PS_LTextureTarget_LSizedInternalFormat_IJJ());
	}
	public static MethodHandle glTexBufferRangeOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexBufferRangeOES", MLS_LTextureTarget_LSizedInternalFormat_IJJ(), PS_LTextureTarget_LSizedInternalFormat_IJJ());
	}
	public static MethodHandle glTexBumpParameterfvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexBumpParameterfvATI", MLS_LTexBumpParameterATI_p(), PS_LTexBumpParameterATI_p());
	}
	public static MethodHandle glTexBumpParameterivATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexBumpParameterivATI", MLS_LTexBumpParameterATI_p(), PS_LTexBumpParameterATI_p());
	}
	public static MethodHandle glTexCoord1bOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1bOES", MLS_B(), PS_B());
	}
	public static MethodHandle glTexCoord1bvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1bvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord1d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1d", MLS_D(), PS_D());
	}
	public static MethodHandle glTexCoord1dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1dv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord1f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1f", MLS_F(), PS_F());
	}
	public static MethodHandle glTexCoord1fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1fv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord1hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1hNV", MLS_C(), PS_C());
	}
	public static MethodHandle glTexCoord1hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1hvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord1i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1i", MLS_I(), PS_I());
	}
	public static MethodHandle glTexCoord1iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1iv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord1s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1s", MLS_S(), PS_S());
	}
	public static MethodHandle glTexCoord1sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1sv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord1xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1xOES", MLS_I(), PS_I());
	}
	public static MethodHandle glTexCoord1xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord1xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord2bOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2bOES", MLS_BB(), PS_BB());
	}
	public static MethodHandle glTexCoord2bvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2bvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord2d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2d", MLS_DD(), PS_DD());
	}
	public static MethodHandle glTexCoord2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2dv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord2f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2f", MLS_FF(), PS_FF());
	}
	public static MethodHandle glTexCoord2fColor3fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2fColor3fVertex3fSUN", MLS_FFFFFFFF(), PS_FFFFFFFF());
	}
	public static MethodHandle glTexCoord2fColor3fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2fColor3fVertex3fvSUN", MLS_ppp(), PS_ppp());
	}
	public static MethodHandle glTexCoord2fColor4fNormal3fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2fColor4fNormal3fVertex3fSUN", MLS_FFFFFFFFFFFF(), PS_FFFFFFFFFFFF());
	}
	public static MethodHandle glTexCoord2fColor4fNormal3fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2fColor4fNormal3fVertex3fvSUN", MLS_pppp(), PS_pppp());
	}
	public static MethodHandle glTexCoord2fColor4ubVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2fColor4ubVertex3fSUN", MLS_FFBBBBFFF(), PS_FFBBBBFFF());
	}
	public static MethodHandle glTexCoord2fColor4ubVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2fColor4ubVertex3fvSUN", MLS_ppp(), PS_ppp());
	}
	public static MethodHandle glTexCoord2fNormal3fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2fNormal3fVertex3fSUN", MLS_FFFFFFFF(), PS_FFFFFFFF());
	}
	public static MethodHandle glTexCoord2fNormal3fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2fNormal3fVertex3fvSUN", MLS_ppp(), PS_ppp());
	}
	public static MethodHandle glTexCoord2fVertex3fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2fVertex3fSUN", MLS_FFFFF(), PS_FFFFF());
	}
	public static MethodHandle glTexCoord2fVertex3fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2fVertex3fvSUN", MLS_pp(), PS_pp());
	}
	public static MethodHandle glTexCoord2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2fv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord2hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2hNV", MLS_CC(), PS_CC());
	}
	public static MethodHandle glTexCoord2hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2hvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord2i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2i", MLS_II(), PS_II());
	}
	public static MethodHandle glTexCoord2iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2iv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord2s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2s", MLS_SS(), PS_SS());
	}
	public static MethodHandle glTexCoord2sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2sv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord2xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2xOES", MLS_II(), PS_II());
	}
	public static MethodHandle glTexCoord2xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord2xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord3bOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3bOES", MLS_BBB(), PS_BBB());
	}
	public static MethodHandle glTexCoord3bvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3bvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord3d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3d", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glTexCoord3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3dv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord3f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3f", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glTexCoord3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3fv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord3hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3hNV", MLS_CCC(), PS_CCC());
	}
	public static MethodHandle glTexCoord3hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3hvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord3i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3i", MLS_III(), PS_III());
	}
	public static MethodHandle glTexCoord3iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3iv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord3s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3s", MLS_SSS(), PS_SSS());
	}
	public static MethodHandle glTexCoord3sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3sv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord3xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3xOES", MLS_III(), PS_III());
	}
	public static MethodHandle glTexCoord3xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord3xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord4bOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4bOES", MLS_BBBB(), PS_BBBB());
	}
	public static MethodHandle glTexCoord4bvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4bvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord4d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4d", MLS_DDDD(), PS_DDDD());
	}
	public static MethodHandle glTexCoord4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4dv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord4f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4f", MLS_FFFF(), PS_FFFF());
	}
	public static MethodHandle glTexCoord4fColor4fNormal3fVertex4fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4fColor4fNormal3fVertex4fSUN", MLS_FFFFFFFFFFFFFFF(), PS_FFFFFFFFFFFFFFF());
	}
	public static MethodHandle glTexCoord4fColor4fNormal3fVertex4fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4fColor4fNormal3fVertex4fvSUN", MLS_pppp(), PS_pppp());
	}
	public static MethodHandle glTexCoord4fVertex4fSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4fVertex4fSUN", MLS_FFFFFFFF(), PS_FFFFFFFF());
	}
	public static MethodHandle glTexCoord4fVertex4fvSUN(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4fVertex4fvSUN", MLS_pp(), PS_pp());
	}
	public static MethodHandle glTexCoord4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4fv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord4hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4hNV", MLS_CCCC(), PS_CCCC());
	}
	public static MethodHandle glTexCoord4hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4hvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord4i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4i", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glTexCoord4iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4iv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord4s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4s", MLS_SSSS(), PS_SSSS());
	}
	public static MethodHandle glTexCoord4sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4sv", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoord4xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4xOES", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glTexCoord4xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoord4xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glTexCoordFormatNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordFormatNV", MLS_IEI(), PS_IEI());
	}
	public static MethodHandle glTexCoordP1ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordP1ui", MLS_LTexCoordPointerType_I(), PS_LTexCoordPointerType_I());
	}
	public static MethodHandle glTexCoordP1uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordP1uiv", MLS_LTexCoordPointerType_p(), PS_LTexCoordPointerType_p());
	}
	public static MethodHandle glTexCoordP2ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordP2ui", MLS_LTexCoordPointerType_I(), PS_LTexCoordPointerType_I());
	}
	public static MethodHandle glTexCoordP2uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordP2uiv", MLS_LTexCoordPointerType_p(), PS_LTexCoordPointerType_p());
	}
	public static MethodHandle glTexCoordP3ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordP3ui", MLS_LTexCoordPointerType_I(), PS_LTexCoordPointerType_I());
	}
	public static MethodHandle glTexCoordP3uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordP3uiv", MLS_LTexCoordPointerType_p(), PS_LTexCoordPointerType_p());
	}
	public static MethodHandle glTexCoordP4ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordP4ui", MLS_LTexCoordPointerType_I(), PS_LTexCoordPointerType_I());
	}
	public static MethodHandle glTexCoordP4uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordP4uiv", MLS_LTexCoordPointerType_p(), PS_LTexCoordPointerType_p());
	}
	public static MethodHandle glTexCoordPointer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordPointer", MLS_ILTexCoordPointerType_Ip(), PS_ILTexCoordPointerType_Ip());
	}
	public static MethodHandle glTexCoordPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordPointerEXT", MLS_ILTexCoordPointerType_IIp(), PS_ILTexCoordPointerType_IIp());
	}
	public static MethodHandle glTexCoordPointerListIBM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordPointerListIBM", MLS_ILTexCoordPointerType_IPI(), PS_ILTexCoordPointerType_IPI());
	}
	public static MethodHandle glTexCoordPointervINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexCoordPointervINTEL", MLS_ILVertexPointerType_P(), PS_ILVertexPointerType_P());
	}
	public static MethodHandle glTexEnvf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexEnvf", MLS_LTextureEnvTarget_LTextureEnvParameter_F(), PS_LTextureEnvTarget_LTextureEnvParameter_F());
	}
	public static MethodHandle glTexEnvfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexEnvfv", MLS_LTextureEnvTarget_LTextureEnvParameter_p(), PS_LTextureEnvTarget_LTextureEnvParameter_p());
	}
	public static MethodHandle glTexEnvi(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexEnvi", MLS_LTextureEnvTarget_LTextureEnvParameter_I(), PS_LTextureEnvTarget_LTextureEnvParameter_I());
	}
	public static MethodHandle glTexEnviv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexEnviv", MLS_LTextureEnvTarget_LTextureEnvParameter_p(), PS_LTextureEnvTarget_LTextureEnvParameter_p());
	}
	public static MethodHandle glTexEnvx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexEnvx", MLS_LTextureEnvTarget_LTextureEnvParameter_I(), PS_LTextureEnvTarget_LTextureEnvParameter_I());
	}
	public static MethodHandle glTexEnvxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexEnvxOES", MLS_LTextureEnvTarget_LTextureEnvParameter_I(), PS_LTextureEnvTarget_LTextureEnvParameter_I());
	}
	public static MethodHandle glTexEnvxv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexEnvxv", MLS_LTextureEnvTarget_LTextureEnvParameter_p(), PS_LTextureEnvTarget_LTextureEnvParameter_p());
	}
	public static MethodHandle glTexEnvxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexEnvxvOES", MLS_LTextureEnvTarget_LTextureEnvParameter_p(), PS_LTextureEnvTarget_LTextureEnvParameter_p());
	}
	public static MethodHandle glTexEstimateMotionQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexEstimateMotionQCOM", MLS_III(), PS_III());
	}
	public static MethodHandle glTexEstimateMotionRegionsQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexEstimateMotionRegionsQCOM", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glExtrapolateTex2DQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glExtrapolateTex2DQCOM", MLS_IIIF(), PS_IIIF());
	}
	public static MethodHandle glTexFilterFuncSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexFilterFuncSGIS", MLS_LTextureTarget_LTextureFilterSGIS_Ip(), PS_LTextureTarget_LTextureFilterSGIS_Ip());
	}
	public static MethodHandle glTexGend(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexGend", MLS_LTextureCoordName_LTextureGenParameter_D(), PS_LTextureCoordName_LTextureGenParameter_D());
	}
	public static MethodHandle glTexGendv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexGendv", MLS_LTextureCoordName_LTextureGenParameter_p(), PS_LTextureCoordName_LTextureGenParameter_p());
	}
	public static MethodHandle glTexGenf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexGenf", MLS_LTextureCoordName_LTextureGenParameter_F(), PS_LTextureCoordName_LTextureGenParameter_F());
	}
	public static MethodHandle glTexGenfOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexGenfOES", MLS_LTextureCoordName_LTextureGenParameter_F(), PS_LTextureCoordName_LTextureGenParameter_F());
	}
	public static MethodHandle glTexGenfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexGenfv", MLS_LTextureCoordName_LTextureGenParameter_p(), PS_LTextureCoordName_LTextureGenParameter_p());
	}
	public static MethodHandle glTexGenfvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexGenfvOES", MLS_LTextureCoordName_LTextureGenParameter_p(), PS_LTextureCoordName_LTextureGenParameter_p());
	}
	public static MethodHandle glTexGeni(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexGeni", MLS_LTextureCoordName_LTextureGenParameter_I(), PS_LTextureCoordName_LTextureGenParameter_I());
	}
	public static MethodHandle glTexGeniOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexGeniOES", MLS_LTextureCoordName_LTextureGenParameter_I(), PS_LTextureCoordName_LTextureGenParameter_I());
	}
	public static MethodHandle glTexGeniv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexGeniv", MLS_LTextureCoordName_LTextureGenParameter_p(), PS_LTextureCoordName_LTextureGenParameter_p());
	}
	public static MethodHandle glTexGenivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexGenivOES", MLS_LTextureCoordName_LTextureGenParameter_p(), PS_LTextureCoordName_LTextureGenParameter_p());
	}
	public static MethodHandle glTexGenxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexGenxOES", MLS_LTextureCoordName_LTextureGenParameter_I(), PS_LTextureCoordName_LTextureGenParameter_I());
	}
	public static MethodHandle glTexGenxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexGenxvOES", MLS_LTextureCoordName_LTextureGenParameter_p(), PS_LTextureCoordName_LTextureGenParameter_p());
	}
	public static MethodHandle glTexImage1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexImage1D", MLS_LTextureTarget_ILInternalFormat_IILPixelFormat_LPixelType_p(), PS_LTextureTarget_ILInternalFormat_IILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexImage2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexImage2D", MLS_LTextureTarget_ILInternalFormat_IIILPixelFormat_LPixelType_p(), PS_LTextureTarget_ILInternalFormat_IIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexImage2DMultisample(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexImage2DMultisample", MLS_LTextureTarget_ILInternalFormat_IIZ(), PS_LTextureTarget_ILInternalFormat_IIZ());
	}
	public static MethodHandle glTexImage2DMultisampleCoverageNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexImage2DMultisampleCoverageNV", MLS_LTextureTarget_IILInternalFormat_IIZ(), PS_LTextureTarget_IILInternalFormat_IIZ());
	}
	public static MethodHandle glTexImage3D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexImage3D", MLS_LTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p(), PS_LTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexImage3DEXT", MLS_LTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p(), PS_LTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexImage3DMultisample(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexImage3DMultisample", MLS_LTextureTarget_ILInternalFormat_IIIZ(), PS_LTextureTarget_ILInternalFormat_IIIZ());
	}
	public static MethodHandle glTexImage3DMultisampleCoverageNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexImage3DMultisampleCoverageNV", MLS_LTextureTarget_IILInternalFormat_IIIZ(), PS_LTextureTarget_IILInternalFormat_IIIZ());
	}
	public static MethodHandle glTexImage3DOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexImage3DOES", MLS_LTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p(), PS_LTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexImage4DSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexImage4DSGIS", MLS_LTextureTarget_ILInternalFormat_IIIIILPixelFormat_LPixelType_p(), PS_LTextureTarget_ILInternalFormat_IIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexPageCommitmentARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexPageCommitmentARB", MLS_EIIIIIIIZ(), PS_EIIIIIIIZ());
	}
	public static MethodHandle glTexPageCommitmentEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexPageCommitmentEXT", MLS_EIIIIIIIZ(), PS_EIIIIIIIZ());
	}
	public static MethodHandle glTexPageCommitmentMemNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexPageCommitmentMemNV", MLS_LTextureTarget_IIIIIIIIIJZ(), PS_LTextureTarget_IIIIIIIIIJZ());
	}
	public static MethodHandle glTexParameterIiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameterIiv", MLS_LTextureTarget_LTextureParameterName_p(), PS_LTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glTexParameterIivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameterIivEXT", MLS_LTextureTarget_LTextureParameterName_p(), PS_LTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glTexParameterIivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameterIivOES", MLS_LTextureTarget_LTextureParameterName_p(), PS_LTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glTexParameterIuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameterIuiv", MLS_LTextureTarget_LTextureParameterName_p(), PS_LTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glTexParameterIuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameterIuivEXT", MLS_LTextureTarget_LTextureParameterName_p(), PS_LTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glTexParameterIuivOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameterIuivOES", MLS_LTextureTarget_LTextureParameterName_p(), PS_LTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glTexParameterf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameterf", MLS_LTextureTarget_LTextureParameterName_F(), PS_LTextureTarget_LTextureParameterName_F());
	}
	public static MethodHandle glTexParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameterfv", MLS_LTextureTarget_LTextureParameterName_p(), PS_LTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glTexParameteri(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameteri", MLS_LTextureTarget_LTextureParameterName_I(), PS_LTextureTarget_LTextureParameterName_I());
	}
	public static MethodHandle glTexParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameteriv", MLS_LTextureTarget_LTextureParameterName_p(), PS_LTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glTexParameterx(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameterx", MLS_LTextureTarget_LGetTextureParameter_I(), PS_LTextureTarget_LGetTextureParameter_I());
	}
	public static MethodHandle glTexParameterxOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameterxOES", MLS_LTextureTarget_LGetTextureParameter_I(), PS_LTextureTarget_LGetTextureParameter_I());
	}
	public static MethodHandle glTexParameterxv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameterxv", MLS_LTextureTarget_LGetTextureParameter_p(), PS_LTextureTarget_LGetTextureParameter_p());
	}
	public static MethodHandle glTexParameterxvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexParameterxvOES", MLS_LTextureTarget_LGetTextureParameter_p(), PS_LTextureTarget_LGetTextureParameter_p());
	}
	public static MethodHandle glTexRenderbufferNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexRenderbufferNV", MLS_LTextureTarget_I(), PS_LTextureTarget_I());
	}
	public static MethodHandle glTexStorage1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorage1D", MLS_LTextureTarget_ILSizedInternalFormat_I(), PS_LTextureTarget_ILSizedInternalFormat_I());
	}
	public static MethodHandle glTexStorage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorage1DEXT", MLS_LTextureTarget_ILSizedInternalFormat_I(), PS_LTextureTarget_ILSizedInternalFormat_I());
	}
	public static MethodHandle glTexStorage2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorage2D", MLS_LTextureTarget_ILSizedInternalFormat_II(), PS_LTextureTarget_ILSizedInternalFormat_II());
	}
	public static MethodHandle glTexStorage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorage2DEXT", MLS_LTextureTarget_ILSizedInternalFormat_II(), PS_LTextureTarget_ILSizedInternalFormat_II());
	}
	public static MethodHandle glTexStorage2DMultisample(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorage2DMultisample", MLS_LTextureTarget_ILSizedInternalFormat_IIZ(), PS_LTextureTarget_ILSizedInternalFormat_IIZ());
	}
	public static MethodHandle glTexStorage3D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorage3D", MLS_LTextureTarget_ILSizedInternalFormat_III(), PS_LTextureTarget_ILSizedInternalFormat_III());
	}
	public static MethodHandle glTexStorage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorage3DEXT", MLS_LTextureTarget_ILSizedInternalFormat_III(), PS_LTextureTarget_ILSizedInternalFormat_III());
	}
	public static MethodHandle glTexStorage3DMultisample(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorage3DMultisample", MLS_LTextureTarget_ILSizedInternalFormat_IIIZ(), PS_LTextureTarget_ILSizedInternalFormat_IIIZ());
	}
	public static MethodHandle glTexStorage3DMultisampleOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorage3DMultisampleOES", MLS_LTextureTarget_ILSizedInternalFormat_IIIZ(), PS_LTextureTarget_ILSizedInternalFormat_IIIZ());
	}
	public static MethodHandle glTexStorageAttribs2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorageAttribs2DEXT", MLS_LTextureTarget_ILSizedInternalFormat_IIp(), PS_LTextureTarget_ILSizedInternalFormat_IIp());
	}
	public static MethodHandle glTexStorageAttribs3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorageAttribs3DEXT", MLS_LTextureTarget_ILSizedInternalFormat_IIIp(), PS_LTextureTarget_ILSizedInternalFormat_IIIp());
	}
	public static MethodHandle glTexStorageMem1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorageMem1DEXT", MLS_LTextureTarget_ILSizedInternalFormat_IIJ(), PS_LTextureTarget_ILSizedInternalFormat_IIJ());
	}
	public static MethodHandle glTexStorageMem2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorageMem2DEXT", MLS_LTextureTarget_ILSizedInternalFormat_IIIJ(), PS_LTextureTarget_ILSizedInternalFormat_IIIJ());
	}
	public static MethodHandle glTexStorageMem2DMultisampleEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorageMem2DMultisampleEXT", MLS_LTextureTarget_ILSizedInternalFormat_IIZIJ(), PS_LTextureTarget_ILSizedInternalFormat_IIZIJ());
	}
	public static MethodHandle glTexStorageMem3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorageMem3DEXT", MLS_LTextureTarget_ILSizedInternalFormat_IIIIJ(), PS_LTextureTarget_ILSizedInternalFormat_IIIIJ());
	}
	public static MethodHandle glTexStorageMem3DMultisampleEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorageMem3DMultisampleEXT", MLS_LTextureTarget_ILSizedInternalFormat_IIIZIJ(), PS_LTextureTarget_ILSizedInternalFormat_IIIZIJ());
	}
	public static MethodHandle glTexStorageSparseAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexStorageSparseAMD", MLS_LTextureTarget_LSizedInternalFormat_IIIII(), PS_LTextureTarget_LSizedInternalFormat_IIIII());
	}
	public static MethodHandle glTexSubImage1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexSubImage1D", MLS_LTextureTarget_IIILPixelFormat_LPixelType_p(), PS_LTextureTarget_IIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexSubImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexSubImage1DEXT", MLS_LTextureTarget_IIILPixelFormat_LPixelType_p(), PS_LTextureTarget_IIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexSubImage2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexSubImage2D", MLS_LTextureTarget_IIIIILPixelFormat_LPixelType_p(), PS_LTextureTarget_IIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexSubImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexSubImage2DEXT", MLS_LTextureTarget_IIIIILPixelFormat_LPixelType_p(), PS_LTextureTarget_IIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexSubImage3D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexSubImage3D", MLS_LTextureTarget_IIIIIIILPixelFormat_LPixelType_p(), PS_LTextureTarget_IIIIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexSubImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexSubImage3DEXT", MLS_LTextureTarget_IIIIIIILPixelFormat_LPixelType_p(), PS_LTextureTarget_IIIIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexSubImage3DOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexSubImage3DOES", MLS_LTextureTarget_IIIIIIILPixelFormat_LPixelType_p(), PS_LTextureTarget_IIIIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTexSubImage4DSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexSubImage4DSGIS", MLS_LTextureTarget_IIIIIIIIILPixelFormat_LPixelType_p(), PS_LTextureTarget_IIIIIIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTextureAttachMemoryNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureAttachMemoryNV", MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glTextureBarrier(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureBarrier", MLS_(), PS_());
	}
	public static MethodHandle glTextureBarrierNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureBarrierNV", MLS_(), PS_());
	}
	public static MethodHandle glTextureBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureBuffer", MLS_ILSizedInternalFormat_I(), PS_ILSizedInternalFormat_I());
	}
	public static MethodHandle glTextureBufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureBufferEXT", MLS_ILTextureTarget_LSizedInternalFormat_I(), PS_ILTextureTarget_LSizedInternalFormat_I());
	}
	public static MethodHandle glTextureBufferRange(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureBufferRange", MLS_ILSizedInternalFormat_IJJ(), PS_ILSizedInternalFormat_IJJ());
	}
	public static MethodHandle glTextureBufferRangeEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureBufferRangeEXT", MLS_ILTextureTarget_LSizedInternalFormat_IJJ(), PS_ILTextureTarget_LSizedInternalFormat_IJJ());
	}
	public static MethodHandle glTextureColorMaskSGIS(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureColorMaskSGIS", MLS_ZZZZ(), PS_ZZZZ());
	}
	public static MethodHandle glTextureFoveationParametersQCOM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureFoveationParametersQCOM", MLS_IIIFFFFF(), PS_IIIFFFFF());
	}
	public static MethodHandle glTextureImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureImage1DEXT", MLS_ILTextureTarget_ILInternalFormat_IILPixelFormat_LPixelType_p(), PS_ILTextureTarget_ILInternalFormat_IILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTextureImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureImage2DEXT", MLS_ILTextureTarget_ILInternalFormat_IIILPixelFormat_LPixelType_p(), PS_ILTextureTarget_ILInternalFormat_IIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTextureImage2DMultisampleCoverageNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureImage2DMultisampleCoverageNV", MLS_ILTextureTarget_IILInternalFormat_IIZ(), PS_ILTextureTarget_IILInternalFormat_IIZ());
	}
	public static MethodHandle glTextureImage2DMultisampleNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureImage2DMultisampleNV", MLS_ILTextureTarget_ILInternalFormat_IIZ(), PS_ILTextureTarget_ILInternalFormat_IIZ());
	}
	public static MethodHandle glTextureImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureImage3DEXT", MLS_ILTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p(), PS_ILTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTextureImage3DMultisampleCoverageNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureImage3DMultisampleCoverageNV", MLS_ILTextureTarget_IILInternalFormat_IIIZ(), PS_ILTextureTarget_IILInternalFormat_IIIZ());
	}
	public static MethodHandle glTextureImage3DMultisampleNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureImage3DMultisampleNV", MLS_ILTextureTarget_ILInternalFormat_IIIZ(), PS_ILTextureTarget_ILInternalFormat_IIIZ());
	}
	public static MethodHandle glTextureLightEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureLightEXT", MLS_LLightTexturePNameEXT_(), PS_LLightTexturePNameEXT_());
	}
	public static MethodHandle glTextureMaterialEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureMaterialEXT", MLS_LTriangleFace_LMaterialParameter_(), PS_LTriangleFace_LMaterialParameter_());
	}
	public static MethodHandle glTextureNormalEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureNormalEXT", MLS_LTextureNormalModeEXT_(), PS_LTextureNormalModeEXT_());
	}
	public static MethodHandle glTexturePageCommitmentEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexturePageCommitmentEXT", MLS_IIIIIIIIZ(), PS_IIIIIIIIZ());
	}
	public static MethodHandle glTexturePageCommitmentMemNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTexturePageCommitmentMemNV", MLS_IIIIIIIIIIJZ(), PS_IIIIIIIIIIJZ());
	}
	public static MethodHandle glTextureParameterIiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureParameterIiv", MLS_ILTextureParameterName_p(), PS_ILTextureParameterName_p());
	}
	public static MethodHandle glTextureParameterIivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureParameterIivEXT", MLS_ILTextureTarget_LTextureParameterName_p(), PS_ILTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glTextureParameterIuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureParameterIuiv", MLS_ILTextureParameterName_p(), PS_ILTextureParameterName_p());
	}
	public static MethodHandle glTextureParameterIuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureParameterIuivEXT", MLS_ILTextureTarget_LTextureParameterName_p(), PS_ILTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glTextureParameterf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureParameterf", MLS_ILTextureParameterName_F(), PS_ILTextureParameterName_F());
	}
	public static MethodHandle glTextureParameterfEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureParameterfEXT", MLS_ILTextureTarget_LTextureParameterName_F(), PS_ILTextureTarget_LTextureParameterName_F());
	}
	public static MethodHandle glTextureParameterfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureParameterfv", MLS_ILTextureParameterName_p(), PS_ILTextureParameterName_p());
	}
	public static MethodHandle glTextureParameterfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureParameterfvEXT", MLS_ILTextureTarget_LTextureParameterName_p(), PS_ILTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glTextureParameteri(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureParameteri", MLS_ILTextureParameterName_I(), PS_ILTextureParameterName_I());
	}
	public static MethodHandle glTextureParameteriEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureParameteriEXT", MLS_ILTextureTarget_LTextureParameterName_I(), PS_ILTextureTarget_LTextureParameterName_I());
	}
	public static MethodHandle glTextureParameteriv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureParameteriv", MLS_ILTextureParameterName_p(), PS_ILTextureParameterName_p());
	}
	public static MethodHandle glTextureParameterivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureParameterivEXT", MLS_ILTextureTarget_LTextureParameterName_p(), PS_ILTextureTarget_LTextureParameterName_p());
	}
	public static MethodHandle glTextureRangeAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureRangeAPPLE", MLS_EIp(), PS_EIp());
	}
	public static MethodHandle glTextureRenderbufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureRenderbufferEXT", MLS_ILTextureTarget_I(), PS_ILTextureTarget_I());
	}
	public static MethodHandle glTextureStorage1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorage1D", MLS_IILSizedInternalFormat_I(), PS_IILSizedInternalFormat_I());
	}
	public static MethodHandle glTextureStorage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorage1DEXT", MLS_IEILSizedInternalFormat_I(), PS_IEILSizedInternalFormat_I());
	}
	public static MethodHandle glTextureStorage2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorage2D", MLS_IILSizedInternalFormat_II(), PS_IILSizedInternalFormat_II());
	}
	public static MethodHandle glTextureStorage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorage2DEXT", MLS_IEILSizedInternalFormat_II(), PS_IEILSizedInternalFormat_II());
	}
	public static MethodHandle glTextureStorage2DMultisample(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorage2DMultisample", MLS_IILSizedInternalFormat_IIZ(), PS_IILSizedInternalFormat_IIZ());
	}
	public static MethodHandle glTextureStorage2DMultisampleEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorage2DMultisampleEXT", MLS_ILTextureTarget_ILSizedInternalFormat_IIZ(), PS_ILTextureTarget_ILSizedInternalFormat_IIZ());
	}
	public static MethodHandle glTextureStorage3D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorage3D", MLS_IILSizedInternalFormat_III(), PS_IILSizedInternalFormat_III());
	}
	public static MethodHandle glTextureStorage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorage3DEXT", MLS_IEILSizedInternalFormat_III(), PS_IEILSizedInternalFormat_III());
	}
	public static MethodHandle glTextureStorage3DMultisample(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorage3DMultisample", MLS_IILSizedInternalFormat_IIIZ(), PS_IILSizedInternalFormat_IIIZ());
	}
	public static MethodHandle glTextureStorage3DMultisampleEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorage3DMultisampleEXT", MLS_IEILSizedInternalFormat_IIIZ(), PS_IEILSizedInternalFormat_IIIZ());
	}
	public static MethodHandle glTextureStorageMem1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorageMem1DEXT", MLS_IILSizedInternalFormat_IIJ(), PS_IILSizedInternalFormat_IIJ());
	}
	public static MethodHandle glTextureStorageMem2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorageMem2DEXT", MLS_IILSizedInternalFormat_IIIJ(), PS_IILSizedInternalFormat_IIIJ());
	}
	public static MethodHandle glTextureStorageMem2DMultisampleEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorageMem2DMultisampleEXT", MLS_IILSizedInternalFormat_IIZIJ(), PS_IILSizedInternalFormat_IIZIJ());
	}
	public static MethodHandle glTextureStorageMem3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorageMem3DEXT", MLS_IILSizedInternalFormat_IIIIJ(), PS_IILSizedInternalFormat_IIIIJ());
	}
	public static MethodHandle glTextureStorageMem3DMultisampleEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorageMem3DMultisampleEXT", MLS_IILSizedInternalFormat_IIIZIJ(), PS_IILSizedInternalFormat_IIIZIJ());
	}
	public static MethodHandle glTextureStorageSparseAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureStorageSparseAMD", MLS_IELSizedInternalFormat_IIIII(), PS_IELSizedInternalFormat_IIIII());
	}
	public static MethodHandle glTextureSubImage1D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureSubImage1D", MLS_IIIILPixelFormat_LPixelType_p(), PS_IIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTextureSubImage1DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureSubImage1DEXT", MLS_ILTextureTarget_IIILPixelFormat_LPixelType_p(), PS_ILTextureTarget_IIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTextureSubImage2D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureSubImage2D", MLS_IIIIIILPixelFormat_LPixelType_p(), PS_IIIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTextureSubImage2DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureSubImage2DEXT", MLS_ILTextureTarget_IIIIILPixelFormat_LPixelType_p(), PS_ILTextureTarget_IIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTextureSubImage3D(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureSubImage3D", MLS_IIIIIIIILPixelFormat_LPixelType_p(), PS_IIIIIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTextureSubImage3DEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureSubImage3DEXT", MLS_ILTextureTarget_IIIIIIILPixelFormat_LPixelType_p(), PS_ILTextureTarget_IIIIIIILPixelFormat_LPixelType_p());
	}
	public static MethodHandle glTextureView(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureView", MLS_ILTextureTarget_ILSizedInternalFormat_IIII(), PS_ILTextureTarget_ILSizedInternalFormat_IIII());
	}
	public static MethodHandle glTextureViewEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureViewEXT", MLS_ILTextureTarget_ILSizedInternalFormat_IIII(), PS_ILTextureTarget_ILSizedInternalFormat_IIII());
	}
	public static MethodHandle glTextureViewOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTextureViewOES", MLS_ILTextureTarget_ILSizedInternalFormat_IIII(), PS_ILTextureTarget_ILSizedInternalFormat_IIII());
	}
	public static MethodHandle glTrackMatrixNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTrackMatrixNV", MLS_LVertexAttribEnumNV_ILVertexAttribEnumNV_LVertexAttribEnumNV_(), PS_LVertexAttribEnumNV_ILVertexAttribEnumNV_LVertexAttribEnumNV_());
	}
	public static MethodHandle glTransformFeedbackAttribsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTransformFeedbackAttribsNV", MLS_IpE(), PS_IpE());
	}
	public static MethodHandle glTransformFeedbackBufferBase(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTransformFeedbackBufferBase", MLS_III(), PS_III());
	}
	public static MethodHandle glTransformFeedbackBufferRange(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTransformFeedbackBufferRange", MLS_IIIJJ(), PS_IIIJJ());
	}
	public static MethodHandle glTransformFeedbackStreamAttribsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTransformFeedbackStreamAttribsNV", MLS_IpIpE(), PS_IpIpE());
	}
	public static MethodHandle glTransformFeedbackVaryings(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTransformFeedbackVaryings", MLS_IIpLTransformFeedbackBufferMode_(), PS_IIpLTransformFeedbackBufferMode_());
	}
	public static MethodHandle glTransformFeedbackVaryingsEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTransformFeedbackVaryingsEXT", MLS_IIpLTransformFeedbackBufferMode_(), PS_IIpLTransformFeedbackBufferMode_());
	}
	public static MethodHandle glTransformFeedbackVaryingsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTransformFeedbackVaryingsNV", MLS_IIpLTransformFeedbackBufferMode_(), PS_IIpLTransformFeedbackBufferMode_());
	}
	public static MethodHandle glTransformPathNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTransformPathNV", MLS_IILPathTransformType_p(), PS_IILPathTransformType_p());
	}
	public static MethodHandle glTranslated(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTranslated", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glTranslatef(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTranslatef", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glTranslatex(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTranslatex", MLS_III(), PS_III());
	}
	public static MethodHandle glTranslatexOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glTranslatexOES", MLS_III(), PS_III());
	}
	public static MethodHandle glUniform1d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1d", MLS_ID(), PS_ID());
	}
	public static MethodHandle glUniform1dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1dv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform1f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1f", MLS_IF(), PS_IF());
	}
	public static MethodHandle glUniform1fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1fARB", MLS_IF(), PS_IF());
	}
	public static MethodHandle glUniform1fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1fv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform1fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1fvARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform1i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1i", MLS_II(), PS_II());
	}
	public static MethodHandle glUniform1i64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1i64ARB", MLS_IJ(), PS_IJ());
	}
	public static MethodHandle glUniform1i64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1i64NV", MLS_IJ(), PS_IJ());
	}
	public static MethodHandle glUniform1i64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1i64vARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform1i64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1i64vNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform1iARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1iARB", MLS_II(), PS_II());
	}
	public static MethodHandle glUniform1iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1iv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform1ivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1ivARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform1ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1ui", MLS_II(), PS_II());
	}
	public static MethodHandle glUniform1ui64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1ui64ARB", MLS_IJ(), PS_IJ());
	}
	public static MethodHandle glUniform1ui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1ui64NV", MLS_IJ(), PS_IJ());
	}
	public static MethodHandle glUniform1ui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1ui64vARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform1ui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1ui64vNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform1uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1uiEXT", MLS_II(), PS_II());
	}
	public static MethodHandle glUniform1uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1uiv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform1uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform1uivEXT", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform2d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2d", MLS_IDD(), PS_IDD());
	}
	public static MethodHandle glUniform2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2dv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform2f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2f", MLS_IFF(), PS_IFF());
	}
	public static MethodHandle glUniform2fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2fARB", MLS_IFF(), PS_IFF());
	}
	public static MethodHandle glUniform2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2fv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform2fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2fvARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform2i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2i", MLS_III(), PS_III());
	}
	public static MethodHandle glUniform2i64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2i64ARB", MLS_IJJ(), PS_IJJ());
	}
	public static MethodHandle glUniform2i64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2i64NV", MLS_IJJ(), PS_IJJ());
	}
	public static MethodHandle glUniform2i64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2i64vARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform2i64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2i64vNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform2iARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2iARB", MLS_III(), PS_III());
	}
	public static MethodHandle glUniform2iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2iv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform2ivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2ivARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform2ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2ui", MLS_III(), PS_III());
	}
	public static MethodHandle glUniform2ui64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2ui64ARB", MLS_IJJ(), PS_IJJ());
	}
	public static MethodHandle glUniform2ui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2ui64NV", MLS_IJJ(), PS_IJJ());
	}
	public static MethodHandle glUniform2ui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2ui64vARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform2ui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2ui64vNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform2uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2uiEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glUniform2uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2uiv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform2uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform2uivEXT", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform3d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3d", MLS_IDDD(), PS_IDDD());
	}
	public static MethodHandle glUniform3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3dv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform3f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3f", MLS_IFFF(), PS_IFFF());
	}
	public static MethodHandle glUniform3fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3fARB", MLS_IFFF(), PS_IFFF());
	}
	public static MethodHandle glUniform3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3fv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform3fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3fvARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform3i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3i", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glUniform3i64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3i64ARB", MLS_IJJJ(), PS_IJJJ());
	}
	public static MethodHandle glUniform3i64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3i64NV", MLS_IJJJ(), PS_IJJJ());
	}
	public static MethodHandle glUniform3i64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3i64vARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform3i64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3i64vNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform3iARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3iARB", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glUniform3iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3iv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform3ivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3ivARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform3ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3ui", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glUniform3ui64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3ui64ARB", MLS_IJJJ(), PS_IJJJ());
	}
	public static MethodHandle glUniform3ui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3ui64NV", MLS_IJJJ(), PS_IJJJ());
	}
	public static MethodHandle glUniform3ui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3ui64vARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform3ui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3ui64vNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform3uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3uiEXT", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glUniform3uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3uiv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform3uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform3uivEXT", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform4d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4d", MLS_IDDDD(), PS_IDDDD());
	}
	public static MethodHandle glUniform4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4dv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform4f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4f", MLS_IFFFF(), PS_IFFFF());
	}
	public static MethodHandle glUniform4fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4fARB", MLS_IFFFF(), PS_IFFFF());
	}
	public static MethodHandle glUniform4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4fv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform4fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4fvARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform4i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4i", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glUniform4i64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4i64ARB", MLS_IJJJJ(), PS_IJJJJ());
	}
	public static MethodHandle glUniform4i64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4i64NV", MLS_IJJJJ(), PS_IJJJJ());
	}
	public static MethodHandle glUniform4i64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4i64vARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform4i64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4i64vNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform4iARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4iARB", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glUniform4iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4iv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform4ivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4ivARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform4ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4ui", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glUniform4ui64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4ui64ARB", MLS_IJJJJ(), PS_IJJJJ());
	}
	public static MethodHandle glUniform4ui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4ui64NV", MLS_IJJJJ(), PS_IJJJJ());
	}
	public static MethodHandle glUniform4ui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4ui64vARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform4ui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4ui64vNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform4uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4uiEXT", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glUniform4uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4uiv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniform4uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniform4uivEXT", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniformBlockBinding(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformBlockBinding", MLS_III(), PS_III());
	}
	public static MethodHandle glUniformBufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformBufferEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glUniformHandleui64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformHandleui64ARB", MLS_IJ(), PS_IJ());
	}
	public static MethodHandle glUniformHandleui64IMG(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformHandleui64IMG", MLS_IJ(), PS_IJ());
	}
	public static MethodHandle glUniformHandleui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformHandleui64NV", MLS_IJ(), PS_IJ());
	}
	public static MethodHandle glUniformHandleui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformHandleui64vARB", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniformHandleui64vIMG(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformHandleui64vIMG", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniformHandleui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformHandleui64vNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUniformMatrix2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix2dv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix2fv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix2fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix2fvARB", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix2x3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix2x3dv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix2x3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix2x3fv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix2x3fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix2x3fvNV", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix2x4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix2x4dv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix2x4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix2x4fv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix2x4fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix2x4fvNV", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix3dv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix3fv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix3fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix3fvARB", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix3x2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix3x2dv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix3x2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix3x2fv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix3x2fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix3x2fvNV", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix3x4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix3x4dv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix3x4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix3x4fv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix3x4fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix3x4fvNV", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix4dv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix4fv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix4fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix4fvARB", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix4x2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix4x2dv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix4x2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix4x2fv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix4x2fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix4x2fvNV", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix4x3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix4x3dv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix4x3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix4x3fv", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformMatrix4x3fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformMatrix4x3fvNV", MLS_IIZp(), PS_IIZp());
	}
	public static MethodHandle glUniformSubroutinesuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformSubroutinesuiv", MLS_LShaderType_Ip(), PS_LShaderType_Ip());
	}
	public static MethodHandle glUniformui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformui64NV", MLS_IJ(), PS_IJ());
	}
	public static MethodHandle glUniformui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUniformui64vNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glUnlockArraysEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUnlockArraysEXT", MLS_(), PS_());
	}
	public static MethodHandle glUnmapBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glUnmapBuffer", GLParamTypeSets.ML_Z(), boolean.class, MLS_LBufferTarget_(), PS_LBufferTarget_());
	}
	public static MethodHandle glUnmapBufferARB(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glUnmapBufferARB", GLParamTypeSets.ML_Z(), boolean.class, MLS_LBufferTarget_(), PS_LBufferTarget_());
	}
	public static MethodHandle glUnmapBufferOES(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glUnmapBufferOES", GLParamTypeSets.ML_Z(), boolean.class, MLS_E(), PS_E());
	}
	public static MethodHandle glUnmapNamedBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glUnmapNamedBuffer", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glUnmapNamedBufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glUnmapNamedBufferEXT", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glUnmapObjectBufferATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUnmapObjectBufferATI", MLS_I(), PS_I());
	}
	public static MethodHandle glUnmapTexture2DINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUnmapTexture2DINTEL", MLS_II(), PS_II());
	}
	public static MethodHandle glUpdateObjectBufferATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUpdateObjectBufferATI", MLS_IIIpLPreserveModeATI_(), PS_IIIpLPreserveModeATI_());
	}
	public static MethodHandle glUploadGpuMaskNVX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUploadGpuMaskNVX", MLS_I(), PS_I());
	}
	public static MethodHandle glUseProgram(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUseProgram", MLS_I(), PS_I());
	}
	public static MethodHandle glUseProgramObjectARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUseProgramObjectARB", MLS_I(), PS_I());
	}
	public static MethodHandle glUseProgramStages(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUseProgramStages", MLS_III(), PS_III());
	}
	public static MethodHandle glUseProgramStagesEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUseProgramStagesEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glUseShaderProgramEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glUseShaderProgramEXT", MLS_EI(), PS_EI());
	}
	public static MethodHandle glVDPAUFiniNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVDPAUFiniNV", MLS_(), PS_());
	}
	public static MethodHandle glVDPAUGetSurfaceivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVDPAUGetSurfaceivNV", MLS_IEIPP(), PS_IEIPP());
	}
	public static MethodHandle glVDPAUInitNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVDPAUInitNV", MLS_pp(), PS_pp());
	}
	public static MethodHandle glVDPAUIsSurfaceNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glVDPAUIsSurfaceNV", GLParamTypeSets.ML_Z(), boolean.class, MLS_I(), PS_I());
	}
	public static MethodHandle glVDPAUMapSurfacesNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVDPAUMapSurfacesNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVDPAURegisterOutputSurfaceNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glVDPAURegisterOutputSurfaceNV", GLParamTypeSets.ML_I(), int.class, MLS_pEIp(), PS_pEIp());
	}
	public static MethodHandle glVDPAURegisterVideoSurfaceNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glVDPAURegisterVideoSurfaceNV", GLParamTypeSets.ML_I(), int.class, MLS_pEIp(), PS_pEIp());
	}
	public static MethodHandle glVDPAURegisterVideoSurfaceWithPictureStructureNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glVDPAURegisterVideoSurfaceWithPictureStructureNV", GLParamTypeSets.ML_I(), int.class, MLS_pEIpZ(), PS_pEIpZ());
	}
	public static MethodHandle glVDPAUSurfaceAccessNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVDPAUSurfaceAccessNV", MLS_IE(), PS_IE());
	}
	public static MethodHandle glVDPAUUnmapSurfacesNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVDPAUUnmapSurfacesNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVDPAUUnregisterSurfaceNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVDPAUUnregisterSurfaceNV", MLS_I(), PS_I());
	}
	public static MethodHandle glValidateProgram(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glValidateProgram", MLS_I(), PS_I());
	}
	public static MethodHandle glValidateProgramARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glValidateProgramARB", MLS_I(), PS_I());
	}
	public static MethodHandle glValidateProgramPipeline(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glValidateProgramPipeline", MLS_I(), PS_I());
	}
	public static MethodHandle glValidateProgramPipelineEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glValidateProgramPipelineEXT", MLS_I(), PS_I());
	}
	public static MethodHandle glVariantArrayObjectATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVariantArrayObjectATI", MLS_ILScalarType_III(), PS_ILScalarType_III());
	}
	public static MethodHandle glVariantPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVariantPointerEXT", MLS_ILScalarType_Ip(), PS_ILScalarType_Ip());
	}
	public static MethodHandle glVariantbvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVariantbvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVariantdvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVariantdvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVariantfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVariantfvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVariantivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVariantivEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVariantsvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVariantsvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVariantubvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVariantubvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVariantuivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVariantuivEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVariantusvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVariantusvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertex2bOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2bOES", MLS_BB(), PS_BB());
	}
	public static MethodHandle glVertex2bvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2bvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex2d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2d", MLS_DD(), PS_DD());
	}
	public static MethodHandle glVertex2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2dv", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex2f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2f", MLS_FF(), PS_FF());
	}
	public static MethodHandle glVertex2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2fv", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex2hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2hNV", MLS_CC(), PS_CC());
	}
	public static MethodHandle glVertex2hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2hvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex2i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2i", MLS_II(), PS_II());
	}
	public static MethodHandle glVertex2iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2iv", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex2s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2s", MLS_SS(), PS_SS());
	}
	public static MethodHandle glVertex2sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2sv", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex2xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2xOES", MLS_I(), PS_I());
	}
	public static MethodHandle glVertex2xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex2xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex3bOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3bOES", MLS_BBB(), PS_BBB());
	}
	public static MethodHandle glVertex3bvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3bvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex3d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3d", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glVertex3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3dv", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex3f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3f", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glVertex3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3fv", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex3hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3hNV", MLS_CCC(), PS_CCC());
	}
	public static MethodHandle glVertex3hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3hvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex3i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3i", MLS_III(), PS_III());
	}
	public static MethodHandle glVertex3iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3iv", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex3s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3s", MLS_SSS(), PS_SSS());
	}
	public static MethodHandle glVertex3sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3sv", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex3xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3xOES", MLS_II(), PS_II());
	}
	public static MethodHandle glVertex3xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex3xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex4bOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4bOES", MLS_BBBB(), PS_BBBB());
	}
	public static MethodHandle glVertex4bvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4bvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex4d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4d", MLS_DDDD(), PS_DDDD());
	}
	public static MethodHandle glVertex4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4dv", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex4f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4f", MLS_FFFF(), PS_FFFF());
	}
	public static MethodHandle glVertex4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4fv", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex4hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4hNV", MLS_CCCC(), PS_CCCC());
	}
	public static MethodHandle glVertex4hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4hvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex4i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4i", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glVertex4iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4iv", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex4s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4s", MLS_SSSS(), PS_SSSS());
	}
	public static MethodHandle glVertex4sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4sv", MLS_p(), PS_p());
	}
	public static MethodHandle glVertex4xOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4xOES", MLS_III(), PS_III());
	}
	public static MethodHandle glVertex4xvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertex4xvOES", MLS_p(), PS_p());
	}
	public static MethodHandle glVertexArrayAttribBinding(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayAttribBinding", MLS_III(), PS_III());
	}
	public static MethodHandle glVertexArrayAttribFormat(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayAttribFormat", MLS_IIILVertexAttribType_ZI(), PS_IIILVertexAttribType_ZI());
	}
	public static MethodHandle glVertexArrayAttribIFormat(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayAttribIFormat", MLS_IIILVertexAttribIType_I(), PS_IIILVertexAttribIType_I());
	}
	public static MethodHandle glVertexArrayAttribLFormat(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayAttribLFormat", MLS_IIILVertexAttribLType_I(), PS_IIILVertexAttribLType_I());
	}
	public static MethodHandle glVertexArrayBindVertexBufferEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayBindVertexBufferEXT", MLS_IIIJI(), PS_IIIJI());
	}
	public static MethodHandle glVertexArrayBindingDivisor(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayBindingDivisor", MLS_III(), PS_III());
	}
	public static MethodHandle glVertexArrayColorOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayColorOffsetEXT", MLS_IIILColorPointerType_IJ(), PS_IIILColorPointerType_IJ());
	}
	public static MethodHandle glVertexArrayEdgeFlagOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayEdgeFlagOffsetEXT", MLS_IIIJ(), PS_IIIJ());
	}
	public static MethodHandle glVertexArrayElementBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayElementBuffer", MLS_II(), PS_II());
	}
	public static MethodHandle glVertexArrayFogCoordOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayFogCoordOffsetEXT", MLS_IILFogCoordinatePointerType_IJ(), PS_IILFogCoordinatePointerType_IJ());
	}
	public static MethodHandle glVertexArrayIndexOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayIndexOffsetEXT", MLS_IILIndexPointerType_IJ(), PS_IILIndexPointerType_IJ());
	}
	public static MethodHandle glVertexArrayMultiTexCoordOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayMultiTexCoordOffsetEXT", MLS_IIEILTexCoordPointerType_IJ(), PS_IIEILTexCoordPointerType_IJ());
	}
	public static MethodHandle glVertexArrayNormalOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayNormalOffsetEXT", MLS_IILNormalPointerType_IJ(), PS_IILNormalPointerType_IJ());
	}
	public static MethodHandle glVertexArrayParameteriAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayParameteriAPPLE", MLS_LVertexArrayPNameAPPLE_I(), PS_LVertexArrayPNameAPPLE_I());
	}
	public static MethodHandle glVertexArrayRangeAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayRangeAPPLE", MLS_IP(), PS_IP());
	}
	public static MethodHandle glVertexArrayRangeNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayRangeNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexArraySecondaryColorOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArraySecondaryColorOffsetEXT", MLS_IIILColorPointerType_IJ(), PS_IIILColorPointerType_IJ());
	}
	public static MethodHandle glVertexArrayTexCoordOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayTexCoordOffsetEXT", MLS_IIILTexCoordPointerType_IJ(), PS_IIILTexCoordPointerType_IJ());
	}
	public static MethodHandle glVertexArrayVertexAttribBindingEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayVertexAttribBindingEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glVertexArrayVertexAttribDivisorEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayVertexAttribDivisorEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glVertexArrayVertexAttribFormatEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayVertexAttribFormatEXT", MLS_IIILVertexAttribType_ZI(), PS_IIILVertexAttribType_ZI());
	}
	public static MethodHandle glVertexArrayVertexAttribIFormatEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayVertexAttribIFormatEXT", MLS_IIILVertexAttribIType_I(), PS_IIILVertexAttribIType_I());
	}
	public static MethodHandle glVertexArrayVertexAttribIOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayVertexAttribIOffsetEXT", MLS_IIIILVertexAttribType_IJ(), PS_IIIILVertexAttribType_IJ());
	}
	public static MethodHandle glVertexArrayVertexAttribLFormatEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayVertexAttribLFormatEXT", MLS_IIILVertexAttribLType_I(), PS_IIILVertexAttribLType_I());
	}
	public static MethodHandle glVertexArrayVertexAttribLOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayVertexAttribLOffsetEXT", MLS_IIIILVertexAttribLType_IJ(), PS_IIIILVertexAttribLType_IJ());
	}
	public static MethodHandle glVertexArrayVertexAttribOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayVertexAttribOffsetEXT", MLS_IIIILVertexAttribPointerType_ZIJ(), PS_IIIILVertexAttribPointerType_ZIJ());
	}
	public static MethodHandle glVertexArrayVertexBindingDivisorEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayVertexBindingDivisorEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glVertexArrayVertexBuffer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayVertexBuffer", MLS_IIIJI(), PS_IIIJI());
	}
	public static MethodHandle glVertexArrayVertexBuffers(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayVertexBuffers", MLS_IIIppp(), PS_IIIppp());
	}
	public static MethodHandle glVertexArrayVertexOffsetEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexArrayVertexOffsetEXT", MLS_IIILVertexPointerType_IJ(), PS_IIILVertexPointerType_IJ());
	}
	public static MethodHandle glVertexAttrib1d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1d", MLS_ID(), PS_ID());
	}
	public static MethodHandle glVertexAttrib1dARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1dARB", MLS_ID(), PS_ID());
	}
	public static MethodHandle glVertexAttrib1dNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1dNV", MLS_ID(), PS_ID());
	}
	public static MethodHandle glVertexAttrib1dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1dv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib1dvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1dvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib1dvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1dvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib1f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1f", MLS_IF(), PS_IF());
	}
	public static MethodHandle glVertexAttrib1fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1fARB", MLS_IF(), PS_IF());
	}
	public static MethodHandle glVertexAttrib1fNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1fNV", MLS_IF(), PS_IF());
	}
	public static MethodHandle glVertexAttrib1fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1fv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib1fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1fvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib1fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1fvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib1hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1hNV", MLS_IC(), PS_IC());
	}
	public static MethodHandle glVertexAttrib1hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1hvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib1s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1s", MLS_IS(), PS_IS());
	}
	public static MethodHandle glVertexAttrib1sARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1sARB", MLS_IS(), PS_IS());
	}
	public static MethodHandle glVertexAttrib1sNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1sNV", MLS_IS(), PS_IS());
	}
	public static MethodHandle glVertexAttrib1sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1sv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib1svARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1svARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib1svNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib1svNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib2d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2d", MLS_IDD(), PS_IDD());
	}
	public static MethodHandle glVertexAttrib2dARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2dARB", MLS_IDD(), PS_IDD());
	}
	public static MethodHandle glVertexAttrib2dNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2dNV", MLS_IDD(), PS_IDD());
	}
	public static MethodHandle glVertexAttrib2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2dv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib2dvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2dvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib2dvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2dvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib2f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2f", MLS_IFF(), PS_IFF());
	}
	public static MethodHandle glVertexAttrib2fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2fARB", MLS_IFF(), PS_IFF());
	}
	public static MethodHandle glVertexAttrib2fNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2fNV", MLS_IFF(), PS_IFF());
	}
	public static MethodHandle glVertexAttrib2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2fv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib2fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2fvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib2fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2fvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib2hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2hNV", MLS_ICC(), PS_ICC());
	}
	public static MethodHandle glVertexAttrib2hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2hvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib2s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2s", MLS_ISS(), PS_ISS());
	}
	public static MethodHandle glVertexAttrib2sARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2sARB", MLS_ISS(), PS_ISS());
	}
	public static MethodHandle glVertexAttrib2sNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2sNV", MLS_ISS(), PS_ISS());
	}
	public static MethodHandle glVertexAttrib2sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2sv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib2svARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2svARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib2svNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib2svNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib3d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3d", MLS_IDDD(), PS_IDDD());
	}
	public static MethodHandle glVertexAttrib3dARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3dARB", MLS_IDDD(), PS_IDDD());
	}
	public static MethodHandle glVertexAttrib3dNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3dNV", MLS_IDDD(), PS_IDDD());
	}
	public static MethodHandle glVertexAttrib3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3dv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib3dvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3dvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib3dvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3dvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib3f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3f", MLS_IFFF(), PS_IFFF());
	}
	public static MethodHandle glVertexAttrib3fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3fARB", MLS_IFFF(), PS_IFFF());
	}
	public static MethodHandle glVertexAttrib3fNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3fNV", MLS_IFFF(), PS_IFFF());
	}
	public static MethodHandle glVertexAttrib3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3fv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib3fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3fvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib3fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3fvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib3hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3hNV", MLS_ICCC(), PS_ICCC());
	}
	public static MethodHandle glVertexAttrib3hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3hvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib3s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3s", MLS_ISSS(), PS_ISSS());
	}
	public static MethodHandle glVertexAttrib3sARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3sARB", MLS_ISSS(), PS_ISSS());
	}
	public static MethodHandle glVertexAttrib3sNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3sNV", MLS_ISSS(), PS_ISSS());
	}
	public static MethodHandle glVertexAttrib3sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3sv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib3svARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3svARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib3svNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib3svNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4Nbv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4Nbv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4NbvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4NbvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4Niv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4Niv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4NivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4NivARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4Nsv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4Nsv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4NsvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4NsvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4Nub(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4Nub", MLS_IBBBB(), PS_IBBBB());
	}
	public static MethodHandle glVertexAttrib4NubARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4NubARB", MLS_IBBBB(), PS_IBBBB());
	}
	public static MethodHandle glVertexAttrib4Nubv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4Nubv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4NubvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4NubvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4Nuiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4Nuiv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4NuivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4NuivARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4Nusv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4Nusv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4NusvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4NusvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4bv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4bv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4bvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4bvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4d", MLS_IDDDD(), PS_IDDDD());
	}
	public static MethodHandle glVertexAttrib4dARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4dARB", MLS_IDDDD(), PS_IDDDD());
	}
	public static MethodHandle glVertexAttrib4dNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4dNV", MLS_IDDDD(), PS_IDDDD());
	}
	public static MethodHandle glVertexAttrib4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4dv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4dvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4dvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4dvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4dvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4f", MLS_IFFFF(), PS_IFFFF());
	}
	public static MethodHandle glVertexAttrib4fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4fARB", MLS_IFFFF(), PS_IFFFF());
	}
	public static MethodHandle glVertexAttrib4fNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4fNV", MLS_IFFFF(), PS_IFFFF());
	}
	public static MethodHandle glVertexAttrib4fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4fv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4fvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4fvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4hNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4hNV", MLS_ICCCC(), PS_ICCCC());
	}
	public static MethodHandle glVertexAttrib4hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4hvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4iv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4ivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4ivARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4s", MLS_ISSSS(), PS_ISSSS());
	}
	public static MethodHandle glVertexAttrib4sARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4sARB", MLS_ISSSS(), PS_ISSSS());
	}
	public static MethodHandle glVertexAttrib4sNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4sNV", MLS_ISSSS(), PS_ISSSS());
	}
	public static MethodHandle glVertexAttrib4sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4sv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4svARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4svARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4svNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4svNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4ubNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4ubNV", MLS_IBBBB(), PS_IBBBB());
	}
	public static MethodHandle glVertexAttrib4ubv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4ubv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4ubvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4ubvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4ubvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4ubvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4uiv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4uivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4uivARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4usv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4usv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttrib4usvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttrib4usvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribArrayObjectATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribArrayObjectATI", MLS_IILVertexAttribPointerType_ZIII(), PS_IILVertexAttribPointerType_ZIII());
	}
	public static MethodHandle glVertexAttribBinding(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribBinding", MLS_II(), PS_II());
	}
	public static MethodHandle glVertexAttribDivisor(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribDivisor", MLS_II(), PS_II());
	}
	public static MethodHandle glVertexAttribDivisorANGLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribDivisorANGLE", MLS_II(), PS_II());
	}
	public static MethodHandle glVertexAttribDivisorARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribDivisorARB", MLS_II(), PS_II());
	}
	public static MethodHandle glVertexAttribDivisorEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribDivisorEXT", MLS_II(), PS_II());
	}
	public static MethodHandle glVertexAttribDivisorNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribDivisorNV", MLS_II(), PS_II());
	}
	public static MethodHandle glVertexAttribFormat(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribFormat", MLS_IILVertexAttribType_ZI(), PS_IILVertexAttribType_ZI());
	}
	public static MethodHandle glVertexAttribFormatNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribFormatNV", MLS_IILVertexAttribType_ZI(), PS_IILVertexAttribType_ZI());
	}
	public static MethodHandle glVertexAttribI1i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI1i", MLS_II(), PS_II());
	}
	public static MethodHandle glVertexAttribI1iEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI1iEXT", MLS_II(), PS_II());
	}
	public static MethodHandle glVertexAttribI1iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI1iv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI1ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI1ivEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI1ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI1ui", MLS_II(), PS_II());
	}
	public static MethodHandle glVertexAttribI1uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI1uiEXT", MLS_II(), PS_II());
	}
	public static MethodHandle glVertexAttribI1uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI1uiv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI1uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI1uivEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI2i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI2i", MLS_III(), PS_III());
	}
	public static MethodHandle glVertexAttribI2iEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI2iEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glVertexAttribI2iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI2iv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI2ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI2ivEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI2ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI2ui", MLS_III(), PS_III());
	}
	public static MethodHandle glVertexAttribI2uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI2uiEXT", MLS_III(), PS_III());
	}
	public static MethodHandle glVertexAttribI2uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI2uiv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI2uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI2uivEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI3i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI3i", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glVertexAttribI3iEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI3iEXT", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glVertexAttribI3iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI3iv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI3ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI3ivEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI3ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI3ui", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glVertexAttribI3uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI3uiEXT", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glVertexAttribI3uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI3uiv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI3uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI3uivEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI4bv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4bv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI4bvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4bvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI4i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4i", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glVertexAttribI4iEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4iEXT", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glVertexAttribI4iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4iv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI4ivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4ivEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI4sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4sv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI4svEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4svEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI4ubv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4ubv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI4ubvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4ubvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI4ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4ui", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glVertexAttribI4uiEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4uiEXT", MLS_IIIII(), PS_IIIII());
	}
	public static MethodHandle glVertexAttribI4uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4uiv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI4uivEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4uivEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI4usv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4usv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribI4usvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribI4usvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribIFormat(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribIFormat", MLS_IILVertexAttribIType_I(), PS_IILVertexAttribIType_I());
	}
	public static MethodHandle glVertexAttribIFormatNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribIFormatNV", MLS_IILVertexAttribIType_I(), PS_IILVertexAttribIType_I());
	}
	public static MethodHandle glVertexAttribIPointer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribIPointer", MLS_IILVertexAttribIType_Ip(), PS_IILVertexAttribIType_Ip());
	}
	public static MethodHandle glVertexAttribIPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribIPointerEXT", MLS_IILVertexAttribIType_Ip(), PS_IILVertexAttribIType_Ip());
	}
	public static MethodHandle glVertexAttribL1d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL1d", MLS_ID(), PS_ID());
	}
	public static MethodHandle glVertexAttribL1dEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL1dEXT", MLS_ID(), PS_ID());
	}
	public static MethodHandle glVertexAttribL1dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL1dv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL1dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL1dvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL1i64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL1i64NV", MLS_IJ(), PS_IJ());
	}
	public static MethodHandle glVertexAttribL1i64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL1i64vNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL1ui64ARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL1ui64ARB", MLS_IJ(), PS_IJ());
	}
	public static MethodHandle glVertexAttribL1ui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL1ui64NV", MLS_IJ(), PS_IJ());
	}
	public static MethodHandle glVertexAttribL1ui64vARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL1ui64vARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL1ui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL1ui64vNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL2d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL2d", MLS_IDD(), PS_IDD());
	}
	public static MethodHandle glVertexAttribL2dEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL2dEXT", MLS_IDD(), PS_IDD());
	}
	public static MethodHandle glVertexAttribL2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL2dv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL2dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL2dvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL2i64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL2i64NV", MLS_IJJ(), PS_IJJ());
	}
	public static MethodHandle glVertexAttribL2i64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL2i64vNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL2ui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL2ui64NV", MLS_IJJ(), PS_IJJ());
	}
	public static MethodHandle glVertexAttribL2ui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL2ui64vNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL3d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL3d", MLS_IDDD(), PS_IDDD());
	}
	public static MethodHandle glVertexAttribL3dEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL3dEXT", MLS_IDDD(), PS_IDDD());
	}
	public static MethodHandle glVertexAttribL3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL3dv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL3dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL3dvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL3i64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL3i64NV", MLS_IJJJ(), PS_IJJJ());
	}
	public static MethodHandle glVertexAttribL3i64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL3i64vNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL3ui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL3ui64NV", MLS_IJJJ(), PS_IJJJ());
	}
	public static MethodHandle glVertexAttribL3ui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL3ui64vNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL4d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL4d", MLS_IDDDD(), PS_IDDDD());
	}
	public static MethodHandle glVertexAttribL4dEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL4dEXT", MLS_IDDDD(), PS_IDDDD());
	}
	public static MethodHandle glVertexAttribL4dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL4dv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL4dvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL4dvEXT", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL4i64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL4i64NV", MLS_IJJJJ(), PS_IJJJJ());
	}
	public static MethodHandle glVertexAttribL4i64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL4i64vNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribL4ui64NV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL4ui64NV", MLS_IJJJJ(), PS_IJJJJ());
	}
	public static MethodHandle glVertexAttribL4ui64vNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribL4ui64vNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glVertexAttribLFormat(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribLFormat", MLS_IILVertexAttribLType_I(), PS_IILVertexAttribLType_I());
	}
	public static MethodHandle glVertexAttribLFormatNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribLFormatNV", MLS_IILVertexAttribLType_I(), PS_IILVertexAttribLType_I());
	}
	public static MethodHandle glVertexAttribLPointer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribLPointer", MLS_IILVertexAttribLType_Ip(), PS_IILVertexAttribLType_Ip());
	}
	public static MethodHandle glVertexAttribLPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribLPointerEXT", MLS_IILVertexAttribLType_Ip(), PS_IILVertexAttribLType_Ip());
	}
	public static MethodHandle glVertexAttribP1ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribP1ui", MLS_ILVertexAttribPointerType_ZI(), PS_ILVertexAttribPointerType_ZI());
	}
	public static MethodHandle glVertexAttribP1uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribP1uiv", MLS_ILVertexAttribPointerType_Zp(), PS_ILVertexAttribPointerType_Zp());
	}
	public static MethodHandle glVertexAttribP2ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribP2ui", MLS_ILVertexAttribPointerType_ZI(), PS_ILVertexAttribPointerType_ZI());
	}
	public static MethodHandle glVertexAttribP2uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribP2uiv", MLS_ILVertexAttribPointerType_Zp(), PS_ILVertexAttribPointerType_Zp());
	}
	public static MethodHandle glVertexAttribP3ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribP3ui", MLS_ILVertexAttribPointerType_ZI(), PS_ILVertexAttribPointerType_ZI());
	}
	public static MethodHandle glVertexAttribP3uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribP3uiv", MLS_ILVertexAttribPointerType_Zp(), PS_ILVertexAttribPointerType_Zp());
	}
	public static MethodHandle glVertexAttribP4ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribP4ui", MLS_ILVertexAttribPointerType_ZI(), PS_ILVertexAttribPointerType_ZI());
	}
	public static MethodHandle glVertexAttribP4uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribP4uiv", MLS_ILVertexAttribPointerType_Zp(), PS_ILVertexAttribPointerType_Zp());
	}
	public static MethodHandle glVertexAttribParameteriAMD(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribParameteriAMD", MLS_IEI(), PS_IEI());
	}
	public static MethodHandle glVertexAttribPointer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribPointer", MLS_IILVertexAttribPointerType_ZIp(), PS_IILVertexAttribPointerType_ZIp());
	}
	public static MethodHandle glVertexAttribPointerARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribPointerARB", MLS_IILVertexAttribPointerType_ZIp(), PS_IILVertexAttribPointerType_ZIp());
	}
	public static MethodHandle glVertexAttribPointerNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribPointerNV", MLS_IILVertexAttribEnumNV_Ip(), PS_IILVertexAttribEnumNV_Ip());
	}
	public static MethodHandle glVertexAttribs1dvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs1dvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs1fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs1fvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs1hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs1hvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs1svNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs1svNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs2dvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs2dvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs2fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs2fvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs2hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs2hvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs2svNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs2svNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs3dvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs3dvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs3fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs3fvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs3hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs3hvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs3svNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs3svNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs4dvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs4dvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs4fvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs4fvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs4hvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs4hvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs4svNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs4svNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexAttribs4ubvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexAttribs4ubvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glVertexBindingDivisor(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexBindingDivisor", MLS_II(), PS_II());
	}
	public static MethodHandle glVertexBlendARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexBlendARB", MLS_I(), PS_I());
	}
	public static MethodHandle glVertexBlendEnvfATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexBlendEnvfATI", MLS_LVertexStreamATI_F(), PS_LVertexStreamATI_F());
	}
	public static MethodHandle glVertexBlendEnviATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexBlendEnviATI", MLS_LVertexStreamATI_I(), PS_LVertexStreamATI_I());
	}
	public static MethodHandle glVertexFormatNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexFormatNV", MLS_ILVertexPointerType_I(), PS_ILVertexPointerType_I());
	}
	public static MethodHandle glVertexP2ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexP2ui", MLS_LVertexPointerType_I(), PS_LVertexPointerType_I());
	}
	public static MethodHandle glVertexP2uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexP2uiv", MLS_LVertexPointerType_p(), PS_LVertexPointerType_p());
	}
	public static MethodHandle glVertexP3ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexP3ui", MLS_LVertexPointerType_I(), PS_LVertexPointerType_I());
	}
	public static MethodHandle glVertexP3uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexP3uiv", MLS_LVertexPointerType_p(), PS_LVertexPointerType_p());
	}
	public static MethodHandle glVertexP4ui(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexP4ui", MLS_LVertexPointerType_I(), PS_LVertexPointerType_I());
	}
	public static MethodHandle glVertexP4uiv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexP4uiv", MLS_LVertexPointerType_p(), PS_LVertexPointerType_p());
	}
	public static MethodHandle glVertexPointer(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexPointer", MLS_ILVertexPointerType_Ip(), PS_ILVertexPointerType_Ip());
	}
	public static MethodHandle glVertexPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexPointerEXT", MLS_ILVertexPointerType_IIp(), PS_ILVertexPointerType_IIp());
	}
	public static MethodHandle glVertexPointerListIBM(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexPointerListIBM", MLS_ILVertexPointerType_IPI(), PS_ILVertexPointerType_IPI());
	}
	public static MethodHandle glVertexPointervINTEL(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexPointervINTEL", MLS_ILVertexPointerType_P(), PS_ILVertexPointerType_P());
	}
	public static MethodHandle glVertexStream1dATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream1dATI", MLS_LVertexStreamATI_D(), PS_LVertexStreamATI_D());
	}
	public static MethodHandle glVertexStream1dvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream1dvATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream1fATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream1fATI", MLS_LVertexStreamATI_F(), PS_LVertexStreamATI_F());
	}
	public static MethodHandle glVertexStream1fvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream1fvATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream1iATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream1iATI", MLS_LVertexStreamATI_I(), PS_LVertexStreamATI_I());
	}
	public static MethodHandle glVertexStream1ivATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream1ivATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream1sATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream1sATI", MLS_LVertexStreamATI_S(), PS_LVertexStreamATI_S());
	}
	public static MethodHandle glVertexStream1svATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream1svATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream2dATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream2dATI", MLS_LVertexStreamATI_DD(), PS_LVertexStreamATI_DD());
	}
	public static MethodHandle glVertexStream2dvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream2dvATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream2fATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream2fATI", MLS_LVertexStreamATI_FF(), PS_LVertexStreamATI_FF());
	}
	public static MethodHandle glVertexStream2fvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream2fvATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream2iATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream2iATI", MLS_LVertexStreamATI_II(), PS_LVertexStreamATI_II());
	}
	public static MethodHandle glVertexStream2ivATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream2ivATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream2sATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream2sATI", MLS_LVertexStreamATI_SS(), PS_LVertexStreamATI_SS());
	}
	public static MethodHandle glVertexStream2svATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream2svATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream3dATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream3dATI", MLS_LVertexStreamATI_DDD(), PS_LVertexStreamATI_DDD());
	}
	public static MethodHandle glVertexStream3dvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream3dvATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream3fATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream3fATI", MLS_LVertexStreamATI_FFF(), PS_LVertexStreamATI_FFF());
	}
	public static MethodHandle glVertexStream3fvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream3fvATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream3iATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream3iATI", MLS_LVertexStreamATI_III(), PS_LVertexStreamATI_III());
	}
	public static MethodHandle glVertexStream3ivATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream3ivATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream3sATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream3sATI", MLS_LVertexStreamATI_SSS(), PS_LVertexStreamATI_SSS());
	}
	public static MethodHandle glVertexStream3svATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream3svATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream4dATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream4dATI", MLS_LVertexStreamATI_DDDD(), PS_LVertexStreamATI_DDDD());
	}
	public static MethodHandle glVertexStream4dvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream4dvATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream4fATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream4fATI", MLS_LVertexStreamATI_FFFF(), PS_LVertexStreamATI_FFFF());
	}
	public static MethodHandle glVertexStream4fvATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream4fvATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream4iATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream4iATI", MLS_LVertexStreamATI_IIII(), PS_LVertexStreamATI_IIII());
	}
	public static MethodHandle glVertexStream4ivATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream4ivATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexStream4sATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream4sATI", MLS_LVertexStreamATI_SSSS(), PS_LVertexStreamATI_SSSS());
	}
	public static MethodHandle glVertexStream4svATI(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexStream4svATI", MLS_LVertexStreamATI_p(), PS_LVertexStreamATI_p());
	}
	public static MethodHandle glVertexWeightPointerEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexWeightPointerEXT", MLS_ILVertexWeightPointerTypeEXT_Ip(), PS_ILVertexWeightPointerTypeEXT_Ip());
	}
	public static MethodHandle glVertexWeightfEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexWeightfEXT", MLS_F(), PS_F());
	}
	public static MethodHandle glVertexWeightfvEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexWeightfvEXT", MLS_p(), PS_p());
	}
	public static MethodHandle glVertexWeighthNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexWeighthNV", MLS_C(), PS_C());
	}
	public static MethodHandle glVertexWeighthvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVertexWeighthvNV", MLS_p(), PS_p());
	}
	public static MethodHandle glVideoCaptureNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glVideoCaptureNV", GLParamTypeSets.ML_E(), GLEnum.class, MLS_IPP(), PS_IPP());
	}
	public static MethodHandle glVideoCaptureStreamParameterdvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVideoCaptureStreamParameterdvNV", MLS_IIEp(), PS_IIEp());
	}
	public static MethodHandle glVideoCaptureStreamParameterfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVideoCaptureStreamParameterfvNV", MLS_IIEp(), PS_IIEp());
	}
	public static MethodHandle glVideoCaptureStreamParameterivNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glVideoCaptureStreamParameterivNV", MLS_IIEp(), PS_IIEp());
	}
	public static MethodHandle glViewport(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glViewport", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glViewportArrayv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glViewportArrayv", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glViewportArrayvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glViewportArrayvNV", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glViewportArrayvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glViewportArrayvOES", MLS_IIp(), PS_IIp());
	}
	public static MethodHandle glViewportIndexedf(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glViewportIndexedf", MLS_IFFFF(), PS_IFFFF());
	}
	public static MethodHandle glViewportIndexedfOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glViewportIndexedfOES", MLS_IFFFF(), PS_IFFFF());
	}
	public static MethodHandle glViewportIndexedfNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glViewportIndexedfNV", MLS_IFFFF(), PS_IFFFF());
	}
	public static MethodHandle glViewportIndexedfv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glViewportIndexedfv", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glViewportIndexedfvOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glViewportIndexedfvOES", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glViewportIndexedfvNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glViewportIndexedfvNV", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glViewportPositionWScaleNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glViewportPositionWScaleNV", MLS_IFF(), PS_IFF());
	}
	public static MethodHandle glViewportSwizzleNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glViewportSwizzleNV", MLS_IEEEE(), PS_IEEEE());
	}
	public static MethodHandle glWaitSemaphoreEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWaitSemaphoreEXT", MLS_IIpIpp(), PS_IIpIpp());
	}
	public static MethodHandle glWaitSemaphoreui64NVX(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWaitSemaphoreui64NVX", MLS_IIpp(), PS_IIpp());
	}
	public static MethodHandle glWaitSync(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWaitSync", MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glWaitSyncAPPLE(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWaitSyncAPPLE", MLS_IIJ(), PS_IIJ());
	}
	public static MethodHandle glWeightPathsNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWeightPathsNV", MLS_IIpp(), PS_IIpp());
	}
	public static MethodHandle glWeightPointerARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWeightPointerARB", MLS_ILWeightPointerTypeARB_Ip(), PS_ILWeightPointerTypeARB_Ip());
	}
	public static MethodHandle glWeightPointerOES(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWeightPointerOES", MLS_IEIp(), PS_IEIp());
	}
	public static MethodHandle glWeightbvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWeightbvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glWeightdvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWeightdvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glWeightfvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWeightfvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glWeightivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWeightivARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glWeightsvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWeightsvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glWeightubvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWeightubvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glWeightuivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWeightuivARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glWeightusvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWeightusvARB", MLS_Ip(), PS_Ip());
	}
	public static MethodHandle glWindowPos2d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2d", MLS_DD(), PS_DD());
	}
	public static MethodHandle glWindowPos2dARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2dARB", MLS_DD(), PS_DD());
	}
	public static MethodHandle glWindowPos2dMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2dMESA", MLS_DD(), PS_DD());
	}
	public static MethodHandle glWindowPos2dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2dv", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos2dvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2dvARB", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos2dvMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2dvMESA", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos2f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2f", MLS_FF(), PS_FF());
	}
	public static MethodHandle glWindowPos2fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2fARB", MLS_FF(), PS_FF());
	}
	public static MethodHandle glWindowPos2fMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2fMESA", MLS_FF(), PS_FF());
	}
	public static MethodHandle glWindowPos2fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2fv", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos2fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2fvARB", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos2fvMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2fvMESA", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos2i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2i", MLS_II(), PS_II());
	}
	public static MethodHandle glWindowPos2iARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2iARB", MLS_II(), PS_II());
	}
	public static MethodHandle glWindowPos2iMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2iMESA", MLS_II(), PS_II());
	}
	public static MethodHandle glWindowPos2iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2iv", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos2ivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2ivARB", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos2ivMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2ivMESA", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos2s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2s", MLS_SS(), PS_SS());
	}
	public static MethodHandle glWindowPos2sARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2sARB", MLS_SS(), PS_SS());
	}
	public static MethodHandle glWindowPos2sMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2sMESA", MLS_SS(), PS_SS());
	}
	public static MethodHandle glWindowPos2sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2sv", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos2svARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2svARB", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos2svMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos2svMESA", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos3d(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3d", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glWindowPos3dARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3dARB", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glWindowPos3dMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3dMESA", MLS_DDD(), PS_DDD());
	}
	public static MethodHandle glWindowPos3dv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3dv", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos3dvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3dvARB", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos3dvMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3dvMESA", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos3f(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3f", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glWindowPos3fARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3fARB", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glWindowPos3fMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3fMESA", MLS_FFF(), PS_FFF());
	}
	public static MethodHandle glWindowPos3fv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3fv", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos3fvARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3fvARB", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos3fvMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3fvMESA", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos3i(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3i", MLS_III(), PS_III());
	}
	public static MethodHandle glWindowPos3iARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3iARB", MLS_III(), PS_III());
	}
	public static MethodHandle glWindowPos3iMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3iMESA", MLS_III(), PS_III());
	}
	public static MethodHandle glWindowPos3iv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3iv", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos3ivARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3ivARB", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos3ivMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3ivMESA", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos3s(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3s", MLS_SSS(), PS_SSS());
	}
	public static MethodHandle glWindowPos3sARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3sARB", MLS_SSS(), PS_SSS());
	}
	public static MethodHandle glWindowPos3sMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3sMESA", MLS_SSS(), PS_SSS());
	}
	public static MethodHandle glWindowPos3sv(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3sv", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos3svARB(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3svARB", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos3svMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos3svMESA", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos4dMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos4dMESA", MLS_DDDD(), PS_DDDD());
	}
	public static MethodHandle glWindowPos4dvMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos4dvMESA", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos4fMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos4fMESA", MLS_FFFF(), PS_FFFF());
	}
	public static MethodHandle glWindowPos4fvMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos4fvMESA", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos4iMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos4iMESA", MLS_IIII(), PS_IIII());
	}
	public static MethodHandle glWindowPos4ivMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos4ivMESA", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowPos4sMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos4sMESA", MLS_SSSS(), PS_SSSS());
	}
	public static MethodHandle glWindowPos4svMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowPos4svMESA", MLS_p(), PS_p());
	}
	public static MethodHandle glWindowRectanglesEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWindowRectanglesEXT", MLS_EIp(), PS_EIp());
	}
	public static MethodHandle glWriteMaskEXT(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWriteMaskEXT", MLS_IILVertexShaderWriteMaskEXT_LVertexShaderWriteMaskEXT_LVertexShaderWriteMaskEXT_LVertexShaderWriteMaskEXT_(), PS_IILVertexShaderWriteMaskEXT_LVertexShaderWriteMaskEXT_LVertexShaderWriteMaskEXT_LVertexShaderWriteMaskEXT_());
	}
	public static MethodHandle glDrawVkImageNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glDrawVkImageNV", MLS_JIFFFFFFFFF(), PS_JIFFFFFFFFF());
	}
	public static MethodHandle glGetVkProcAddrNV(MethodHandles.Lookup l, String n, Class t) {
		return prepare("glGetVkProcAddrNV", GLParamTypeSets.ML_I(), int.class, MLS_p(), PS_p());
	}
	public static MethodHandle glWaitVkSemaphoreNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glWaitVkSemaphoreNV", MLS_J(), PS_J());
	}
	public static MethodHandle glSignalVkSemaphoreNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSignalVkSemaphoreNV", MLS_J(), PS_J());
	}
	public static MethodHandle glSignalVkFenceNV(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glSignalVkFenceNV", MLS_J(), PS_J());
	}
	public static MethodHandle glFramebufferParameteriMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glFramebufferParameteriMESA", MLS_LFramebufferTarget_LFramebufferParameterName_I(), PS_LFramebufferTarget_LFramebufferParameterName_I());
	}
	public static MethodHandle glGetFramebufferParameterivMESA(MethodHandles.Lookup l, String n, Class t) {
		return prepareVoid("glGetFramebufferParameterivMESA", MLS_LFramebufferTarget_LFramebufferAttachmentParameterName_P(), PS_LFramebufferTarget_LFramebufferAttachmentParameterName_P());
	}

	private static MethodHandle prepare(String name, MemoryLayout retLayout, Class<?> retType, List<MemoryLayout> argLayouts, List<Class<?>> argTypes) {
		return UnlinkedGLFunction.prepareTrusted(name, retLayout, retType, argLayouts, argTypes, EMPTY_LINKER_OPTIONS);
	}

	private static MethodHandle prepareVoid(String name, List<MemoryLayout> argLayouts, List<Class<?>> argTypes) {
		return prepare(name, null, void.class, argLayouts, argTypes);
	}
}