package dev.pfaff.glass.opengl;

import java.lang.foreign.MemoryLayout;
import java.lang.invoke.MethodHandles;
import java.util.List;

import dev.pfaff.glass.opengl.enums.*;

import static java.lang.foreign.ValueLayout.*;

import static dev.pfaff.glass.opengl.GLParamTypeSets.*;
import static dev.pfaff.glass.opengl.Util.ADDRESS_SIZED_INT;
import static dev.pfaff.glass.opengl.Util.LOGGER;

final class GLParamTypeSetsInit {
    //<editor-fold desc="PS_*">
	static List<Class<?>> PS_LAccumOp_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLAccumOp.class,float.class); }
	static List<Class<?>> PS_EI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class); }
	static List<Class<?>> PS_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class); }
	static List<Class<?>> PS_II(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class); }
	static List<Class<?>> PS_LTriangleFace_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTriangleFace.class); }
	static List<Class<?>> PS_LTextureUnit_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class); }
	static List<Class<?>> PS_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class); }
	static List<Class<?>> PS_LFragmentOp1ATI_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentOp1ATI.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LFragmentOp2ATI_IIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentOp2ATI.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LFragmentOp3ATI_IIIIIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentOp3ATI.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LAlphaFunction_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLAlphaFunction.class,float.class); }
	static List<Class<?>> PS_EF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,float.class); }
	static List<Class<?>> PS_LAlphaFunction_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLAlphaFunction.class,int.class); }
	static List<Class<?>> PS_E(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class); }
	static List<Class<?>> PS_(MethodHandles.Lookup l, String n, Class t) { return List.of(); }
	static List<Class<?>> PS_LLightTextureModeEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLLightTextureModeEXT.class); }
	static List<Class<?>> PS_IJI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,int.class); }
	static List<Class<?>> PS_IpP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class,MutPointer.class); }
	static List<Class<?>> PS_LEnableCap_ILScalarType_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnableCap.class,int.class,GLScalarType.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_IppIIIIJJJIpp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class,ConstPointer.class,int.class,int.class,int.class,int.class,long.class,long.class,long.class,int.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_IppIIIEIIIIIEIIIIIIIIpp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class,ConstPointer.class,int.class,int.class,int.class,GLEnum.class,int.class,int.class,int.class,int.class,int.class,GLEnum.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_LPrimitiveType_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class); }
	static List<Class<?>> PS_ILConditionalRenderMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLConditionalRenderMode.class); }
	static List<Class<?>> PS_LQueryTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLQueryTarget.class,int.class); }
	static List<Class<?>> PS_LQueryTarget_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLQueryTarget.class,int.class,int.class); }
	static List<Class<?>> PS_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LBufferTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,int.class); }
	static List<Class<?>> PS_LBufferTarget_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,int.class,int.class); }
	static List<Class<?>> PS_LBufferTarget_IIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,int.class,int.class,long.class); }
	static List<Class<?>> PS_LBufferTarget_IIJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,int.class,int.class,long.class,long.class); }
	static List<Class<?>> PS_LBufferTarget_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LBufferTarget_IIppp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,int.class,int.class,ConstPointer.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_IIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LFramebufferTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,int.class); }
	static List<Class<?>> PS_IIIZILBufferAccess_LInternalFormat_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,boolean.class,int.class,GLBufferAccess.class,GLInternalFormat.class); }
	static List<Class<?>> PS_IIIZILBufferAccess_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,boolean.class,int.class,GLBufferAccess.class,int.class); }
	static List<Class<?>> PS_LLightName_LLightParameter_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLLightName.class,GLLightParameter.class); }
	static List<Class<?>> PS_LTriangleFace_LMaterialParameter_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTriangleFace.class,GLMaterialParameter.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class); }
	static List<Class<?>> PS_LVertexShaderParameterEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexShaderParameterEXT.class); }
	static List<Class<?>> PS_LProgramTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLProgramTarget.class,int.class); }
	static List<Class<?>> PS_LVertexAttribEnumNV_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexAttribEnumNV.class,int.class); }
	static List<Class<?>> PS_LRenderbufferTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLRenderbufferTarget.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureCoordName.class,GLTextureGenParameter.class); }
	static List<Class<?>> PS_LTextureTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LVertexShaderTextureUnitParameter_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLVertexShaderTextureUnitParameter.class); }
	static List<Class<?>> PS_LBindTransformFeedbackTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBindTransformFeedbackTarget.class,int.class); }
	static List<Class<?>> PS_IIJI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,long.class,int.class); }
	static List<Class<?>> PS_IIppp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,ConstPointer.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_IIEJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLEnum.class,long.class); }
	static List<Class<?>> PS_IIEEI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLEnum.class,GLEnum.class,int.class); }
	static List<Class<?>> PS_BBB(MethodHandles.Lookup l, String n, Class t) { return List.of(byte.class,byte.class,byte.class); }
	static List<Class<?>> PS_p(MethodHandles.Lookup l, String n, Class t) { return List.of(ConstPointer.class); }
	static List<Class<?>> PS_DDD(MethodHandles.Lookup l, String n, Class t) { return List.of(double.class,double.class,double.class); }
	static List<Class<?>> PS_FFF(MethodHandles.Lookup l, String n, Class t) { return List.of(float.class,float.class,float.class); }
	static List<Class<?>> PS_III(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class); }
	static List<Class<?>> PS_SSS(MethodHandles.Lookup l, String n, Class t) { return List.of(short.class,short.class,short.class); }
	static List<Class<?>> PS_LBinormalPointerTypeEXT_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBinormalPointerTypeEXT.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IIFFFFp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,float.class,float.class,float.class,float.class,ConstPointer.class); }
	static List<Class<?>> PS_IIIIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_FFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LBlendEquationModeEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBlendEquationModeEXT.class); }
	static List<Class<?>> PS_ILBlendEquationModeEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLBlendEquationModeEXT.class); }
	static List<Class<?>> PS_LBlendEquationModeEXT_LBlendEquationModeEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBlendEquationModeEXT.class,GLBlendEquationModeEXT.class); }
	static List<Class<?>> PS_ILBlendEquationModeEXT_LBlendEquationModeEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLBlendEquationModeEXT.class,GLBlendEquationModeEXT.class); }
	static List<Class<?>> PS_LBlendingFactor_LBlendingFactor_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBlendingFactor.class,GLBlendingFactor.class); }
	static List<Class<?>> PS_IEE(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,GLEnum.class); }
	static List<Class<?>> PS_LBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBlendingFactor.class,GLBlendingFactor.class,GLBlendingFactor.class,GLBlendingFactor.class); }
	static List<Class<?>> PS_ILBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLBlendingFactor.class,GLBlendingFactor.class,GLBlendingFactor.class,GLBlendingFactor.class); }
	static List<Class<?>> PS_ILBlendingFactor_LBlendingFactor_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLBlendingFactor.class,GLBlendingFactor.class); }
	static List<Class<?>> PS_IIIIIIIIILBlitFramebufferFilter_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLBlitFramebufferFilter.class); }
	static List<Class<?>> PS_IIIIIIIIIIILBlitFramebufferFilter_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLBlitFramebufferFilter.class); }
	static List<Class<?>> PS_EIJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,long.class,long.class); }
	static List<Class<?>> PS_LBufferTarget_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,int.class,long.class); }
	static List<Class<?>> PS_LBufferTarget_JpLBufferUsage_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,long.class,ConstPointer.class,GLBufferUsage.class); }
	static List<Class<?>> PS_EJJZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,long.class,long.class,boolean.class); }
	static List<Class<?>> PS_LBufferStorageTarget_JJIJZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferStorageTarget.class,long.class,long.class,int.class,long.class,boolean.class); }
	static List<Class<?>> PS_EEI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,GLEnum.class,int.class); }
	static List<Class<?>> PS_LBufferStorageTarget_JpI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferStorageTarget.class,long.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_EJJII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,long.class,long.class,int.class,int.class); }
	static List<Class<?>> PS_LBufferTarget_JIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,long.class,int.class,long.class); }
	static List<Class<?>> PS_LBufferTarget_JJp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,long.class,long.class,ConstPointer.class); }
	static List<Class<?>> PS_ILListNameType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLListNameType.class,ConstPointer.class); }
	static List<Class<?>> PS_LFramebufferTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class); }
	static List<Class<?>> PS_ILFramebufferTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFramebufferTarget.class); }
	static List<Class<?>> PS_LClampColorTargetARB_LClampColorModeARB_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLClampColorTargetARB.class,GLClampColorModeARB.class); }
	static List<Class<?>> PS_LBufferStorageTarget_LSizedInternalFormat_LPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferStorageTarget.class,GLSizedInternalFormat.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LBufferTarget_LSizedInternalFormat_JJLPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,GLSizedInternalFormat.class,long.class,long.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LBuffer_IFI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBuffer.class,int.class,float.class,int.class); }
	static List<Class<?>> PS_LBuffer_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBuffer.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_D(MethodHandles.Lookup l, String n, Class t) { return List.of(double.class); }
	static List<Class<?>> PS_F(MethodHandles.Lookup l, String n, Class t) { return List.of(float.class); }
	static List<Class<?>> PS_ILSizedInternalFormat_LPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSizedInternalFormat.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILSizedInternalFormat_JJLPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSizedInternalFormat.class,long.class,long.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILBuffer_IFI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLBuffer.class,int.class,float.class,int.class); }
	static List<Class<?>> PS_ILBuffer_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLBuffer.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_IIIIIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LVertexStreamATI_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class); }
	static List<Class<?>> PS_Ipp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_IIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,long.class); }
	static List<Class<?>> PS_LClipControlOrigin_LClipControlDepth_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLClipControlOrigin.class,GLClipControlDepth.class); }
	static List<Class<?>> PS_EE(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,GLEnum.class); }
	static List<Class<?>> PS_LClipPlaneName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLClipPlaneName.class,ConstPointer.class); }
	static List<Class<?>> PS_FFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(float.class,float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_pp(MethodHandles.Lookup l, String n, Class t) { return List.of(ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_CCC(MethodHandles.Lookup l, String n, Class t) { return List.of(char.class,char.class,char.class); }
	static List<Class<?>> PS_BBBB(MethodHandles.Lookup l, String n, Class t) { return List.of(byte.class,byte.class,byte.class,byte.class); }
	static List<Class<?>> PS_DDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(double.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_FFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_ppp(MethodHandles.Lookup l, String n, Class t) { return List.of(ConstPointer.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_CCCC(MethodHandles.Lookup l, String n, Class t) { return List.of(char.class,char.class,char.class,char.class); }
	static List<Class<?>> PS_SSSS(MethodHandles.Lookup l, String n, Class t) { return List.of(short.class,short.class,short.class,short.class); }
	static List<Class<?>> PS_BBBBFF(MethodHandles.Lookup l, String n, Class t) { return List.of(byte.class,byte.class,byte.class,byte.class,float.class,float.class); }
	static List<Class<?>> PS_BBBBFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(byte.class,byte.class,byte.class,byte.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_ILColorPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLColorPointerType.class,int.class); }
	static List<Class<?>> PS_LFragmentOp1ATI_IIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentOp1ATI.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LFragmentOp2ATI_IIIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentOp2ATI.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LFragmentOp3ATI_IIIIIIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentOp3ATI.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ZZZZ(MethodHandles.Lookup l, String n, Class t) { return List.of(boolean.class,boolean.class,boolean.class,boolean.class); }
	static List<Class<?>> PS_IZZZZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,boolean.class,boolean.class,boolean.class,boolean.class); }
	static List<Class<?>> PS_LTriangleFace_LColorMaterialParameter_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTriangleFace.class,GLColorMaterialParameter.class); }
	static List<Class<?>> PS_LColorPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorPointerType.class,int.class); }
	static List<Class<?>> PS_LColorPointerType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorPointerType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILColorPointerType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLColorPointerType.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILColorPointerType_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLColorPointerType.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILColorPointerType_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLColorPointerType.class,int.class,MutPointer.class,int.class); }
	static List<Class<?>> PS_ILVertexPointerType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexPointerType.class,MutPointer.class); }
	static List<Class<?>> PS_LColorTableTarget_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTarget.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LColorTableTarget_LInternalFormat_ILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTarget.class,GLInternalFormat.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LColorTableTarget_LColorTableParameterPName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTarget.class,GLColorTableParameterPName.class,ConstPointer.class); }
	static List<Class<?>> PS_LColorTableTargetSGI_LColorTableParameterPName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTargetSGI.class,GLColorTableParameterPName.class,ConstPointer.class); }
	static List<Class<?>> PS_LColorTableTargetSGI_LInternalFormat_ILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTargetSGI.class,GLInternalFormat.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LCombinerStageNV_LCombinerPortionNV_LCombinerVariableNV_LCombinerRegisterNV_LCombinerMappingNV_LCombinerComponentUsageNV_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCombinerStageNV.class,GLCombinerPortionNV.class,GLCombinerVariableNV.class,GLCombinerRegisterNV.class,GLCombinerMappingNV.class,GLCombinerComponentUsageNV.class); }
	static List<Class<?>> PS_LCombinerStageNV_LCombinerPortionNV_LCombinerRegisterNV_LCombinerRegisterNV_LCombinerRegisterNV_LCombinerScaleNV_LCombinerBiasNV_ZZZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCombinerStageNV.class,GLCombinerPortionNV.class,GLCombinerRegisterNV.class,GLCombinerRegisterNV.class,GLCombinerRegisterNV.class,GLCombinerScaleNV.class,GLCombinerBiasNV.class,boolean.class,boolean.class,boolean.class); }
	static List<Class<?>> PS_LCombinerParameterNV_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCombinerParameterNV.class,float.class); }
	static List<Class<?>> PS_LCombinerParameterNV_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCombinerParameterNV.class,ConstPointer.class); }
	static List<Class<?>> PS_LCombinerParameterNV_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCombinerParameterNV.class,int.class); }
	static List<Class<?>> PS_LCombinerStageNV_LCombinerParameterNV_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCombinerStageNV.class,GLCombinerParameterNV.class,ConstPointer.class); }
	static List<Class<?>> PS_IIpp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_IIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,int.class,int.class,GLInternalFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_IIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,GLInternalFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_IIIIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLInternalFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_ILInternalFormat_IIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_ILInternalFormat_IIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_ILInternalFormat_IIIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_IIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,int.class,GLInternalFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_IIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,GLInternalFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_IIIIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLInternalFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_ILInternalFormat_IIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_ILInternalFormat_IIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_ILInternalFormat_IIIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,GLInternalFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_IIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,int.class,int.class,GLInternalFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IIIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,GLInternalFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_IIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,GLInternalFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IIIIIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLInternalFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_IIIIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLInternalFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LConvolutionTarget_LInternalFormat_ILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTarget.class,GLInternalFormat.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LConvolutionTargetEXT_LInternalFormat_ILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTargetEXT.class,GLInternalFormat.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LConvolutionTarget_LInternalFormat_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTarget.class,GLInternalFormat.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LConvolutionTargetEXT_LInternalFormat_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTargetEXT.class,GLInternalFormat.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LConvolutionTarget_LConvolutionParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTarget.class,GLConvolutionParameter.class,float.class); }
	static List<Class<?>> PS_LConvolutionTargetEXT_LConvolutionParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTargetEXT.class,GLConvolutionParameter.class,float.class); }
	static List<Class<?>> PS_LConvolutionTarget_LConvolutionParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTarget.class,GLConvolutionParameter.class,ConstPointer.class); }
	static List<Class<?>> PS_LConvolutionTargetEXT_LConvolutionParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTargetEXT.class,GLConvolutionParameter.class,ConstPointer.class); }
	static List<Class<?>> PS_LConvolutionTarget_LConvolutionParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTarget.class,GLConvolutionParameter.class,int.class); }
	static List<Class<?>> PS_LConvolutionTargetEXT_LConvolutionParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTargetEXT.class,GLConvolutionParameter.class,int.class); }
	static List<Class<?>> PS_LCopyBufferSubDataTarget_LCopyBufferSubDataTarget_JJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCopyBufferSubDataTarget.class,GLCopyBufferSubDataTarget.class,long.class,long.class,long.class); }
	static List<Class<?>> PS_LColorTableTarget_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTarget.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LColorTableTarget_LInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTarget.class,GLInternalFormat.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LColorTableTargetSGI_LInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTargetSGI.class,GLInternalFormat.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LConvolutionTarget_LInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTarget.class,GLInternalFormat.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LConvolutionTargetEXT_LInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTargetEXT.class,GLInternalFormat.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LConvolutionTarget_LInternalFormat_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTarget.class,GLInternalFormat.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LConvolutionTargetEXT_LInternalFormat_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTargetEXT.class,GLInternalFormat.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILCopyImageSubDataTarget_IIIIILCopyImageSubDataTarget_IIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLCopyImageSubDataTarget.class,int.class,int.class,int.class,int.class,int.class,GLCopyImageSubDataTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILCopyBufferSubDataTarget_IIIIILCopyBufferSubDataTarget_IIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLCopyBufferSubDataTarget.class,int.class,int.class,int.class,int.class,int.class,GLCopyBufferSubDataTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_IIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_IIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_IIJJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,long.class,long.class,long.class); }
	static List<Class<?>> PS_IIIILPixelCopyType_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,GLPixelCopyType.class); }
	static List<Class<?>> PS_LTextureTarget_ILInternalFormat_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_ILInternalFormat_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_IIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_IIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_EIIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILTextureTarget_ILInternalFormat_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILTextureTarget_ILInternalFormat_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_IIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILTextureTarget_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_IIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILTextureTarget_IIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_IIIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILTextureTarget_IIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILPathElementType_pILInstancedPathCoverMode_LPathTransformType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathElementType.class,ConstPointer.class,int.class,GLInstancedPathCoverMode.class,GLPathTransformType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILPathCoverMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathCoverMode.class); }
	static List<Class<?>> PS_Z(MethodHandles.Lookup l, String n, Class t) { return List.of(boolean.class); }
	static List<Class<?>> PS_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,MutPointer.class); }
	static List<Class<?>> PS_LQueryTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLQueryTarget.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LShaderType_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLShaderType.class); }
	static List<Class<?>> PS_LShaderType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLShaderType.class,ConstPointer.class); }
	static List<Class<?>> PS_LShaderType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLShaderType.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_PPI(MethodHandles.Lookup l, String n, Class t) { return List.of(MutPointer.class,MutPointer.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LCullParameterEXT_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCullParameterEXT.class,MutPointer.class); }
	static List<Class<?>> PS_LDebugSource_LDebugType_LDebugSeverity_IpZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLDebugSource.class,GLDebugType.class,GLDebugSeverity.class,int.class,ConstPointer.class,boolean.class); }
	static List<Class<?>> PS_ELDebugSeverity_IpZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,GLDebugSeverity.class,int.class,ConstPointer.class,boolean.class); }
	static List<Class<?>> PS_LDebugSource_LDebugType_ILDebugSeverity_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLDebugSource.class,GLDebugType.class,int.class,GLDebugSeverity.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ELDebugSeverity_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,GLDebugSeverity.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LFfdTargetSGIX_DDIIDDIIDDIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFfdTargetSGIX.class,double.class,double.class,int.class,int.class,double.class,double.class,int.class,int.class,double.class,double.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LFfdTargetSGIX_FFIIFFIIFFIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFfdTargetSGIX.class,float.class,float.class,int.class,int.class,float.class,float.class,int.class,int.class,float.class,float.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_EIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_DD(MethodHandles.Lookup l, String n, Class t) { return List.of(double.class,double.class); }
	static List<Class<?>> PS_LDepthFunction_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLDepthFunction.class); }
	static List<Class<?>> PS_IDD(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,double.class,double.class); }
	static List<Class<?>> PS_IFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,float.class,float.class); }
	static List<Class<?>> PS_FF(MethodHandles.Lookup l, String n, Class t) { return List.of(float.class,float.class); }
	static List<Class<?>> PS_LTextureTarget_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LEnableCap_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnableCap.class); }
	static List<Class<?>> PS_LEnableCap_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnableCap.class,int.class); }
	static List<Class<?>> PS_ILEnableCap_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnableCap.class); }
	static List<Class<?>> PS_IE(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class); }
	static List<Class<?>> PS_LFramebufferTarget_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_J(MethodHandles.Lookup l, String n, Class t) { return List.of(long.class); }
	static List<Class<?>> PS_LPrimitiveType_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,int.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,ConstPointer.class); }
	static List<Class<?>> PS_LPrimitiveType_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LDrawBufferMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLDrawBufferMode.class); }
	static List<Class<?>> PS_EppI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,ConstPointer.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_EIppI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,ConstPointer.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_ppppI(MethodHandles.Lookup l, String n, Class t) { return List.of(ConstPointer.class,ConstPointer.class,ConstPointer.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_IppppI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class,ConstPointer.class,ConstPointer.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_ILDrawElementsType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,int.class,GLDrawElementsType.class,ConstPointer.class); }
	static List<Class<?>> PS_LPrimitiveType_ILDrawElementsType_pI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,int.class,GLDrawElementsType.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_LDrawElementsType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,GLDrawElementsType.class,ConstPointer.class); }
	static List<Class<?>> PS_LPrimitiveType_ILDrawElementsType_pII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,int.class,GLDrawElementsType.class,ConstPointer.class,int.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_ILDrawElementsType_pIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,int.class,GLDrawElementsType.class,ConstPointer.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_IIILDrawElementsType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,int.class,int.class,int.class,GLDrawElementsType.class,ConstPointer.class); }
	static List<Class<?>> PS_LPrimitiveType_IIILDrawElementsType_pI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,int.class,int.class,int.class,GLDrawElementsType.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_FFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_SSSSS(MethodHandles.Lookup l, String n, Class t) { return List.of(short.class,short.class,short.class,short.class,short.class); }
	static List<Class<?>> PS_IIFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,MutPointer.class,int.class); }
	static List<Class<?>> PS_LElementPointerTypeATI_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLElementPointerTypeATI.class,ConstPointer.class); }
	static List<Class<?>> PS_LQueryTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLQueryTarget.class); }
	static List<Class<?>> PS_LEvalTargetNV_LEvalMapsModeNV_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEvalTargetNV.class,GLEvalMapsModeNV.class); }
	static List<Class<?>> PS_LMeshMode1_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMeshMode1.class,int.class,int.class); }
	static List<Class<?>> PS_LMeshMode2_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMeshMode2.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LVertexAttribEnumNV_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexAttribEnumNV.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_EP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,MutPointer.class); }
	static List<Class<?>> PS_PIP(MethodHandles.Lookup l, String n, Class t) { return List.of(MutPointer.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILShaderType_PP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLShaderType.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_IEIEP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,int.class,GLEnum.class,MutPointer.class); }
	static List<Class<?>> PS_EIIIIIIILPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,MutPointer.class); }
	static List<Class<?>> PS_ILFeedbackType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFeedbackType.class,MutPointer.class); }
	static List<Class<?>> PS_IEp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,ConstPointer.class); }
	static List<Class<?>> PS_LSyncCondition_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLSyncCondition.class,int.class); }
	static List<Class<?>> PS_LCombinerVariableNV_LCombinerRegisterNV_LCombinerMappingNV_LCombinerComponentUsageNV_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCombinerVariableNV.class,GLCombinerRegisterNV.class,GLCombinerMappingNV.class,GLCombinerComponentUsageNV.class); }
	static List<Class<?>> PS_P(MethodHandles.Lookup l, String n, Class t) { return List.of(MutPointer.class); }
	static List<Class<?>> PS_LObjectTypeAPPLE_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLObjectTypeAPPLE.class,int.class); }
	static List<Class<?>> PS_LBufferTarget_JJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,long.class,long.class); }
	static List<Class<?>> PS_IJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,long.class); }
	static List<Class<?>> PS_LPixelDataRangeTargetNV_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelDataRangeTargetNV.class); }
	static List<Class<?>> PS_LFogPointerTypeEXT_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFogPointerTypeEXT.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LFogPointerTypeIBM_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFogPointerTypeIBM.class,int.class,MutPointer.class,int.class); }
	static List<Class<?>> PS_C(MethodHandles.Lookup l, String n, Class t) { return List.of(char.class); }
	static List<Class<?>> PS_LFogParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFogParameter.class,float.class); }
	static List<Class<?>> PS_LFogParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFogParameter.class,ConstPointer.class); }
	static List<Class<?>> PS_LFogParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFogParameter.class,int.class); }
	static List<Class<?>> PS_LFogPName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFogPName.class,int.class); }
	static List<Class<?>> PS_LFogPName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFogPName.class,ConstPointer.class); }
	static List<Class<?>> PS_LFragmentLightModelParameterSGIX_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentLightModelParameterSGIX.class,float.class); }
	static List<Class<?>> PS_LFragmentLightModelParameterSGIX_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentLightModelParameterSGIX.class,ConstPointer.class); }
	static List<Class<?>> PS_LFragmentLightModelParameterSGIX_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentLightModelParameterSGIX.class,int.class); }
	static List<Class<?>> PS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentLightNameSGIX.class,GLFragmentLightParameterSGIX.class,float.class); }
	static List<Class<?>> PS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentLightNameSGIX.class,GLFragmentLightParameterSGIX.class,ConstPointer.class); }
	static List<Class<?>> PS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentLightNameSGIX.class,GLFragmentLightParameterSGIX.class,int.class); }
	static List<Class<?>> PS_LTriangleFace_LMaterialParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTriangleFace.class,GLMaterialParameter.class,float.class); }
	static List<Class<?>> PS_LTriangleFace_LMaterialParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTriangleFace.class,GLMaterialParameter.class,ConstPointer.class); }
	static List<Class<?>> PS_LTriangleFace_LMaterialParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTriangleFace.class,GLMaterialParameter.class,int.class); }
	static List<Class<?>> PS_ILDrawBufferMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLDrawBufferMode.class); }
	static List<Class<?>> PS_IIIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_IIIFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferParameterName.class,int.class); }
	static List<Class<?>> PS_ILReadBufferMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLReadBufferMode.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferAttachment_LRenderbufferTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferAttachment.class,GLRenderbufferTarget.class,int.class); }
	static List<Class<?>> PS_LFramebufferTarget_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferAttachment_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferAttachment.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferAttachment_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferAttachment.class,int.class,int.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferAttachment.class,GLTextureTarget.class,int.class,int.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferAttachment.class,GLTextureTarget.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferAttachment.class,GLTextureTarget.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferAttachment_IILTextureTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferAttachment.class,int.class,int.class,GLTextureTarget.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferAttachment_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferAttachment.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferAttachment_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferAttachment.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LFrontFaceDirection_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFrontFaceDirection.class); }
	static List<Class<?>> PS_DDDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(double.class,double.class,double.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_EIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LDataTypeEXT_LVertexShaderStorageTypeEXT_LParameterRangeEXT_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLDataTypeEXT.class,GLVertexShaderStorageTypeEXT.class,GLParameterRangeEXT.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class); }
	static List<Class<?>> PS_ILTextureTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class); }
	static List<Class<?>> PS_IILAtomicCounterBufferPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLAtomicCounterBufferPName.class,MutPointer.class); }
	static List<Class<?>> PS_IIIPPPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,MutPointer.class,MutPointer.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_ILShaderType_IIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLShaderType.class,int.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_ILShaderType_ILSubroutineParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLShaderType.class,int.class,GLSubroutineParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_IIIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_IILUniformBlockPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLUniformBlockPName.class,MutPointer.class); }
	static List<Class<?>> PS_IIpLUniformPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,ConstPointer.class,GLUniformPName.class,MutPointer.class); }
	static List<Class<?>> PS_LEnableCap_LArrayObjectPNameATI_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnableCap.class,GLArrayObjectPNameATI.class,MutPointer.class); }
	static List<Class<?>> PS_IIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_LBufferTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LGetPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLGetPName.class,MutPointer.class); }
	static List<Class<?>> PS_LBufferTarget_LBufferPNameARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,GLBufferPNameARB.class,MutPointer.class); }
	static List<Class<?>> PS_LBufferTarget_EP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,GLEnum.class,MutPointer.class); }
	static List<Class<?>> PS_LBufferTarget_LBufferPointerNameARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,GLBufferPointerNameARB.class,MutPointer.class); }
	static List<Class<?>> PS_LBufferTarget_JJP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,long.class,long.class,MutPointer.class); }
	static List<Class<?>> PS_LClipPlaneName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLClipPlaneName.class,MutPointer.class); }
	static List<Class<?>> PS_LColorTableTarget_LPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTarget.class,GLPixelFormat.class,GLPixelType.class,MutPointer.class); }
	static List<Class<?>> PS_LColorTableTarget_LColorTableParameterPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTarget.class,GLColorTableParameterPName.class,MutPointer.class); }
	static List<Class<?>> PS_LColorTableTargetSGI_LColorTableParameterPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTargetSGI.class,GLColorTableParameterPName.class,MutPointer.class); }
	static List<Class<?>> PS_LColorTableTargetSGI_LPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTargetSGI.class,GLPixelFormat.class,GLPixelType.class,MutPointer.class); }
	static List<Class<?>> PS_LCombinerStageNV_LCombinerPortionNV_LCombinerVariableNV_LCombinerParameterNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCombinerStageNV.class,GLCombinerPortionNV.class,GLCombinerVariableNV.class,GLCombinerParameterNV.class,MutPointer.class); }
	static List<Class<?>> PS_LCombinerStageNV_LCombinerPortionNV_LCombinerParameterNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCombinerStageNV.class,GLCombinerPortionNV.class,GLCombinerParameterNV.class,MutPointer.class); }
	static List<Class<?>> PS_LCombinerStageNV_LCombinerParameterNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCombinerStageNV.class,GLCombinerParameterNV.class,MutPointer.class); }
	static List<Class<?>> PS_LCommandOpcodesNV_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCommandOpcodesNV.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_IIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_IIIIIIIIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LConvolutionTarget_LPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTarget.class,GLPixelFormat.class,GLPixelType.class,MutPointer.class); }
	static List<Class<?>> PS_LConvolutionTargetEXT_LPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTargetEXT.class,GLPixelFormat.class,GLPixelType.class,MutPointer.class); }
	static List<Class<?>> PS_LConvolutionTarget_LConvolutionParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTarget.class,GLConvolutionParameter.class,MutPointer.class); }
	static List<Class<?>> PS_LConvolutionTargetEXT_LConvolutionParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTargetEXT.class,GLConvolutionParameter.class,MutPointer.class); }
	static List<Class<?>> PS_EEP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,GLEnum.class,MutPointer.class); }
	static List<Class<?>> PS_IIPPPPPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,MutPointer.class,MutPointer.class,MutPointer.class,MutPointer.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_IIPPPPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,MutPointer.class,MutPointer.class,MutPointer.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureTarget_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,MutPointer.class); }
	static List<Class<?>> PS_LGetPName_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLGetPName.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILFenceParameterNameNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFenceParameterNameNV.class,MutPointer.class); }
	static List<Class<?>> PS_LCombinerVariableNV_LCombinerParameterNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLCombinerVariableNV.class,GLCombinerParameterNV.class,MutPointer.class); }
	static List<Class<?>> PS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFragmentLightNameSGIX.class,GLFragmentLightParameterSGIX.class,MutPointer.class); }
	static List<Class<?>> PS_LTriangleFace_LMaterialParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTriangleFace.class,GLMaterialParameter.class,MutPointer.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferAttachment_LFramebufferAttachmentParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferAttachment.class,GLFramebufferAttachmentParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferAttachmentParameterName_IIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferAttachmentParameterName.class,int.class,int.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LFramebufferTarget_LFramebufferAttachmentParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,GLFramebufferAttachmentParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_ILGetFramebufferParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLGetFramebufferParameter.class,MutPointer.class); }
	static List<Class<?>> PS_LContainerType_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLContainerType.class); }
	static List<Class<?>> PS_LHistogramTargetEXT_ZLPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLHistogramTargetEXT.class,boolean.class,GLPixelFormat.class,GLPixelType.class,MutPointer.class); }
	static List<Class<?>> PS_LHistogramTargetEXT_LGetHistogramParameterPNameEXT_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLHistogramTargetEXT.class,GLGetHistogramParameterPNameEXT.class,MutPointer.class); }
	static List<Class<?>> PS_IIZILPixelFormat_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,boolean.class,int.class,GLPixelFormat.class); }
	static List<Class<?>> PS_LImageTransformTargetHP_LImageTransformPNameHP_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLImageTransformTargetHP.class,GLImageTransformPNameHP.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureTarget_LInternalFormat_ILInternalFormatPName_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLInternalFormat.class,int.class,GLInternalFormatPName.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureTarget_LInternalFormat_LInternalFormatPName_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLInternalFormat.class,GLInternalFormatPName.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILGetVariantValueEXT_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLGetVariantValueEXT.class,MutPointer.class); }
	static List<Class<?>> PS_LLightName_LLightParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLLightName.class,GLLightParameter.class,MutPointer.class); }
	static List<Class<?>> PS_ILListParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLListParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_LEvalTargetNV_ILMapAttribParameterNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEvalTargetNV.class,int.class,GLMapAttribParameterNV.class,MutPointer.class); }
	static List<Class<?>> PS_LEvalTargetNV_ILMapTypeNV_IIZP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEvalTargetNV.class,int.class,GLMapTypeNV.class,int.class,int.class,boolean.class,MutPointer.class); }
	static List<Class<?>> PS_LEvalTargetNV_LMapParameterNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEvalTargetNV.class,GLMapParameterNV.class,MutPointer.class); }
	static List<Class<?>> PS_LMapTarget_LGetMapQuery_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMapTarget.class,GLGetMapQuery.class,MutPointer.class); }
	static List<Class<?>> PS_IEIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,int.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILMemoryObjectParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLMemoryObjectParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_LMinmaxTargetEXT_ZLPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMinmaxTargetEXT.class,boolean.class,GLPixelFormat.class,GLPixelType.class,MutPointer.class); }
	static List<Class<?>> PS_LMinmaxTargetEXT_LGetMinmaxParameterPNameEXT_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMinmaxTargetEXT.class,GLGetMinmaxParameterPNameEXT.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureEnvTarget.class,GLTextureEnvParameter.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureCoordName.class,GLTextureGenParameter.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_ILPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,GLPixelFormat.class,GLPixelType.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_ILGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,GLGetTextureParameter.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_LGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,GLGetTextureParameter.class,MutPointer.class); }
	static List<Class<?>> PS_LGetMultisamplePNameNV_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLGetMultisamplePNameNV.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILBufferPNameARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLBufferPNameARB.class,MutPointer.class); }
	static List<Class<?>> PS_ILBufferPointerNameARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLBufferPointerNameARB.class,MutPointer.class); }
	static List<Class<?>> PS_IJJP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,long.class,MutPointer.class); }
	static List<Class<?>> PS_IEIIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,int.class,int.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILFramebufferAttachment_LFramebufferAttachmentParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFramebufferAttachment.class,GLFramebufferAttachmentParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_ILProgramTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramTarget.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILProgramTarget_LProgramStringProperty_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramTarget.class,GLProgramStringProperty.class,MutPointer.class); }
	static List<Class<?>> PS_ILProgramTarget_LProgramPropertyARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramTarget.class,GLProgramPropertyARB.class,MutPointer.class); }
	static List<Class<?>> PS_ILRenderbufferParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLRenderbufferParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_IpIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_IpEP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class,GLEnum.class,MutPointer.class); }
	static List<Class<?>> PS_ILArrayObjectPNameATI_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLArrayObjectPNameATI.class,MutPointer.class); }
	static List<Class<?>> PS_LObjectIdentifier_IIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLObjectIdentifier.class,int.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_EIIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_IEP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,MutPointer.class); }
	static List<Class<?>> PS_EIEP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,GLEnum.class,MutPointer.class); }
	static List<Class<?>> PS_pIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(ConstPointer.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_ILOcclusionQueryParameterNameNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLOcclusionQueryParameterNameNV.class,MutPointer.class); }
	static List<Class<?>> PS_LPathColor_LPathGenMode_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPathColor.class,GLPathGenMode.class,MutPointer.class); }
	static List<Class<?>> PS_IILPathElementType_pIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLPathElementType.class,ConstPointer.class,int.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILPathParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathParameter.class,MutPointer.class); }
	static List<Class<?>> PS_LPathListMode_ILPathElementType_pIFFLPathTransformType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPathListMode.class,int.class,GLPathElementType.class,ConstPointer.class,int.class,float.class,float.class,GLPathTransformType.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LPathGenMode_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLPathGenMode.class,MutPointer.class); }
	static List<Class<?>> PS_IIIPIPPPPPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,MutPointer.class,int.class,MutPointer.class,MutPointer.class,MutPointer.class,MutPointer.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_IEIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_IIEP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLEnum.class,MutPointer.class); }
	static List<Class<?>> PS_IPPIP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,MutPointer.class,MutPointer.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_PP(MethodHandles.Lookup l, String n, Class t) { return List.of(MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_LPixelMap_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelMap.class,MutPointer.class); }
	static List<Class<?>> PS_LPixelMap_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelMap.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LPixelTexGenParameterNameSGIS_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelTexGenParameterNameSGIS.class,MutPointer.class); }
	static List<Class<?>> PS_LGetPointervPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLGetPointervPName.class,MutPointer.class); }
	static List<Class<?>> PS_IIPPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,MutPointer.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_LProgramTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLProgramTarget.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILProgramInterface_LProgramInterfacePName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramInterface.class,GLProgramInterfacePName.class,MutPointer.class); }
	static List<Class<?>> PS_IIpP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,ConstPointer.class,MutPointer.class); }
	static List<Class<?>> PS_LVertexAttribEnumNV_ILVertexAttribEnumNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexAttribEnumNV.class,int.class,GLVertexAttribEnumNV.class,MutPointer.class); }
	static List<Class<?>> PS_ILPipelineParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPipelineParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_ILProgramInterface_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramInterface.class,ConstPointer.class); }
	static List<Class<?>> PS_ILProgramInterface_IIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramInterface.class,int.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_ILProgramInterface_IIpIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramInterface.class,int.class,int.class,ConstPointer.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_ILShaderType_LProgramStagePName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLShaderType.class,GLProgramStagePName.class,MutPointer.class); }
	static List<Class<?>> PS_LProgramTarget_LProgramStringProperty_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLProgramTarget.class,GLProgramStringProperty.class,MutPointer.class); }
	static List<Class<?>> PS_ILVertexAttribEnumNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexAttribEnumNV.class,MutPointer.class); }
	static List<Class<?>> PS_ILProgramPropertyARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramPropertyARB.class,MutPointer.class); }
	static List<Class<?>> PS_LProgramTarget_LProgramPropertyARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLProgramTarget.class,GLProgramPropertyARB.class,MutPointer.class); }
	static List<Class<?>> PS_IILQueryObjectParameterName_J(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLQueryObjectParameterName.class,long.class); }
	static List<Class<?>> PS_LQueryTarget_ILQueryParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLQueryTarget.class,int.class,GLQueryParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_ILQueryObjectParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLQueryObjectParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_LQueryTarget_LQueryParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLQueryTarget.class,GLQueryParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_LRenderbufferTarget_LRenderbufferParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLRenderbufferTarget.class,GLRenderbufferParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_ILSamplerParameterI_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSamplerParameterI.class,MutPointer.class); }
	static List<Class<?>> PS_ILSamplerParameterF_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSamplerParameterF.class,MutPointer.class); }
	static List<Class<?>> PS_ILSemaphoreParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSemaphoreParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_LSeparableTargetEXT_LPixelFormat_LPixelType_PPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLSeparableTargetEXT.class,GLPixelFormat.class,GLPixelType.class,MutPointer.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_LShaderType_LPrecisionType_PP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLShaderType.class,GLPrecisionType.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_ILShaderParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLShaderParameterName.class,MutPointer.class); }
	static List<Class<?>> PS_IIP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_EIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LStringName_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLStringName.class); }
	static List<Class<?>> PS_LStringName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLStringName.class,int.class); }
	static List<Class<?>> PS_ILShaderType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLShaderType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILSyncParameterName_IPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSyncParameterName.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_LGetTexBumpParameterATI_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLGetTexBumpParameterATI.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureEnvTarget_LTextureEnvParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureEnvTarget.class,GLTextureEnvParameter.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureTarget_LTextureFilterSGIS_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLTextureFilterSGIS.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureCoordName_LTextureGenParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureCoordName.class,GLTextureGenParameter.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureTarget_ILPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLPixelFormat.class,GLPixelType.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureTarget_ILGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLGetTextureParameter.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureTarget_LGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLGetTextureParameter.class,MutPointer.class); }
	static List<Class<?>> PS_IILPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLPixelFormat.class,GLPixelType.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_ILPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLPixelFormat.class,GLPixelType.class,MutPointer.class); }
	static List<Class<?>> PS_IILGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLGetTextureParameter.class,MutPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_ILGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLGetTextureParameter.class,MutPointer.class); }
	static List<Class<?>> PS_ILGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLGetTextureParameter.class,MutPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_LGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,GLGetTextureParameter.class,MutPointer.class); }
	static List<Class<?>> PS_IIIIIIIILPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILTransformFeedbackPName_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTransformFeedbackPName.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILTransformFeedbackPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTransformFeedbackPName.class,MutPointer.class); }
	static List<Class<?>> PS_LShaderType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLShaderType.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_IILVertexArrayPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLVertexArrayPName.class,MutPointer.class); }
	static List<Class<?>> PS_ILVertexArrayPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexArrayPName.class,MutPointer.class); }
	static List<Class<?>> PS_ILVertexAttribEnum_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexAttribEnum.class,MutPointer.class); }
	static List<Class<?>> PS_ILVertexAttribPointerPropertyARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexAttribPointerPropertyARB.class,MutPointer.class); }
	static List<Class<?>> PS_ILVertexAttribPropertyARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexAttribPropertyARB.class,MutPointer.class); }
	static List<Class<?>> PS_LColorTableTarget_LPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLColorTableTarget.class,GLPixelFormat.class,GLPixelType.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureTarget_IIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LConvolutionTarget_LPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLConvolutionTarget.class,GLPixelFormat.class,GLPixelType.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LHistogramTarget_ZLPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLHistogramTarget.class,boolean.class,GLPixelFormat.class,GLPixelType.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LHistogramTargetEXT_ZLPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLHistogramTargetEXT.class,boolean.class,GLPixelFormat.class,GLPixelType.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LMapTarget_LMapQuery_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMapTarget.class,GLMapQuery.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LMinmaxTarget_ZLPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMinmaxTarget.class,boolean.class,GLPixelFormat.class,GLPixelType.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LMinmaxTargetEXT_ZLPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMinmaxTargetEXT.class,boolean.class,GLPixelFormat.class,GLPixelType.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_LSeparableTarget_LPixelFormat_LPixelType_IPIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLSeparableTarget.class,GLPixelFormat.class,GLPixelType.class,int.class,MutPointer.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_LSeparableTargetEXT_LPixelFormat_LPixelType_IPIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLSeparableTargetEXT.class,GLPixelFormat.class,GLPixelType.class,int.class,MutPointer.class,int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_LTextureTarget_ILPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLPixelFormat.class,GLPixelType.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_B(MethodHandles.Lookup l, String n, Class t) { return List.of(byte.class); }
	static List<Class<?>> PS_S(MethodHandles.Lookup l, String n, Class t) { return List.of(short.class); }
	static List<Class<?>> PS_LHintTarget_LHintMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLHintTarget.class,GLHintMode.class); }
	static List<Class<?>> PS_LHintTargetPGI_LVertexHintsMaskPGI_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLHintTargetPGI.class,GLVertexHintsMaskPGI.class); }
	static List<Class<?>> PS_LHistogramTargetEXT_ILInternalFormat_Z(MethodHandles.Lookup l, String n, Class t) { return List.of(GLHistogramTargetEXT.class,int.class,GLInternalFormat.class,boolean.class); }
	static List<Class<?>> PS_Ep(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,ConstPointer.class); }
	static List<Class<?>> PS_LImageTransformTargetHP_LImageTransformPNameHP_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLImageTransformTargetHP.class,GLImageTransformPNameHP.class,float.class); }
	static List<Class<?>> PS_LImageTransformTargetHP_LImageTransformPNameHP_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLImageTransformTargetHP.class,GLImageTransformPNameHP.class,ConstPointer.class); }
	static List<Class<?>> PS_LImageTransformTargetHP_LImageTransformPNameHP_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLImageTransformTargetHP.class,GLImageTransformPNameHP.class,int.class); }
	static List<Class<?>> PS_IJLExternalHandleType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,GLExternalHandleType.class,int.class); }
	static List<Class<?>> PS_IJLExternalHandleType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,GLExternalHandleType.class,MutPointer.class); }
	static List<Class<?>> PS_IJLExternalHandleType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,GLExternalHandleType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILExternalHandleType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLExternalHandleType.class,int.class); }
	static List<Class<?>> PS_ILExternalHandleType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLExternalHandleType.class,MutPointer.class); }
	static List<Class<?>> PS_ILExternalHandleType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLExternalHandleType.class,ConstPointer.class); }
	static List<Class<?>> PS_EJI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,long.class,int.class); }
	static List<Class<?>> PS_LIndexFunctionEXT_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLIndexFunctionEXT.class,float.class); }
	static List<Class<?>> PS_LTriangleFace_LIndexMaterialParameterEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTriangleFace.class,GLIndexMaterialParameterEXT.class); }
	static List<Class<?>> PS_LIndexPointerType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLIndexPointerType.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LIndexPointerType_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLIndexPointerType.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LIndexPointerType_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLIndexPointerType.class,int.class,MutPointer.class,int.class); }
	static List<Class<?>> PS_LInterleavedArrayFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLInterleavedArrayFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IIIF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,float.class); }
	static List<Class<?>> PS_IIpIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,ConstPointer.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LFramebufferTarget_IpIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLFramebufferTarget.class,int.class,ConstPointer.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_IIFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,float.class,float.class); }
	static List<Class<?>> PS_ILVariantCapEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVariantCapEXT.class); }
	static List<Class<?>> PS_IIIEIIIIIEIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,GLEnum.class,int.class,int.class,int.class,int.class,int.class,GLEnum.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_IIJJp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,long.class,long.class,ConstPointer.class); }
	static List<Class<?>> PS_EIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LLightEnvParameterSGIX_LLightEnvModeSGIX_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLLightEnvParameterSGIX.class,GLLightEnvModeSGIX.class); }
	static List<Class<?>> PS_LLightModelParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLLightModelParameter.class,float.class); }
	static List<Class<?>> PS_LLightModelParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLLightModelParameter.class,ConstPointer.class); }
	static List<Class<?>> PS_LLightModelParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLLightModelParameter.class,int.class); }
	static List<Class<?>> PS_LLightName_LLightParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLLightName.class,GLLightParameter.class,float.class); }
	static List<Class<?>> PS_LLightName_LLightParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLLightName.class,GLLightParameter.class,ConstPointer.class); }
	static List<Class<?>> PS_LLightName_LLightParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLLightName.class,GLLightParameter.class,int.class); }
	static List<Class<?>> PS_IC(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,char.class); }
	static List<Class<?>> PS_IIPpppI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,MutPointer.class,ConstPointer.class,ConstPointer.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_ILListParameterName_F(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLListParameterName.class,float.class); }
	static List<Class<?>> PS_ILListParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLListParameterName.class,ConstPointer.class); }
	static List<Class<?>> PS_ILListParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLListParameterName.class,int.class); }
	static List<Class<?>> PS_LVertexAttribEnumNV_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexAttribEnumNV.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LLogicOp_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLLogicOp.class); }
	static List<Class<?>> PS_JE(MethodHandles.Lookup l, String n, Class t) { return List.of(long.class,GLEnum.class); }
	static List<Class<?>> PS_LMapTarget_DDIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMapTarget.class,double.class,double.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LMapTarget_FFIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMapTarget.class,float.class,float.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LMapTarget_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMapTarget.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LMapTarget_DDIIDDIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMapTarget.class,double.class,double.class,int.class,int.class,double.class,double.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LMapTarget_FFIIFFIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMapTarget.class,float.class,float.class,int.class,int.class,float.class,float.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LMapTarget_IIIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMapTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LBufferTarget_LBufferAccess_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,GLBufferAccess.class); }
	static List<Class<?>> PS_LBufferTarget_JJI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class,long.class,long.class,int.class); }
	static List<Class<?>> PS_LEvalTargetNV_ILMapTypeNV_IIIIZp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEvalTargetNV.class,int.class,GLMapTypeNV.class,int.class,int.class,int.class,int.class,boolean.class,ConstPointer.class); }
	static List<Class<?>> PS_IDDIDD(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,double.class,double.class,int.class,double.class,double.class); }
	static List<Class<?>> PS_IFFIFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,float.class,float.class,int.class,float.class,float.class); }
	static List<Class<?>> PS_ILBufferAccess_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLBufferAccess.class); }
	static List<Class<?>> PS_IJJI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,long.class,int.class); }
	static List<Class<?>> PS_LEvalTargetNV_LMapParameterNV_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEvalTargetNV.class,GLMapParameterNV.class,ConstPointer.class); }
	static List<Class<?>> PS_IIDDIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,double.class,double.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IIFFIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,float.class,float.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IIDDIIDDIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,double.class,double.class,int.class,int.class,double.class,double.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IIFFIIFFIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,float.class,float.class,int.class,int.class,float.class,float.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LMatrixMode_DDDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMatrixMode.class,double.class,double.class,double.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_ILMatrixIndexPointerTypeARB_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLMatrixIndexPointerTypeARB.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LMatrixMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMatrixMode.class); }
	static List<Class<?>> PS_LMatrixMode_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMatrixMode.class,ConstPointer.class); }
	static List<Class<?>> PS_LMatrixMode_DDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMatrixMode.class,double.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_LMatrixMode_FFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMatrixMode.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_LMatrixMode_DDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMatrixMode.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_LMatrixMode_FFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMatrixMode.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_ILMemoryObjectParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLMemoryObjectParameterName.class,ConstPointer.class); }
	static List<Class<?>> PS_LMinmaxTargetEXT_LInternalFormat_Z(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMinmaxTargetEXT.class,GLInternalFormat.class,boolean.class); }
	static List<Class<?>> PS_LPrimitiveType_ppI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,ConstPointer.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_pII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,ConstPointer.class,int.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_pIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,ConstPointer.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_pIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,ConstPointer.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_pJII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,ConstPointer.class,long.class,int.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_pLDrawElementsType_pI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,ConstPointer.class,GLDrawElementsType.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_pLDrawElementsType_pIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,ConstPointer.class,GLDrawElementsType.class,ConstPointer.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LPrimitiveType_LDrawElementsType_pII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,GLDrawElementsType.class,ConstPointer.class,int.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_LDrawElementsType_pIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,GLDrawElementsType.class,ConstPointer.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_LDrawElementsType_pIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,GLDrawElementsType.class,ConstPointer.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_LDrawElementsType_pJII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,GLDrawElementsType.class,ConstPointer.class,long.class,int.class,int.class); }
	static List<Class<?>> PS_JII(MethodHandles.Lookup l, String n, Class t) { return List.of(long.class,int.class,int.class); }
	static List<Class<?>> PS_JJII(MethodHandles.Lookup l, String n, Class t) { return List.of(long.class,long.class,int.class,int.class); }
	static List<Class<?>> PS_LPrimitiveType_IIppI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPrimitiveType.class,int.class,int.class,ConstPointer.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_pppII(MethodHandles.Lookup l, String n, Class t) { return List.of(ConstPointer.class,ConstPointer.class,ConstPointer.class,int.class,int.class); }
	static List<Class<?>> PS_ppLDrawElementsType_pII(MethodHandles.Lookup l, String n, Class t) { return List.of(ConstPointer.class,ConstPointer.class,GLDrawElementsType.class,ConstPointer.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_LInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,GLInternalFormat.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_B(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,byte.class); }
	static List<Class<?>> PS_LTextureUnit_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_D(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,double.class); }
	static List<Class<?>> PS_LTextureUnit_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,float.class); }
	static List<Class<?>> PS_LTextureUnit_C(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,char.class); }
	static List<Class<?>> PS_LTextureUnit_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_S(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,short.class); }
	static List<Class<?>> PS_LTextureUnit_BB(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,byte.class,byte.class); }
	static List<Class<?>> PS_LTextureUnit_DD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,double.class,double.class); }
	static List<Class<?>> PS_LTextureUnit_FF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,float.class,float.class); }
	static List<Class<?>> PS_LTextureUnit_CC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,char.class,char.class); }
	static List<Class<?>> PS_LTextureUnit_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_SS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,short.class,short.class); }
	static List<Class<?>> PS_LTextureUnit_BBB(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,byte.class,byte.class,byte.class); }
	static List<Class<?>> PS_LTextureUnit_DDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_LTextureUnit_FFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_LTextureUnit_CCC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,char.class,char.class,char.class); }
	static List<Class<?>> PS_LTextureUnit_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_SSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,short.class,short.class,short.class); }
	static List<Class<?>> PS_LTextureUnit_BBBB(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,byte.class,byte.class,byte.class,byte.class); }
	static List<Class<?>> PS_LTextureUnit_DDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,double.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_LTextureUnit_FFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_LTextureUnit_CCCC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,char.class,char.class,char.class,char.class); }
	static List<Class<?>> PS_LTextureUnit_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_SSSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,short.class,short.class,short.class,short.class); }
	static List<Class<?>> PS_LTextureUnit_LTexCoordPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTexCoordPointerType.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LTexCoordPointerType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTexCoordPointerType.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_ILTexCoordPointerType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,int.class,GLTexCoordPointerType.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureEnvTarget.class,GLTextureEnvParameter.class,float.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureEnvTarget.class,GLTextureEnvParameter.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureEnvTarget.class,GLTextureEnvParameter.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_D(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureCoordName.class,GLTextureGenParameter.class,double.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureCoordName.class,GLTextureGenParameter.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureCoordName.class,GLTextureGenParameter.class,float.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureCoordName_LTextureGenParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureCoordName.class,GLTextureGenParameter.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_ILInternalFormat_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_LTextureParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,GLTextureParameterName.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_LTextureParameterName_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,GLTextureParameterName.class,float.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_LTextureParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,GLTextureParameterName.class,int.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_IIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_IIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureUnit_LTextureTarget_IIIIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureUnit.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_IIIIIIIIIIIE(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLEnum.class); }
	static List<Class<?>> PS_IIIIJJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,long.class,long.class,long.class); }
	static List<Class<?>> PS_IIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IJpLVertexBufferObjectUsage_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,ConstPointer.class,GLVertexBufferObjectUsage.class); }
	static List<Class<?>> PS_IJJZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,long.class,boolean.class); }
	static List<Class<?>> PS_IJJIJZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,long.class,int.class,long.class,boolean.class); }
	static List<Class<?>> PS_IJpI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_IJJII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,long.class,int.class,int.class); }
	static List<Class<?>> PS_IJIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,int.class,long.class); }
	static List<Class<?>> PS_IJJp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,long.class,ConstPointer.class); }
	static List<Class<?>> PS_ILColorBuffer_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLColorBuffer.class); }
	static List<Class<?>> PS_ILFramebufferParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFramebufferParameterName.class,int.class); }
	static List<Class<?>> PS_ILFramebufferAttachment_LRenderbufferTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFramebufferAttachment.class,GLRenderbufferTarget.class,int.class); }
	static List<Class<?>> PS_ILFramebufferAttachment_II(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFramebufferAttachment.class,int.class,int.class); }
	static List<Class<?>> PS_ILFramebufferAttachment_LTextureTarget_II(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFramebufferAttachment.class,GLTextureTarget.class,int.class,int.class); }
	static List<Class<?>> PS_ILFramebufferAttachment_LTextureTarget_III(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFramebufferAttachment.class,GLTextureTarget.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILFramebufferAttachment_IILTextureTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFramebufferAttachment.class,int.class,int.class,GLTextureTarget.class); }
	static List<Class<?>> PS_ILFramebufferAttachment_III(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFramebufferAttachment.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILFramebufferAttachment_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFramebufferAttachment.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILProgramTarget_IDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramTarget.class,int.class,double.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_ILProgramTarget_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramTarget.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILProgramTarget_IFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramTarget.class,int.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_ILProgramTarget_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramTarget.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILProgramTarget_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramTarget.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILProgramTarget_LProgramFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramTarget.class,GLProgramFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLInternalFormat.class,int.class,int.class); }
	static List<Class<?>> PS_IILInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLInternalFormat.class,int.class,int.class); }
	static List<Class<?>> PS_IIILInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,GLInternalFormat.class,int.class,int.class); }
	static List<Class<?>> PS_EIpIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,ConstPointer.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILListMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLListMode.class); }
	static List<Class<?>> PS_IpLArrayObjectUsageATI_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class,GLArrayObjectUsageATI.class); }
	static List<Class<?>> PS_LNormalPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLNormalPointerType.class,int.class); }
	static List<Class<?>> PS_LNormalPointerType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLNormalPointerType.class,ConstPointer.class); }
	static List<Class<?>> PS_LNormalPointerType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLNormalPointerType.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LNormalPointerType_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLNormalPointerType.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LNormalPointerType_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLNormalPointerType.class,int.class,MutPointer.class,int.class); }
	static List<Class<?>> PS_LNormalPointerType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLNormalPointerType.class,MutPointer.class); }
	static List<Class<?>> PS_LVertexStreamATI_BBB(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,byte.class,byte.class,byte.class); }
	static List<Class<?>> PS_LVertexStreamATI_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,ConstPointer.class); }
	static List<Class<?>> PS_LVertexStreamATI_DDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_LVertexStreamATI_FFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_LVertexStreamATI_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LVertexStreamATI_SSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,short.class,short.class,short.class); }
	static List<Class<?>> PS_LObjectIdentifier_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLObjectIdentifier.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_pIp(MethodHandles.Lookup l, String n, Class t) { return List.of(ConstPointer.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_EIE(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,GLEnum.class); }
	static List<Class<?>> PS_LPNTrianglesPNameATI_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPNTrianglesPNameATI.class,float.class); }
	static List<Class<?>> PS_LPNTrianglesPNameATI_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPNTrianglesPNameATI.class,int.class); }
	static List<Class<?>> PS_IILSwizzleOpATI_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLSwizzleOpATI.class); }
	static List<Class<?>> PS_LPatchParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPatchParameterName.class,ConstPointer.class); }
	static List<Class<?>> PS_LPatchParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPatchParameterName.class,int.class); }
	static List<Class<?>> PS_LPathColor_LPathGenMode_LPathColorFormat_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPathColor.class,GLPathGenMode.class,GLPathColorFormat.class,ConstPointer.class); }
	static List<Class<?>> PS_IIpILPathCoordType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,ConstPointer.class,int.class,GLPathCoordType.class,ConstPointer.class); }
	static List<Class<?>> PS_IILPathCoordType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLPathCoordType.class,ConstPointer.class); }
	static List<Class<?>> PS_LPathGenMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPathGenMode.class); }
	static List<Class<?>> PS_IEpIIIIF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,ConstPointer.class,int.class,int.class,int.class,int.class,float.class); }
	static List<Class<?>> PS_EpIIFP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,ConstPointer.class,int.class,int.class,float.class,MutPointer.class); }
	static List<Class<?>> PS_ILPathFontTarget_pIIILPathHandleMissingGlyphs_IF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathFontTarget.class,ConstPointer.class,int.class,int.class,int.class,GLPathHandleMissingGlyphs.class,int.class,float.class); }
	static List<Class<?>> PS_ILPathFontTarget_pIILPathElementType_pLPathHandleMissingGlyphs_IF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathFontTarget.class,ConstPointer.class,int.class,int.class,GLPathElementType.class,ConstPointer.class,GLPathHandleMissingGlyphs.class,int.class,float.class); }
	static List<Class<?>> PS_IEJpIIIIF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,long.class,ConstPointer.class,int.class,int.class,int.class,int.class,float.class); }
	static List<Class<?>> PS_ILPathParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathParameter.class,float.class); }
	static List<Class<?>> PS_ILPathParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathParameter.class,ConstPointer.class); }
	static List<Class<?>> PS_ILPathParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathParameter.class,int.class); }
	static List<Class<?>> PS_LStencilFunction_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLStencilFunction.class,int.class,int.class); }
	static List<Class<?>> PS_ILPathStringFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathStringFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IIIIpILPathCoordType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,ConstPointer.class,int.class,GLPathCoordType.class,ConstPointer.class); }
	static List<Class<?>> PS_IIILPathCoordType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,GLPathCoordType.class,ConstPointer.class); }
	static List<Class<?>> PS_LPathColor_LPathGenMode_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPathColor.class,GLPathGenMode.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LPixelDataRangeTargetNV_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelDataRangeTargetNV.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LPixelMap_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelMap.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LPixelStoreParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelStoreParameter.class,float.class); }
	static List<Class<?>> PS_LPixelStoreParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelStoreParameter.class,int.class); }
	static List<Class<?>> PS_LPixelTexGenParameterNameSGIS_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelTexGenParameterNameSGIS.class,float.class); }
	static List<Class<?>> PS_LPixelTexGenParameterNameSGIS_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelTexGenParameterNameSGIS.class,ConstPointer.class); }
	static List<Class<?>> PS_LPixelTexGenParameterNameSGIS_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelTexGenParameterNameSGIS.class,int.class); }
	static List<Class<?>> PS_LPixelTexGenModeSGIX_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelTexGenModeSGIX.class); }
	static List<Class<?>> PS_LPixelTransferParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelTransferParameter.class,float.class); }
	static List<Class<?>> PS_LPixelTransferParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelTransferParameter.class,int.class); }
	static List<Class<?>> PS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelTransformTargetEXT.class,GLPixelTransformPNameEXT.class,float.class); }
	static List<Class<?>> PS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelTransformTargetEXT.class,GLPixelTransformPNameEXT.class,ConstPointer.class); }
	static List<Class<?>> PS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPixelTransformTargetEXT.class,GLPixelTransformPNameEXT.class,int.class); }
	static List<Class<?>> PS_IIIFPPPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,float.class,MutPointer.class,MutPointer.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_LPointParameterNameARB_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPointParameterNameARB.class,float.class); }
	static List<Class<?>> PS_LPointParameterNameARB_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPointParameterNameARB.class,ConstPointer.class); }
	static List<Class<?>> PS_LPointParameterNameARB_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLPointParameterNameARB.class,int.class); }
	static List<Class<?>> PS_LTriangleFace_LPolygonMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTriangleFace.class,GLPolygonMode.class); }
	static List<Class<?>> PS_IJIIEEIEIEIEI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,int.class,int.class,GLEnum.class,GLEnum.class,int.class,GLEnum.class,int.class,GLEnum.class,int.class,GLEnum.class,int.class); }
	static List<Class<?>> PS_IJIIEEIIEII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,int.class,int.class,GLEnum.class,GLEnum.class,int.class,int.class,GLEnum.class,int.class,int.class); }
	static List<Class<?>> PS_FFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_IEpI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_LProgramTarget_IIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLProgramTarget.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LProgramTarget_IDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLProgramTarget.class,int.class,double.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_LProgramTarget_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLProgramTarget.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LProgramTarget_IFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLProgramTarget.class,int.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_LProgramTarget_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLProgramTarget.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LProgramTarget_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLProgramTarget.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IIpDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,ConstPointer.class,double.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_IIpFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,ConstPointer.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_LVertexAttribEnumNV_IDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexAttribEnumNV.class,int.class,double.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_LVertexAttribEnumNV_IFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexAttribEnumNV.class,int.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_ILProgramParameterPName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLProgramParameterPName.class,int.class); }
	static List<Class<?>> PS_IIEIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLEnum.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LProgramTarget_LProgramFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLProgramTarget.class,GLProgramFormat.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IID(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,double.class); }
	static List<Class<?>> PS_IIF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,float.class); }
	static List<Class<?>> PS_IIDD(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,double.class,double.class); }
	static List<Class<?>> PS_IIJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,long.class,long.class); }
	static List<Class<?>> PS_IIDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_IIFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_IIDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,double.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_IIFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_IIJJJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,long.class,long.class,long.class,long.class); }
	static List<Class<?>> PS_IIIZp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,boolean.class,ConstPointer.class); }
	static List<Class<?>> PS_LVertexProvokingMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexProvokingMode.class); }
	static List<Class<?>> PS_LDebugSource_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLDebugSource.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILQueryCounterTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLQueryCounterTarget.class); }
	static List<Class<?>> PS_LQueryTarget_IEI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLQueryTarget.class,int.class,GLEnum.class,int.class); }
	static List<Class<?>> PS_SS(MethodHandles.Lookup l, String n, Class t) { return List.of(short.class,short.class); }
	static List<Class<?>> PS_IZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,boolean.class); }
	static List<Class<?>> PS_LReadBufferMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLReadBufferMode.class); }
	static List<Class<?>> PS_LReadBufferMode_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLReadBufferMode.class,int.class); }
	static List<Class<?>> PS_IIIILPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,MutPointer.class); }
	static List<Class<?>> PS_IIIILPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class); }
	static List<Class<?>> PS_LRenderingMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLRenderingMode.class); }
	static List<Class<?>> PS_LRenderbufferTarget_LInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLRenderbufferTarget.class,GLInternalFormat.class,int.class,int.class); }
	static List<Class<?>> PS_LRenderbufferTarget_ILInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLRenderbufferTarget.class,int.class,GLInternalFormat.class,int.class,int.class); }
	static List<Class<?>> PS_LRenderbufferTarget_IILInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLRenderbufferTarget.class,int.class,int.class,GLInternalFormat.class,int.class,int.class); }
	static List<Class<?>> PS_LReplacementCodeTypeSUN_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLReplacementCodeTypeSUN.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_IFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,float.class,float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_IFFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_pppp(MethodHandles.Lookup l, String n, Class t) { return List.of(ConstPointer.class,ConstPointer.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_IBBBBFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,byte.class,byte.class,byte.class,byte.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_IFFFFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_ppppp(MethodHandles.Lookup l, String n, Class t) { return List.of(ConstPointer.class,ConstPointer.class,ConstPointer.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_IFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_IFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_IFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_LHistogramTargetEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLHistogramTargetEXT.class); }
	static List<Class<?>> PS_LMinmaxTargetEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLMinmaxTargetEXT.class); }
	static List<Class<?>> PS_FZ(MethodHandles.Lookup l, String n, Class t) { return List.of(float.class,boolean.class); }
	static List<Class<?>> PS_LSamplePatternEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLSamplePatternEXT.class); }
	static List<Class<?>> PS_LSamplePatternSGIS_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLSamplePatternSGIS.class); }
	static List<Class<?>> PS_ILSamplerParameterI_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSamplerParameterI.class,ConstPointer.class); }
	static List<Class<?>> PS_ILSamplerParameterF_F(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSamplerParameterF.class,float.class); }
	static List<Class<?>> PS_ILSamplerParameterF_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSamplerParameterF.class,ConstPointer.class); }
	static List<Class<?>> PS_ILSamplerParameterI_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSamplerParameterI.class,int.class); }
	static List<Class<?>> PS_ILSecondaryColorPointerTypeIBM_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSecondaryColorPointerTypeIBM.class,int.class,MutPointer.class,int.class); }
	static List<Class<?>> PS_IZIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,boolean.class,int.class,int.class,MutPointer.class); }
	static List<Class<?>> PS_ILSemaphoreParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSemaphoreParameterName.class,ConstPointer.class); }
	static List<Class<?>> PS_LSeparableTargetEXT_LInternalFormat_IILPixelFormat_LPixelType_pp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLSeparableTargetEXT.class,GLInternalFormat.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_ILFenceConditionNV_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLFenceConditionNV.class); }
	static List<Class<?>> PS_ILScalarType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLScalarType.class,ConstPointer.class); }
	static List<Class<?>> PS_LShadingModel_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLShadingModel.class); }
	static List<Class<?>> PS_IpLShaderBinaryFormat_pI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class,GLShaderBinaryFormat.class,ConstPointer.class,int.class); }
	static List<Class<?>> PS_LVertexShaderOpEXT_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexShaderOpEXT.class,int.class,int.class); }
	static List<Class<?>> PS_LVertexShaderOpEXT_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexShaderOpEXT.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LVertexShaderOpEXT_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexShaderOpEXT.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_IIPp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,MutPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_LShadingRate_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLShadingRate.class); }
	static List<Class<?>> PS_LShadingRateCombinerOp_LShadingRateCombinerOp_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLShadingRateCombinerOp.class,GLShadingRateCombinerOp.class); }
	static List<Class<?>> PS_LShadingRateQCOM_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLShadingRateQCOM.class); }
	static List<Class<?>> PS_IIpIpp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,ConstPointer.class,int.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_IpIpp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class,int.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_LSpriteParameterNameSGIX_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLSpriteParameterNameSGIX.class,float.class); }
	static List<Class<?>> PS_LSpriteParameterNameSGIX_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLSpriteParameterNameSGIX.class,ConstPointer.class); }
	static List<Class<?>> PS_LSpriteParameterNameSGIX_LSpriteModeSGIX_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLSpriteParameterNameSGIX.class,GLSpriteModeSGIX.class); }
	static List<Class<?>> PS_ILPathElementType_pILPathFillMode_ILPathTransformType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathElementType.class,ConstPointer.class,int.class,GLPathFillMode.class,int.class,GLPathTransformType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILPathFillMode_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathFillMode.class,int.class); }
	static List<Class<?>> PS_LTriangleFace_LStencilFunction_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTriangleFace.class,GLStencilFunction.class,int.class,int.class); }
	static List<Class<?>> PS_LStencilFunction_LStencilFunction_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLStencilFunction.class,GLStencilFunction.class,int.class,int.class); }
	static List<Class<?>> PS_LTriangleFace_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTriangleFace.class,int.class); }
	static List<Class<?>> PS_LStencilOp_LStencilOp_LStencilOp_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLStencilOp.class,GLStencilOp.class,GLStencilOp.class); }
	static List<Class<?>> PS_LTriangleFace_LStencilOp_LStencilOp_LStencilOp_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTriangleFace.class,GLStencilOp.class,GLStencilOp.class,GLStencilOp.class); }
	static List<Class<?>> PS_ILPathElementType_pIIILPathTransformType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathElementType.class,ConstPointer.class,int.class,int.class,int.class,GLPathTransformType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILPathElementType_pILPathFillMode_ILInstancedPathCoverMode_LPathTransformType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathElementType.class,ConstPointer.class,int.class,GLPathFillMode.class,int.class,GLInstancedPathCoverMode.class,GLPathTransformType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILPathFillMode_ILPathCoverMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathFillMode.class,int.class,GLPathCoverMode.class); }
	static List<Class<?>> PS_ILPathElementType_pIIILInstancedPathCoverMode_LPathTransformType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLPathElementType.class,ConstPointer.class,int.class,int.class,int.class,GLInstancedPathCoverMode.class,GLPathTransformType.class,ConstPointer.class); }
	static List<Class<?>> PS_IIILPathCoverMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,GLPathCoverMode.class); }
	static List<Class<?>> PS_IILVertexShaderCoordOutEXT_LVertexShaderCoordOutEXT_LVertexShaderCoordOutEXT_LVertexShaderCoordOutEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLVertexShaderCoordOutEXT.class,GLVertexShaderCoordOutEXT.class,GLVertexShaderCoordOutEXT.class,GLVertexShaderCoordOutEXT.class); }
	static List<Class<?>> PS_LTangentPointerTypeEXT_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTangentPointerTypeEXT.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,long.class); }
	static List<Class<?>> PS_LTextureTarget_LSizedInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLSizedInternalFormat.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_LSizedInternalFormat_IJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLSizedInternalFormat.class,int.class,long.class,long.class); }
	static List<Class<?>> PS_LTexBumpParameterATI_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTexBumpParameterATI.class,ConstPointer.class); }
	static List<Class<?>> PS_BB(MethodHandles.Lookup l, String n, Class t) { return List.of(byte.class,byte.class); }
	static List<Class<?>> PS_FFFFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_FFBBBBFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(float.class,float.class,byte.class,byte.class,byte.class,byte.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_CC(MethodHandles.Lookup l, String n, Class t) { return List.of(char.class,char.class); }
	static List<Class<?>> PS_FFFFFFFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_IEI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,int.class); }
	static List<Class<?>> PS_LTexCoordPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTexCoordPointerType.class,int.class); }
	static List<Class<?>> PS_LTexCoordPointerType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTexCoordPointerType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTexCoordPointerType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTexCoordPointerType.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTexCoordPointerType_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTexCoordPointerType.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTexCoordPointerType_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTexCoordPointerType.class,int.class,MutPointer.class,int.class); }
	static List<Class<?>> PS_LTextureEnvTarget_LTextureEnvParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureEnvTarget.class,GLTextureEnvParameter.class,float.class); }
	static List<Class<?>> PS_LTextureEnvTarget_LTextureEnvParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureEnvTarget.class,GLTextureEnvParameter.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureEnvTarget_LTextureEnvParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureEnvTarget.class,GLTextureEnvParameter.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_LTextureFilterSGIS_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLTextureFilterSGIS.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureCoordName_LTextureGenParameter_D(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureCoordName.class,GLTextureGenParameter.class,double.class); }
	static List<Class<?>> PS_LTextureCoordName_LTextureGenParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureCoordName.class,GLTextureGenParameter.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureCoordName_LTextureGenParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureCoordName.class,GLTextureGenParameter.class,float.class); }
	static List<Class<?>> PS_LTextureCoordName_LTextureGenParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureCoordName.class,GLTextureGenParameter.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_ILInternalFormat_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_ILInternalFormat_IIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_ILInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_LTextureTarget_IILInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,GLInternalFormat.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_LTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_ILInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_LTextureTarget_IILInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_LTextureTarget_ILInternalFormat_IIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_EIIIIIIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLEnum.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_LTextureTarget_IIIIIIIIIJZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,long.class,boolean.class); }
	static List<Class<?>> PS_LTextureTarget_LTextureParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLTextureParameterName.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_LTextureParameterName_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLTextureParameterName.class,float.class); }
	static List<Class<?>> PS_LTextureTarget_LTextureParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLTextureParameterName.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_LGetTextureParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLGetTextureParameter.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_LGetTextureParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLGetTextureParameter.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_ILSizedInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_ILSizedInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_ILSizedInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_LTextureTarget_ILSizedInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_ILSizedInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_LTextureTarget_ILSizedInternalFormat_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_ILSizedInternalFormat_IIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_ILSizedInternalFormat_IIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class,long.class); }
	static List<Class<?>> PS_LTextureTarget_ILSizedInternalFormat_IIIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class,long.class); }
	static List<Class<?>> PS_LTextureTarget_ILSizedInternalFormat_IIZIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class,boolean.class,int.class,long.class); }
	static List<Class<?>> PS_LTextureTarget_ILSizedInternalFormat_IIIIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class,int.class,long.class); }
	static List<Class<?>> PS_LTextureTarget_ILSizedInternalFormat_IIIZIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class,boolean.class,int.class,long.class); }
	static List<Class<?>> PS_LTextureTarget_LSizedInternalFormat_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,GLSizedInternalFormat.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LTextureTarget_IIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_IIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_IIIIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_LTextureTarget_IIIIIIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILSizedInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSizedInternalFormat.class,int.class); }
	static List<Class<?>> PS_ILTextureTarget_LSizedInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,GLSizedInternalFormat.class,int.class); }
	static List<Class<?>> PS_ILSizedInternalFormat_IJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLSizedInternalFormat.class,int.class,long.class,long.class); }
	static List<Class<?>> PS_ILTextureTarget_LSizedInternalFormat_IJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,GLSizedInternalFormat.class,int.class,long.class,long.class); }
	static List<Class<?>> PS_ILTextureTarget_ILInternalFormat_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_ILInternalFormat_IIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_IILInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,int.class,GLInternalFormat.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_ILTextureTarget_ILInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_ILTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_IILInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_ILTextureTarget_ILInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLInternalFormat.class,int.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_LLightTexturePNameEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLLightTexturePNameEXT.class); }
	static List<Class<?>> PS_LTextureNormalModeEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLTextureNormalModeEXT.class); }
	static List<Class<?>> PS_IIIIIIIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_IIIIIIIIIIJZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,long.class,boolean.class); }
	static List<Class<?>> PS_ILTextureParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureParameterName.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_LTextureParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,GLTextureParameterName.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureParameterName_F(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureParameterName.class,float.class); }
	static List<Class<?>> PS_ILTextureTarget_LTextureParameterName_F(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,GLTextureParameterName.class,float.class); }
	static List<Class<?>> PS_ILTextureParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureParameterName.class,int.class); }
	static List<Class<?>> PS_ILTextureTarget_LTextureParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,GLTextureParameterName.class,int.class); }
	static List<Class<?>> PS_ILTextureTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class); }
	static List<Class<?>> PS_IILSizedInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLSizedInternalFormat.class,int.class); }
	static List<Class<?>> PS_IEILSizedInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,int.class,GLSizedInternalFormat.class,int.class); }
	static List<Class<?>> PS_IILSizedInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLSizedInternalFormat.class,int.class,int.class); }
	static List<Class<?>> PS_IEILSizedInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,int.class,GLSizedInternalFormat.class,int.class,int.class); }
	static List<Class<?>> PS_IILSizedInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLSizedInternalFormat.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_ILTextureTarget_ILSizedInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_IILSizedInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_IEILSizedInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_IILSizedInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_IEILSizedInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class,boolean.class); }
	static List<Class<?>> PS_IILSizedInternalFormat_IIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLSizedInternalFormat.class,int.class,int.class,long.class); }
	static List<Class<?>> PS_IILSizedInternalFormat_IIIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class,long.class); }
	static List<Class<?>> PS_IILSizedInternalFormat_IIZIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLSizedInternalFormat.class,int.class,int.class,boolean.class,int.class,long.class); }
	static List<Class<?>> PS_IILSizedInternalFormat_IIIIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class,int.class,long.class); }
	static List<Class<?>> PS_IILSizedInternalFormat_IIIZIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class,boolean.class,int.class,long.class); }
	static List<Class<?>> PS_IELSizedInternalFormat_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,GLSizedInternalFormat.class,int.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_IIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_IIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_IIIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_IIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_IIIIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,int.class,int.class,int.class,int.class,int.class,int.class,GLPixelFormat.class,GLPixelType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILTextureTarget_ILSizedInternalFormat_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLTextureTarget.class,int.class,GLSizedInternalFormat.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LVertexAttribEnumNV_ILVertexAttribEnumNV_LVertexAttribEnumNV_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexAttribEnumNV.class,int.class,GLVertexAttribEnumNV.class,GLVertexAttribEnumNV.class); }
	static List<Class<?>> PS_IpE(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class,GLEnum.class); }
	static List<Class<?>> PS_IIIJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,long.class,long.class); }
	static List<Class<?>> PS_IpIpE(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,ConstPointer.class,int.class,ConstPointer.class,GLEnum.class); }
	static List<Class<?>> PS_IIpLTransformFeedbackBufferMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,ConstPointer.class,GLTransformFeedbackBufferMode.class); }
	static List<Class<?>> PS_IILPathTransformType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLPathTransformType.class,ConstPointer.class); }
	static List<Class<?>> PS_ID(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,double.class); }
	static List<Class<?>> PS_IF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,float.class); }
	static List<Class<?>> PS_IDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_IJJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,long.class,long.class); }
	static List<Class<?>> PS_IDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,double.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_IFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_IJJJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,long.class,long.class,long.class,long.class); }
	static List<Class<?>> PS_IIZp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,boolean.class,ConstPointer.class); }
	static List<Class<?>> PS_LBufferTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLBufferTarget.class); }
	static List<Class<?>> PS_IIIpLPreserveModeATI_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,ConstPointer.class,GLPreserveModeATI.class); }
	static List<Class<?>> PS_pEIp(MethodHandles.Lookup l, String n, Class t) { return List.of(ConstPointer.class,GLEnum.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_pEIpZ(MethodHandles.Lookup l, String n, Class t) { return List.of(ConstPointer.class,GLEnum.class,int.class,ConstPointer.class,boolean.class); }
	static List<Class<?>> PS_ILScalarType_III(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLScalarType.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_ILScalarType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLScalarType.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IIILVertexAttribType_ZI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,GLVertexAttribType.class,boolean.class,int.class); }
	static List<Class<?>> PS_IIILVertexAttribIType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,GLVertexAttribIType.class,int.class); }
	static List<Class<?>> PS_IIILVertexAttribLType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,GLVertexAttribLType.class,int.class); }
	static List<Class<?>> PS_IIIJI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,long.class,int.class); }
	static List<Class<?>> PS_IIILColorPointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,GLColorPointerType.class,int.class,long.class); }
	static List<Class<?>> PS_IIIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,long.class); }
	static List<Class<?>> PS_IILFogCoordinatePointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLFogCoordinatePointerType.class,int.class,long.class); }
	static List<Class<?>> PS_IILIndexPointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLIndexPointerType.class,int.class,long.class); }
	static List<Class<?>> PS_IIEILTexCoordPointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLEnum.class,int.class,GLTexCoordPointerType.class,int.class,long.class); }
	static List<Class<?>> PS_IILNormalPointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLNormalPointerType.class,int.class,long.class); }
	static List<Class<?>> PS_LVertexArrayPNameAPPLE_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexArrayPNameAPPLE.class,int.class); }
	static List<Class<?>> PS_IIILTexCoordPointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,GLTexCoordPointerType.class,int.class,long.class); }
	static List<Class<?>> PS_IIIILVertexAttribType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,GLVertexAttribType.class,int.class,long.class); }
	static List<Class<?>> PS_IIIILVertexAttribLType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,GLVertexAttribLType.class,int.class,long.class); }
	static List<Class<?>> PS_IIIILVertexAttribPointerType_ZIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,int.class,GLVertexAttribPointerType.class,boolean.class,int.class,long.class); }
	static List<Class<?>> PS_IIIppp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,ConstPointer.class,ConstPointer.class,ConstPointer.class); }
	static List<Class<?>> PS_IIILVertexPointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,int.class,GLVertexPointerType.class,int.class,long.class); }
	static List<Class<?>> PS_IS(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,short.class); }
	static List<Class<?>> PS_ICC(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,char.class,char.class); }
	static List<Class<?>> PS_ISS(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,short.class,short.class); }
	static List<Class<?>> PS_ICCC(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,char.class,char.class,char.class); }
	static List<Class<?>> PS_ISSS(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,short.class,short.class,short.class); }
	static List<Class<?>> PS_IBBBB(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,byte.class,byte.class,byte.class,byte.class); }
	static List<Class<?>> PS_ICCCC(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,char.class,char.class,char.class,char.class); }
	static List<Class<?>> PS_ISSSS(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,short.class,short.class,short.class,short.class); }
	static List<Class<?>> PS_IILVertexAttribPointerType_ZIII(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLVertexAttribPointerType.class,boolean.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_IILVertexAttribType_ZI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLVertexAttribType.class,boolean.class,int.class); }
	static List<Class<?>> PS_IILVertexAttribIType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLVertexAttribIType.class,int.class); }
	static List<Class<?>> PS_IILVertexAttribIType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLVertexAttribIType.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IILVertexAttribLType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLVertexAttribLType.class,int.class); }
	static List<Class<?>> PS_IILVertexAttribLType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLVertexAttribLType.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILVertexAttribPointerType_ZI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexAttribPointerType.class,boolean.class,int.class); }
	static List<Class<?>> PS_ILVertexAttribPointerType_Zp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexAttribPointerType.class,boolean.class,ConstPointer.class); }
	static List<Class<?>> PS_IILVertexAttribPointerType_ZIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLVertexAttribPointerType.class,boolean.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IILVertexAttribEnumNV_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLVertexAttribEnumNV.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_LVertexStreamATI_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,float.class); }
	static List<Class<?>> PS_LVertexStreamATI_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,int.class); }
	static List<Class<?>> PS_ILVertexPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexPointerType.class,int.class); }
	static List<Class<?>> PS_LVertexPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexPointerType.class,int.class); }
	static List<Class<?>> PS_LVertexPointerType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexPointerType.class,ConstPointer.class); }
	static List<Class<?>> PS_ILVertexPointerType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexPointerType.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILVertexPointerType_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexPointerType.class,int.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_ILVertexPointerType_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexPointerType.class,int.class,MutPointer.class,int.class); }
	static List<Class<?>> PS_LVertexStreamATI_D(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,double.class); }
	static List<Class<?>> PS_LVertexStreamATI_S(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,short.class); }
	static List<Class<?>> PS_LVertexStreamATI_DD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,double.class,double.class); }
	static List<Class<?>> PS_LVertexStreamATI_FF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,float.class,float.class); }
	static List<Class<?>> PS_LVertexStreamATI_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,int.class,int.class); }
	static List<Class<?>> PS_LVertexStreamATI_SS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,short.class,short.class); }
	static List<Class<?>> PS_LVertexStreamATI_DDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,double.class,double.class,double.class,double.class); }
	static List<Class<?>> PS_LVertexStreamATI_FFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,float.class,float.class,float.class,float.class); }
	static List<Class<?>> PS_LVertexStreamATI_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,int.class,int.class,int.class,int.class); }
	static List<Class<?>> PS_LVertexStreamATI_SSSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLVertexStreamATI.class,short.class,short.class,short.class,short.class); }
	static List<Class<?>> PS_ILVertexWeightPointerTypeEXT_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLVertexWeightPointerTypeEXT.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IPP(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,MutPointer.class,MutPointer.class); }
	static List<Class<?>> PS_IIEp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLEnum.class,ConstPointer.class); }
	static List<Class<?>> PS_IEEEE(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,GLEnum.class,GLEnum.class,GLEnum.class); }
	static List<Class<?>> PS_ILWeightPointerTypeARB_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLWeightPointerTypeARB.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IEIp(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,GLEnum.class,int.class,ConstPointer.class); }
	static List<Class<?>> PS_IILVertexShaderWriteMaskEXT_LVertexShaderWriteMaskEXT_LVertexShaderWriteMaskEXT_LVertexShaderWriteMaskEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(int.class,int.class,GLVertexShaderWriteMaskEXT.class,GLVertexShaderWriteMaskEXT.class,GLVertexShaderWriteMaskEXT.class,GLVertexShaderWriteMaskEXT.class); }
	static List<Class<?>> PS_JIFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(long.class,int.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class,float.class); }
    //</editor-fold>

	//<editor-fold desc="ML_*">
	static MemoryLayout ML_E(MethodHandles.Lookup l, String n, Class t) { return JAVA_INT.withName("GLenum"); }
	static MemoryLayout ML_LAccumOp_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("AccumOp"); }
	static MemoryLayout ML_F(MethodHandles.Lookup l, String n, Class t) { return JAVA_FLOAT; }
	static MemoryLayout ML_V(MethodHandles.Lookup l, String n, Class t) { return null; }
	static MemoryLayout ML_I(MethodHandles.Lookup l, String n, Class t) { return JAVA_INT; }
	static MemoryLayout ML_LTriangleFace_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TriangleFace"); }
	static MemoryLayout ML_LTextureUnit_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TextureUnit"); }
	static MemoryLayout ML_p(MethodHandles.Lookup l, String n, Class t) { return ADDRESS; }
	static MemoryLayout ML_LFragmentOp1ATI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FragmentOp1ATI"); }
	static MemoryLayout ML_LFragmentOp2ATI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FragmentOp2ATI"); }
	static MemoryLayout ML_LFragmentOp3ATI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FragmentOp3ATI"); }
	static MemoryLayout ML_LAlphaFunction_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("AlphaFunction"); }
	static MemoryLayout ML_LLightTextureModeEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("LightTextureModeEXT"); }
	static MemoryLayout ML_J(MethodHandles.Lookup l, String n, Class t) { return JAVA_LONG; }
	static MemoryLayout ML_Z(MethodHandles.Lookup l, String n, Class t) { return JAVA_BOOLEAN; }
	static MemoryLayout ML_P(MethodHandles.Lookup l, String n, Class t) { return ADDRESS; }
	static MemoryLayout ML_LEnableCap_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("EnableCap"); }
	static MemoryLayout ML_LScalarType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ScalarType"); }
	static MemoryLayout ML_LPrimitiveType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PrimitiveType"); }
	static MemoryLayout ML_LConditionalRenderMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ConditionalRenderMode"); }
	static MemoryLayout ML_LQueryTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("QueryTarget"); }
	static MemoryLayout ML_LBufferTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("BufferTarget"); }
	static MemoryLayout ML_LFramebufferTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FramebufferTarget"); }
	static MemoryLayout ML_LBufferAccess_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("BufferAccess"); }
	static MemoryLayout ML_LInternalFormat_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("InternalFormat"); }
	static MemoryLayout ML_LLightName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("LightName"); }
	static MemoryLayout ML_LLightParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("LightParameter"); }
	static MemoryLayout ML_LMaterialParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MaterialParameter"); }
	static MemoryLayout ML_LTextureTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TextureTarget"); }
	static MemoryLayout ML_LVertexShaderParameterEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexShaderParameterEXT"); }
	static MemoryLayout ML_LProgramTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ProgramTarget"); }
	static MemoryLayout ML_LVertexAttribEnumNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexAttribEnumNV"); }
	static MemoryLayout ML_LRenderbufferTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("RenderbufferTarget"); }
	static MemoryLayout ML_LTextureCoordName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TextureCoordName"); }
	static MemoryLayout ML_LTextureGenParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TextureGenParameter"); }
	static MemoryLayout ML_LVertexShaderTextureUnitParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexShaderTextureUnitParameter"); }
	static MemoryLayout ML_LBindTransformFeedbackTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("BindTransformFeedbackTarget"); }
	static MemoryLayout ML_B(MethodHandles.Lookup l, String n, Class t) { return JAVA_BYTE; }
	static MemoryLayout ML_D(MethodHandles.Lookup l, String n, Class t) { return JAVA_DOUBLE; }
	static MemoryLayout ML_S(MethodHandles.Lookup l, String n, Class t) { return JAVA_SHORT; }
	static MemoryLayout ML_LBinormalPointerTypeEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("BinormalPointerTypeEXT"); }
	static MemoryLayout ML_LBlendEquationModeEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("BlendEquationModeEXT"); }
	static MemoryLayout ML_LBlendingFactor_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("BlendingFactor"); }
	static MemoryLayout ML_LBlitFramebufferFilter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("BlitFramebufferFilter"); }
	static MemoryLayout ML_LBufferUsage_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("BufferUsage"); }
	static MemoryLayout ML_LBufferStorageTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("BufferStorageTarget"); }
	static MemoryLayout ML_LListNameType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ListNameType"); }
	static MemoryLayout ML_LFramebufferStatus_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FramebufferStatus"); }
	static MemoryLayout ML_LClampColorTargetARB_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ClampColorTargetARB"); }
	static MemoryLayout ML_LClampColorModeARB_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ClampColorModeARB"); }
	static MemoryLayout ML_LSizedInternalFormat_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SizedInternalFormat"); }
	static MemoryLayout ML_LPixelFormat_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PixelFormat"); }
	static MemoryLayout ML_LPixelType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PixelType"); }
	static MemoryLayout ML_LBuffer_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("Buffer"); }
	static MemoryLayout ML_LVertexStreamATI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexStreamATI"); }
	static MemoryLayout ML_LSyncStatus_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SyncStatus"); }
	static MemoryLayout ML_LClipControlOrigin_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ClipControlOrigin"); }
	static MemoryLayout ML_LClipControlDepth_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ClipControlDepth"); }
	static MemoryLayout ML_LClipPlaneName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ClipPlaneName"); }
	static MemoryLayout ML_C(MethodHandles.Lookup l, String n, Class t) { return JAVA_CHAR; }
	static MemoryLayout ML_LColorPointerType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ColorPointerType"); }
	static MemoryLayout ML_LColorMaterialParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ColorMaterialParameter"); }
	static MemoryLayout ML_LVertexPointerType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexPointerType"); }
	static MemoryLayout ML_LColorTableTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ColorTableTarget"); }
	static MemoryLayout ML_LColorTableParameterPName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ColorTableParameterPName"); }
	static MemoryLayout ML_LColorTableTargetSGI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ColorTableTargetSGI"); }
	static MemoryLayout ML_LCombinerStageNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CombinerStageNV"); }
	static MemoryLayout ML_LCombinerPortionNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CombinerPortionNV"); }
	static MemoryLayout ML_LCombinerVariableNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CombinerVariableNV"); }
	static MemoryLayout ML_LCombinerRegisterNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CombinerRegisterNV"); }
	static MemoryLayout ML_LCombinerMappingNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CombinerMappingNV"); }
	static MemoryLayout ML_LCombinerComponentUsageNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CombinerComponentUsageNV"); }
	static MemoryLayout ML_LCombinerScaleNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CombinerScaleNV"); }
	static MemoryLayout ML_LCombinerBiasNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CombinerBiasNV"); }
	static MemoryLayout ML_LCombinerParameterNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CombinerParameterNV"); }
	static MemoryLayout ML_LConvolutionTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ConvolutionTarget"); }
	static MemoryLayout ML_LConvolutionTargetEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ConvolutionTargetEXT"); }
	static MemoryLayout ML_LConvolutionParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ConvolutionParameter"); }
	static MemoryLayout ML_LCopyBufferSubDataTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CopyBufferSubDataTarget"); }
	static MemoryLayout ML_LCopyImageSubDataTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CopyImageSubDataTarget"); }
	static MemoryLayout ML_LPixelCopyType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PixelCopyType"); }
	static MemoryLayout ML_LPathElementType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathElementType"); }
	static MemoryLayout ML_LInstancedPathCoverMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("InstancedPathCoverMode"); }
	static MemoryLayout ML_LPathTransformType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathTransformType"); }
	static MemoryLayout ML_LPathCoverMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathCoverMode"); }
	static MemoryLayout ML_LShaderType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ShaderType"); }
	static MemoryLayout ML_LCullParameterEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CullParameterEXT"); }
	static MemoryLayout ML_LDebugSource_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("DebugSource"); }
	static MemoryLayout ML_LDebugType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("DebugType"); }
	static MemoryLayout ML_LDebugSeverity_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("DebugSeverity"); }
	static MemoryLayout ML_LFfdTargetSGIX_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FfdTargetSGIX"); }
	static MemoryLayout ML_LDepthFunction_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("DepthFunction"); }
	static MemoryLayout ML_LDrawBufferMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("DrawBufferMode"); }
	static MemoryLayout ML_LDrawElementsType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("DrawElementsType"); }
	static MemoryLayout ML_LElementPointerTypeATI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ElementPointerTypeATI"); }
	static MemoryLayout ML_LEvalTargetNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("EvalTargetNV"); }
	static MemoryLayout ML_LEvalMapsModeNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("EvalMapsModeNV"); }
	static MemoryLayout ML_LMeshMode1_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MeshMode1"); }
	static MemoryLayout ML_LMeshMode2_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MeshMode2"); }
	static MemoryLayout ML_LFeedbackType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FeedbackType"); }
	static MemoryLayout ML_LSyncCondition_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SyncCondition"); }
	static MemoryLayout ML_LObjectTypeAPPLE_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ObjectTypeAPPLE"); }
	static MemoryLayout ML_LPixelDataRangeTargetNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PixelDataRangeTargetNV"); }
	static MemoryLayout ML_LFogPointerTypeEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FogPointerTypeEXT"); }
	static MemoryLayout ML_LFogPointerTypeIBM_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FogPointerTypeIBM"); }
	static MemoryLayout ML_LFogParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FogParameter"); }
	static MemoryLayout ML_LFogPName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FogPName"); }
	static MemoryLayout ML_LFragmentLightModelParameterSGIX_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FragmentLightModelParameterSGIX"); }
	static MemoryLayout ML_LFragmentLightNameSGIX_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FragmentLightNameSGIX"); }
	static MemoryLayout ML_LFragmentLightParameterSGIX_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FragmentLightParameterSGIX"); }
	static MemoryLayout ML_LFramebufferParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FramebufferParameterName"); }
	static MemoryLayout ML_LReadBufferMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ReadBufferMode"); }
	static MemoryLayout ML_LFramebufferAttachment_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FramebufferAttachment"); }
	static MemoryLayout ML_LFrontFaceDirection_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FrontFaceDirection"); }
	static MemoryLayout ML_LDataTypeEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("DataTypeEXT"); }
	static MemoryLayout ML_LVertexShaderStorageTypeEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexShaderStorageTypeEXT"); }
	static MemoryLayout ML_LParameterRangeEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ParameterRangeEXT"); }
	static MemoryLayout ML_LAtomicCounterBufferPName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("AtomicCounterBufferPName"); }
	static MemoryLayout ML_LSubroutineParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SubroutineParameterName"); }
	static MemoryLayout ML_LUniformBlockPName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("UniformBlockPName"); }
	static MemoryLayout ML_LUniformPName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("UniformPName"); }
	static MemoryLayout ML_LArrayObjectPNameATI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ArrayObjectPNameATI"); }
	static MemoryLayout ML_LGetPName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("GetPName"); }
	static MemoryLayout ML_LBufferPNameARB_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("BufferPNameARB"); }
	static MemoryLayout ML_LBufferPointerNameARB_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("BufferPointerNameARB"); }
	static MemoryLayout ML_LCommandOpcodesNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("CommandOpcodesNV"); }
	static MemoryLayout ML_LErrorCode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ErrorCode"); }
	static MemoryLayout ML_LFenceParameterNameNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FenceParameterNameNV"); }
	static MemoryLayout ML_LFramebufferAttachmentParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FramebufferAttachmentParameterName"); }
	static MemoryLayout ML_LGetFramebufferParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("GetFramebufferParameter"); }
	static MemoryLayout ML_LGraphicsResetStatus_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("GraphicsResetStatus"); }
	static MemoryLayout ML_LContainerType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ContainerType"); }
	static MemoryLayout ML_LHistogramTargetEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("HistogramTargetEXT"); }
	static MemoryLayout ML_LGetHistogramParameterPNameEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("GetHistogramParameterPNameEXT"); }
	static MemoryLayout ML_LImageTransformTargetHP_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ImageTransformTargetHP"); }
	static MemoryLayout ML_LImageTransformPNameHP_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ImageTransformPNameHP"); }
	static MemoryLayout ML_LInternalFormatPName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("InternalFormatPName"); }
	static MemoryLayout ML_LGetVariantValueEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("GetVariantValueEXT"); }
	static MemoryLayout ML_LListParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ListParameterName"); }
	static MemoryLayout ML_LMapAttribParameterNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MapAttribParameterNV"); }
	static MemoryLayout ML_LMapTypeNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MapTypeNV"); }
	static MemoryLayout ML_LMapParameterNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MapParameterNV"); }
	static MemoryLayout ML_LMapTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MapTarget"); }
	static MemoryLayout ML_LGetMapQuery_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("GetMapQuery"); }
	static MemoryLayout ML_LMemoryObjectParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MemoryObjectParameterName"); }
	static MemoryLayout ML_LMinmaxTargetEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MinmaxTargetEXT"); }
	static MemoryLayout ML_LGetMinmaxParameterPNameEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("GetMinmaxParameterPNameEXT"); }
	static MemoryLayout ML_LTextureEnvTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TextureEnvTarget"); }
	static MemoryLayout ML_LTextureEnvParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TextureEnvParameter"); }
	static MemoryLayout ML_LGetTextureParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("GetTextureParameter"); }
	static MemoryLayout ML_LGetMultisamplePNameNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("GetMultisamplePNameNV"); }
	static MemoryLayout ML_LProgramStringProperty_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ProgramStringProperty"); }
	static MemoryLayout ML_LProgramPropertyARB_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ProgramPropertyARB"); }
	static MemoryLayout ML_LRenderbufferParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("RenderbufferParameterName"); }
	static MemoryLayout ML_LObjectIdentifier_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ObjectIdentifier"); }
	static MemoryLayout ML_LOcclusionQueryParameterNameNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("OcclusionQueryParameterNameNV"); }
	static MemoryLayout ML_LPathColor_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathColor"); }
	static MemoryLayout ML_LPathGenMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathGenMode"); }
	static MemoryLayout ML_LPathParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathParameter"); }
	static MemoryLayout ML_LPathListMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathListMode"); }
	static MemoryLayout ML_LPixelMap_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PixelMap"); }
	static MemoryLayout ML_LPixelTexGenParameterNameSGIS_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PixelTexGenParameterNameSGIS"); }
	static MemoryLayout ML_LGetPointervPName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("GetPointervPName"); }
	static MemoryLayout ML_LProgramInterface_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ProgramInterface"); }
	static MemoryLayout ML_LProgramInterfacePName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ProgramInterfacePName"); }
	static MemoryLayout ML_LPipelineParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PipelineParameterName"); }
	static MemoryLayout ML_LProgramStagePName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ProgramStagePName"); }
	static MemoryLayout ML_LQueryObjectParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("QueryObjectParameterName"); }
	static MemoryLayout ML_LQueryParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("QueryParameterName"); }
	static MemoryLayout ML_LSamplerParameterI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SamplerParameterI"); }
	static MemoryLayout ML_LSamplerParameterF_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SamplerParameterF"); }
	static MemoryLayout ML_LSemaphoreParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SemaphoreParameterName"); }
	static MemoryLayout ML_LSeparableTargetEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SeparableTargetEXT"); }
	static MemoryLayout ML_LPrecisionType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PrecisionType"); }
	static MemoryLayout ML_LShaderParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ShaderParameterName"); }
	static MemoryLayout ML_LStringName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("StringName"); }
	static MemoryLayout ML_LSyncParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SyncParameterName"); }
	static MemoryLayout ML_LGetTexBumpParameterATI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("GetTexBumpParameterATI"); }
	static MemoryLayout ML_LTextureFilterSGIS_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TextureFilterSGIS"); }
	static MemoryLayout ML_LTransformFeedbackPName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TransformFeedbackPName"); }
	static MemoryLayout ML_LVertexArrayPName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexArrayPName"); }
	static MemoryLayout ML_LVertexAttribEnum_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexAttribEnum"); }
	static MemoryLayout ML_LVertexAttribPointerPropertyARB_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexAttribPointerPropertyARB"); }
	static MemoryLayout ML_LVertexAttribPropertyARB_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexAttribPropertyARB"); }
	static MemoryLayout ML_LHistogramTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("HistogramTarget"); }
	static MemoryLayout ML_LMapQuery_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MapQuery"); }
	static MemoryLayout ML_LMinmaxTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MinmaxTarget"); }
	static MemoryLayout ML_LSeparableTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SeparableTarget"); }
	static MemoryLayout ML_LHintTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("HintTarget"); }
	static MemoryLayout ML_LHintMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("HintMode"); }
	static MemoryLayout ML_LHintTargetPGI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("HintTargetPGI"); }
	static MemoryLayout ML_LVertexHintsMaskPGI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexHintsMaskPGI"); }
	static MemoryLayout ML_LExternalHandleType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ExternalHandleType"); }
	static MemoryLayout ML_LIndexFunctionEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("IndexFunctionEXT"); }
	static MemoryLayout ML_LIndexMaterialParameterEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("IndexMaterialParameterEXT"); }
	static MemoryLayout ML_LIndexPointerType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("IndexPointerType"); }
	static MemoryLayout ML_LInterleavedArrayFormat_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("InterleavedArrayFormat"); }
	static MemoryLayout ML_LVariantCapEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VariantCapEXT"); }
	static MemoryLayout ML_LLightEnvParameterSGIX_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("LightEnvParameterSGIX"); }
	static MemoryLayout ML_LLightEnvModeSGIX_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("LightEnvModeSGIX"); }
	static MemoryLayout ML_LLightModelParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("LightModelParameter"); }
	static MemoryLayout ML_LLogicOp_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("LogicOp"); }
	static MemoryLayout ML_LMatrixMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MatrixMode"); }
	static MemoryLayout ML_LMatrixIndexPointerTypeARB_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("MatrixIndexPointerTypeARB"); }
	static MemoryLayout ML_LTexCoordPointerType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TexCoordPointerType"); }
	static MemoryLayout ML_LTextureParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TextureParameterName"); }
	static MemoryLayout ML_LVertexBufferObjectUsage_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexBufferObjectUsage"); }
	static MemoryLayout ML_LColorBuffer_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ColorBuffer"); }
	static MemoryLayout ML_LProgramFormat_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ProgramFormat"); }
	static MemoryLayout ML_LListMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ListMode"); }
	static MemoryLayout ML_LArrayObjectUsageATI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ArrayObjectUsageATI"); }
	static MemoryLayout ML_LNormalPointerType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("NormalPointerType"); }
	static MemoryLayout ML_LPNTrianglesPNameATI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PNTrianglesPNameATI"); }
	static MemoryLayout ML_LSwizzleOpATI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SwizzleOpATI"); }
	static MemoryLayout ML_LPatchParameterName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PatchParameterName"); }
	static MemoryLayout ML_LPathColorFormat_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathColorFormat"); }
	static MemoryLayout ML_LPathCoordType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathCoordType"); }
	static MemoryLayout ML_LPathFontTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathFontTarget"); }
	static MemoryLayout ML_LPathHandleMissingGlyphs_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathHandleMissingGlyphs"); }
	static MemoryLayout ML_LStencilFunction_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("StencilFunction"); }
	static MemoryLayout ML_LPathStringFormat_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathStringFormat"); }
	static MemoryLayout ML_LPixelStoreParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PixelStoreParameter"); }
	static MemoryLayout ML_LPixelTexGenModeSGIX_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PixelTexGenModeSGIX"); }
	static MemoryLayout ML_LPixelTransferParameter_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PixelTransferParameter"); }
	static MemoryLayout ML_LPixelTransformTargetEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PixelTransformTargetEXT"); }
	static MemoryLayout ML_LPixelTransformPNameEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PixelTransformPNameEXT"); }
	static MemoryLayout ML_LPointParameterNameARB_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PointParameterNameARB"); }
	static MemoryLayout ML_LPolygonMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PolygonMode"); }
	static MemoryLayout ML_LProgramParameterPName_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ProgramParameterPName"); }
	static MemoryLayout ML_LVertexProvokingMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexProvokingMode"); }
	static MemoryLayout ML_LQueryCounterTarget_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("QueryCounterTarget"); }
	static MemoryLayout ML_LRenderingMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("RenderingMode"); }
	static MemoryLayout ML_LReplacementCodeTypeSUN_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ReplacementCodeTypeSUN"); }
	static MemoryLayout ML_LSamplePatternEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SamplePatternEXT"); }
	static MemoryLayout ML_LSamplePatternSGIS_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SamplePatternSGIS"); }
	static MemoryLayout ML_LSecondaryColorPointerTypeIBM_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SecondaryColorPointerTypeIBM"); }
	static MemoryLayout ML_LFenceConditionNV_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FenceConditionNV"); }
	static MemoryLayout ML_LShadingModel_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ShadingModel"); }
	static MemoryLayout ML_LShaderBinaryFormat_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ShaderBinaryFormat"); }
	static MemoryLayout ML_LVertexShaderOpEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexShaderOpEXT"); }
	static MemoryLayout ML_LShadingRate_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ShadingRate"); }
	static MemoryLayout ML_LShadingRateCombinerOp_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ShadingRateCombinerOp"); }
	static MemoryLayout ML_LShadingRateQCOM_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("ShadingRateQCOM"); }
	static MemoryLayout ML_LSpriteParameterNameSGIX_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SpriteParameterNameSGIX"); }
	static MemoryLayout ML_LSpriteModeSGIX_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("SpriteModeSGIX"); }
	static MemoryLayout ML_LPathFillMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PathFillMode"); }
	static MemoryLayout ML_LStencilOp_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("StencilOp"); }
	static MemoryLayout ML_LVertexShaderCoordOutEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexShaderCoordOutEXT"); }
	static MemoryLayout ML_LTangentPointerTypeEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TangentPointerTypeEXT"); }
	static MemoryLayout ML_LTexBumpParameterATI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TexBumpParameterATI"); }
	static MemoryLayout ML_LLightTexturePNameEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("LightTexturePNameEXT"); }
	static MemoryLayout ML_LTextureNormalModeEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TextureNormalModeEXT"); }
	static MemoryLayout ML_LTransformFeedbackBufferMode_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("TransformFeedbackBufferMode"); }
	static MemoryLayout ML_LPreserveModeATI_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("PreserveModeATI"); }
	static MemoryLayout ML_LVertexAttribType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexAttribType"); }
	static MemoryLayout ML_LVertexAttribIType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexAttribIType"); }
	static MemoryLayout ML_LVertexAttribLType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexAttribLType"); }
	static MemoryLayout ML_LFogCoordinatePointerType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("FogCoordinatePointerType"); }
	static MemoryLayout ML_LVertexArrayPNameAPPLE_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexArrayPNameAPPLE"); }
	static MemoryLayout ML_LVertexAttribPointerType_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexAttribPointerType"); }
	static MemoryLayout ML_LVertexWeightPointerTypeEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexWeightPointerTypeEXT"); }
	static MemoryLayout ML_LWeightPointerTypeARB_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("WeightPointerTypeARB"); }
	static MemoryLayout ML_LVertexShaderWriteMaskEXT_(MethodHandles.Lookup l, String n, Class t) { return GLParamTypeSets.ML_E().withName("VertexShaderWriteMaskEXT"); }
    //</editor-fold>

    //<editor-fold desc="MLS_*">
	static List<MemoryLayout> MLS_LAccumOp_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LAccumOp_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_EI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTriangleFace_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTriangleFace_()); }
	static List<MemoryLayout> MLS_LTextureUnit_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_()); }
	static List<MemoryLayout> MLS_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LFragmentOp1ATI_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentOp1ATI_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFragmentOp2ATI_IIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentOp2ATI_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFragmentOp3ATI_IIIIIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentOp3ATI_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LAlphaFunction_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LAlphaFunction_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_EF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LAlphaFunction_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LAlphaFunction_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_E(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E()); }
	static List<MemoryLayout> MLS_(MethodHandles.Lookup l, String n, Class t) { return List.of(); }
	static List<MemoryLayout> MLS_LLightTextureModeEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LLightTextureModeEXT_()); }
	static List<MemoryLayout> MLS_IJI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IpP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LEnableCap_ILScalarType_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LEnableCap_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LScalarType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IppIIIIJJJIpp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IppIIIEIIIIIEIIIIIIIIpp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPrimitiveType_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_()); }
	static List<MemoryLayout> MLS_ILConditionalRenderMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LConditionalRenderMode_()); }
	static List<MemoryLayout> MLS_LQueryTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LQueryTarget_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LQueryTarget_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LQueryTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LBufferTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LBufferTarget_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LBufferTarget_IIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LBufferTarget_IIJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LBufferTarget_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LBufferTarget_IIppp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIIZILBufferAccess_LInternalFormat_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBufferAccess_(),GLParamTypeSets.ML_LInternalFormat_()); }
	static List<MemoryLayout> MLS_IIIZILBufferAccess_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBufferAccess_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LLightName_LLightParameter_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LLightName_(),GLParamTypeSets.ML_LLightParameter_()); }
	static List<MemoryLayout> MLS_LTriangleFace_LMaterialParameter_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTriangleFace_(),GLParamTypeSets.ML_LMaterialParameter_()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexShaderParameterEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexShaderParameterEXT_()); }
	static List<MemoryLayout> MLS_LProgramTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexAttribEnumNV_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexAttribEnumNV_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LRenderbufferTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LRenderbufferTarget_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureCoordName_(),GLParamTypeSets.ML_LTextureGenParameter_()); }
	static List<MemoryLayout> MLS_LTextureTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LVertexShaderTextureUnitParameter_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LVertexShaderTextureUnitParameter_()); }
	static List<MemoryLayout> MLS_LBindTransformFeedbackTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBindTransformFeedbackTarget_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIJI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIppp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIEJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IIEEI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_BBB(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B()); }
	static List<MemoryLayout> MLS_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_DDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_FFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_SSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_LBinormalPointerTypeEXT_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBinormalPointerTypeEXT_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIFFFFp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIIIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_FFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LBlendEquationModeEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBlendEquationModeEXT_()); }
	static List<MemoryLayout> MLS_ILBlendEquationModeEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBlendEquationModeEXT_()); }
	static List<MemoryLayout> MLS_LBlendEquationModeEXT_LBlendEquationModeEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBlendEquationModeEXT_(),GLParamTypeSets.ML_LBlendEquationModeEXT_()); }
	static List<MemoryLayout> MLS_ILBlendEquationModeEXT_LBlendEquationModeEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBlendEquationModeEXT_(),GLParamTypeSets.ML_LBlendEquationModeEXT_()); }
	static List<MemoryLayout> MLS_LBlendingFactor_LBlendingFactor_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBlendingFactor_(),GLParamTypeSets.ML_LBlendingFactor_()); }
	static List<MemoryLayout> MLS_IEE(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_E()); }
	static List<MemoryLayout> MLS_LBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBlendingFactor_(),GLParamTypeSets.ML_LBlendingFactor_(),GLParamTypeSets.ML_LBlendingFactor_(),GLParamTypeSets.ML_LBlendingFactor_()); }
	static List<MemoryLayout> MLS_ILBlendingFactor_LBlendingFactor_LBlendingFactor_LBlendingFactor_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBlendingFactor_(),GLParamTypeSets.ML_LBlendingFactor_(),GLParamTypeSets.ML_LBlendingFactor_(),GLParamTypeSets.ML_LBlendingFactor_()); }
	static List<MemoryLayout> MLS_ILBlendingFactor_LBlendingFactor_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBlendingFactor_(),GLParamTypeSets.ML_LBlendingFactor_()); }
	static List<MemoryLayout> MLS_IIIIIIIIILBlitFramebufferFilter_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBlitFramebufferFilter_()); }
	static List<MemoryLayout> MLS_IIIIIIIIIIILBlitFramebufferFilter_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBlitFramebufferFilter_()); }
	static List<MemoryLayout> MLS_EIJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LBufferTarget_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LBufferTarget_JpLBufferUsage_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_LBufferUsage_()); }
	static List<MemoryLayout> MLS_EJJZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LBufferStorageTarget_JJIJZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferStorageTarget_(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_EEI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LBufferStorageTarget_JpI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferStorageTarget_(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_EJJII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LBufferTarget_JIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LBufferTarget_JJp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILListNameType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LListNameType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_()); }
	static List<MemoryLayout> MLS_ILFramebufferTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFramebufferTarget_()); }
	static List<MemoryLayout> MLS_LClampColorTargetARB_LClampColorModeARB_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LClampColorTargetARB_(),GLParamTypeSets.ML_LClampColorModeARB_()); }
	static List<MemoryLayout> MLS_LBufferStorageTarget_LSizedInternalFormat_LPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferStorageTarget_(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LBufferTarget_LSizedInternalFormat_JJLPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LBuffer_IFI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBuffer_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LBuffer_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBuffer_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_D(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILSizedInternalFormat_LPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILSizedInternalFormat_JJLPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILBuffer_IFI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBuffer_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILBuffer_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBuffer_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIIIIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_()); }
	static List<MemoryLayout> MLS_Ipp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LClipControlOrigin_LClipControlDepth_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LClipControlOrigin_(),GLParamTypeSets.ML_LClipControlDepth_()); }
	static List<MemoryLayout> MLS_EE(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_E()); }
	static List<MemoryLayout> MLS_LClipPlaneName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LClipPlaneName_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_FFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_pp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_CCC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C()); }
	static List<MemoryLayout> MLS_BBBB(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B()); }
	static List<MemoryLayout> MLS_DDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_FFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ppp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_CCCC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C()); }
	static List<MemoryLayout> MLS_SSSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_BBBBFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_BBBBFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILColorPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LColorPointerType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFragmentOp1ATI_IIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentOp1ATI_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFragmentOp2ATI_IIIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentOp2ATI_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFragmentOp3ATI_IIIIIIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentOp3ATI_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ZZZZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_IZZZZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LTriangleFace_LColorMaterialParameter_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTriangleFace_(),GLParamTypeSets.ML_LColorMaterialParameter_()); }
	static List<MemoryLayout> MLS_LColorPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorPointerType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LColorPointerType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorPointerType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILColorPointerType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LColorPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILColorPointerType_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LColorPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILColorPointerType_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LColorPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILVertexPointerType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexPointerType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LColorTableTarget_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LColorTableTarget_LInternalFormat_ILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTarget_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LColorTableTarget_LColorTableParameterPName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTarget_(),GLParamTypeSets.ML_LColorTableParameterPName_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LColorTableTargetSGI_LColorTableParameterPName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTargetSGI_(),GLParamTypeSets.ML_LColorTableParameterPName_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LColorTableTargetSGI_LInternalFormat_ILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTargetSGI_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LCombinerStageNV_LCombinerPortionNV_LCombinerVariableNV_LCombinerRegisterNV_LCombinerMappingNV_LCombinerComponentUsageNV_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCombinerStageNV_(),GLParamTypeSets.ML_LCombinerPortionNV_(),GLParamTypeSets.ML_LCombinerVariableNV_(),GLParamTypeSets.ML_LCombinerRegisterNV_(),GLParamTypeSets.ML_LCombinerMappingNV_(),GLParamTypeSets.ML_LCombinerComponentUsageNV_()); }
	static List<MemoryLayout> MLS_LCombinerStageNV_LCombinerPortionNV_LCombinerRegisterNV_LCombinerRegisterNV_LCombinerRegisterNV_LCombinerScaleNV_LCombinerBiasNV_ZZZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCombinerStageNV_(),GLParamTypeSets.ML_LCombinerPortionNV_(),GLParamTypeSets.ML_LCombinerRegisterNV_(),GLParamTypeSets.ML_LCombinerRegisterNV_(),GLParamTypeSets.ML_LCombinerRegisterNV_(),GLParamTypeSets.ML_LCombinerScaleNV_(),GLParamTypeSets.ML_LCombinerBiasNV_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LCombinerParameterNV_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCombinerParameterNV_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LCombinerParameterNV_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCombinerParameterNV_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LCombinerParameterNV_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCombinerParameterNV_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LCombinerStageNV_LCombinerParameterNV_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCombinerStageNV_(),GLParamTypeSets.ML_LCombinerParameterNV_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIpp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_IIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_IIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_IIIIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILInternalFormat_IIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILInternalFormat_IIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILInternalFormat_IIIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_IIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_IIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_IIIIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILInternalFormat_IIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILInternalFormat_IIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILInternalFormat_IIIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_IIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_IIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIIIIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_IIIIIIILInternalFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LConvolutionTarget_LInternalFormat_ILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTarget_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LConvolutionTargetEXT_LInternalFormat_ILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTargetEXT_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LConvolutionTarget_LInternalFormat_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTarget_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LConvolutionTargetEXT_LInternalFormat_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTargetEXT_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LConvolutionTarget_LConvolutionParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTarget_(),GLParamTypeSets.ML_LConvolutionParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LConvolutionTargetEXT_LConvolutionParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTargetEXT_(),GLParamTypeSets.ML_LConvolutionParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LConvolutionTarget_LConvolutionParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTarget_(),GLParamTypeSets.ML_LConvolutionParameter_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LConvolutionTargetEXT_LConvolutionParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTargetEXT_(),GLParamTypeSets.ML_LConvolutionParameter_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LConvolutionTarget_LConvolutionParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTarget_(),GLParamTypeSets.ML_LConvolutionParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LConvolutionTargetEXT_LConvolutionParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTargetEXT_(),GLParamTypeSets.ML_LConvolutionParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LCopyBufferSubDataTarget_LCopyBufferSubDataTarget_JJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCopyBufferSubDataTarget_(),GLParamTypeSets.ML_LCopyBufferSubDataTarget_(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LColorTableTarget_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LColorTableTarget_LInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTarget_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LColorTableTargetSGI_LInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTargetSGI_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LConvolutionTarget_LInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTarget_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LConvolutionTargetEXT_LInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTargetEXT_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LConvolutionTarget_LInternalFormat_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTarget_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LConvolutionTargetEXT_LInternalFormat_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTargetEXT_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILCopyImageSubDataTarget_IIIIILCopyImageSubDataTarget_IIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LCopyImageSubDataTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LCopyImageSubDataTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILCopyBufferSubDataTarget_IIIIILCopyBufferSubDataTarget_IIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LCopyBufferSubDataTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LCopyBufferSubDataTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_IIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_IIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIJJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IIIILPixelCopyType_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelCopyType_()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILInternalFormat_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILInternalFormat_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_IIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_IIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_EIIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILInternalFormat_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILInternalFormat_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILTextureTarget_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILTextureTarget_IIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILTextureTarget_IIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILPathElementType_pILInstancedPathCoverMode_LPathTransformType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathElementType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInstancedPathCoverMode_(),GLParamTypeSets.ML_LPathTransformType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILPathCoverMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathCoverMode_()); }
	static List<MemoryLayout> MLS_Z(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LQueryTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LQueryTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LShaderType_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LShaderType_()); }
	static List<MemoryLayout> MLS_LShaderType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LShaderType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LShaderType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LShaderType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_PPI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LCullParameterEXT_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCullParameterEXT_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LDebugSource_LDebugType_LDebugSeverity_IpZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LDebugSource_(),GLParamTypeSets.ML_LDebugType_(),GLParamTypeSets.ML_LDebugSeverity_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_ELDebugSeverity_IpZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_LDebugSeverity_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LDebugSource_LDebugType_ILDebugSeverity_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LDebugSource_(),GLParamTypeSets.ML_LDebugType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LDebugSeverity_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ELDebugSeverity_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_LDebugSeverity_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LFfdTargetSGIX_DDIIDDIIDDIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFfdTargetSGIX_(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LFfdTargetSGIX_FFIIFFIIFFIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFfdTargetSGIX_(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_EIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_DD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LDepthFunction_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LDepthFunction_()); }
	static List<MemoryLayout> MLS_IDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_IFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_FF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTextureTarget_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LEnableCap_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LEnableCap_()); }
	static List<MemoryLayout> MLS_LEnableCap_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LEnableCap_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILEnableCap_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LEnableCap_()); }
	static List<MemoryLayout> MLS_IE(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_J(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LPrimitiveType_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPrimitiveType_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LDrawBufferMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LDrawBufferMode_()); }
	static List<MemoryLayout> MLS_EppI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_EIppI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ppppI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IppppI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_ILDrawElementsType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPrimitiveType_ILDrawElementsType_pI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_LDrawElementsType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPrimitiveType_ILDrawElementsType_pII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_ILDrawElementsType_pIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_IIILDrawElementsType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPrimitiveType_IIILDrawElementsType_pI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_FFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_SSSSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_IIFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LElementPointerTypeATI_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LElementPointerTypeATI_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LQueryTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LQueryTarget_()); }
	static List<MemoryLayout> MLS_LEvalTargetNV_LEvalMapsModeNV_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LEvalTargetNV_(),GLParamTypeSets.ML_LEvalMapsModeNV_()); }
	static List<MemoryLayout> MLS_LMeshMode1_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMeshMode1_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LMeshMode2_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMeshMode2_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexAttribEnumNV_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexAttribEnumNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_EP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_PIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILShaderType_PP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LShaderType_(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IEIEP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_EIIIIIIILPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILFeedbackType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFeedbackType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IEp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LSyncCondition_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LSyncCondition_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LCombinerVariableNV_LCombinerRegisterNV_LCombinerMappingNV_LCombinerComponentUsageNV_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCombinerVariableNV_(),GLParamTypeSets.ML_LCombinerRegisterNV_(),GLParamTypeSets.ML_LCombinerMappingNV_(),GLParamTypeSets.ML_LCombinerComponentUsageNV_()); }
	static List<MemoryLayout> MLS_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LObjectTypeAPPLE_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LObjectTypeAPPLE_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LBufferTarget_JJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LPixelDataRangeTargetNV_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelDataRangeTargetNV_()); }
	static List<MemoryLayout> MLS_LFogPointerTypeEXT_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFogPointerTypeEXT_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LFogPointerTypeIBM_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFogPointerTypeIBM_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_C(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_C()); }
	static List<MemoryLayout> MLS_LFogParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFogParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LFogParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFogParameter_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LFogParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFogParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFogPName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFogPName_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFogPName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFogPName_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LFragmentLightModelParameterSGIX_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentLightModelParameterSGIX_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LFragmentLightModelParameterSGIX_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentLightModelParameterSGIX_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LFragmentLightModelParameterSGIX_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentLightModelParameterSGIX_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentLightNameSGIX_(),GLParamTypeSets.ML_LFragmentLightParameterSGIX_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentLightNameSGIX_(),GLParamTypeSets.ML_LFragmentLightParameterSGIX_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentLightNameSGIX_(),GLParamTypeSets.ML_LFragmentLightParameterSGIX_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTriangleFace_LMaterialParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTriangleFace_(),GLParamTypeSets.ML_LMaterialParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTriangleFace_LMaterialParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTriangleFace_(),GLParamTypeSets.ML_LMaterialParameter_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTriangleFace_LMaterialParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTriangleFace_(),GLParamTypeSets.ML_LMaterialParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILDrawBufferMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LDrawBufferMode_()); }
	static List<MemoryLayout> MLS_IIIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIIFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferParameterName_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILReadBufferMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LReadBufferMode_()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferAttachment_LRenderbufferTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_LRenderbufferTarget_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferAttachment_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferAttachment_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferAttachment_LTextureTarget_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferAttachment_IILTextureTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferAttachment_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferAttachment_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFrontFaceDirection_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFrontFaceDirection_()); }
	static List<MemoryLayout> MLS_DDDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_EIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LDataTypeEXT_LVertexShaderStorageTypeEXT_LParameterRangeEXT_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LDataTypeEXT_(),GLParamTypeSets.ML_LVertexShaderStorageTypeEXT_(),GLParamTypeSets.ML_LParameterRangeEXT_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_()); }
	static List<MemoryLayout> MLS_ILTextureTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_()); }
	static List<MemoryLayout> MLS_IILAtomicCounterBufferPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LAtomicCounterBufferPName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIIPPPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILShaderType_IIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LShaderType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILShaderType_ILSubroutineParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LShaderType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSubroutineParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IILUniformBlockPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LUniformBlockPName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIpLUniformPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_LUniformPName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LEnableCap_LArrayObjectPNameATI_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LEnableCap_(),GLParamTypeSets.ML_LArrayObjectPNameATI_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LBufferTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LGetPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LGetPName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LBufferTarget_LBufferPNameARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_LBufferPNameARB_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LBufferTarget_EP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LBufferTarget_LBufferPointerNameARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_LBufferPointerNameARB_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LBufferTarget_JJP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LClipPlaneName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LClipPlaneName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LColorTableTarget_LPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTarget_(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LColorTableTarget_LColorTableParameterPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTarget_(),GLParamTypeSets.ML_LColorTableParameterPName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LColorTableTargetSGI_LColorTableParameterPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTargetSGI_(),GLParamTypeSets.ML_LColorTableParameterPName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LColorTableTargetSGI_LPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTargetSGI_(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LCombinerStageNV_LCombinerPortionNV_LCombinerVariableNV_LCombinerParameterNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCombinerStageNV_(),GLParamTypeSets.ML_LCombinerPortionNV_(),GLParamTypeSets.ML_LCombinerVariableNV_(),GLParamTypeSets.ML_LCombinerParameterNV_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LCombinerStageNV_LCombinerPortionNV_LCombinerParameterNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCombinerStageNV_(),GLParamTypeSets.ML_LCombinerPortionNV_(),GLParamTypeSets.ML_LCombinerParameterNV_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LCombinerStageNV_LCombinerParameterNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCombinerStageNV_(),GLParamTypeSets.ML_LCombinerParameterNV_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LCommandOpcodesNV_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCommandOpcodesNV_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILTextureTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIIIIIIIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LConvolutionTarget_LPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTarget_(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LConvolutionTargetEXT_LPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTargetEXT_(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LConvolutionTarget_LConvolutionParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTarget_(),GLParamTypeSets.ML_LConvolutionParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LConvolutionTargetEXT_LConvolutionParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTargetEXT_(),GLParamTypeSets.ML_LConvolutionParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_EEP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIPPPPPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIPPPPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureTarget_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LGetPName_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LGetPName_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILFenceParameterNameNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFenceParameterNameNV_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LCombinerVariableNV_LCombinerParameterNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LCombinerVariableNV_(),GLParamTypeSets.ML_LCombinerParameterNV_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LFragmentLightNameSGIX_LFragmentLightParameterSGIX_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFragmentLightNameSGIX_(),GLParamTypeSets.ML_LFragmentLightParameterSGIX_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTriangleFace_LMaterialParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTriangleFace_(),GLParamTypeSets.ML_LMaterialParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferAttachment_LFramebufferAttachmentParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_LFramebufferAttachmentParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferAttachmentParameterName_IIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferAttachmentParameterName_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_LFramebufferAttachmentParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_LFramebufferAttachmentParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILGetFramebufferParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LGetFramebufferParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LContainerType_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LContainerType_()); }
	static List<MemoryLayout> MLS_LHistogramTargetEXT_ZLPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LHistogramTargetEXT_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LHistogramTargetEXT_LGetHistogramParameterPNameEXT_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LHistogramTargetEXT_(),GLParamTypeSets.ML_LGetHistogramParameterPNameEXT_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIZILPixelFormat_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_()); }
	static List<MemoryLayout> MLS_LImageTransformTargetHP_LImageTransformPNameHP_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LImageTransformTargetHP_(),GLParamTypeSets.ML_LImageTransformPNameHP_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureTarget_LInternalFormat_ILInternalFormatPName_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormatPName_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureTarget_LInternalFormat_LInternalFormatPName_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_LInternalFormatPName_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILGetVariantValueEXT_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LGetVariantValueEXT_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LLightName_LLightParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LLightName_(),GLParamTypeSets.ML_LLightParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILListParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LListParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LEvalTargetNV_ILMapAttribParameterNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LEvalTargetNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LMapAttribParameterNV_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LEvalTargetNV_ILMapTypeNV_IIZP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LEvalTargetNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LMapTypeNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LEvalTargetNV_LMapParameterNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LEvalTargetNV_(),GLParamTypeSets.ML_LMapParameterNV_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LMapTarget_LGetMapQuery_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMapTarget_(),GLParamTypeSets.ML_LGetMapQuery_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IEIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILMemoryObjectParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LMemoryObjectParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LMinmaxTargetEXT_ZLPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMinmaxTargetEXT_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LMinmaxTargetEXT_LGetMinmaxParameterPNameEXT_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMinmaxTargetEXT_(),GLParamTypeSets.ML_LGetMinmaxParameterPNameEXT_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureEnvTarget_(),GLParamTypeSets.ML_LTextureEnvParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureCoordName_(),GLParamTypeSets.ML_LTextureGenParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_ILPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_ILGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LGetTextureParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_LGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LGetTextureParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LGetMultisamplePNameNV_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LGetMultisamplePNameNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILBufferPNameARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBufferPNameARB_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILBufferPointerNameARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBufferPointerNameARB_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IJJP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IEIIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILFramebufferAttachment_LFramebufferAttachmentParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_LFramebufferAttachmentParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILProgramTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILProgramTarget_LProgramStringProperty_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_LProgramStringProperty_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILProgramTarget_LProgramPropertyARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_LProgramPropertyARB_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILRenderbufferParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LRenderbufferParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IpIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IpEP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILArrayObjectPNameATI_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LArrayObjectPNameATI_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LObjectIdentifier_IIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LObjectIdentifier_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_EIIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IEP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_EIEP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_pIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILOcclusionQueryParameterNameNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LOcclusionQueryParameterNameNV_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LPathColor_LPathGenMode_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPathColor_(),GLParamTypeSets.ML_LPathGenMode_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IILPathElementType_pIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathElementType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILPathParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LPathListMode_ILPathElementType_pIFFLPathTransformType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPathListMode_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathElementType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_LPathTransformType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureUnit_LPathGenMode_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LPathGenMode_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIIPIPPPPPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IEIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIEP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IPPIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_PP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LPixelMap_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelMap_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LPixelMap_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelMap_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LPixelTexGenParameterNameSGIS_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelTexGenParameterNameSGIS_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LGetPointervPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LGetPointervPName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIPPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LProgramTarget_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILProgramInterface_LProgramInterfacePName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramInterface_(),GLParamTypeSets.ML_LProgramInterfacePName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIpP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LVertexAttribEnumNV_ILVertexAttribEnumNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexAttribEnumNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribEnumNV_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILPipelineParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPipelineParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILProgramInterface_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramInterface_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILProgramInterface_IIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramInterface_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILProgramInterface_IIpIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramInterface_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILShaderType_LProgramStagePName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LShaderType_(),GLParamTypeSets.ML_LProgramStagePName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LProgramTarget_LProgramStringProperty_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_LProgramStringProperty_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILVertexAttribEnumNV_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribEnumNV_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILProgramPropertyARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramPropertyARB_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LProgramTarget_LProgramPropertyARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_LProgramPropertyARB_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IILQueryObjectParameterName_J(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LQueryObjectParameterName_(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LQueryTarget_ILQueryParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LQueryTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LQueryParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILQueryObjectParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LQueryObjectParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LQueryTarget_LQueryParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LQueryTarget_(),GLParamTypeSets.ML_LQueryParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LRenderbufferTarget_LRenderbufferParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LRenderbufferTarget_(),GLParamTypeSets.ML_LRenderbufferParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILSamplerParameterI_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSamplerParameterI_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILSamplerParameterF_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSamplerParameterF_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILSemaphoreParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSemaphoreParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LSeparableTargetEXT_LPixelFormat_LPixelType_PPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LSeparableTargetEXT_(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LShaderType_LPrecisionType_PP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LShaderType_(),GLParamTypeSets.ML_LPrecisionType_(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILShaderParameterName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LShaderParameterName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_EIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LStringName_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LStringName_()); }
	static List<MemoryLayout> MLS_LStringName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LStringName_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILShaderType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LShaderType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILSyncParameterName_IPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSyncParameterName_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LGetTexBumpParameterATI_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LGetTexBumpParameterATI_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureEnvTarget_LTextureEnvParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureEnvTarget_(),GLParamTypeSets.ML_LTextureEnvParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureTarget_LTextureFilterSGIS_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LTextureFilterSGIS_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureCoordName_LTextureGenParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureCoordName_(),GLParamTypeSets.ML_LTextureGenParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LGetTextureParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureTarget_LGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LGetTextureParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IILPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IILGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LGetTextureParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LGetTextureParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LGetTextureParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILTextureTarget_LGetTextureParameter_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LGetTextureParameter_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIIIIIIILPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILTransformFeedbackPName_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTransformFeedbackPName_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILTransformFeedbackPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTransformFeedbackPName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LShaderType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LShaderType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IILVertexArrayPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexArrayPName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILVertexArrayPName_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexArrayPName_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILVertexAttribEnum_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribEnum_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILVertexAttribPointerPropertyARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribPointerPropertyARB_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILVertexAttribPropertyARB_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribPropertyARB_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LColorTableTarget_LPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LColorTableTarget_(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureTarget_IIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LConvolutionTarget_LPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LConvolutionTarget_(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LHistogramTarget_ZLPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LHistogramTarget_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LHistogramTargetEXT_ZLPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LHistogramTargetEXT_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LMapTarget_LMapQuery_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMapTarget_(),GLParamTypeSets.ML_LMapQuery_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LMinmaxTarget_ZLPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMinmaxTarget_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LMinmaxTargetEXT_ZLPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMinmaxTargetEXT_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LSeparableTarget_LPixelFormat_LPixelType_IPIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LSeparableTarget_(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LSeparableTargetEXT_LPixelFormat_LPixelType_IPIPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LSeparableTargetEXT_(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_B(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_B()); }
	static List<MemoryLayout> MLS_S(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_LHintTarget_LHintMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LHintTarget_(),GLParamTypeSets.ML_LHintMode_()); }
	static List<MemoryLayout> MLS_LHintTargetPGI_LVertexHintsMaskPGI_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LHintTargetPGI_(),GLParamTypeSets.ML_LVertexHintsMaskPGI_()); }
	static List<MemoryLayout> MLS_LHistogramTargetEXT_ILInternalFormat_Z(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LHistogramTargetEXT_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_Ep(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LImageTransformTargetHP_LImageTransformPNameHP_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LImageTransformTargetHP_(),GLParamTypeSets.ML_LImageTransformPNameHP_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LImageTransformTargetHP_LImageTransformPNameHP_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LImageTransformTargetHP_(),GLParamTypeSets.ML_LImageTransformPNameHP_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LImageTransformTargetHP_LImageTransformPNameHP_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LImageTransformTargetHP_(),GLParamTypeSets.ML_LImageTransformPNameHP_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IJLExternalHandleType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_LExternalHandleType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IJLExternalHandleType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_LExternalHandleType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IJLExternalHandleType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_LExternalHandleType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILExternalHandleType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LExternalHandleType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILExternalHandleType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LExternalHandleType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILExternalHandleType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LExternalHandleType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_EJI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LIndexFunctionEXT_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LIndexFunctionEXT_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTriangleFace_LIndexMaterialParameterEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTriangleFace_(),GLParamTypeSets.ML_LIndexMaterialParameterEXT_()); }
	static List<MemoryLayout> MLS_LIndexPointerType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LIndexPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LIndexPointerType_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LIndexPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LIndexPointerType_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LIndexPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LInterleavedArrayFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LInterleavedArrayFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIIF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IIpIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LFramebufferTarget_IpIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LFramebufferTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILVariantCapEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVariantCapEXT_()); }
	static List<MemoryLayout> MLS_IIIEIIIIIEIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIJJp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_EIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LLightEnvParameterSGIX_LLightEnvModeSGIX_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LLightEnvParameterSGIX_(),GLParamTypeSets.ML_LLightEnvModeSGIX_()); }
	static List<MemoryLayout> MLS_LLightModelParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LLightModelParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LLightModelParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LLightModelParameter_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LLightModelParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LLightModelParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LLightName_LLightParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LLightName_(),GLParamTypeSets.ML_LLightParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LLightName_LLightParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LLightName_(),GLParamTypeSets.ML_LLightParameter_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LLightName_LLightParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LLightName_(),GLParamTypeSets.ML_LLightParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_C()); }
	static List<MemoryLayout> MLS_IIPpppI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILListParameterName_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LListParameterName_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILListParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LListParameterName_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILListParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LListParameterName_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexAttribEnumNV_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexAttribEnumNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LLogicOp_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LLogicOp_()); }
	static List<MemoryLayout> MLS_JE(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_J(),GLParamTypeSets.ML_E()); }
	static List<MemoryLayout> MLS_LMapTarget_DDIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMapTarget_(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LMapTarget_FFIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMapTarget_(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LMapTarget_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMapTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LMapTarget_DDIIDDIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMapTarget_(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LMapTarget_FFIIFFIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMapTarget_(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LMapTarget_IIIIIIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMapTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LBufferTarget_LBufferAccess_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_LBufferAccess_()); }
	static List<MemoryLayout> MLS_LBufferTarget_JJI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LEvalTargetNV_ILMapTypeNV_IIIIZp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LEvalTargetNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LMapTypeNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IDDIDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_IFFIFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILBufferAccess_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LBufferAccess_()); }
	static List<MemoryLayout> MLS_IJJI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LEvalTargetNV_LMapParameterNV_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LEvalTargetNV_(),GLParamTypeSets.ML_LMapParameterNV_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIDDIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIFFIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIDDIIDDIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIFFIIFFIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LMatrixMode_DDDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMatrixMode_(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_ILMatrixIndexPointerTypeARB_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LMatrixIndexPointerTypeARB_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LMatrixMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMatrixMode_()); }
	static List<MemoryLayout> MLS_LMatrixMode_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMatrixMode_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LMatrixMode_DDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMatrixMode_(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LMatrixMode_FFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMatrixMode_(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LMatrixMode_DDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMatrixMode_(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LMatrixMode_FFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMatrixMode_(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILMemoryObjectParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LMemoryObjectParameterName_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LMinmaxTargetEXT_LInternalFormat_Z(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMinmaxTargetEXT_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LPrimitiveType_ppI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_pII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_pIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_pIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_pJII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_pLDrawElementsType_pI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_pLDrawElementsType_pIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPrimitiveType_LDrawElementsType_pII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_LDrawElementsType_pIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_LDrawElementsType_pIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_LDrawElementsType_pJII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_JII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_JJII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPrimitiveType_IIppI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPrimitiveType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_pppII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ppLDrawElementsType_pII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_LDrawElementsType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_LInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_B(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_B()); }
	static List<MemoryLayout> MLS_LTextureUnit_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_D(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LTextureUnit_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTextureUnit_C(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_C()); }
	static List<MemoryLayout> MLS_LTextureUnit_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_S(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_LTextureUnit_BB(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B()); }
	static List<MemoryLayout> MLS_LTextureUnit_DD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LTextureUnit_FF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTextureUnit_CC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C()); }
	static List<MemoryLayout> MLS_LTextureUnit_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_SS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_LTextureUnit_BBB(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B()); }
	static List<MemoryLayout> MLS_LTextureUnit_DDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LTextureUnit_FFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTextureUnit_CCC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C()); }
	static List<MemoryLayout> MLS_LTextureUnit_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_SSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_LTextureUnit_BBBB(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B()); }
	static List<MemoryLayout> MLS_LTextureUnit_DDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LTextureUnit_FFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTextureUnit_CCCC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C()); }
	static List<MemoryLayout> MLS_LTextureUnit_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_SSSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTexCoordPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTexCoordPointerType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTexCoordPointerType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTexCoordPointerType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_ILTexCoordPointerType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTexCoordPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureEnvTarget_(),GLParamTypeSets.ML_LTextureEnvParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureEnvTarget_(),GLParamTypeSets.ML_LTextureEnvParameter_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureEnvTarget_LTextureEnvParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureEnvTarget_(),GLParamTypeSets.ML_LTextureEnvParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_D(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureCoordName_(),GLParamTypeSets.ML_LTextureGenParameter_(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureCoordName_(),GLParamTypeSets.ML_LTextureGenParameter_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureCoordName_(),GLParamTypeSets.ML_LTextureGenParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureCoordName_LTextureGenParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureCoordName_(),GLParamTypeSets.ML_LTextureGenParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_LTextureParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LTextureParameterName_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_LTextureParameterName_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LTextureParameterName_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_LTextureParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LTextureParameterName_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_IIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_IIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureUnit_LTextureTarget_IIIIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureUnit_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIIIIIIIIIIE(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E()); }
	static List<MemoryLayout> MLS_IIIIJJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IIIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IJpLVertexBufferObjectUsage_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_LVertexBufferObjectUsage_()); }
	static List<MemoryLayout> MLS_IJJZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_IJJIJZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_IJpI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IJJII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IJIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IJJp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILColorBuffer_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LColorBuffer_()); }
	static List<MemoryLayout> MLS_ILFramebufferParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFramebufferParameterName_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILFramebufferAttachment_LRenderbufferTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_LRenderbufferTarget_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILFramebufferAttachment_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILFramebufferAttachment_LTextureTarget_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILFramebufferAttachment_LTextureTarget_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILFramebufferAttachment_IILTextureTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_()); }
	static List<MemoryLayout> MLS_ILFramebufferAttachment_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILFramebufferAttachment_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFramebufferAttachment_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILProgramTarget_IDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_ILProgramTarget_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILProgramTarget_IFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILProgramTarget_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILProgramTarget_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILProgramTarget_LProgramFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_LProgramFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IILInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIILInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_EIpIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILListMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LListMode_()); }
	static List<MemoryLayout> MLS_IpLArrayObjectUsageATI_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_LArrayObjectUsageATI_()); }
	static List<MemoryLayout> MLS_LNormalPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LNormalPointerType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LNormalPointerType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LNormalPointerType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LNormalPointerType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LNormalPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LNormalPointerType_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LNormalPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LNormalPointerType_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LNormalPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LNormalPointerType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LNormalPointerType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_BBB(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_DDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_FFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_SSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_LObjectIdentifier_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LObjectIdentifier_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_pIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_EIE(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E()); }
	static List<MemoryLayout> MLS_LPNTrianglesPNameATI_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPNTrianglesPNameATI_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LPNTrianglesPNameATI_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPNTrianglesPNameATI_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IILSwizzleOpATI_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSwizzleOpATI_()); }
	static List<MemoryLayout> MLS_LPatchParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPatchParameterName_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPatchParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPatchParameterName_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPathColor_LPathGenMode_LPathColorFormat_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPathColor_(),GLParamTypeSets.ML_LPathGenMode_(),GLParamTypeSets.ML_LPathColorFormat_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIpILPathCoordType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathCoordType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IILPathCoordType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathCoordType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPathGenMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPathGenMode_()); }
	static List<MemoryLayout> MLS_IEpIIIIF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_EpIIFP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILPathFontTarget_pIIILPathHandleMissingGlyphs_IF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathFontTarget_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathHandleMissingGlyphs_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILPathFontTarget_pIILPathElementType_pLPathHandleMissingGlyphs_IF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathFontTarget_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathElementType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_LPathHandleMissingGlyphs_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IEJpIIIIF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILPathParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILPathParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathParameter_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILPathParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LStencilFunction_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LStencilFunction_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILPathStringFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathStringFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIIIpILPathCoordType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathCoordType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIILPathCoordType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathCoordType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPathColor_LPathGenMode_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPathColor_(),GLParamTypeSets.ML_LPathGenMode_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPixelDataRangeTargetNV_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelDataRangeTargetNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPixelMap_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelMap_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPixelStoreParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelStoreParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LPixelStoreParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelStoreParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPixelTexGenParameterNameSGIS_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelTexGenParameterNameSGIS_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LPixelTexGenParameterNameSGIS_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelTexGenParameterNameSGIS_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPixelTexGenParameterNameSGIS_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelTexGenParameterNameSGIS_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPixelTexGenModeSGIX_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelTexGenModeSGIX_()); }
	static List<MemoryLayout> MLS_LPixelTransferParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelTransferParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LPixelTransferParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelTransferParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelTransformTargetEXT_(),GLParamTypeSets.ML_LPixelTransformPNameEXT_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelTransformTargetEXT_(),GLParamTypeSets.ML_LPixelTransformPNameEXT_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPixelTransformTargetEXT_LPixelTransformPNameEXT_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPixelTransformTargetEXT_(),GLParamTypeSets.ML_LPixelTransformPNameEXT_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIIFPPPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_LPointParameterNameARB_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPointParameterNameARB_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LPointParameterNameARB_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPointParameterNameARB_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LPointParameterNameARB_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LPointParameterNameARB_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTriangleFace_LPolygonMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTriangleFace_(),GLParamTypeSets.ML_LPolygonMode_()); }
	static List<MemoryLayout> MLS_IJIIEEIEIEIEI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IJIIEEIIEII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_FFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IEpI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LProgramTarget_IIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LProgramTarget_IDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LProgramTarget_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LProgramTarget_IFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LProgramTarget_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LProgramTarget_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIpDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_IIpFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LVertexAttribEnumNV_IDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexAttribEnumNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LVertexAttribEnumNV_IFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexAttribEnumNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILProgramParameterPName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LProgramParameterPName_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIEIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LProgramTarget_LProgramFormat_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LProgramTarget_(),GLParamTypeSets.ML_LProgramFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IID(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_IIF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IIDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_IIJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IIDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_IIFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IIDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_IIFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IIJJJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IIIZp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LVertexProvokingMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexProvokingMode_()); }
	static List<MemoryLayout> MLS_LDebugSource_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LDebugSource_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILQueryCounterTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LQueryCounterTarget_()); }
	static List<MemoryLayout> MLS_LQueryTarget_IEI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LQueryTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_SS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_IZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LReadBufferMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LReadBufferMode_()); }
	static List<MemoryLayout> MLS_LReadBufferMode_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LReadBufferMode_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIIILPixelFormat_LPixelType_P(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIIILPixelFormat_LPixelType_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LRenderingMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LRenderingMode_()); }
	static List<MemoryLayout> MLS_LRenderbufferTarget_LInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LRenderbufferTarget_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LRenderbufferTarget_ILInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LRenderbufferTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LRenderbufferTarget_IILInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LRenderbufferTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LReplacementCodeTypeSUN_IP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LReplacementCodeTypeSUN_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IFFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_pppp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IBBBBFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IFFFFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ppppp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LHistogramTargetEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LHistogramTargetEXT_()); }
	static List<MemoryLayout> MLS_LMinmaxTargetEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LMinmaxTargetEXT_()); }
	static List<MemoryLayout> MLS_FZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_F(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LSamplePatternEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LSamplePatternEXT_()); }
	static List<MemoryLayout> MLS_LSamplePatternSGIS_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LSamplePatternSGIS_()); }
	static List<MemoryLayout> MLS_ILSamplerParameterI_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSamplerParameterI_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILSamplerParameterF_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSamplerParameterF_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILSamplerParameterF_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSamplerParameterF_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILSamplerParameterI_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSamplerParameterI_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILSecondaryColorPointerTypeIBM_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSecondaryColorPointerTypeIBM_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IZIIP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_ILSemaphoreParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSemaphoreParameterName_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LSeparableTargetEXT_LInternalFormat_IILPixelFormat_LPixelType_pp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LSeparableTargetEXT_(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILFenceConditionNV_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFenceConditionNV_()); }
	static List<MemoryLayout> MLS_ILScalarType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LScalarType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LShadingModel_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LShadingModel_()); }
	static List<MemoryLayout> MLS_IpLShaderBinaryFormat_pI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_LShaderBinaryFormat_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexShaderOpEXT_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexShaderOpEXT_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexShaderOpEXT_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexShaderOpEXT_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexShaderOpEXT_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexShaderOpEXT_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIPp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LShadingRate_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LShadingRate_()); }
	static List<MemoryLayout> MLS_LShadingRateCombinerOp_LShadingRateCombinerOp_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LShadingRateCombinerOp_(),GLParamTypeSets.ML_LShadingRateCombinerOp_()); }
	static List<MemoryLayout> MLS_LShadingRateQCOM_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LShadingRateQCOM_()); }
	static List<MemoryLayout> MLS_IIpIpp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IpIpp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LSpriteParameterNameSGIX_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LSpriteParameterNameSGIX_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LSpriteParameterNameSGIX_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LSpriteParameterNameSGIX_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LSpriteParameterNameSGIX_LSpriteModeSGIX_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LSpriteParameterNameSGIX_(),GLParamTypeSets.ML_LSpriteModeSGIX_()); }
	static List<MemoryLayout> MLS_ILPathElementType_pILPathFillMode_ILPathTransformType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathElementType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathFillMode_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathTransformType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILPathFillMode_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathFillMode_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTriangleFace_LStencilFunction_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTriangleFace_(),GLParamTypeSets.ML_LStencilFunction_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LStencilFunction_LStencilFunction_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LStencilFunction_(),GLParamTypeSets.ML_LStencilFunction_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTriangleFace_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTriangleFace_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LStencilOp_LStencilOp_LStencilOp_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LStencilOp_(),GLParamTypeSets.ML_LStencilOp_(),GLParamTypeSets.ML_LStencilOp_()); }
	static List<MemoryLayout> MLS_LTriangleFace_LStencilOp_LStencilOp_LStencilOp_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTriangleFace_(),GLParamTypeSets.ML_LStencilOp_(),GLParamTypeSets.ML_LStencilOp_(),GLParamTypeSets.ML_LStencilOp_()); }
	static List<MemoryLayout> MLS_ILPathElementType_pIIILPathTransformType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathElementType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathTransformType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILPathElementType_pILPathFillMode_ILInstancedPathCoverMode_LPathTransformType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathElementType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathFillMode_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInstancedPathCoverMode_(),GLParamTypeSets.ML_LPathTransformType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILPathFillMode_ILPathCoverMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathFillMode_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathCoverMode_()); }
	static List<MemoryLayout> MLS_ILPathElementType_pIIILInstancedPathCoverMode_LPathTransformType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathElementType_(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInstancedPathCoverMode_(),GLParamTypeSets.ML_LPathTransformType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIILPathCoverMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathCoverMode_()); }
	static List<MemoryLayout> MLS_IILVertexShaderCoordOutEXT_LVertexShaderCoordOutEXT_LVertexShaderCoordOutEXT_LVertexShaderCoordOutEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexShaderCoordOutEXT_(),GLParamTypeSets.ML_LVertexShaderCoordOutEXT_(),GLParamTypeSets.ML_LVertexShaderCoordOutEXT_(),GLParamTypeSets.ML_LVertexShaderCoordOutEXT_()); }
	static List<MemoryLayout> MLS_LTangentPointerTypeEXT_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTangentPointerTypeEXT_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LTextureTarget_LSizedInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_LSizedInternalFormat_IJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LTexBumpParameterATI_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTexBumpParameterATI_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_BB(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B()); }
	static List<MemoryLayout> MLS_FFFFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_FFBBBBFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_CC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C()); }
	static List<MemoryLayout> MLS_FFFFFFFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IEI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTexCoordPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTexCoordPointerType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTexCoordPointerType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTexCoordPointerType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTexCoordPointerType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTexCoordPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTexCoordPointerType_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTexCoordPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTexCoordPointerType_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTexCoordPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureEnvTarget_LTextureEnvParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureEnvTarget_(),GLParamTypeSets.ML_LTextureEnvParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTextureEnvTarget_LTextureEnvParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureEnvTarget_(),GLParamTypeSets.ML_LTextureEnvParameter_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureEnvTarget_LTextureEnvParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureEnvTarget_(),GLParamTypeSets.ML_LTextureEnvParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_LTextureFilterSGIS_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LTextureFilterSGIS_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureCoordName_LTextureGenParameter_D(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureCoordName_(),GLParamTypeSets.ML_LTextureGenParameter_(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LTextureCoordName_LTextureGenParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureCoordName_(),GLParamTypeSets.ML_LTextureGenParameter_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureCoordName_LTextureGenParameter_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureCoordName_(),GLParamTypeSets.ML_LTextureGenParameter_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTextureCoordName_LTextureGenParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureCoordName_(),GLParamTypeSets.ML_LTextureGenParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILInternalFormat_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILInternalFormat_IIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LTextureTarget_IILInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LTextureTarget_IILInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILInternalFormat_IIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_EIIIIIIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LTextureTarget_IIIIIIIIIJZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LTextureTarget_LTextureParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LTextureParameterName_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_LTextureParameterName_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LTextureParameterName_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LTextureTarget_LTextureParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LTextureParameterName_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_LGetTextureParameter_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LGetTextureParameter_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_LGetTextureParameter_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LGetTextureParameter_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILSizedInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILSizedInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILSizedInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILSizedInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILSizedInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILSizedInternalFormat_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILSizedInternalFormat_IIIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILSizedInternalFormat_IIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILSizedInternalFormat_IIIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILSizedInternalFormat_IIZIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILSizedInternalFormat_IIIIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LTextureTarget_ILSizedInternalFormat_IIIZIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LTextureTarget_LSizedInternalFormat_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LTextureTarget_IIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_IIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_IIIIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LTextureTarget_IIIIIIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILSizedInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILTextureTarget_LSizedInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILSizedInternalFormat_IJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_ILTextureTarget_LSizedInternalFormat_IJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILInternalFormat_IILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILInternalFormat_IIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_IILInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILInternalFormat_IIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_IILInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_LLightTexturePNameEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LLightTexturePNameEXT_()); }
	static List<MemoryLayout> MLS_LTextureNormalModeEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LTextureNormalModeEXT_()); }
	static List<MemoryLayout> MLS_IIIIIIIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_IIIIIIIIIIJZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_ILTextureParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureParameterName_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_LTextureParameterName_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LTextureParameterName_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureParameterName_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureParameterName_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILTextureTarget_LTextureParameterName_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LTextureParameterName_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_ILTextureParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureParameterName_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILTextureTarget_LTextureParameterName_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_LTextureParameterName_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILTextureTarget_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IILSizedInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IEILSizedInternalFormat_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IILSizedInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IEILSizedInternalFormat_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IILSizedInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILSizedInternalFormat_IIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_IILSizedInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IEILSizedInternalFormat_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IILSizedInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_IEILSizedInternalFormat_IIIZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_IILSizedInternalFormat_IIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IILSizedInternalFormat_IIIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IILSizedInternalFormat_IIZIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IILSizedInternalFormat_IIIIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IILSizedInternalFormat_IIIZIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IELSizedInternalFormat_IIIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_IIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_IIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_IIIIIIILPixelFormat_LPixelType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPixelFormat_(),GLParamTypeSets.ML_LPixelType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILTextureTarget_ILSizedInternalFormat_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTextureTarget_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LSizedInternalFormat_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexAttribEnumNV_ILVertexAttribEnumNV_LVertexAttribEnumNV_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexAttribEnumNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribEnumNV_(),GLParamTypeSets.ML_LVertexAttribEnumNV_()); }
	static List<MemoryLayout> MLS_IpE(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_E()); }
	static List<MemoryLayout> MLS_IIIJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IpIpE(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_E()); }
	static List<MemoryLayout> MLS_IIpLTransformFeedbackBufferMode_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_LTransformFeedbackBufferMode_()); }
	static List<MemoryLayout> MLS_IILPathTransformType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LPathTransformType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ID(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_IF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_IJJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IDDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_IFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_IJJJJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IIZp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LBufferTarget_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LBufferTarget_()); }
	static List<MemoryLayout> MLS_IIIpLPreserveModeATI_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_LPreserveModeATI_()); }
	static List<MemoryLayout> MLS_pEIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_p(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_pEIpZ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_p(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_Z()); }
	static List<MemoryLayout> MLS_ILScalarType_III(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LScalarType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILScalarType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LScalarType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIILVertexAttribType_ZI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribType_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIILVertexAttribIType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribIType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIILVertexAttribLType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribLType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIIJI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIILColorPointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LColorPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IIIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IILFogCoordinatePointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LFogCoordinatePointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IILIndexPointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LIndexPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IIEILTexCoordPointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTexCoordPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IILNormalPointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LNormalPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_LVertexArrayPNameAPPLE_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexArrayPNameAPPLE_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IIILTexCoordPointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LTexCoordPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IIIILVertexAttribType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IIIILVertexAttribLType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribLType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IIIILVertexAttribPointerType_ZIJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribPointerType_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IIIppp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IIILVertexPointerType_IJ(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_J()); }
	static List<MemoryLayout> MLS_IS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_ICC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C()); }
	static List<MemoryLayout> MLS_ISS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_ICCC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C()); }
	static List<MemoryLayout> MLS_ISSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_IBBBB(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B(),GLParamTypeSets.ML_B()); }
	static List<MemoryLayout> MLS_ICCCC(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C(),GLParamTypeSets.ML_C()); }
	static List<MemoryLayout> MLS_ISSSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_IILVertexAttribPointerType_ZIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribPointerType_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IILVertexAttribType_ZI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribType_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IILVertexAttribIType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribIType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IILVertexAttribIType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribIType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IILVertexAttribLType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribLType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_IILVertexAttribLType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribLType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILVertexAttribPointerType_ZI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribPointerType_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILVertexAttribPointerType_Zp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribPointerType_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IILVertexAttribPointerType_ZIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribPointerType_(),GLParamTypeSets.ML_Z(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IILVertexAttribEnumNV_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexAttribEnumNV_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_F(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_ILVertexPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexPointerType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexPointerType_I(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexPointerType_(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexPointerType_p(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexPointerType_(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILVertexPointerType_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILVertexPointerType_IIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_ILVertexPointerType_IPI(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexPointerType_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_D(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_S(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_DD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_FF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_II(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_SS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_DDDD(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D(),GLParamTypeSets.ML_D()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_FFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_IIII(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I()); }
	static List<MemoryLayout> MLS_LVertexStreamATI_SSSS(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_LVertexStreamATI_(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S(),GLParamTypeSets.ML_S()); }
	static List<MemoryLayout> MLS_ILVertexWeightPointerTypeEXT_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexWeightPointerTypeEXT_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IPP(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_P(),GLParamTypeSets.ML_P()); }
	static List<MemoryLayout> MLS_IIEp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IEEEE(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_E()); }
	static List<MemoryLayout> MLS_ILWeightPointerTypeARB_Ip(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LWeightPointerTypeARB_(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IEIp(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_E(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_p()); }
	static List<MemoryLayout> MLS_IILVertexShaderWriteMaskEXT_LVertexShaderWriteMaskEXT_LVertexShaderWriteMaskEXT_LVertexShaderWriteMaskEXT_(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_I(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_LVertexShaderWriteMaskEXT_(),GLParamTypeSets.ML_LVertexShaderWriteMaskEXT_(),GLParamTypeSets.ML_LVertexShaderWriteMaskEXT_(),GLParamTypeSets.ML_LVertexShaderWriteMaskEXT_()); }
	static List<MemoryLayout> MLS_JIFFFFFFFFF(MethodHandles.Lookup l, String n, Class t) { return List.of(GLParamTypeSets.ML_J(),GLParamTypeSets.ML_I(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F(),GLParamTypeSets.ML_F()); }
    //</editor-fold>
}